#!/bin/sh

if [ `whoami` != "root" ];then
  echo "请使用 root 运行"
  exit 1
fi

# 当前目录
CURDIR=`pwd`

# 当前系统时间
YMD=`LANG=en date "+%Y%m%d%H%M%S"`
# 创建存放系统信息的临时目录
LOGNAME=system-log-$1-${YMD}
LOGDIR=${CURDIR}/${LOGNAME}
sudo rm -rf ${LOGNAME}
mkdir -pv $LOGNAME > /dev/null 2>&1
sync

# dpkg、rpm命令
DPKG=`which dpkg 2>/dev/null`
RPM=`which rpm 2>/dev/null`

############# 获取软件包的二进制文件信息 #############
get_csmicro_file_info() {
#gp101-102
# 内核驱动文件
sudo find  /lib/modules/`uname -r`/  -name '*csm*' > gp100-kernel_csmicro_ko.txt

echo "--------------------------------------------------" >> gp100-kernel_csmicro_ko.txt
echo "sudo find  /lib/modules/`uname -r`/  -name '*csm*' | xargs md5sum" >> gp100-kernel_csmicro_ko.txt
sudo find  /lib/modules/`uname -r`/  -name '*csm*' | xargs md5sum >> gp100-kernel_csmicro_ko.txt

echo "--------------------------------------------------" >> gp100-kernel_csmicro_ko.txt
echo "sudo find  /lib/modules/`uname -r`/  -name '*csm*' | xargs ls -l" >> gp100-kernel_csmicro_ko.txt
sudo find  /lib/modules/`uname -r`/  -name '*csm*' | xargs ls -l >> gp100-kernel_csmicro_ko.txt

# 核外驱动文件
ls -l  /usr/lib/*-linux-gnu*/  | grep -i csmicro >> gp100-usr_lib_xorg_csmicro_so.txt 2>/dev/null
echo "--------------------------------------------------" >> gp100-usr_lib_xorg_csmicro_so.txt
ls -l  /usr/lib/*-linux-gnu*/libGL*.so* >> gp100-usr_lib_xorg_csmicro_so.txt 2>/dev/null
echo "--------------------------------------------------" >> gp100-usr_lib_xorg_csmicro_so.txt

sudo find  /usr/lib*/xorg/modules/ -name '*csmicro*' 2>/dev/null | xargs  ls -l >> gp100-usr_lib_xorg_csmicro_so.txt 2>/dev/null
echo "--------------------------------------------------" >> gp100-usr_lib_xorg_csmicro_so.txt
sudo find  /usr/lib*/xorg/modules/ -name '*csmicro*' 2>/dev/null | xargs  md5sum >> gp100-usr_lib_xorg_csmicro_so.txt 2>/dev/null
echo "--------------------------------------------------" >> gp100-usr_lib_xorg_csmicro_so.txt

sudo find  /usr/lib/*-linux-gnu*/  -maxdepth  1 -type f | grep -i csmicro | xargs ls -l >> gp100-usr_lib_arch_csmicro_files.txt 2>/dev/null
echo "--------------------------------------------------" >> gp100-usr_lib_arch_csmicro_files.txt
sudo find  /usr/lib/*-linux-gnu*/  -maxdepth  1 -type f | grep -i csmicro | xargs -i ldd {} >> gp100-usr_lib_arch_csmicro_files.txt 2>/dev/null
echo "--------------------------------------------------" >> gp100-usr_lib_arch_csmicro_files.txt
sudo find  /usr/lib/*-linux-gnu*/  -maxdepth  1 -type f | grep -i csmicro | xargs md5sum >> gp100-usr_lib_arch_csmicro_files.txt 2>/dev/null
echo "--------------------------------------------------" >> gp100-usr_lib_arch_csmicro_files.txt

if [ ! -z $DPKG ]; then
    sudo find  /usr/lib/*-linux-gnu*/csmicro/ -type f  2>/dev/null | xargs  ls -l >> gp100-usr_lib_arch_csmicro_files.txt 2>/dev/null
    echo "--------------------------------------------------" >> gp100-usr_lib_arch_csmicro_files.txt
    sudo find  /usr/lib/*-linux-gnu*/csmicro/ -type f  2>/dev/null | xargs -i ldd {} >> gp100-usr_lib_arch_csmicro_files.txt
    echo "--------------------------------------------------" >> gp100-usr_lib_arch_csmicro_files.txt
    sudo find  /usr/lib/*-linux-gnu*/csmicro/ -type f  2>/dev/null | xargs  md5sum >> gp100-usr_lib_arch_csmicro_files.txt 2>/dev/null
    echo "--------------------------------------------------" >> gp100-usr_lib_arch_csmicro_files.txt
	if [ -f /usr/lib/*-linux-gnu*/csmicro/sw-csmicro ]; then
		cp /usr/lib/*-linux-gnu*/csmicro/sw-csmicro .
	fi
fi

if [ ! -z $RPM ]; then
    sudo find  /usr/lib64/*-linux-gnu*/csmicro/ -type f  2>/dev/null | xargs  ls -l >> gp100-usr_lib_arch_csmicro_files.txt 2>/dev/null
    echo "--------------------------------------------------" >> gp100-usr_lib_arch_csmicro_files.txt
    sudo find  /usr/lib64/*-linux-gnu*/csmicro/ -type f  2>/dev/null | xargs -i ldd {} >> gp100-usr_lib_arch_csmicro_files.txt
    echo "--------------------------------------------------" >> gp100-usr_lib_arch_csmicro_files.txt
    sudo find  /usr/lib64/*-linux-gnu*/csmicro/ -type f  2>/dev/null | xargs  md5sum >> gp100-usr_lib_arch_csmicro_files.txt 2>/dev/null
    echo "--------------------------------------------------" >> gp100-usr_lib_arch_csmicro_files.txt
	if [ -f /usr/lib64/*-linux-gnu*/csmicro/sw-csmicro ]; then
		cp /usr/lib64/*-linux-gnu*/csmicro/sw-csmicro .
	fi
fi

if [ ! -z $RPM ]; then
    sudo find /usr/lib*/csmicro/ -type f 2>/dev/null | xargs ls -l >> gp100-usr_lib_csmicro_files.txt 2>/dev/null
    echo "--------------------------------------------------" >> gp100-usr_lib_csmicro_files.txt
    sudo find /usr/lib*/csmicro/ -type f 2>/dev/null | xargs -i ldd {} >> gp100-usr_lib_csmicro_files.txt 2>/dev/null
    echo "--------------------------------------------------" >> gp100-usr_lib_csmicro_files.txt
    sudo find /usr/lib*/csmicro/ -type f 2>/dev/null | xargs md5sum >> gp100-usr_lib_csmicro_files.txt 2>/dev/null
    echo "--------------------------------------------------" >> gp100-usr_lib_csmicro_files.txt
	if [ -f /usr/lib*/csmicro/sw-csmicro ]; then
		cp /usr/lib*/csmicro/sw-csmicro .
	fi
fi

#gp200
# 内核驱动文件
sudo find  /lib/modules/`uname -r`/  -name '*ljm*' > gp200-kernel_ljm_ko.txt

echo "--------------------------------------------------" >> gp200-kernel_ljm_ko.txt
echo "sudo find  /lib/modules/`uname -r`/  -name '*ljm*' | xargs md5sum" >> gp200-kernel_ljm_ko.txt
sudo find  /lib/modules/`uname -r`/  -name '*ljm*' | xargs md5sum >> gp200-kernel_ljm_ko.txt

echo "--------------------------------------------------" >> gp200-kernel_ljm_ko.txt
echo "sudo find  /lib/modules/`uname -r`/  -name '*ljm*' | xargs ls -l" >> gp200-kernel_ljm_ko.txt
sudo find  /lib/modules/`uname -r`/  -name '*ljm*' | xargs ls -l >> gp200-kernel_ljm_ko.txt

# 核外驱动文件
ls -l  /usr/lib/*-linux-gnu*/  | grep -i ljm >> gp200-usr_lib_xorg_ljm_so.txt 2>/dev/null
echo "--------------------------------------------------" >> gp200-usr_lib_xorg_ljm_so.txt
ls -l  /usr/lib/*-linux-gnu*/libGL*.so* >> gp200-usr_lib_xorg_ljm_so.txt 2>/dev/null
echo "--------------------------------------------------" >> gp200-usr_lib_xorg_ljm_so.txt

sudo find  /usr/lib*/xorg/modules/ -name '*ljm*' 2>/dev/null | xargs  ls -l >> gp200-usr_lib_xorg_ljm_so.txt 2>/dev/null
echo "--------------------------------------------------" >> gp200-usr_lib_xorg_ljm_so.txt
sudo find  /usr/lib*/xorg/modules/ -name '*ljm*' 2>/dev/null | xargs  md5sum >> gp200-usr_lib_xorg_ljm_so.txt 2>/dev/null
echo "--------------------------------------------------" >> gp200-usr_lib_xorg_ljm_so.txt

sudo find  /usr/lib/*-linux-gnu*/  -maxdepth  1 -type f | grep -i ljm | xargs ls -l >> gp200-usr_lib_arch_ljm_files.txt 2>/dev/null
echo "--------------------------------------------------" >> gp200-usr_lib_arch_ljm_files.txt
sudo find  /usr/lib/*-linux-gnu*/  -maxdepth  1 -type f | grep -i ljm | xargs -i ldd {} >> gp200-usr_lib_arch_ljm_files.txt 2>/dev/null
echo "--------------------------------------------------" >> gp200-usr_lib_arch_ljm_files.txt
sudo find  /usr/lib/*-linux-gnu*/  -maxdepth  1 -type f | grep -i ljm | xargs md5sum >> gp200-usr_lib_arch_ljm_files.txt 2>/dev/null
echo "--------------------------------------------------" >> gp200-usr_lib_arch_ljm_files.txt

if [ ! -z $DPKG ]; then
    sudo find  /usr/lib/*-linux-gnu*/ljm/ -type f  2>/dev/null | xargs  ls -l >> gp200-usr_lib_arch_ljm_files.txt 2>/dev/null
    echo "--------------------------------------------------" >> gp200-usr_lib_arch_ljm_files.txt
    sudo find  /usr/lib/*-linux-gnu*/ljm/ -type f  2>/dev/null | xargs -i ldd {} >> gp200-usr_lib_arch_ljm_files.txt
    echo "--------------------------------------------------" >> gp200-usr_lib_arch_ljm_files.txt
    sudo find  /usr/lib/*-linux-gnu*/ljm/ -type f  2>/dev/null | xargs  md5sum >> gp200-usr_lib_arch_ljm_files.txt 2>/dev/null
    echo "--------------------------------------------------" >> gp200-usr_lib_arch_ljm_files.txt
	if [ -f /usr/lib/*-linux-gnu*/ljm/sw-ljmgp ]; then
		cp /usr/lib/*-linux-gnu*/ljm/sw-ljmgp .
	fi
fi

if [ ! -z $RPM ]; then
    sudo find  /usr/lib64/*-linux-gnu*/ljm/ -type f  2>/dev/null | xargs  ls -l >> gp200-usr_lib_arch_ljm_files.txt 2>/dev/null
    echo "--------------------------------------------------" >> gp200-usr_lib_arch_ljm_files.txt
    sudo find  /usr/lib64/*-linux-gnu*/ljm/ -type f  2>/dev/null | xargs -i ldd {} >> gp200-usr_lib_arch_ljm_files.txt
    echo "--------------------------------------------------" >> gp200-usr_lib_arch_ljm_files.txt
    sudo find  /usr/lib64/*-linux-gnu*/ljm/ -type f  2>/dev/null | xargs  md5sum >> gp200-usr_lib_arch_ljm_files.txt 2>/dev/null
    echo "--------------------------------------------------" >> gp200-usr_lib_arch_ljm_files.txt
	if [ -f /usr/lib64/*-linux-gnu*/ljm/sw-ljmgp ]; then
		cp /usr/lib64/*-linux-gnu*/ljm/sw-ljmgp .
	fi
fi

if [ ! -z $RPM ]; then
    sudo find /usr/lib*/ljm/ -type f 2>/dev/null | xargs ls -l >> gp200-usr_lib_ljm_files.txt 2>/dev/null
    echo "--------------------------------------------------" >> gp200-usr_lib_ljm_files.txt
    sudo find /usr/lib*/ljm/ -type f 2>/dev/null | xargs -i ldd {} >> gp200-usr_lib_ljm_files.txt 2>/dev/null
    echo "--------------------------------------------------" >> gp200-usr_lib_ljm_files.txt
    sudo find /usr/lib*/ljm/ -type f 2>/dev/null | xargs md5sum >> gp200-usr_lib_ljm_files.txt 2>/dev/null
    echo "--------------------------------------------------" >> gp200-usr_lib_ljm_files.txt
	if [ -f /usr/lib*/ljm/sw-ljmgp ]; then
		cp /usr/lib*/ljm/sw-ljmgp .
	fi
fi

if [ -f /usr/share/X11/xorg.conf.d/20-device.conf ]; then
	cp /usr/share/X11/xorg.conf.d/20-device.conf .
fi

if [ -f /etc/ld.so.conf.d/10-csm.conf ]; then
	cp /etc/ld.so.conf.d/10-csm.conf .
fi

}


#############
cd $LOGNAME
############# 获取系统信息 #############
# 当前内核日志
sudo dmesg > dmesg.log.txt

# 完整内核日志
if [ -e /var/log/kern.log ]; then
  sudo cp /var/log/kern.log .
fi
if [ -e /var/log/messages ]; then
	sudo cp /var/log/messages .
fi

# 完整的syslog日志
if [ -e /var/log/syslog ]; then
  sudo cp /var/log/syslog .
fi

# Xorg日志文件
if [ -e /var/log/Xorg.0.log ]; then
  sudo cp /var/log/Xorg.0.log* .
fi


# 完整的PCI信息
sudo lspci -x |grep VGA -A5 > lspci.txt 2>/dev/null
echo "-----------------------------" >> lspci.txt
sudo cat /proc/iomem >> lspci.txt
echo "-----------------------------" >> lspci.txt
sudo lspci -vvv |grep "VGA " -A50 >> lspci.txt 2>/dev/null
echo "-----------------------------" >> lspci.txt
sudo lspci -vvv >> lspci.txt

# 中断信息
sudo cat /proc/interrupts > interrupts.txt

# 当前CPU信息
sudo lscpu >> lscpu.txt

# 显卡信息
if [ -e /proc/gpuinfo_0 ]; then
  cat /proc/gpuinfo_0 > gpuinfo_0.txt
fi

if [ -e /usr/bin/glxgears ]; then
  ldd /usr/bin/glxgears  > glxgears
fi

if [ -e /usr/bin/glmark2 ]; then
  ldd /usr/bin/glmark2  > glmark2
fi

# 当前内存使用情况
free -m >> free.txt

# 当前进程信息
ps auxf > ps.auxf.txt

# xrandr信息
export DISPLAY=:0
xrandr > xrandr.txt 2>/dev/null
echo "-----------------------------------" >> xrandr.txt
xrandr --verbose >> xrandr.txt 2>/dev/null

# 系统安装的软件包信息
#gp101-102
if [ ! -z $DPKG ]; then
	dpkg -l >> gp100-dpkg-all.txt
	dpkg -l | grep csmicro | awk '{ print $2 }' | xargs -i dpkg -s {} > gp100-dpkg-csmicro.txt
	echo "---------------------" >> gp100-dpkg-csmicro.txt
	
	FLS=`dpkg -l | grep csmicro | awk '{ print $2 }' | xargs -i dpkg -L {} | xargs -i  echo {}`
	for FL in $FLS
	do
	   if [ -f $FL ]; then
	     ls -l $FL >> gp100-dpkg-csmicro.txt
	     md5sum $FL >> gp100-dpkg-csmicro.txt
	   fi
	done
fi
if [ ! -z $RPM ]; then
	rpm -qa >> rpm-qa.txt
	rpm -qa | grep csmicro | awk '{ print $1 }' | xargs -i rpm -qi {} > gp100-rpm-csmicro.txt
	echo "---------------------" >> gp100-rpm-csmicro.txt
	FLS=`rpm -qa | grep csmicro | awk '{ print $1 }' | xargs -i rpm -ql {}`
	for FL in $FLS
	do
	    if [ -f $FL ]; then
	      ls -l $FL >> gp100-rpm-csmicro.txt
	      md5sum $FL >> gp100-rpm-csmicro.txt
	    fi
	done
fi

#gp200
if [ ! -z $DPKG ]; then
	dpkg -l >> gp200-dpkg-all.txt
	dpkg -l | grep ljm | awk '{ print $2 }' | xargs -i dpkg -s {} > gp200-dpkg-ljm.txt
	echo "---------------------" >> gp200-dpkg-ljm.txt
	
	FLS=`dpkg -l | grep ljm | awk '{ print $2 }' | xargs -i dpkg -L {} | xargs -i  echo {}`
	for FL in $FLS
	do
	   if [ -f $FL ]; then
	     ls -l $FL >> gp200-dpkg-ljm.txt
	     md5sum $FL >> gp200-dpkg-ljm.txt
	   fi
	done
fi
if [ ! -z $RPM ]; then
	rpm -qa >> gp200-rpm-qa.txt
	rpm -qa | grep ljm | awk '{ print $1 }' | xargs -i rpm -qi {} > gp200-rpm-ljm.txt
	echo "---------------------" >> gp200-rpm-ljm.txt
	FLS=`rpm -qa | grep ljm | awk '{ print $1 }' | xargs -i rpm -ql {}`
	for FL in $FLS
	do
	    if [ -f $FL ]; then
	      ls -l $FL >> gp200-rpm-ljm.txt
	      md5sum $FL >> gp200-rpm-ljm.txt
	    fi
	done
fi

cp `find /var/lib/dkms/ljm*/ -name "make.log" 2>/dev/null`  ljm.make.log  2>/dev/null
cp `find /var/lib/dkms/csm*/ -name "make.log" 2>/dev/null`  csm.make.log  2>/dev/null

# 当前内核版本信息
uname -a > uname-a.txt
echo "\n\n\n" >> uname-a.txt
# 内核启动参数
cat /proc/cmdline >> uname-a.txt

# 当前系统版本信息
if [ -e /etc/lsb-release ]; then
	cp /etc/lsb-release .
fi
if [ -e /etc/os-release ]; then
	cp /etc/os-release .
fi
if [ -e /etc/.kyinfo ]; then
	cp /etc/.kyinfo .
fi
if [ -e /etc/.productinfo ]; then
	cp /etc/.productinfo .
fi

# 获取软件包相关的信息
#gp101-102 #gp200
get_csmicro_file_info

sync

# 当前进程占用CPU情况
top -n 2 > top.txt


############# 获取系统信息 #############
cd $CURDIR
#sudo chmod -R 0777 ${LOGNAME}

sync
sudo tar czf ${LOGNAME}.tgz ${LOGNAME}
rm -rf ${LOGNAME}
sync


echo "收集收集系统日志成功，日志文件位于 ${LOGNAME}.tgz "
# echo "System Log File ${LOGNAME}.tgz"
