/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

#if ljdENABLE_TTM
#ifndef __lj_hal_kernel_ttm_h_
#define __lj_hal_ketnel_ttm_h_

#include <drm/drm_device.h>
#include <drm/drm_file.h>
#include <drm/drm_vram_mm_helper.h>
#include <drm/ttm/ttm_bo_driver.h>
#include <drm/ttm/ttm_bo_api.h>
#include <drm/ttm/ttm_page_alloc.h>

#define VIV_MEM_DOMAIN_CPU      (1 << 0)
#define VIV_MEM_DOMAIN_GTT      (1 << 1)
#define VIV_MEM_DOMAIN_VRAM     (1 << 2)
#define VIV_MEM_DOMAIN_PRIV     (1 << 3)

#define VIV_MEM_CREATE_CPU_ACCESS_REQUIRED  (1 << 0)
#define VIV_MEM_CREATE_CPU_NO_CPU_ACCESS    (1 << 1)
#define VIV_MEM_CREATE_CONTIGUOUS_VRAM      (1 << 2)
#define VIV_MEM_CREATE_WAITING_MOVE         (1 << 10)

typedef struct _ljm_ttm {
    struct ttm_bo_device bdev;
    ljtPOINTER vram_pin_size;
    ljtPOINTER visible_pin_size;
} ljm_ttm_t;

struct _ljm_evict_info {
    ljtUINT32 evictedHandle;
    ljtPOINTER pageTables;
    ljtADDRESS address;
};

typedef struct _ljm_bo {
    ljkOS os;
    ljkKERNEL kernel;
    struct ttm_buffer_object tbo;
    struct ttm_placement placement;
    struct ttm_place    placements[3];
    struct ttm_place    busy_placements[3];
    ljtUINT32 preferred_domains;
    ljtUINT32 allowed_domains;
    struct ttm_bo_kmap_obj  kmap;
    struct list_head head;
    struct drm_file *reserved_by;
    struct list_head entry;
    struct list_head vma_list;
    ljtUINT32 pin_count;
    /*TODO SHUAI reset cpu accessable flags*/
    ljtUINT32 flags;
    ljkVIDMEM_NODE nodeObject;
    ljtBOOL evicting;
    ljtUINT32 evictedHandle;
    ljtBOOL isImport;
    ljtBOOL isExport;
    ljtUINT64 userLogical;
    ljtUINT32 gpuAddress;
    struct _ljm_evict_info *evictInfo;
    ljtUINT32 type;
    struct file *file;
    ljtUINT64 vma_offset;

    /* per-perocess information */
    ljtUINT32 nodeHandle;
    ljtUINT32 gemHandle;
    ljtUINT32 processID;
    ljtPOINTER next;
} ljm_bo_t;

struct ljm_bo_param {
    unsigned long            size;
    ljtINT32                 byte_align;
    ljtUINT32                domain;
    ljtUINT32                preferred_domain;
    ljtUINT32                flags;
    enum ttm_bo_type         type;
    ljtUINT32                vidMemType;
    struct dma_resv          *resv;
};

int ljkDRM_TTMInit(struct drm_device *drm_drv);

ljtPOINTER
ljkDRM_GetGALFromTTM(struct ttm_bo_device *dev);

ljtPOINTER
ljkDRM_GetVIVBo(struct ttm_buffer_object *bo);

ljtPOINTER
ljkDRM_GetNodeObjFromHandle(ljkKERNEL kernel, ljtUINT32 processID,
                                    ljtUINT32 handle);

#endif
#endif /* ljdENABLE_TTM */
