/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/



#include <linux/version.h>
#include <linux/slab.h>
#include <linux/vmalloc.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/debugfs.h>
#include <linux/types.h>
#include <linux/device.h>
#include <linux/pagemap.h>
#include <linux/sched.h>
#if LINUX_VERSION_CODE < KERNEL_VERSION(6, 2, 0)
#include <stddef.h>
#else
#include <linux/stddef.h>
#endif

#if LINUX_VERSION_CODE >= KERNEL_VERSION(5, 10, 0)
#include <linux/dma-map-ops.h>
#else
#include <linux/dma-contiguous.h>
#endif

#include <linux/platform_device.h>
#include <linux/dma-buf.h>

#include "hantroaxife.h"

#define HANTRO_AXIFE_OFFSET 0

void AXIFEEnable (unsigned char *hwregs) {
  if (!hwregs) return;

  //AXI FE pass through
  iowrite32(0x0, (void*)(hwregs + HANTRO_AXIFE_OFFSET + 0x2C));
  printk(KERN_INFO "AXI FE: 0x2C = 0x%x\n", ioread32((void*)(hwregs + 0x2C)));
  iowrite32(0x2, (void*)(hwregs + HANTRO_AXIFE_OFFSET + 0x28));
  printk(KERN_INFO "AXI FE: 0x28 = 0x%x\n", ioread32((void*)(hwregs + 0x28)));
}

