/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

#ifndef __lj_hal_enum_h_
#define __lj_hal_enum_h_

#include "lj_hal_options.h"
#include "lj_hal_enum_shared.h"

#ifdef __cplusplus
extern "C" {
#endif

/* dummy draw type.*/
typedef enum _ljeDUMMY_DRAW_TYPE {
    ljvDUMMY_DRAW_INVALID = 0,
    ljvDUMMY_DRAW_LJ400,
    ljvDUMMY_DRAW_V60,
} ljeDUMMY_DRAW_TYPE;

/* Option Set*/
typedef enum _ljeOPTION {
    /* HW setting. */
    ljvOPTION_PREFER_ZCONVERT_BYPASS      = 0,
    ljvOPTION_PREFER_TILED_DISPLAY_BUFFER = 1,
    ljvOPTION_PREFER_GUARDBAND            = 2,
    ljvOPTION_PREFER_TPG_TRIVIALMODEL     = 3,
    ljvOPTION_PREFER_RA_DEPTH_WRITE       = 4,
    ljvOPTION_PREFER_USC_RECONFIG         = 5,
    ljvOPTION_PREFER_DISALBE_HZ           = 6,

    /* SW options */
    ljvOPTION_HW_NULL           = 50,
    ljvOPTION_PRINT_OPTION      = 51,
    ljvOPTION_KERNEL_FENCE      = 52,
    ljvOPTION_ASYNC_PIPE        = 53,
    ljvOPTION_FBO_PREFER_MEM    = 54,
    ljvOPTION_GPU_TEX_UPLOAD    = 55,
    ljvOPTION_GPU_BUFOBJ_UPLOAD = 56,
    ljvOPTION_NO_Y_INVERT       = 60,

    /* OCL option */
    ljvOPTION_OCL_ASYNC_BLT = 200,
    ljvOPTION_OCL_IN_THREAD,
    ljvOPTION_COMPRESSION_DEC400,
    ljvOPTION_OCL_VIR_SHADER,
    ljvOPTION_OCL_USE_MULTI_DEVICES,

#if ljdUSE_VX
    /* OVX options that HAL could access */
    ljvOPTION_OVX_ENABLE_NN_ZDP3 = 500,
    ljvOPTION_OVX_ENABLE_NN_ZDP6,
    ljvOPTION_OVX_ENABLE_NN_STRIDE,
    ljvOPTION_OVX_USE_MULTI_DEVICES,
    ljvOPTION_OVX_ENABLE_NN_DDR_BURST_SIZE_1024B,
    ljvOPTION_OVX_ENABLE_NN_DDR_BURST_SIZE_512B,
    ljvOPTION_OVX_ENABLE_NN_DDR_BURST_SIZE_256B,
    ljvOPTION_OVX_ENABLE_NN_DDR_BURST_SIZE_128B,
    ljvOPTION_OVX_ENABLE_NN_DDR_BURST_SIZE_64B,

    ljvOPTION_OVX_ENABLE_VIP_AXI_ID1_DDR_BURST_SIZE_1024B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID1_DDR_BURST_SIZE_512B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID1_DDR_BURST_SIZE_256B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID1_DDR_BURST_SIZE_128B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID1_DDR_BURST_SIZE_64B,

    ljvOPTION_OVX_ENABLE_VIP_AXI_ID2_DDR_BURST_SIZE_1024B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID2_DDR_BURST_SIZE_512B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID2_DDR_BURST_SIZE_256B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID2_DDR_BURST_SIZE_128B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID2_DDR_BURST_SIZE_64B,

    ljvOPTION_OVX_ENABLE_VIP_AXI_ID3_DDR_BURST_SIZE_1024B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID3_DDR_BURST_SIZE_512B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID3_DDR_BURST_SIZE_256B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID3_DDR_BURST_SIZE_128B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID3_DDR_BURST_SIZE_64B,

    ljvOPTION_OVX_ENABLE_VIP_AXI_ID0_MIN_AXI_BURST_SIZE_1024B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID0_MIN_AXI_BURST_SIZE_512B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID0_MIN_AXI_BURST_SIZE_256B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID0_MIN_AXI_BURST_SIZE_128B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID0_MIN_AXI_BURST_SIZE_64B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID0_MIN_AXI_BURST_SIZE_32B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID0_MIN_AXI_BURST_SIZE_16B,

    ljvOPTION_OVX_ENABLE_VIP_AXI_ID1_MIN_AXI_BURST_SIZE_1024B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID1_MIN_AXI_BURST_SIZE_512B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID1_MIN_AXI_BURST_SIZE_256B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID1_MIN_AXI_BURST_SIZE_128B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID1_MIN_AXI_BURST_SIZE_64B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID1_MIN_AXI_BURST_SIZE_32B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID1_MIN_AXI_BURST_SIZE_16B,

    ljvOPTION_OVX_ENABLE_VIP_AXI_ID2_MIN_AXI_BURST_SIZE_1024B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID2_MIN_AXI_BURST_SIZE_512B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID2_MIN_AXI_BURST_SIZE_256B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID2_MIN_AXI_BURST_SIZE_128B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID2_MIN_AXI_BURST_SIZE_64B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID2_MIN_AXI_BURST_SIZE_32B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID2_MIN_AXI_BURST_SIZE_16B,

    ljvOPTION_OVX_ENABLE_VIP_AXI_ID3_MIN_AXI_BURST_SIZE_1024B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID3_MIN_AXI_BURST_SIZE_512B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID3_MIN_AXI_BURST_SIZE_256B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID3_MIN_AXI_BURST_SIZE_128B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID3_MIN_AXI_BURST_SIZE_64B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID3_MIN_AXI_BURST_SIZE_32B,
    ljvOPTION_OVX_ENABLE_VIP_AXI_ID3_MIN_AXI_BURST_SIZE_16B,

#endif
    /* Insert option above this comment only */
    ljvOPTION_COUNT /* Not a OPTION*/
} ljeOPTION;

typedef enum _ljeFRAMEINFO {
    /* Total frame count in one run */
    ljvFRAMEINFO_FRAME_NUM      = 0,
    /* Total draw count in current frame, including draw/compute */
    ljvFRAMEINFO_DRAW_NUM       = 1,
    /* Total compute count in current frame, subset of drawNum */
    ljvFRAMEINFO_COMPUTE_NUM    = 2,
    /* Total dual16 draw/compute count in current frame, subset of drawNum */
    ljvFRAMEINFO_DUAL16_NUM     = 3,
    /* Current programID is being set. only valid for ES20 driver right now */
    ljvFRAMEINFO_PROGRAM_ID     = 4,

    ljvFRAMEINFO_COUNT,
} ljeFRAMEINFO;

typedef enum _ljeFRAMEINFO_OP {
    ljvFRAMEINFO_OP_INC     = 0,
    ljvFRAMEINFO_OP_DEC     = 1,
    ljvFRAMEINFO_OP_ZERO    = 2,
    ljvFRAMEINFO_OP_GET     = 3,
    ljvFRAMEINFO_OP_SET     = 4,
    ljvFRAMEINFO_OP_COUNT,
} ljeFRAMEINFO_OP;

typedef enum _ljeSURF_USAGE {
    ljvSURF_USAGE_UNKNOWN,
    ljvSURF_USAGE_RESOLVE_AFTER_CPU,
    ljvSURF_USAGE_RESOLVE_AFTER_3D
} ljeSURF_USAGE;

typedef enum _ljeSURF_COLOR_SPACE {
    ljvSURF_COLOR_SPACE_UNKNOWN,
    ljvSURF_COLOR_SPACE_LINEAR,
    ljvSURF_COLOR_SPACE_NONLINEAR,
} ljeSURF_COLOR_SPACE;

typedef enum _ljeSURF_COLOR_TYPE {
    ljvSURF_COLOR_UNKNOWN   = 0,
    ljvSURF_COLOR_LINEAR    = 0x01,
    ljvSURF_COLOR_ALPHA_PRE = 0x02,
} ljeSURF_COLOR_TYPE;

/* Rotation. */
typedef enum _ljeSURF_ROTATION {
    ljvSURF_0_DEGREE = 0,
    ljvSURF_90_DEGREE,
    ljvSURF_180_DEGREE,
    ljvSURF_270_DEGREE,
    ljvSURF_FLIP_X,
    ljvSURF_FLIP_Y,

    ljvSURF_POST_FLIP_X = 0x40000000,
    ljvSURF_POST_FLIP_Y = 0x80000000,
} ljeSURF_ROTATION;

/* Surface flag */
typedef enum _ljeSURF_FLAG {
    /* None flag */
    ljvSURF_FLAG_NONE                = 0x0,
    /* content is preserved after swap */
    ljvSURF_FLAG_CONTENT_PRESERVED   = 0x1,
    /* content is updated after swap*/
    ljvSURF_FLAG_CONTENT_UPDATED     = 0x2,
    /* content is y inverted */
    ljvSURF_FLAG_CONTENT_YINVERTED   = 0x4,
    /* surface has multiple nodes */
    ljvSURF_FLAG_MULTI_NODE          = 0x8,
    /* surface no need do dither when resovle*/
    ljvSURF_FLAG_DITHER_DISABLED     = 0x10,
    /* surface used a fake hal format */
    ljvSURF_FLAG_FAKE_FORMAT         = 0x20,
} ljeSURF_FLAG;

typedef enum _ljeMIPMAP_IMAGE_FORMAT {
    ljvUNKNOWN_MIPMAP_IMAGE_FORMAT = -2
} ljeMIPMAP_IMAGE_FORMAT;

typedef enum _ljeIMAGE_MEM_TYPE {
    ljvIMAGE_MEM_DEFAULT,
    ljvIMAGE_MEM_HOST_PTR,
    ljvIMAGE_MEM_HOST_PTR_UNCACHED,
    ljvIMAGE_MEM_HOST_PHY_PTR,
    ljvIMAGE_MEM_HOST_PHY_PTR_UNCACHED,
} ljeIMAGE_MEM_TYPE;

typedef enum _ljeSURF_YUV_COLOR_SPACE {
    ljvSURF_ITU_REC601,
    ljvSURF_ITU_REC709,
    ljvSURF_ITU_REC2020,
} ljeSURF_YUV_COLOR_SPACE;

typedef enum _ljeSURF_YUV_SAMPLE_RANGE {
    ljvSURF_YUV_UNKNOWN_RANGE,
    ljvSURF_YUV_FULL_RANGE,
    ljvSURF_YUV_NARROW_RANGE,
} ljeSURF_YUV_SAMPLE_RANGE;

typedef enum _ljeSURF_YUV_CHROMA_SITING {
    ljvSURF_YUV_CHROMA_SITING_0,
    ljvSURF_YUV_CHROMA_SITING_0_5,
} ljeSURF_YUV_CHROMA_SITING;

typedef enum _ljeSURF_INFO_TYPE {
    ljvSURF_INFO_UNKNOWN   = 0,
    ljvSURF_INFO_LAYERSIZE = 1,
    ljvSURF_INFO_SLICESIZE = 2,
} ljeSURF_INFO_TYPE;

/* Format modifiers. */
typedef enum _ljeSURF_FORMAT_MODE {
    ljvSURF_FORMAT_OCL          = 0x80000000,
    ljvSURF_FORMAT_PATCH_BORDER = 0x40000000,
} ljeSURF_FORMAT_MODE;

/* Pixel swizzle modes. */
typedef enum _ljeSURF_SWIZZLE {
    ljvSURF_NOSWIZZLE = 0,
    ljvSURF_ARGB,
    ljvSURF_ABGR,
    ljvSURF_RGBA,
    ljvSURF_BGRA
} ljeSURF_SWIZZLE;

/* Transparency modes. */
typedef enum _ljeSURF_TRANSPARENCY {
    /* Valid only for PE 1.0 */
    ljvSURF_OPAQUE = 0,
    ljvSURF_SOURCE_MATCH,
    ljvSURF_SOURCE_MASK,
    ljvSURF_PATTERN_MASK,
} ljeSURF_TRANSPARENCY;

/* Surface Alignment. */
typedef enum _ljeSURF_ALIGNMENT {
    ljvSURF_FOUR = 0,
    ljvSURF_SIXTEEN,
    ljvSURF_SUPER_TILED,
    ljvSURF_SPLIT_TILED,
    ljvSURF_SPLIT_SUPER_TILED
} ljeSURF_ALIGNMENT;

/* Surface Addressing. */
typedef enum _ljeSURF_ADDRESSING {
    ljvSURF_NO_STRIDE_TILED = 0,
    ljvSURF_NO_STRIDE_LINEAR,
    ljvSURF_STRIDE_TILED,
    ljvSURF_STRIDE_LINEAR
} ljeSURF_ADDRESSING;

/* Transparency modes. */
typedef enum _lje2D_TRANSPARENCY {
    /* Valid only for PE 2.0 */
    ljv2D_OPAQUE = 0,
    ljv2D_KEYED,
    ljv2D_MASKED
} lje2D_TRANSPARENCY;

/* Mono packing modes. */
typedef enum _ljeSURF_MONOPACK {
    ljvSURF_PACKED8 = 0,
    ljvSURF_PACKED16,
    ljvSURF_PACKED32,
    ljvSURF_UNPACKED,
} ljeSURF_MONOPACK;

/* Blending modes. */
typedef enum _ljeSURF_BLEND_MODE {
    /* Porter-Duff blending modes.                    */
    /*                          Fsrc      Fdst        */
    ljvBLEND_CLEAR = 0, /* 0         0           */
    ljvBLEND_SRC, /* 1         0           */
    ljvBLEND_DST, /* 0         1           */
    ljvBLEND_SRC_OVER_DST, /* 1         1 - Asrc    */
    ljvBLEND_DST_OVER_SRC, /* 1 - Adst  1           */
    ljvBLEND_SRC_IN_DST, /* Adst      0           */
    ljvBLEND_DST_IN_SRC, /* 0         Asrc        */
    ljvBLEND_SRC_OUT_DST, /* 1 - Adst  0           */
    ljvBLEND_DST_OUT_SRC, /* 0         1 - Asrc    */
    ljvBLEND_SRC_ATOP_DST, /* Adst      1 - Asrc    */
    ljvBLEND_DST_ATOP_SRC, /* 1 - Adst  Asrc        */
    ljvBLEND_SRC_XOR_DST, /* 1 - Adst  1 - Asrc    */

    /* Special blending modes.                        */
    ljvBLEND_SET, /* DST = 1               */
    ljvBLEND_SUB             /* DST = DST * (1 - SRC) */
} ljeSURF_BLEND_MODE;

/* Per-pixel alpha modes. */
typedef enum _ljeSURF_PIXEL_ALPHA_MODE {
    ljvSURF_PIXEL_ALPHA_STRAIGHT = 0,
    ljvSURF_PIXEL_ALPHA_INVERSED
} ljeSURF_PIXEL_ALPHA_MODE;

/* Global alpha modes. */
typedef enum _ljeSURF_GLOBAL_ALPHA_MODE {
    ljvSURF_GLOBAL_ALPHA_OFF = 0,
    ljvSURF_GLOBAL_ALPHA_ON,
    ljvSURF_GLOBAL_ALPHA_SCALE
} ljeSURF_GLOBAL_ALPHA_MODE;

/* Color component modes for alpha blending. */
typedef enum _ljeSURF_PIXEL_COLOR_MODE {
    ljvSURF_COLOR_STRAIGHT = 0,
    ljvSURF_COLOR_MULTIPLY
} ljeSURF_PIXEL_COLOR_MODE;

/* Color component modes for alpha blending. */
typedef enum _lje2D_PIXEL_COLOR_MULTIPLY_MODE {
    ljv2D_COLOR_MULTIPLY_DISABLE = 0,
    ljv2D_COLOR_MULTIPLY_ENABLE
} lje2D_PIXEL_COLOR_MULTIPLY_MODE;

/* Color component modes for alpha blending. */
typedef enum _lje2D_GLOBAL_COLOR_MULTIPLY_MODE {
    ljv2D_GLOBAL_COLOR_MULTIPLY_DISABLE = 0,
    ljv2D_GLOBAL_COLOR_MULTIPLY_ALPHA,
    ljv2D_GLOBAL_COLOR_MULTIPLY_COLOR
} lje2D_GLOBAL_COLOR_MULTIPLY_MODE;

/* Alpha blending factor modes. */
typedef enum _ljeSURF_BLEND_FACTOR_MODE {
    ljvSURF_BLEND_ZERO = 0,
    ljvSURF_BLEND_ONE,
    ljvSURF_BLEND_STRAIGHT,
    ljvSURF_BLEND_INVERSED,
    ljvSURF_BLEND_COLOR,
    ljvSURF_BLEND_COLOR_INVERSED,
    ljvSURF_BLEND_SRC_ALPHA_SATURATED,
    ljvSURF_BLEND_STRAIGHT_NO_CROSS,
    ljvSURF_BLEND_INVERSED_NO_CROSS,
    ljvSURF_BLEND_COLOR_NO_CROSS,
    ljvSURF_BLEND_COLOR_INVERSED_NO_CROSS,
    ljvSURF_BLEND_SRC_ALPHA_SATURATED_CROSS
} ljeSURF_BLEND_FACTOR_MODE;

/* Alpha blending porter duff rules. */
typedef enum _lje2D_PORTER_DUFF_RULE {
    ljvPD_CLEAR = 0,
    ljvPD_SRC,
    ljvPD_SRC_OVER,
    ljvPD_DST_OVER,
    ljvPD_SRC_IN,
    ljvPD_DST_IN,
    ljvPD_SRC_OUT,
    ljvPD_DST_OUT,
    ljvPD_SRC_ATOP,
    ljvPD_DST_ATOP,
    ljvPD_ADD,
    ljvPD_XOR,
    ljvPD_DST
} lje2D_PORTER_DUFF_RULE;

/* Alpha blending factor modes. */
typedef enum _lje2D_YUV_COLOR_MODE {
    ljv2D_YUV_601 = 0,
    ljv2D_YUV_709,
    ljv2D_YUV_2020,
    ljv2D_YUV_USER_DEFINED,
    ljv2D_YUV_USER_DEFINED_CLAMP,

    /*  Default setting is for src. ljv2D_YUV_DST
     *  can be ORed to set dst.
     */
    ljv2D_YUV_DST = 0x80000000,
} lje2D_YUV_COLOR_MODE;

/* Nature rotation rules. */
typedef enum _lje2D_NATURE_ROTATION {
    ljvNR_0_DEGREE = 0,
    ljvNR_LEFT_90_DEGREE,
    ljvNR_RIGHT_90_DEGREE,
    ljvNR_180_DEGREE,
    ljvNR_FLIP_X,
    ljvNR_FLIP_Y,
    ljvNR_TOTAL_RULE,
} lje2D_NATURE_ROTATION;

typedef enum _lje2D_COMMAND {
    ljv2D_CLEAR = 0,
    ljv2D_LINE,
    ljv2D_BLT,
    ljv2D_STRETCH,
    ljv2D_HOR_FILTER,
    ljv2D_VER_FILTER,
    ljv2D_MULTI_SOURCE_BLT,
    ljv2D_FILTER_BLT,
} lje2D_COMMAND;

typedef enum _lje2D_TILE_STATUS_CONFIG {
    ljv2D_TSC_DISABLE       = 0,
    ljv2D_TSC_ENABLE        = 0x00000001,
    ljv2D_TSC_COMPRESSED    = 0x00000002,
    ljv2D_TSC_DOWN_SAMPLER  = 0x00000004,
    ljv2D_TSC_2D_COMPRESSED = 0x00000008,

    ljv2D_TSC_DEC_COMPRESSED     = 0x00000020,
    ljv2D_TSC_DEC_TPC            = 0x00000040,
    ljv2D_TSC_DEC_TPC_COMPRESSED = 0x00000080,

    ljv2D_TSC_V4_COMPRESSED      = 0x00000100,
    ljv2D_TSC_V4_COMPRESSED_256B = 0x00000200 | ljv2D_TSC_V4_COMPRESSED,

    ljv2D_TSC_DEC_TPC_TILED            = ljv2D_TSC_DEC_COMPRESSED | ljv2D_TSC_DEC_TPC,
    ljv2D_TSC_DEC_TPC_TILED_COMPRESSED = ljv2D_TSC_DEC_TPC_TILED | ljv2D_TSC_DEC_TPC_COMPRESSED,

    ljv2D_TSC_TPC_COMPRESSED     = 0x00001000,
    ljv2D_TSC_TPC_COMPRESSED_V10 = ljv2D_TSC_TPC_COMPRESSED | 0x00000400,
    ljv2D_TSC_TPC_COMPRESSED_V11 = ljv2D_TSC_TPC_COMPRESSED | 0x00000800,
} lje2D_TILE_STATUS_CONFIG;

typedef enum _lje2D_DEC400_MINOR_VERSION {
    ljv2D_DEC400_MINOR_V1 = 1,
    ljv2D_DEC400_MINOR_V2 = 2,
    ljv2D_DEC400_MINOR_V3 = 3,
    ljv2D_DEC400_MINOR_V4 = 4,
} lje2D_DEC400_MINOR_VERSION;

/*Tiling version when disable compression*/
typedef enum _lje2D_TILING_MINOR_VERSION {
    ljv2D_TILING_MINOR_V1 = 0,
    ljv2D_TILING_MINOR_V2 = 1,
} lje2D_TILING_MINOR_VERSION;

typedef enum _lje2D_QUERY {
    ljv2D_QUERY_RGB_ADDRESS_MIN_ALIGN = 0,
    ljv2D_QUERY_RGB_STRIDE_MIN_ALIGN,
    ljv2D_QUERY_YUV_ADDRESS_MIN_ALIGN,
    ljv2D_QUERY_YUV_STRIDE_MIN_ALIGN,
    ljv2D_QUERY_DEC400_MINOR_VERSION,
    ljv2D_QUERY_TILING_MINOR_VERSION,
} lje2D_QUERY;

typedef enum _lje2D_SUPER_TILE_VERSION {
    ljv2D_SUPER_TILE_VERSION_V1 = 1,
    ljv2D_SUPER_TILE_VERSION_V2 = 2,
    ljv2D_SUPER_TILE_VERSION_V3 = 3,
} lje2D_SUPER_TILE_VERSION;

typedef enum _lje2D_STATE {
    ljv2D_STATE_SPECIAL_FILTER_MIRROR_MODE = 1,
    ljv2D_STATE_SUPER_TILE_VERSION,
    ljv2D_STATE_EN_GAMMA,
    ljv2D_STATE_DE_GAMMA,
    ljv2D_STATE_MULTI_SRC_BLIT_UNIFIED_DST_RECT,
    ljv2D_STATE_MULTI_SRC_BLIT_BILINEAR_FILTER,
    ljv2D_STATE_PROFILE_ENABLE,
    ljv2D_STATE_XRGB_ENABLE,

    ljv2D_STATE_ARRAY_EN_GAMMA      = 0x10001,
    ljv2D_STATE_ARRAY_DE_GAMMA,
    ljv2D_STATE_ARRAY_CSC_YUV_TO_RGB,
    ljv2D_STATE_ARRAY_CSC_RGB_TO_YUV,

    ljv2D_STATE_DEC_TPC_NV12_10BIT  = 0x20001,
    ljv2D_STATE_ARRAY_YUV_SRC_TILE_STATUS_ADDR,
    ljv2D_STATE_ARRAY_YUV_DST_TILE_STATUS_ADDR,
} lje2D_STATE;

typedef enum _lje2D_STATE_PROFILE {
    ljv2D_STATE_PROFILE_NONE    = 0x0,
    ljv2D_STATE_PROFILE_COMMAND = 0x1,
    ljv2D_STATE_PROFILE_SURFACE = 0x2,
    ljv2D_STATE_PROFILE_ALL     = 0xFFFF,
} lje2D_STATE_PROFILE;

/* Texture object types */
typedef enum _ljeTEXTURE_TYPE {
    ljvTEXTURE_UNKNOWN = 0,
    ljvTEXTURE_1D,
    ljvTEXTURE_2D,
    ljvTEXTURE_3D,
    ljvTEXTURE_CUBEMAP,
    ljvTEXTURE_1D_ARRAY,
    ljvTEXTURE_2D_ARRAY,
    ljvTEXTURE_2D_MS,
    ljvTEXTURE_2D_MS_ARRAY,
    ljvTEXTURE_CUBEMAP_ARRAY,
    ljvTEXTURE_EXTERNAL
} ljeTEXTURE_TYPE;

#if ljdENABLE_3D
/* Texture functions. */
typedef enum _ljeTEXTURE_FUNCTION {
    ljvTEXTURE_DUMMY   = 0,
    ljvTEXTURE_REPLACE = 0,
    ljvTEXTURE_MODULATE,
    ljvTEXTURE_ADD,
    ljvTEXTURE_ADD_SIGNED,
    ljvTEXTURE_INTERPOLATE,
    ljvTEXTURE_SUBTRACT,
    ljvTEXTURE_DOT3
} ljeTEXTURE_FUNCTION;

/* Texture sources. */
typedef enum _ljeTEXTURE_SOURCE {
    ljvCOLOR_FROM_TEXTURE = 0,
    ljvCOLOR_FROM_CONSTANT_COLOR,
    ljvCOLOR_FROM_PRIMARY_COLOR,
    ljvCOLOR_FROM_PREVIOUS_COLOR
} ljeTEXTURE_SOURCE;

/* Texture source channels. */
typedef enum _ljeTEXTURE_CHANNEL {
    ljvFROM_COLOR = 0,
    ljvFROM_ONE_MINUS_COLOR,
    ljvFROM_ALPHA,
    ljvFROM_ONE_MINUS_ALPHA
} ljeTEXTURE_CHANNEL;
#endif /* ljdENABLE_3D */

/* Filter types. */
typedef enum _ljeFILTER_TYPE {
    ljvFILTER_SYNC = 0,
    ljvFILTER_BLUR,
    ljvFILTER_USER
} ljeFILTER_TYPE;

/* Filter pass types. */
typedef enum _ljeFILTER_PASS_TYPE {
    ljvFILTER_HOR_PASS = 0,
    ljvFILTER_VER_PASS
} ljeFILTER_PASS_TYPE;

/* Endian hints. */
typedef enum _ljeENDIAN_HINT {
    ljvENDIAN_NO_SWAP    = 0,
    ljvENDIAN_SWAP_WORD  = 1,
    ljvENDIAN_SWAP_DWORD = 2,
    ljvENDIAN_SWAP_QWORD = 3,
} ljeENDIAN_HINT;

/* Tiling modes. */
typedef enum _ljeTILING {
    ljvINVALIDTILED = 0x0, /* Invalid tiling */
    /* Tiling basic modes enum'ed in power of 2. */
    ljvLINEAR       = 0x1, /* No    tiling. */
    ljvTILED        = 0x2, /* 4x4   tiling. */
    ljvSUPERTILED   = 0x4, /* 64x64 tiling. */
    ljvMINORTILED   = 0x8, /* 2x2   tiling. */

    /* Tiling special layouts. */
    ljvTILING_SPLIT_BUFFER = 0x10,
    ljvTILING_X_MAJOR      = 0x20,
    ljvTILING_Y_MAJOR      = 0x40,
    ljvTILING_SWAP         = 0x80,

    /* Tiling combination layouts. */
    ljvMULTI_TILED       = ljvTILED      | ljvTILING_SPLIT_BUFFER,

    ljvMULTI_SUPERTILED  = ljvSUPERTILED | ljvTILING_SPLIT_BUFFER,

    ljvYMAJOR_SUPERTILED = ljvSUPERTILED | ljvTILING_Y_MAJOR,

    ljvTILED_8X4  = 0x0100,
    ljvTILED_4X8  = 0x0100 | ljvTILING_SWAP,
    ljvTILED_8X8  = 0x0200,
    ljvTILED_16X4 = 0x0400,
    ljvTILED_32X4 = 0x0800,
    ljvTILED_64X4 = 0x1000,

    ljvTILED_8X8_XMAJOR = ljvTILED_8X8 | ljvTILING_X_MAJOR,
    ljvTILED_8X8_YMAJOR = ljvTILED_8X8 | ljvTILING_Y_MAJOR,

    ljvSUPERTILED_128B = 0x10000 | ljvSUPERTILED,
    ljvSUPERTILED_256B = 0x20000 | ljvSUPERTILED,
} ljeTILING;

typedef enum _ljeCACHE_MODE {
    ljvCACHE_NONE,
    ljvCACHE_128,
    ljvCACHE_256,
} ljeCACHE_MODE;

#define DEFAULT_CACHE_MODE ljvCACHE_256

/* 2D pattern type. */
typedef enum _lje2D_PATTERN {
    ljv2D_PATTERN_SOLID = 0,
    ljv2D_PATTERN_MONO,
    ljv2D_PATTERN_COLOR,
    ljv2D_PATTERN_INVALID
} lje2D_PATTERN;

/* 2D source type. */
typedef enum _lje2D_SOURCE {
    ljv2D_SOURCE_MASKED = 0,
    ljv2D_SOURCE_MONO,
    ljv2D_SOURCE_COLOR,
    ljv2D_SOURCE_INVALID
} lje2D_SOURCE;

typedef enum _ljeMMU_MODE {
    ljvMMU_MODE_1K,
    ljvMMU_MODE_4K,
} ljeMMU_MODE;

/* ljdDUMP message type. */
typedef enum _ljeDEBUG_MESSAGE_TYPE {
    ljvMESSAGE_TEXT,
    ljvMESSAGE_DUMP
} ljeDEBUG_MESSAGE_TYPE;

/* Shading format. */
typedef enum _ljeSHADING {
    ljvSHADING_SMOOTH,
    ljvSHADING_FLAT_D3D,
    ljvSHADING_FLAT_OPENGL,
} ljeSHADING;

/* Culling modes. */
typedef enum _ljeCULL {
    ljvCULL_NONE,
    ljvCULL_CCW,
    ljvCULL_CW,
} ljeCULL;

/* Fill modes. */
typedef enum _ljeFILL {
    ljvFILL_POINT,
    ljvFILL_WIRE_FRAME,
    ljvFILL_SOLID,
} ljeFILL;

/* Compare modes. */
typedef enum _ljeCOMPARE {
    ljvCOMPARE_INVALID = 0,
    ljvCOMPARE_NEVER,
    ljvCOMPARE_NOT_EQUAL,
    ljvCOMPARE_LESS,
    ljvCOMPARE_LESS_OR_EQUAL,
    ljvCOMPARE_EQUAL,
    ljvCOMPARE_GREATER,
    ljvCOMPARE_GREATER_OR_EQUAL,
    ljvCOMPARE_ALWAYS,
} ljeCOMPARE;

/* Stencil modes. */
typedef enum _ljeSTENCIL_MODE {
    ljvSTENCIL_NONE,
    ljvSTENCIL_SINGLE_SIDED,
    ljvSTENCIL_DOUBLE_SIDED,
} ljeSTENCIL_MODE;

/* Stencil operations. */
typedef enum _ljeSTENCIL_OPERATION {
    ljvSTENCIL_KEEP,
    ljvSTENCIL_REPLACE,
    ljvSTENCIL_ZERO,
    ljvSTENCIL_INVERT,
    ljvSTENCIL_INCREMENT,
    ljvSTENCIL_DECREMENT,
    ljvSTENCIL_INCREMENT_SATURATE,
    ljvSTENCIL_DECREMENT_SATURATE,
    ljvSTENCIL_OPERATION_INVALID = -1
} ljeSTENCIL_OPERATION;

/* Stencil selection. */
typedef enum _ljeSTENCIL_WHERE {
    ljvSTENCIL_FRONT,
    ljvSTENCIL_BACK,
} ljeSTENCIL_WHERE;

/* Texture addressing selection. */
typedef enum _ljeTEXTURE_WHICH {
    ljvTEXTURE_S,
    ljvTEXTURE_T,
    ljvTEXTURE_R,
} ljeTEXTURE_WHICH;

/* Texture addressing modes. */
typedef enum _ljeTEXTURE_ADDRESSING {
    ljvTEXTURE_INVALID = 0,
    ljvTEXTURE_CLAMP,
    ljvTEXTURE_WRAP,
    ljvTEXTURE_MIRROR,
    ljvTEXTURE_BORDER,
    ljvTEXTURE_MIRROR_ONCE,
} ljeTEXTURE_ADDRESSING;

/* Texture filters. */
typedef enum _ljeTEXTURE_FILTER {
    ljvTEXTURE_NONE,
    ljvTEXTURE_POINT,
    ljvTEXTURE_LINEAR,
    ljvTEXTURE_ANISOTROPIC,
} ljeTEXTURE_FILTER;

typedef enum _ljeTEXTURE_COMPONENT {
    ljvTEXTURE_COMPONENT_R,
    ljvTEXTURE_COMPONENT_G,
    ljvTEXTURE_COMPONENT_B,
    ljvTEXTURE_COMPONENT_A,

    ljvTEXTURE_COMPONENT_NUM,
} ljeTEXTURE_COMPONENT;

/* Texture swizzle modes. */
typedef enum _ljeTEXTURE_SWIZZLE {
    ljvTEXTURE_SWIZZLE_R = 0,
    ljvTEXTURE_SWIZZLE_G,
    ljvTEXTURE_SWIZZLE_B,
    ljvTEXTURE_SWIZZLE_A,
    ljvTEXTURE_SWIZZLE_0,
    ljvTEXTURE_SWIZZLE_1,

    ljvTEXTURE_SWIZZLE_INVALID,
} ljeTEXTURE_SWIZZLE;

typedef enum _ljeTEXTURE_SRGBDECODE {
    ljvTEXTURE_SRGB_INVALID = 0,
    ljvTEXTURE_DECODE,
    ljvTEXTURE_SKIP_DECODE,
} ljeTEXTURE_SRGBDECODE;

typedef enum _ljeTEXTURE_COMPARE_MODE {
    ljvTEXTURE_COMPARE_MODE_INVALID = 0,
    ljvTEXTURE_COMPARE_MODE_NONE,
    ljvTEXTURE_COMPARE_MODE_REF,
} ljeTEXTURE_COMPARE_MODE;

typedef enum _ljeTEXTURE_DS_MODE {
    ljvTEXTURE_DS_MODE_INVALID = 0,
    ljvTEXTURE_DS_MODE_DEPTH   = 1,
    ljvTEXTURE_DS_MODE_STENCIL = 2,
} ljeTEXTURE_DS_MODE;

typedef enum _ljeTEXTURE_DS_TEX_MODE {
    ljvTEXTURE_DS_TEXTURE_MODE_LUMINANCE = 0,
    ljvTEXTURE_DS_TEXTURE_MODE_INTENSITY,
    ljvTEXTURE_DS_TEXTURE_MODE_ALPHA,
    ljvTEXTURE_DS_TEXTURE_MODE_RED,

    ljvTEXTURE_DS_TEXTURE_MODE_INVALID,
} ljeTEXTURE_DS_TEX_MODE;

/* Texture stage */
typedef enum _ljeTEXTURE_STAGE {
    ljvTEXTURE_STAGE_INVALID = -1,
    ljvTEXTURE_STAGE_VS      = 0,
    ljvTEXTURE_STAGE_TCS,
    ljvTEXTURE_STAGE_TES,
    ljvTEXTURE_STAGE_GS,
    ljvTEXTURE_STAGE_FS,
    ljvTEXTURE_STAGE_CS,

    ljvTEXTURE_STAGE_LAST
} ljeTEXTURE_STAGE;

/* Pixel output swizzle modes. */
typedef enum _ljePIXEL_SWIZZLE {
    ljvPIXEL_SWIZZLE_R = ljvTEXTURE_SWIZZLE_R,
    ljvPIXEL_SWIZZLE_G = ljvTEXTURE_SWIZZLE_G,
    ljvPIXEL_SWIZZLE_B = ljvTEXTURE_SWIZZLE_B,
    ljvPIXEL_SWIZZLE_A = ljvTEXTURE_SWIZZLE_A,

    ljvPIXEL_SWIZZLE_INVALID,
} ljePIXEL_SWIZZLE;

/* Primitive types. */
typedef enum _ljePRIMITIVE {
    ljvPRIMITIVE_POINT_LIST,
    ljvPRIMITIVE_LINE_LIST,
    ljvPRIMITIVE_LINE_STRIP,
    ljvPRIMITIVE_LINE_LOOP,
    ljvPRIMITIVE_TRIANGLE_LIST,
    ljvPRIMITIVE_TRIANGLE_STRIP,
    ljvPRIMITIVE_TRIANGLE_FAN,
    ljvPRIMITIVE_RECTANGLE,
    ljvPRIMITIVE_LINES_ADJACENCY,
    ljvPRIMITIVE_LINE_STRIP_ADJACENCY,
    ljvPRIMITIVE_TRIANGLES_ADJACENCY,
    ljvPRIMITIVE_TRIANGLE_STRIP_ADJACENCY,
    ljvPRIMITIVE_PATCH_LIST,
} ljePRIMITIVE;

/* Index types. */
typedef enum _ljeINDEX_TYPE {
    ljvINDEX_8,
    ljvINDEX_16,
    ljvINDEX_32,
} ljeINDEX_TYPE;

/* Multi GPU rendering modes. */
typedef enum _ljeMULTI_GPU_RENDERING_MODE {
    ljvMULTI_GPU_RENDERING_MODE_OFF,
    ljvMULTI_GPU_RENDERING_MODE_SPLIT_WIDTH,
    ljvMULTI_GPU_RENDERING_MODE_SPLIT_HEIGHT,
    ljvMULTI_GPU_RENDERING_MODE_INTERLEAVED_64x64,
    ljvMULTI_GPU_RENDERING_MODE_INTERLEAVED_128x64,
    ljvMULTI_GPU_RENDERING_MODE_INTERLEAVED_128x128,
    ljvMULTI_GPU_RENDERING_MODE_INTERLEAVED,
    ljvMULTI_GPU_RENDERING_MODE_INVALID
} ljeMULTI_GPU_RENDERING_MODE;

typedef enum _ljeMACHINECODE {
    ljvMACHINECODE_ANTUTU0 = 0x0,

    ljvMACHINECODE_GLB27_RELEASE_0,

    ljvMACHINECODE_GLB25_RELEASE_0,
    ljvMACHINECODE_GLB25_RELEASE_1,

    ljvMACHINECODE_COUNT,

    /* flag as dynamic allocation for shader partial replace */
    ljvSHADER_SRC_PARTIAL_REPLACE,
} ljeMACHINECODE;

typedef enum _ljeUNIFORMCVT {
    ljvUNIFORMCVT_NONE = 0,
    ljvUNIFORMCVT_TO_BOOL,
    ljvUNIFORMCVT_TO_FLOAT,
} ljeUNIFORMCVT;

typedef enum _ljeHAL_ARG_VERSION {
    ljvHAL_ARG_VERSION_V1 = 0x0,
    ljvHAL_ARG_VERSION_V2,
} ljeHAL_ARG_VERSION;


/** endian mode  for each 2Bytes
 * endian mode                        endian
 *    mode0: 0  1  2  3  4  5  6  7  8  9  10  11  12  13  14  15
 *    mode1: 1  0  3  2  5  4  7  6  9  8  11  10  13  12  15  14
 *    mode2: 2  3  0  1  6  7  4  5  10  11  8  9  14  15  12  13
 *    mode3: 3  2  1  0  7  6  5  4  11  10  9  8  15  14  13  12
 *    mode4: 12  13  14  15  8  9  10  11  4  5  6  7  0  1  2  3
 *    mode5: 13  12  15  14  9  8  11  10  5  4  7  6  1  0  3  2
 *    mode6: 14  15  12  13  10  11  8  9  6  7  4  5  2  3  0  1
 *    mode7: 15  14  13  12  11  10  9  8  7  6  5  4  3  2  1  0
 **/
typedef enum _ljeENDIAN_MODE {
    ljvENDIAN_MODE0     = 0x0, /* endian mode0 */
    ljvENDIAN_MODE1     = 0x1, /* endian mode1 */
    ljvENDIAN_MODE2     = 0x2, /* endian mode2 */
    ljvENDIAN_MODE3     = 0x3, /* endian mode3 */
    ljvENDIAN_MODE4     = 0x4, /* endian mode4 */
    ljvENDIAN_MODE5     = 0x5, /* endian mode5 */
    ljvENDIAN_MODE6     = 0x6, /* endian mode6 */
    ljvENDIAN_MODE7     = 0x7, /* endian mode7 */
} ljeENDIAN_MODE;

typedef enum _ljeHW_FE_TYPE {
    ljvHW_FE_WAIT_LINK,
    ljvHW_FE_ASYNC,
    ljvHW_FE_MULTI_CHANNEL,
    ljvHW_FE_END,
} ljeHW_FE_TYPE;

typedef enum _ljeMCFE_CHANNEL_TYPE {
    ljvMCFE_CHANNEL_NONE = 0,
    ljvMCFE_CHANNEL_SYSTEM,
    ljvMCFE_CHANNEL_SHADER,
    ljvMCFE_CHANNEL_NN,
    ljvMCFE_CHANNEL_TP,

    ljvMCFE_CHANNEL_3DBLIT = 128,
} ljeMCFE_CHANNEL_TYPE;

typedef enum _ljePAGE_TYPE {
    ljvPAGE_TYPE_4K,
    ljvPAGE_TYPE_64K,
    ljvPAGE_TYPE_1M,
    ljvPAGE_TYPE_16M,
} ljePAGE_TYPE;

typedef enum _ljeAREA_TYPE {
    ljvAREA_TYPE_UNKNOWN = 0,
    ljvAREA_TYPE_FLATMAP,
    ljvAREA_TYPE_1M,
    ljvAREA_TYPE_4K,
} ljeAREA_TYPE;

typedef enum _lje2D_U8ToU10_CONVERSION_MODE
{
    ljvADD_LOWER_BITS,
    ljvNOT_ADD_LOWER_BITS,
    ljvNOT_ADD_HIGHER_BITS
} lje2D_U8ToU10_CONVERSION_MODE;

typedef enum _lje2D_NORMALIZATION_MODE
{
    ljvNORMALIZATION_STD_Z_SCORE,
    ljvNORMALIZATION_Z_SCORE,
    ljvNORMALIZATION_MIN_MAX,
} lje2D_NORMALIZATION_MODE;

typedef enum _lje2D_MULTICORE_MODE
{
    ljvMULTICORE_COMBINED_MODE = 0,
    ljvMULTICORE_INDEPENDENT_MODE
}lje2D_MULTICORE_MODE;

typedef enum _lje2D_MULTICORE_INDEX
{
    ljv2D_CORE_0 = 0,
    ljv2D_CORE_1,
    ljv2D_CORE_2,
    ljv2D_CORE_3,
}lje2D_MULTICORE_INDEX;

/* Available enumeration values that can be used to set 2D state */
typedef enum _lje2D_STATE_KEY
{
    ljvNORMALIZATION_ENABLE = 0,
    ljvNORMALIZATION_MODE,
    ljvNORMALIZATION_MAXMINRECIPROCAL,
    ljvNORMALIZATION_MINVALUE,
    ljvNORMALIZATION_MEANVALUE,
    ljvNORMALIZATION_STDRECIPROCAL,
    ljvQUANTIZATION_STEPRECIPROCAL,
    ljvQUANTIZATION_BYPASSSTEPQUANTIZATION,
    ljvUINT8_2_UINT10_CONVERSION_MODE,
    ljvMulticoreMode,

    ljvSTATE_TAIL,
} lje2D_STATE_KEY;

/*******************************************************************************
 ** Broadcast interface.
 */

typedef enum _ljeBROADCAST {
    /* GPU might be idle. */
    ljvBROADCAST_GPU_IDLE,

    /* A commit is going to happen. */
    ljvBROADCAST_GPU_COMMIT,

    /* GPU seems to be stuck. */
    ljvBROADCAST_GPU_STUCK,

    /* First process gets attached. */
    ljvBROADCAST_FIRST_PROCESS,

    /* Last process gets detached. */
    ljvBROADCAST_LAST_PROCESS,

    /* AXI bus error. */
    ljvBROADCAST_AXI_BUS_ERROR,

    /* Out of memory. */
    ljvBROADCAST_OUT_OF_MEMORY,
} ljeBROADCAST;

/* Notifications. */
typedef enum _ljeNOTIFY {
    ljvNOTIFY_INTERRUPT,
    ljvNOTIFY_COMMAND_QUEUE,
} ljeNOTIFY;

/* Flush flags. */
typedef enum _ljeKERNEL_FLUSH {
    ljvFLUSH_COLOR              = 0x01,
    ljvFLUSH_DEPTH              = 0x02,
    ljvFLUSH_TEXTURE            = 0x04,
    ljvFLUSH_2D                 = 0x08,
    ljvFLUSH_L2                 = 0x10,
    ljvFLUSH_TILE_STATUS        = 0x20,
    ljvFLUSH_ICACHE             = 0x40,
    ljvFLUSH_TXDESC             = 0x80,
    ljvFLUSH_FENCE              = 0x100,
    ljvFLUSH_VERTEX             = 0x200,
    ljvFLUSH_TFBHEADER          = 0x400,
    ljvFLUSH_ALL                = ljvFLUSH_COLOR
                                | ljvFLUSH_DEPTH
                                | ljvFLUSH_TEXTURE
                                | ljvFLUSH_2D
                                | ljvFLUSH_L2
                                | ljvFLUSH_TILE_STATUS
                                | ljvFLUSH_ICACHE
                                | ljvFLUSH_TXDESC
                                | ljvFLUSH_FENCE
                                | ljvFLUSH_VERTEX
                                | ljvFLUSH_TFBHEADER
} ljeKERNEL_FLUSH;

typedef enum _ljeCOUNTER {
    ljvCOUNTER_FRONT_END,
    ljvCOUNTER_VERTEX_SHADER,
    ljvCOUNTER_PRIMITIVE_ASSEMBLY,
    ljvCOUNTER_SETUP,
    ljvCOUNTER_RASTERIZER,
    ljvCOUNTER_PIXEL_SHADER,
    ljvCOUNTER_TEXTURE,
    ljvCOUNTER_PIXEL_ENGINE,
    ljvCOUNTER_MEMORY_CONTROLLER_COLOR,
    ljvCOUNTER_MEMORY_CONTROLLER_DEPTH,
    ljvCOUNTER_HOST_INTERFACE0,
    ljvCOUNTER_HOST_INTERFACE1,
    ljvCOUNTER_GPUL2_CACHE,
    ljvCOUNTER_COUNT
} ljeCOUNTER;

typedef enum _ljeProfilerClient {
    ljvCLIENT_OPENGLES11 = 1,
    ljvCLIENT_OPENGLES,
    ljvCLIENT_OPENGL,
    ljvCLIENT_OPENVG,
    ljvCLIENT_OPENCL,
    ljvCLIENT_OPENVX,
    ljvCLIENT_OPENVK,
} ljeProfilerClient;

typedef enum _ljeCOUNTER_OPTYPE {
    ljvCOUNTER_OP_DRAW      = 0,
    ljvCOUNTER_OP_BLT       = 1,
    ljvCOUNTER_OP_COMPUTE   = 2,
    ljvCOUNTER_OP_RS        = 3,
    ljvCOUNTER_OP_FINISH    = 4,
    ljvCOUNTER_OP_FRAME     = 5,
    ljvCOUNTER_OP_OPERATION = 6,
    ljvCOUNTER_OP_NONE      = 7
}
ljeCOUNTER_OPTYPE;

typedef enum _ljeProbeStatus {
    ljvPROBE_Disabled = 0,
    ljvPROBE_Paused   = 1,
    ljvPROBE_Enabled  = 2,
} ljeProbeStatus;

typedef enum _ljeProbeCmd {
    ljvPROBECMD_BEGIN  = 0,
    ljvPROBECMD_PAUSE  = 1,
    ljvPROBECMD_RESUME = 2,
    ljvPROBECMD_END    = 3,
} ljeProbeCmd;

/*******************************************************************************
 * Events. *********************************************************************
 */

typedef enum _halEventType {
    /* Keyboard event. */
    HAL_KEYBOARD,

    /* Mouse move event. */
    HAL_POINTER,

    /* Mouse button event. */
    HAL_BUTTON,

    /* Application close event. */
    HAL_CLOSE,

    /* Application window has been updated. */
    HAL_WINDOW_UPDATE
} halEventType;

/* Scancodes for keyboard. */
typedef enum _halKeys {
    HAL_UNKNOWN = -1,

    HAL_BACKSPACE = 0x08,
    HAL_TAB,
    HAL_ENTER  = 0x0D,
    HAL_ESCAPE = 0x1B,

    HAL_SPACE        = 0x20,
    HAL_SINGLEQUOTE  = 0x27,
    HAL_PAD_ASTERISK = 0x2A,
    HAL_COMMA        = 0x2C,
    HAL_HYPHEN,
    HAL_PERIOD,
    HAL_SLASH,
    HAL_0,
    HAL_1,
    HAL_2,
    HAL_3,
    HAL_4,
    HAL_5,
    HAL_6,
    HAL_7,
    HAL_8,
    HAL_9,
    HAL_SEMICOLON = 0x3B,
    HAL_EQUAL     = 0x3D,
    HAL_A         = 0x41,
    HAL_B,
    HAL_C,
    HAL_D,
    HAL_E,
    HAL_F,
    HAL_G,
    HAL_H,
    HAL_I,
    HAL_J,
    HAL_K,
    HAL_L,
    HAL_M,
    HAL_N,
    HAL_O,
    HAL_P,
    HAL_Q,
    HAL_R,
    HAL_S,
    HAL_T,
    HAL_U,
    HAL_V,
    HAL_W,
    HAL_X,
    HAL_Y,
    HAL_Z,
    HAL_LBRACKET,
    HAL_BACKSLASH,
    HAL_RBRACKET,
    HAL_BACKQUOTE = 0x60,

    HAL_F1 = 0x80,
    HAL_F2,
    HAL_F3,
    HAL_F4,
    HAL_F5,
    HAL_F6,
    HAL_F7,
    HAL_F8,
    HAL_F9,
    HAL_F10,
    HAL_F11,
    HAL_F12,

    HAL_LCTRL,
    HAL_RCTRL,
    HAL_LSHIFT,
    HAL_RSHIFT,
    HAL_LALT,
    HAL_RALT,
    HAL_CAPSLOCK,
    HAL_NUMLOCK,
    HAL_SCROLLLOCK,
    HAL_PAD_0,
    HAL_PAD_1,
    HAL_PAD_2,
    HAL_PAD_3,
    HAL_PAD_4,
    HAL_PAD_5,
    HAL_PAD_6,
    HAL_PAD_7,
    HAL_PAD_8,
    HAL_PAD_9,
    HAL_PAD_HYPHEN,
    HAL_PAD_PLUS,
    HAL_PAD_SLASH,
    HAL_PAD_PERIOD,
    HAL_PAD_ENTER,
    HAL_SYSRQ,
    HAL_PRNTSCRN,
    HAL_BREAK,
    HAL_UP,
    HAL_LEFT,
    HAL_RIGHT,
    HAL_DOWN,
    HAL_HOME,
    HAL_END,
    HAL_PGUP,
    HAL_PGDN,
    HAL_INSERT,
    HAL_DELETE,
    HAL_LWINDOW,
    HAL_RWINDOW,
    HAL_MENU,
    HAL_POWER,
    HAL_SLEEP,
    HAL_WAKE
} halKeys;

/*!
 * @brief Command codes between kernel module and TrustZone
 * @discussion
 * Critical services must be done in TrustZone to avoid sensitive content leak.
 * Most of kernel module is kept in non-Secure os to minimize code in TrustZone.
 */
typedef enum kernel_packet_command {
    KERNEL_START_COMMAND,
    KERNEL_SUBMIT,
    KERNEL_MAP_MEMORY, /* */
    KERNEL_UNMAP_MEMORY,
    KERNEL_ALLOCATE_SECRUE_MEMORY, /*! Security memory management. */
    KERNEL_FREE_SECURE_MEMORY,
    KERNEL_EXECUTE, /* Execute a command buffer. */
    KERNEL_DUMP_MMU_EXCEPTION,
    KERNEL_HANDLE_MMU_EXCEPTION,
    KERNEL_READ_MMU_EXCEPTION,
} kernel_packet_command_t;

enum {
    ljvTA_COMMAND_INIT,
    ljvTA_COMMAND_DISPATCH,

    ljvTA_CALLBACK_ALLOC_SECURE_MEM,
    ljvTA_CALLBACK_FREE_SECURE_MEM,
};

typedef enum {
    ljvFENCE_TYPE_READ          = 0x1,
    ljvFENCE_TYPE_WRITE         = 0x2,
    ljvFENCE_TYPE_ALL           = ljvFENCE_TYPE_READ | ljvFENCE_TYPE_WRITE,
    ljvFNECE_TYPE_INVALID       = 0x10000,
} ljeFENCE_TYPE;

typedef enum _ljeTLS_KEY {
    ljvTLS_KEY_EGL,
    ljvTLS_KEY_OPENGL_ES,
    ljvTLS_KEY_OPENVG,
    ljvTLS_KEY_OPENGL,
    ljvTLS_KEY_OPENCL,
    ljvTLS_KEY_OPENVX,

    ljvTLS_KEY_COUNT
} ljeTLS_KEY;

typedef enum _ljePLS_VALUE {
    ljePLS_VALUE_EGL_DISPLAY_INFO,
    ljePLS_VALUE_EGL_CONFIG_FORMAT_INFO,
    ljePLS_VALUE_EGL_DESTRUCTOR_INFO,
    ljePLS_VALUE_OPENCL_DESTRUCTOR_INFO,
} ljePLS_VALUE;

#if ljdENABLE_3D
/* Blending functions. */
typedef enum _ljeBLEND_FUNCTION {
    ljvBLEND_ZERO,
    ljvBLEND_ONE,
    ljvBLEND_SOURCE_COLOR,
    ljvBLEND_INV_SOURCE_COLOR,
    ljvBLEND_SOURCE_ALPHA,
    ljvBLEND_INV_SOURCE_ALPHA,
    ljvBLEND_TARGET_COLOR,
    ljvBLEND_INV_TARGET_COLOR,
    ljvBLEND_TARGET_ALPHA,
    ljvBLEND_INV_TARGET_ALPHA,
    ljvBLEND_SOURCE_ALPHA_SATURATE,
    ljvBLEND_CONST_COLOR,
    ljvBLEND_INV_CONST_COLOR,
    ljvBLEND_CONST_ALPHA,
    ljvBLEND_INV_CONST_ALPHA,
} ljeBLEND_FUNCTION;

/* Blending modes. */
typedef enum _ljeBLEND_MODE {
    ljvBLEND_ADD = 0,
    ljvBLEND_SUBTRACT,
    ljvBLEND_REVERSE_SUBTRACT,
    ljvBLEND_MIN,
    ljvBLEND_MAX,
    ljvBLEND_MULTIPLY,
    ljvBLEND_SCREEN,
    ljvBLEND_OVERLAY,
    ljvBLEND_DARKEN,
    ljvBLEND_LIGHTEN,
    ljvBLEND_COLORDODGE,
    ljvBLEND_COLORBURN,
    ljvBLEND_HARDLIGHT,
    ljvBLEND_SOFTLIGHT,
    ljvBLEND_DIFFERENCE,
    ljvBLEND_EXCLUSION,
    ljvBLEND_HSL_HUE,
    ljvBLEND_HSL_SATURATION,
    ljvBLEND_HSL_COLOR,
    ljvBLEND_HSL_LUMINOSITY,

    ljvBLEND_TOTAL
} ljeBLEND_MODE;

/* Depth modes. */
typedef enum _ljeDEPTH_MODE {
    ljvDEPTH_NONE,
    ljvDEPTH_Z,
    ljvDEPTH_W,
} ljeDEPTH_MODE;
#endif /* ljdENABLE_3D */

/* API flags. */
typedef enum _ljeAPI {
    ljvAPI_D3D = 1,
    ljvAPI_OPENGL_ES11,
    ljvAPI_OPENGL_ES20,
    ljvAPI_OPENGL_ES30,
    ljvAPI_OPENGL_ES31,
    ljvAPI_OPENGL_ES32,
    ljvAPI_OPENGL,
    ljvAPI_OPENVG,
    ljvAPI_OPENCL,
    ljvAPI_OPENVK,
    ljvAPI_EGL,
    ljvAPI_COUNT,
} ljeAPI;

typedef enum _ljeWHERE {
    ljvWHERE_COMMAND_PREFETCH = 0,
    ljvWHERE_COMMAND,
    ljvWHERE_RASTER,
    ljvWHERE_PIXEL,
    ljvWHERE_BLT,
} ljeWHERE;

typedef enum _ljeHOW {
    ljvHOW_SEMAPHORE            = 0x1,
    ljvHOW_STALL                = 0x2,
    ljvHOW_SEMAPHORE_STALL      = 0x3,
} ljeHOW;

typedef enum _ljeSignalHandlerType {
    ljvHANDLE_SIGFPE_WHEN_SIGNAL_CODE_IS_0 = 0x1,
} ljeSignalHandlerType;

typedef enum _ljeFILE_MODE {
    ljvFILE_CREATE = 0,
    ljvFILE_APPEND,
    ljvFILE_READ,
    ljvFILE_CREATETEXT,
    ljvFILE_APPENDTEXT,
    ljvFILE_READTEXT,
    ljvFILE_READWRITE,
} ljeFILE_MODE;

typedef enum _ljeFILE_WHENCE {
    ljvFILE_SEEK_SET,
    ljvFILE_SEEK_CUR,
    ljvFILE_SEEK_END
} ljeFILE_WHENCE;

/* Color format classes. */
typedef enum _ljeFORMAT_CLASS {
    ljvFORMAT_CLASS_RGBA = 4500,
    ljvFORMAT_CLASS_YUV,
    ljvFORMAT_CLASS_INDEX,
    ljvFORMAT_CLASS_LUMINANCE,
    ljvFORMAT_CLASS_BUMP,
    ljvFORMAT_CLASS_DEPTH,
    ljvFORMAT_CLASS_ASTC,
    ljvFORMAT_CLASS_COMPRESSED,
    ljvFORMAT_CLASS_OTHER,
    ljvFORMAT_CLASS_INTENSITY
} ljeFORMAT_CLASS;

/* Color format data type */
typedef enum _ljeFORMAT_DATATYPE {
    ljvFORMAT_DATATYPE_UNSIGNED_NORMALIZED,
    ljvFORMAT_DATATYPE_SIGNED_NORMALIZED,
    ljvFORMAT_DATATYPE_UNSIGNED_INTEGER,
    ljvFORMAT_DATATYPE_SIGNED_INTEGER,
    ljvFORMAT_DATATYPE_FLOAT16,
    ljvFORMAT_DATATYPE_FLOAT32,
    ljvFORMAT_DATATYPE_FLOAT_E5B9G9R9,
    ljvFORMAT_DATATYPE_FLOAT_B10G11R11F,
    ljvFORMAT_DATATYPE_INDEX,
    ljvFORMAT_DATATYPE_SRGB,
    ljvFORMAT_DATATYPE_FLOAT32_UINT,
} ljeFORMAT_DATATYPE;

typedef enum _ljeORIENTATION {
    ljvORIENTATION_TOP_BOTTOM,
    ljvORIENTATION_BOTTOM_TOP,
} ljeORIENTATION;

/* Special enums for width field in ljsFORMAT_COMPONENT. */
typedef enum _ljeCOMPONENT_CONTROL {
    ljvCOMPONENT_NOTPRESENT     = 0x00,
    ljvCOMPONENT_DONTCARE       = 0x80,
    ljvCOMPONENT_WIDTHMASK      = 0x7F,
    ljvCOMPONENT_ODD            = 0x80
} ljeCOMPONENT_CONTROL;

/* User option. */
typedef enum _ljeDEBUG_MSG {
    ljvDEBUG_MSG_NONE,
    ljvDEBUG_MSG_ERROR,
    ljvDEBUG_MSG_WARNING
} ljeDEBUG_MSG;

/* Compressed format now was defined same as dec400d, should be general. */
typedef enum _VIV_COMPRESS_FMT {
    _VIV_CFMT_ARGB8 = 0,
    _VIV_CFMT_XRGB8,
    _VIV_CFMT_AYUV,
    _VIV_CFMT_UYVY,
    _VIV_CFMT_YUY2,
    _VIV_CFMT_YUV_ONLY,
    _VIV_CFMT_UV_MIX,
    _VIV_CFMT_ARGB4,
    _VIV_CFMT_XRGB4,
    _VIV_CFMT_A1R5G5B5,
    _VIV_CFMT_X1R5G5B5,
    _VIV_CFMT_R5G6B5,
    _VIV_CFMT_Z24S8,
    _VIV_CFMT_Z24,
    _VIV_CFMT_Z16,
    _VIV_CFMT_A2R10G10B10,
    _VIV_CFMT_BAYER,
    _VIV_CFMT_SIGNED_BAYER,
    _VIV_CFMT_VAA16,
    _VIV_CFMT_S8,

    _VIV_CFMT_MAX,
} _VIV_COMPRESS_FMT;

typedef enum _ljePROGRAM_STAGE {
    ljvPROGRAM_STAGE_VERTEX         = 0x0,
    ljvPROGRAM_STAGE_TCS            = 0x1,
    ljvPROGRAM_STAGE_TES            = 0x2,
    ljvPROGRAM_STAGE_GEOMETRY       = 0x3,
    ljvPROGRAM_STAGE_GPIPE_COUNT    = 0x4,
    ljvPROGRAM_STAGE_FRAGMENT       = 0x4,
    ljvPROGRAM_STAGE_GRAPHICS_COUNT = 0x5,
    ljvPROGRAM_STAGE_COMPUTE        = 0x5,
    ljvPROGRAM_STAGE_OPENCL         = 0x6,
    ljvPROGRAM_STAGE_LAST
} ljePROGRAM_STAGE;

typedef enum _ljePROGRAM_STAGE_BIT {
    ljvPROGRAM_STAGE_VERTEX_BIT   = 1 << ljvPROGRAM_STAGE_VERTEX,
    ljvPROGRAM_STAGE_TCS_BIT      = 1 << ljvPROGRAM_STAGE_TCS,
    ljvPROGRAM_STAGE_TES_BIT      = 1 << ljvPROGRAM_STAGE_TES,
    ljvPROGRAM_STAGE_GEOMETRY_BIT = 1 << ljvPROGRAM_STAGE_GEOMETRY,
    ljvPROGRAM_STAGE_FRAGMENT_BIT = 1 << ljvPROGRAM_STAGE_FRAGMENT,
    ljvPROGRAM_STAGE_COMPUTE_BIT  = 1 << ljvPROGRAM_STAGE_COMPUTE,
    ljvPROGRAM_STAGE_OPENCL_BIT   = 1 << ljvPROGRAM_STAGE_OPENCL,
} ljePROGRAM_STAGE_BIT;

typedef enum _ljeBLIT_FLAG {
    ljvBLIT_FLAG_SKIP_DEPTH_WRITE   = 1 << 0,
    ljvBLIT_FLAG_SKIP_STENCIL_WRITE = 1 << 1,
} ljeBLIT_FLAG;

/* Clear flags. */
typedef enum _ljeCLEAR {
    ljvCLEAR_COLOR              = 0x1,
    ljvCLEAR_DEPTH              = 0x2,
    ljvCLEAR_STENCIL            = 0x4,
    ljvCLEAR_HZ                 = 0x8,
    ljvCLEAR_WITH_GPU_ONLY      = 0x100,
    ljvCLEAR_WITH_CPU_ONLY      = 0x200,
    ljvCLEAR_MULTI_SLICES       = 0x400,
} ljeCLEAR;

typedef enum _ljeBLIT_TYPE {
    ljvBLIT_DRAW_CLEAR          = 0,
    ljvBLIT_DRAW_BLIT           = 1,
    ljvBLIT_DRAW_BLIT_DEPTH     = 2,
    ljvBLIT_COMPUTE_BLIT        = 3,

    /* last number, not a real type */
    ljvBLIT_NUM_TYPE
} ljeBLIT_TYPE;

typedef enum _ljeSPLIT_DRAW_TYPE {
    ljvSPLIT_DRAW_UNKNOWN = 0x0,
    ljvSPLIT_DRAW_1,
    ljvSPLIT_DRAW_2,
    ljvSPLIT_DRAW_3,
    ljvSPLIT_DRAW_4,
    ljvSPLIT_DRAW_XFB,
    ljvSPLIT_DRAW_INDEX_FETCH,
    ljvSPLIT_DRAW_TCS,
    ljvSPLIT_DRAW_STIPPLE,
    ljvSPLIT_DRAW_WIDE_LINE,
    ljvSPLIT_DRAW_LINES_HW_ZERO_AREA_LINE_PATCH,
    ljvSPLIT_DRAW_LAST
} ljeSPLIT_DRAW_TYPE;

/* Blending targets. */
typedef enum _ljeBLEND_UNIT {
    ljvBLEND_SOURCE,
    ljvBLEND_TARGET,
} ljeBLEND_UNIT;

typedef enum _ljeXfbCmd {
    ljvXFBCMD_BEGIN             = 0,
    ljvXFBCMD_PAUSE             = 1,
    ljvXFBCMD_RESUME            = 2,
    ljvXFBCMD_END               = 3,
    ljvXFBCMD_PAUSE_INCOMMIT    = 4,
    ljvXFBCMD_RESUME_INCOMMIT   = 5,
    ljvXFBCMD_INVALID           = 6,
} ljeXfbCmd;

typedef enum _ljeXfbStatus {
    ljvXFB_Disabled = 0,
    ljvXFB_Paused,
    ljvXFB_Enabled,
} ljeXfbStatus;

typedef enum _ljeQueryStatus {
    ljvQUERY_Disabled       = 0,
    ljvQUERY_Paused         = 1,
    ljvQUERY_Enabled        = 2,
} ljeQueryStatus;

typedef enum _ljeQueryCmd {
    ljvQUERYCMD_BEGIN       = 0,
    ljvQUERYCMD_PAUSE       = 1,
    ljvQUERYCMD_RESUME      = 2,
    ljvQUERYCMD_END         = 3,
    ljvQUERYCMD_INVALID     = 4,
} ljeQueryCmd;

typedef enum _ljeQueryType {
    ljvQUERY_OCCLUSION      = 0,
    ljvQUERY_XFB_WRITTEN    = 1,
    ljvQUERY_PRIM_GENERATED = 2,
    ljvQUERY_TIME_ELAPSED   = 3,
    ljvQUERY_MAX_NUM        = 4,
} ljeQueryType;

/* Cube faces. */
typedef enum _ljeTEXTURE_FACE {
    ljvFACE_NONE = 0,
    ljvFACE_POSITIVE_X,
    ljvFACE_NEGATIVE_X,
    ljvFACE_POSITIVE_Y,
    ljvFACE_NEGATIVE_Y,
    ljvFACE_POSITIVE_Z,
    ljvFACE_NEGATIVE_Z,
} ljeTEXTURE_FACE;

typedef enum _ljeVERTEX_FORMAT {
    ljvVERTEX_BYTE,
    ljvVERTEX_UNSIGNED_BYTE,
    ljvVERTEX_SHORT,
    ljvVERTEX_UNSIGNED_SHORT,
    ljvVERTEX_INT,
    ljvVERTEX_UNSIGNED_INT,
    ljvVERTEX_FIXED,
    ljvVERTEX_HALF,
    ljvVERTEX_FLOAT,
    ljvVERTEX_DOUBLE,
    ljvVERTEX_UNSIGNED_INT_10_10_10_2,
    ljvVERTEX_INT_10_10_10_2,
    ljvVERTEX_UNSIGNED_INT_2_10_10_10_REV,
    ljvVERTEX_INT_2_10_10_10_REV,
    /* integer format */
    ljvVERTEX_INT8,
    ljvVERTEX_INT16,
    ljvVERTEX_INT32,
} ljeVERTEX_FORMAT;

/* What the SW converting scheme to create temp attrib */
typedef enum _ljeATTRIB_SCHEME {
    ljvATTRIB_SCHEME_KEEP = 0,
    ljvATTRIB_SCHEME_2_10_10_10_REV_TO_FLOAT,
    ljvATTRIB_SCHEME_BYTE_TO_IVEC4,
    ljvATTRIB_SCHEME_SHORT_TO_IVEC4,
    ljvATTRIB_SCHEME_INT_TO_IVEC4,
    ljvATTRIB_SCHEME_UBYTE_TO_UVEC4,
    ljvATTRIB_SCHEME_USHORT_TO_UVEC4,
    ljvATTRIB_SCHEME_UINT_TO_UVEC4,
    ljvATTRIB_SCHEME_DOUBLE_TO_FLOAT,
    ljvATTRIB_SCHEME_UBYTE_BGRA_TO_UBYTE_RGBA,
    ljvATTRIB_SCHEME_2_10_10_10_REV_BGRA_TO_FLOAT_RGBA,
} ljeATTRIB_SCHEME;

typedef enum _ljeBUFOBJ_TYPE {
    ljvBUFOBJ_TYPE_ARRAY_BUFFER         = 1,
    ljvBUFOBJ_TYPE_ELEMENT_ARRAY_BUFFER = 2,
    ljvBUFOBJ_TYPE_UNIFORM_BUFFER       = 3,
    ljvBUFOBJ_TYPE_DRAW_INDIRECT_BUFFER = 4,
    ljvBUFOBJ_TYPE_XFB_BUFFER           = 5,
    ljvBUFOBJ_TYPE_GENERIC_BUFFER       = 100

} ljeBUFOBJ_TYPE;

typedef enum _ljeBUFOBJ_USAGE {
    ljvBUFOBJ_USAGE_NONE                = 0x0,
    ljvBUFOBJ_USAGE_STREAM_DRAW         = 0x1,
    ljvBUFOBJ_USAGE_STREAM_READ         = 0x2,
    ljvBUFOBJ_USAGE_STREAM_COPY         = 0x3,
    ljvBUFOBJ_USAGE_STATIC_DRAW         = 0x4,
    ljvBUFOBJ_USAGE_STATIC_READ         = 0x5,
    ljvBUFOBJ_USAGE_STATIC_COPY         = 0x6,
    ljvBUFOBJ_USAGE_DYNAMIC_DRAW        = 0x7,
    ljvBUFOBJ_USAGE_DYNAMIC_READ        = 0x8,
    ljvBUFOBJ_USAGE_DYNAMIC_COPY        = 0x9,
    ljvBUFOBJ_USAGE_PROBE_COUTNER       = 0x10,

    /* Use 8bits to save the usage. */
    ljvBUFOBJ_USAGE_MASK =              0xFF,

    /* Some special flags. */
    /* special patch for optimaize performance,
     * no fence and duplicate stream to ensure data correct
     */
    ljvBUFOBJ_USAGE_FLAG_DISABLE_FENCE_DYNAMIC_STREAM   = 0x100,

    /* This buffer object is used by driver,
     * so we need to copy the data to the logical memory.
     */
    ljvBUFOBJ_USAGE_FLAG_DATA_USED_BY_DRIVER            = 0x200,
    /* Allocate video memory under 4GB. */
    ljvBUFOBJ_USAGE_FLAG_32BIT_VA                       = 0x400,
} ljeBUFOBJ_USAGE;

/**
 **  @ingroup ljoVG
 **
 **  @brief  Channel mask values.
 **
 **  This enumeration defines the values for channel mask used in image
 **  filtering.
 */

/******************************************************************************
 ******************************** VG Enumerations *****************************
 ******************************************************************************/

/**
 **  @ingroup ljoVG
 **
 **  @brief  Tiling mode for painting and imagig.
 **
 **  This enumeration defines the tiling modes supported by the HAL.  This is
 **  in fact a one-to-one mapping of the OpenVG 1.1 tile modes.
 */
typedef enum _ljeTILE_MODE {
    ljvTILE_FILL,
    ljvTILE_PAD,
    ljvTILE_REPEAT,
    ljvTILE_REFLECT
} ljeTILE_MODE;

/******************************************************************************/
/** @ingroup ljoVG
 **
 **  @brief  The different paint modes.
 **
 **  This enumeration lists the available paint modes.
 */
typedef enum _ljePAINT_TYPE {
    /** Solid color. */
    ljvPAINT_MODE_SOLID,

    /** Linear gradient. */
    ljvPAINT_MODE_LINEAR,

    /** Radial gradient. */
    ljvPAINT_MODE_RADIAL,

    /** Pattern. */
    ljvPAINT_MODE_PATTERN,

    /** Mode count. */
    ljvPAINT_MODE_COUNT
} ljePAINT_TYPE;

/**
 ** @ingroup ljoVG
 **
 **  @brief Types of path data supported by HAL.
 **
 **  This enumeration defines the types of path data supported by the HAL.
 **  This is in fact a one-to-one mapping of the OpenVG 1.1 path types.
 */
typedef enum _ljePATHTYPE {
    ljePATHTYPE_UNKNOWN = -1,
    ljePATHTYPE_INT8,
    ljePATHTYPE_INT16,
    ljePATHTYPE_INT32,
    ljePATHTYPE_FLOAT
} ljePATHTYPE;

/**
 ** @ingroup ljoVG
 **
 **  @brief Supported path segment commands.
 **
 **  This enumeration defines the path segment commands supported by the HAL.
 */
typedef enum _ljeVGCMD {
    ljvVGCMD_END, /*  0: 0x00           */
    ljvVGCMD_CLOSE, /*  1: 0x01         */
    ljvVGCMD_MOVE, /*  2: 0x02          */
    ljvVGCMD_MOVE_REL, /*  3: 0x03      */
    ljvVGCMD_LINE, /*  4: 0x04          */
    ljvVGCMD_LINE_REL, /*  5: 0x05      */
    ljvVGCMD_QUAD, /*  6: 0x06     */
    ljvVGCMD_QUAD_REL, /*  7: 0x07 */
    ljvVGCMD_CUBIC, /*  8: 0x08         */
    ljvVGCMD_CUBIC_REL, /*  9: 0x09     */
    ljvVGCMD_BREAK, /* 10: 0x0A         */
    ljvVGCMD_HLINE, /* 11: ******* R E S E R V E D *******/
    ljvVGCMD_HLINE_REL, /* 12: ******* R E S E R V E D *******/
    ljvVGCMD_VLINE, /* 13: ******* R E S E R V E D *******/
    ljvVGCMD_VLINE_REL, /* 14: ******* R E S E R V E D *******/
    ljvVGCMD_SQUAD, /* 15: ******* R E S E R V E D *******/
    ljvVGCMD_SQUAD_REL, /* 16: ******* R E S E R V E D *******/
    ljvVGCMD_SCUBIC, /* 17: ******* R E S E R V E D *******/
    ljvVGCMD_SCUBIC_REL, /* 18: ******* R E S E R V E D *******/
    ljvVGCMD_SCCWARC, /* 19: ******* R E S E R V E D *******/
    ljvVGCMD_SCCWARC_REL, /* 20: ******* R E S E R V E D *******/
    ljvVGCMD_SCWARC, /* 21: ******* R E S E R V E D *******/
    ljvVGCMD_SCWARC_REL, /* 22: ******* R E S E R V E D *******/
    ljvVGCMD_LCCWARC, /* 23: ******* R E S E R V E D *******/
    ljvVGCMD_LCCWARC_REL, /* 24: ******* R E S E R V E D *******/
    ljvVGCMD_LCWARC, /* 25: ******* R E S E R V E D *******/
    ljvVGCMD_LCWARC_REL, /* 26: ******* R E S E R V E D *******/

    /* The width of the command recognized by the hardware on bits. */
    ljvVGCMD_WIDTH = 5,

    /* Hardware command mask. */
    ljvVGCMD_MASK = (1 << ljvVGCMD_WIDTH) - 1,

    /* Command modifiers. */
    ljvVGCMD_H_MOD   = 1 << ljvVGCMD_WIDTH, /* =  32 */
    ljvVGCMD_V_MOD   = 2 << ljvVGCMD_WIDTH, /* =  64 */
    ljvVGCMD_S_MOD   = 3 << ljvVGCMD_WIDTH, /* =  96 */
    ljvVGCMD_ARC_MOD = 4 << ljvVGCMD_WIDTH, /* = 128 */

    /* Emulated LINE commands. */
    ljvVGCMD_HLINE_EMUL     = ljvVGCMD_H_MOD | ljvVGCMD_LINE, /* =  36 */
    ljvVGCMD_HLINE_EMUL_REL = ljvVGCMD_H_MOD | ljvVGCMD_LINE_REL, /* =  37 */
    ljvVGCMD_VLINE_EMUL     = ljvVGCMD_V_MOD | ljvVGCMD_LINE, /* =  68 */
    ljvVGCMD_VLINE_EMUL_REL = ljvVGCMD_V_MOD | ljvVGCMD_LINE_REL, /* =  69 */

    /* Emulated SMOOTH commands. */
    ljvVGCMD_SQUAD_EMUL      = ljvVGCMD_S_MOD | ljvVGCMD_QUAD, /* = 102 */
    ljvVGCMD_SQUAD_EMUL_REL  = ljvVGCMD_S_MOD | ljvVGCMD_QUAD_REL, /* = 103 */
    ljvVGCMD_SCUBIC_EMUL     = ljvVGCMD_S_MOD | ljvVGCMD_CUBIC, /* = 104 */
    ljvVGCMD_SCUBIC_EMUL_REL = ljvVGCMD_S_MOD | ljvVGCMD_CUBIC_REL, /* = 105 */

    /* Emulation ARC commands. */
    ljvVGCMD_ARC_LINE     = ljvVGCMD_ARC_MOD | ljvVGCMD_LINE, /* = 132 */
    ljvVGCMD_ARC_LINE_REL = ljvVGCMD_ARC_MOD | ljvVGCMD_LINE_REL, /* = 133 */
    ljvVGCMD_ARC_QUAD     = ljvVGCMD_ARC_MOD | ljvVGCMD_QUAD, /* = 134 */
    ljvVGCMD_ARC_QUAD_REL = ljvVGCMD_ARC_MOD | ljvVGCMD_QUAD_REL    /* = 135 */
} ljeVGCMD;
typedef enum _ljeVGCMD *ljeVGCMD_PTR;

/**
 **  @ingroup ljoVG
 **
 **  @brief  Blending modes supported by the HAL.
 **
 **  This enumeration defines the blending modes supported by the HAL.  This is
 **  in fact a one-to-one mapping of the OpenVG 1.1 blending modes.
 */
typedef enum _ljeVG_BLEND {
    ljvVG_BLEND_SRC,
    ljvVG_BLEND_SRC_OVER,
    ljvVG_BLEND_DST_OVER,
    ljvVG_BLEND_SRC_IN,
    ljvVG_BLEND_DST_IN,
    ljvVG_BLEND_MULTIPLY,
    ljvVG_BLEND_SCREEN,
    ljvVG_BLEND_DARKEN,
    ljvVG_BLEND_LIGHTEN,
    ljvVG_BLEND_ADDITIVE,
    ljvVG_BLEND_SUBTRACT,
    ljvVG_BLEND_FILTER
} ljeVG_BLEND;

/**
 **  @ingroup ljoVG
 **
 **  @brief  Image modes supported by the HAL.
 **
 **  This enumeration defines the image modes supported by the HAL.  This is
 **  in fact a one-to-one mapping of the OpenVG 1.1 image modes with the addition
 **  of NO IMAGE.
 */
typedef enum _ljeVG_IMAGE {
    ljvVG_IMAGE_NONE,
    ljvVG_IMAGE_NORMAL,
    ljvVG_IMAGE_MULTIPLY,
    ljvVG_IMAGE_STENCIL,
    ljvVG_IMAGE_FILTER
} ljeVG_IMAGE;

/**
 **  @ingroup ljoVG
 **
 **  @brief  Filter mode patterns and imaging.
 **
 **  This enumeration defines the filter modes supported by the HAL.
 */
typedef enum _ljeIMAGE_FILTER {
    ljvFILTER_POINT,
    ljvFILTER_LINEAR,
    ljvFILTER_BI_LINEAR
} ljeIMAGE_FILTER;

/**
 **  @ingroup ljoVG
 **
 **  @brief  Primitive modes supported by the HAL.
 **
 **  This enumeration defines the primitive modes supported by the HAL.
 */
typedef enum _ljeVG_PRIMITIVE {
    ljvVG_SCANLINE,
    ljvVG_RECTANGLE,
    ljvVG_TESSELLATED,
    ljvVG_TESSELLATED_TILED
} ljeVG_PRIMITIVE;

/**
 **  @ingroup ljoVG
 **
 **  @brief  Rendering quality modes supported by the HAL.
 **
 **  This enumeration defines the rendering quality modes supported by the HAL.
 */
typedef enum _ljeRENDER_QUALITY {
    ljvVG_NONANTIALIASED,
    ljvVG_2X2_MSAA,
    ljvVG_2X4_MSAA,
    ljvVG_4X4_MSAA
} ljeRENDER_QUALITY;

/**
 **  @ingroup ljoVG
 **
 **  @brief  Fill rules supported by the HAL.
 **
 **  This enumeration defines the fill rules supported by the HAL.
 */
typedef enum _ljeFILL_RULE { ljvVG_EVEN_ODD, ljvVG_NON_ZERO } ljeFILL_RULE;

/**
 **  @ingroup ljoVG
 **
 **  @brief  Cap styles supported by the HAL.
 **
 **  This enumeration defines the cap styles supported by the HAL.
 */
typedef enum _ljeCAP_STYLE { ljvCAP_BUTT, ljvCAP_ROUND, ljvCAP_SQUARE } ljeCAP_STYLE;

/**
 **  @ingroup ljoVG
 **
 **  @brief  Join styles supported by the HAL.
 **
 **  This enumeration defines the join styles supported by the HAL.
 */
typedef enum _ljeJOIN_STYLE {
    ljvJOIN_MITER,
    ljvJOIN_ROUND,
    ljvJOIN_BEVEL
} ljeJOIN_STYLE;

/* Base values for channel mask definitions. */
#define ljvCHANNEL_X (0)
#define ljvCHANNEL_R (1 << 0)
#define ljvCHANNEL_G (1 << 1)
#define ljvCHANNEL_B (1 << 2)
#define ljvCHANNEL_A (1 << 3)

typedef enum _ljeCHANNEL {
    ljvCHANNEL_XXXX = (ljvCHANNEL_X | ljvCHANNEL_X | ljvCHANNEL_X | ljvCHANNEL_X),
    ljvCHANNEL_XXXA = (ljvCHANNEL_X | ljvCHANNEL_X | ljvCHANNEL_X | ljvCHANNEL_A),
    ljvCHANNEL_XXBX = (ljvCHANNEL_X | ljvCHANNEL_X | ljvCHANNEL_B | ljvCHANNEL_X),
    ljvCHANNEL_XXBA = (ljvCHANNEL_X | ljvCHANNEL_X | ljvCHANNEL_B | ljvCHANNEL_A),

    ljvCHANNEL_XGXX = (ljvCHANNEL_X | ljvCHANNEL_G | ljvCHANNEL_X | ljvCHANNEL_X),
    ljvCHANNEL_XGXA = (ljvCHANNEL_X | ljvCHANNEL_G | ljvCHANNEL_X | ljvCHANNEL_A),
    ljvCHANNEL_XGBX = (ljvCHANNEL_X | ljvCHANNEL_G | ljvCHANNEL_B | ljvCHANNEL_X),
    ljvCHANNEL_XGBA = (ljvCHANNEL_X | ljvCHANNEL_G | ljvCHANNEL_B | ljvCHANNEL_A),

    ljvCHANNEL_RXXX = (ljvCHANNEL_R | ljvCHANNEL_X | ljvCHANNEL_X | ljvCHANNEL_X),
    ljvCHANNEL_RXXA = (ljvCHANNEL_R | ljvCHANNEL_X | ljvCHANNEL_X | ljvCHANNEL_A),
    ljvCHANNEL_RXBX = (ljvCHANNEL_R | ljvCHANNEL_X | ljvCHANNEL_B | ljvCHANNEL_X),
    ljvCHANNEL_RXBA = (ljvCHANNEL_R | ljvCHANNEL_X | ljvCHANNEL_B | ljvCHANNEL_A),

    ljvCHANNEL_RGXX = (ljvCHANNEL_R | ljvCHANNEL_G | ljvCHANNEL_X | ljvCHANNEL_X),
    ljvCHANNEL_RGXA = (ljvCHANNEL_R | ljvCHANNEL_G | ljvCHANNEL_X | ljvCHANNEL_A),
    ljvCHANNEL_RGBX = (ljvCHANNEL_R | ljvCHANNEL_G | ljvCHANNEL_B | ljvCHANNEL_X),
    ljvCHANNEL_RGBA = (ljvCHANNEL_R | ljvCHANNEL_G | ljvCHANNEL_B | ljvCHANNEL_A),
} ljeCHANNEL;

/* Defines the statistical data keys monitored by the statistics module */
typedef enum _ljeSTATISTICS {
    ljvFRAME_FPS    = 1,
} ljeSTATISTICS;

/* Value types. */
typedef enum _ljeVALUE_TYPE {
    ljvVALUE_UINT = 0x0,
    ljvVALUE_FIXED,
    ljvVALUE_FLOAT,
    ljvVALUE_INT,

    /*
     ** The value need be unsigned denormalized. clamp (0.0-1.0) should be done first.
     */
    ljvVALUE_FLAG_UNSIGNED_DENORM   = 0x00010000,

    /*
     ** The value need be signed denormalized. clamp (-1.0-1.0) should be done first.
     */
    ljvVALUE_FLAG_SIGNED_DENORM     = 0x00020000,

    /*
     ** The value need to gammar
     */
    ljvVALUE_FLAG_GAMMAR            = 0x00040000,

    /*
     ** The value need to convert from float to float16
     */
    ljvVALUE_FLAG_FLOAT_TO_FLOAT16  = 0x0080000,

    /*
     ** Mask for flag field.
     */
    ljvVALUE_FLAG_MASK = 0xFFFF0000,
} ljeVALUE_TYPE;

typedef enum _ljeTRACEMODE {
    ljvTRACEMODE_NONE       = 0,
    ljvTRACEMODE_FULL       = 1,
    ljvTRACEMODE_LOGGER     = 2,
    ljvTRACEMODE_ALLZONE    = 3,
    ljvTRACEMODE_PRE        = 4,
    ljvTRACEMODE_POST       = 5,
} ljeTRACEMODE;

typedef enum _ljeFFDUMP {
    ljvFF_DUMP_NONE         = 0x0,
    ljvFF_DUMP_IR           = 0x1,
    ljvFF_DUMP_INOUT        = 0x2,
    ljvFF_DUMP_UNIFORM      = 0x4,
    ljvFF_DUMP_ALL          = 0xF,
} ljeFFDUMP;

enum {
    /* GPU can't issue more that 32bit physical address */
    ljvPLATFORM_FLAG_LIMIT_4G_ADDRESS = 1 << 0,

    ljvPLATFORM_FLAG_IMX_MM           = 1 << 1,
};

#if ljdUSE_CAPBUF
typedef enum _ljeCAPBUF_META_TYPE {
    ljvCAPBUF_META_TYPE_BASE         = 0,
    ljvCAPBUF_META_TYPE_DRAW_ID,
    ljvCAPBUF_META_TYPE_SH_UNIFORM,
    ljvCAPBUF_META_TYPE_PPU_PARAMETERS,
    ljvCAPBUF_META_TYPE_VIP_SRAM_REMAP,
    ljvCAPBUF_META_TYPE_AXI_SRAM_REMAP,
    ljvCAPBUF_META_TYPE_IMAGE_PHYSICAL_ADDRESS,
    ljvCAPBUF_META_TYPE_IMAGE_PHYSICAL_ADDRESS_40BIT,
    ljvCAPBUF_META_TYPE_SH_INST_ADDRESS,
    ljvCAPBUF_META_TYPE_SH_UNIFORM_ARGS_LOCAL_ADDRESS_SPACE,
    ljvCAPBUF_META_TYPE_SH_UNIFORM_ARGS_CONSTANT_ADDRESS_SPACE,
    ljvCAPBUF_META_TYPE_NN_TP_INST_ADDRESS,
    ljvCAPBUF_META_TYPE_LOW32_OF_40BIT_PHY_ADDR,
    ljvCAPBUF_META_TYPE_GPU_SYNC_CMD,
    ljvCAPBUF_META_TYPE_SH_UNIFORM_ARGS_PRINTFADDRESS,
    ljvCAPBUF_META_TYPE_SH_UNIFORM_ARGS_MAXPRINTFADDRESS,
    /* Keep it at the end of the list. */
    ljvCAPBUF_META_TYPE_COUNT
} ljeCAPBUF_META_TYPE;

typedef enum _ljeCAPBUF_SH_UNIFROM_ARGS {
    ljvCAPBUF_SH_UNIFORM_ARGS_INVALID = 0,
    ljvCAPBUF_SH_UNIFORM_ARGS_IMAGE_PHYSICAL_ADDRESS,
    ljvCAPBUF_SH_UNIFORM_ARGS_IMAGE_PHYSICAL_ADDRESS_40BIT,
    ljvCAPBUF_SH_UNIFORM_ARGS_LOCAL_ADDRESS_SPACE,
    ljvCAPBUF_SH_UNIFORM_ARGS_LOCAL_ADDRESS_SPACE_COMBINE,
    ljvCAPBUF_SH_UNIFORM_ARGS_CONSTANT_ADDRESS_SPACE,
    ljvCAPBUF_SH_UNIFORM_ARGS_LOW32_OF_40BIT_PHY_ADDR,
    ljvCAPBUF_SH_UNIFORM_ARGS_LOW_HIGH_40BIT_PHY_ADDR,
    ljvCAPBUF_SH_UNIFORM_ARGS_PRINTFADDRESS,
    ljvCAPBUF_SH_UNIFORM_ARGS_MAXPRINTFADDRESS,

    /* add new uniform data source type by generate function, fix above type if need */

    /* uniform data generate by function ljfVX_LoadKernelArgValues */
    ljvCAPBUF_SH_UNIFORM_ARGS_40BIT_LOADKERNEL_IMAGE_ADDR,

    /* uniform data generate by function ljfVX_LoadKernelArgValues */
    ljvCAPBUF_SH_UNIFORM_ARGS_40BIT_VIRKERNEL_UNIFORMTABLE,

    /* Keep it at the end of the list. */
    ljvCAPBUF_SH_UNIFORM_ARGS_COUNT
} ljeCAPBUF_SH_UNIFORM_ARGS;

typedef enum _ljeCAPBUF_SH_UNIFORM_STATE_DATA_TYPE
{
    ljvCAPBUF_SH_UNIFORM_STATE_DATA_TYPE_INVALID = 0,
    ljvCAPBUF_SH_UNIFORM_STATE_DATA_TYPE_IMAGE_PHYSICAL_ADDRESS,
    ljvCAPBUF_SH_UNIFORM_STATE_DATA_TYPE_IMAGE_PHYSICAL_ADDRESS_40BIT_LOW,
    ljvCAPBUF_SH_UNIFORM_STATE_DATA_TYPE_IMAGE_PHYSICAL_ADDRESS_40BIT_HIGH,
    ljvCAPBUF_SH_UNIFORM_STATE_DATA_TYPE_IMAGE_PHYSICAL_ADDRESS_40BIT_HIGH1,
    ljvCAPBUF_SH_UNIFORM_STATE_DATA_TYPE_LOCAL_ADDRESS_SPACE,
    ljvCAPBUF_SH_UNIFORM_STATE_DATA_TYPE_CONSTANT_ADDRESS_SPACE,
    ljvCAPBUF_SH_UNIFORM_STATE_DATA_TYPE_LOW32_OF_40BIT_PHY_ADDR,
    ljvCAPBUF_SH_UNIFORM_STATE_DATA_TYPE_LOW_HIGH_40BIT_PHY_ADDR_LOW,
    ljvCAPBUF_SH_UNIFORM_STATE_DATA_TYPE_LOW_HIGH_40BIT_PHY_ADDR_HIGH,
    ljvCAPBUF_SH_UNIFORM_STATE_DATA_TYPE_PRINTFADDRESS,
    ljvCAPBUF_SH_UNIFORM_STATE_DATA_TYPE_MAXPRINTFADDRESS,
    /* Keep it at the end of the list. */
    ljvCAPBUF_SH_UNIFORM_STATE_DATA_TYPE_COUNT
} ljeCAPBUF_SH_UNIFORM_STATE_DATA_TYPE;

typedef enum _ljeCAPBUF_PPU_PARAMETERS_INDEX {
    ljvCAPBUF_PPU_GLOBAL_OFFSET_X = 0,
    ljvCAPBUF_PPU_GLOBAL_OFFSET_Y,
    ljvCAPBUF_PPU_GLOBAL_OFFSET_Z,
    ljvCAPBUF_PPU_GLOBAL_SCALE_X,
    ljvCAPBUF_PPU_GLOBAL_SCALE_Y,
    ljvCAPBUF_PPU_GLOBAL_SCALE_Z,
    ljvCAPBUF_PPU_GROUP_SIZE_X,
    ljvCAPBUF_PPU_GROUP_SIZE_Y,
    ljvCAPBUF_PPU_GROUP_SIZE_Z,
    ljvCAPBUF_PPU_GROUP_COUNT_X,
    ljvCAPBUF_PPU_GROUP_COUNT_Y,
    ljvCAPBUF_PPU_GROUP_COUNT_Z,
    ljvCAPBUF_PPU_PARAMETERS_COUNT
} ljeCAPBUF_PPU_GLOBALE_OFFSET_INDEX;

#endif

/* GL_VIV internal usage */
#ifndef GL_MAP_BUFFER_OBJ_VIV
#define GL_MAP_BUFFER_OBJ_VIV       0x10000
#endif

/* Command buffer usage. */
#define ljvCOMMAND_2D (1 << 0)
#define ljvCOMMAND_3D (1 << 1)

/* Default chip ID means chip ID same as core index. */
#define ljvCHIP_ID_DEFAULT              (~0U)

/* Tile status header size */
#ifndef ljvTS_FC_HEADER_SIZE
#define ljvTS_FC_HEADER_SIZE        128
#endif

/******************************************************************************
 ***************************** Object Declarations ****************************
 ******************************************************************************/
typedef struct _ljkCONTEXT            *ljkCONTEXT;
typedef struct _ljoCMDBUF             *ljoCMDBUF;

typedef struct _ljsSTATE_DELTA        *ljsSTATE_DELTA_PTR;
typedef struct _ljsQUEUE              *ljsQUEUE_PTR;
typedef struct _ljoQUEUE              *ljoQUEUE;
typedef struct _ljsHAL_INTERFACE      *ljsHAL_INTERFACE_PTR;
#if LJMICRO_PROFILER
typedef struct _ljsHAL_PROFILER_INTERFACE   *ljsHAL_PROFILER_INTERFACE_PTR;
#endif
typedef struct _ljs2D_PROFILE         *ljs2D_PROFILE_PTR;

#if ljdENABLE_VG
typedef struct _ljoVGHARDWARE         *ljoVGHARDWARE;
typedef struct _ljoVGBUFFER           *ljoVGBUFFER;
typedef struct _ljkVGHARDWARE         *ljkVGHARDWARE;
typedef struct _ljsVGCONTEXT          *ljsVGCONTEXT_PTR;
typedef struct _ljsVGCONTEXT_MAP      *ljsVGCONTEXT_MAP_PTR;
typedef struct _ljsVGCMDQUEUE         *ljsVGCMDQUEUE_PTR;
typedef struct _ljsTASK_MASTER_TABLE  *ljsTASK_MASTER_TABLE_PTR;
typedef struct _ljkVGKERNEL           *ljkVGKERNEL;
typedef void                          *ljtTHREAD;
#endif

#ifdef __cplusplus
}
#endif

#endif /* __lj_hal_enum_h_ */


