/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

#ifndef __lj_hal_shared_enum_h_
#define __lj_hal_shared_enum_h_

#ifdef __cplusplus
extern "C" {
#endif

/* Chip models. */
typedef enum _ljeCHIPMODEL {
    ljv200  = 0x0200,
    ljv300  = 0x0300,
    ljv320  = 0x0320,
    ljv328  = 0x0328,
    ljv350  = 0x0350,
    ljv355  = 0x0355,
    ljv400  = 0x0400,
    ljv410  = 0x0410,
    ljv420  = 0x0420,
    ljv428  = 0x0428,
    ljv450  = 0x0450,
    ljv500  = 0x0500,
    ljv520  = 0x0520,
    ljv530  = 0x0530,
    ljv600  = 0x0600,
    ljv620  = 0x0620,
    ljv700  = 0x0700,
    ljv800  = 0x0800,
    ljv820  = 0x0820,
    ljv860  = 0x0860,
    ljv880  = 0x0880,
    ljv900  = 0x0900,
    ljv1000 = 0x1000,
    ljv1500 = 0x1500,
    ljv2000 = 0x2000,
    ljv2100 = 0x2100,
    ljv2200 = 0x2200,
    ljv2500 = 0x2500,
    ljv3000 = 0x3000,
    ljv3120 = 0x3120,
    ljv4000 = 0x4000,
    ljv5000 = 0x5000,
    ljv5200 = 0x5200,
    ljv6400 = 0x6400,
    ljv7000 = 0x7000,
    ljv7400 = 0x7400,
    ljv8000 = 0x8000,
    ljv8400 = 0x8400,
    ljv8800 = 0x8800,
    ljv9100 = 0x9100,
    ljv9200 = 0x9200,
} ljeCHIPMODEL;

/* Chip features. */
typedef enum _ljeFEATURE {
    ljvFEATURE_PIPE_2D = 0,
    ljvFEATURE_PIPE_3D,
    ljvFEATURE_PIPE_VG,
    ljvFEATURE_DC,
    ljvFEATURE_HIGH_DYNAMIC_RANGE,
    ljvFEATURE_MODULE_CG,
    ljvFEATURE_MIN_AREA,
    ljvFEATURE_BUFFER_INTERLEAVING,
    ljvFEATURE_BYTE_WRITE_2D,
    ljvFEATURE_ENDIANNESS_CONFIG,
    ljvFEATURE_DUAL_RETURN_BUS,
    ljvFEATURE_DEBUG_MODE,
    ljvFEATURE_YUY2_RENDER_TARGET,
    ljvFEATURE_FRAGMENT_PROCESSOR,
    ljvFEATURE_2DPE20,
    ljvFEATURE_FAST_CLEAR,
    ljvFEATURE_YUV420_TILER,
    ljvFEATURE_YUY2_AVERAGING,
    ljvFEATURE_FLIP_Y,
    ljvFEATURE_EARLY_Z,
    ljvFEATURE_COMPRESSION,
    ljvFEATURE_MSAA,
    ljvFEATURE_SPECIAL_ANTI_ALIASING,
    ljvFEATURE_SPECIAL_MSAA_LOD,
    ljvFEATURE_422_TEXTURE_COMPRESSION,
    ljvFEATURE_DXT_TEXTURE_COMPRESSION,
    ljvFEATURE_ETC1_TEXTURE_COMPRESSION,
    ljvFEATURE_TX_ETC2_COMPRESSION,
    ljvFEATURE_CORRECT_TEXTURE_CONVERTER,
    ljvFEATURE_TEXTURE_8K,
    ljvFEATURE_SCALER,
    ljvFEATURE_YUV420_SCALER,
    ljvFEATURE_SHADER_HAS_W,
    ljvFEATURE_SHADER_HAS_SIGN,
    ljvFEATURE_SHADER_HAS_FLOOR,
    ljvFEATURE_SHADER_HAS_CEIL,
    ljvFEATURE_SHADER_HAS_SQRT,
    ljvFEATURE_SHADER_HAS_TRIG,
    ljvFEATURE_SH_SUPERSCALAR_ARCH,
    ljvFEATURE_HZ,
    ljvFEATURE_CORRECT_STENCIL,
    ljvFEATURE_VG20,
    ljvFEATURE_VG_FILTER,
    ljvFEATURE_VG21,
    ljvFEATURE_VG_DOUBLE_BUFFER,
    ljvFEATURE_VG_RESOLUTION_8K,
    ljvFEATURE_MC20,
    ljvFEATURE_SUPER_TILED,
    ljvFEATURE_FAST_CLEAR_FLUSH,
    ljvFEATURE_2D_FILTERBLIT_PLUS_ALPHABLEND,
    ljvFEATURE_2D_DITHER,
    ljvFEATURE_2D_A8_TARGET,
    ljvFEATURE_2D_A8_NO_ALPHA,
    ljvFEATURE_2D_FILTERBLIT_FULLROTATION,
    ljvFEATURE_2D_BITBLIT_FULLROTATION,
    ljvFEATURE_WIDE_LINE,
    ljvFEATURE_FC_FLUSH_STALL,
    ljvFEATURE_FULL_DIRECTFB,
    ljvFEATURE_HALF_FLOAT_PIPE,
    ljvFEATURE_LINE_LOOP,
    ljvFEATURE_2D_YUV_BLIT,
    ljvFEATURE_2D_TILING,
    ljvFEATURE_NON_POWER_OF_TWO,
    ljvFEATURE_3D_TEXTURE,
    ljvFEATURE_TEXTURE_ARRAY,
    ljvFEATURE_TILE_FILLER,
    ljvFEATURE_LOGIC_OP,
    ljvFEATURE_MIXED_STREAMS,
    ljvFEATURE_2D_MULTI_SOURCE_BLT,
    ljvFEATURE_END_EVENT,
    ljvFEATURE_VERTEX_10_10_10_2,
    ljvFEATURE_TEXTURE_10_10_10_2,
    ljvFEATURE_TEXTURE_ANISOTROPIC_FILTERING,
    ljvFEATURE_TEXTURE_FLOAT_HALF_FLOAT,
    ljvFEATURE_2D_ROTATION_STALL_FIX,
    ljvFEATURE_2D_MULTI_SOURCE_BLT_EX,
    ljvFEATURE_BUG_FIXES10,
    ljvFEATURE_2D_MINOR_TILING,
    ljvFEATURE_TEX_COMPRRESSION_SUPERTILED, /* Supertiled compressed textures are supported. */
    ljvFEATURE_FAST_MSAA,
    ljvFEATURE_BUG_FIXED_INDEXED_TRIANGLE_STRIP,
    ljvFEATURE_TEXTURE_TILE_STATUS_READ,
    ljvFEATURE_DEPTH_BIAS_FIX,
    ljvFEATURE_RECT_PRIMITIVE,
    ljvFEATURE_BUG_FIXES11,
    ljvFEATURE_SUPERTILED_TEXTURE,
    ljvFEATURE_2D_NO_COLORBRUSH_INDEX8,
    ljvFEATURE_RS_YUV_TARGET,
    ljvFEATURE_2D_FC_SOURCE, /* For tilestatus compression feature*/
    ljvFEATURE_2D_CC_NOAA_SOURCE,
    ljvFEATURE_PE_DITHER_FIX,
    ljvFEATURE_2D_YUV_SEPARATE_STRIDE,
    ljvFEATURE_FRUSTUM_CLIP_FIX,
    ljvFEATURE_TEXTURE_SWIZZLE,
    ljvFEATURE_PRIMITIVE_RESTART,
    ljvFEATURE_TEXTURE_LINEAR,
    ljvFEATURE_TEXTURE_YUV_ASSEMBLER,
    ljvFEATURE_LINEAR_RENDER_TARGET,
    ljvFEATURE_SHADER_HAS_ATOMIC,
    ljvFEATURE_SHADER_HAS_INSTRUCTION_CACHE,
    ljvFEATURE_SHADER_ENHANCEMENTS2,
    ljvFEATURE_BUG_FIXES7,
    ljvFEATURE_SHADER_HAS_RTNE,
    ljvFEATURE_SHADER_HAS_EXTRA_INSTRUCTIONS2,
    ljvFEATURE_SHADER_ENHANCEMENTS3,
    ljvFEATURE_DYNAMIC_FREQUENCY_SCALING,
    ljvFEATURE_SINGLE_BUFFER,
    ljvFEATURE_OCCLUSION_QUERY,
    ljvFEATURE_2D_GAMMA,
    ljvFEATURE_2D_COLOR_SPACE_CONVERSION,
    ljvFEATURE_2D_SUPER_TILE_VERSION,
    ljvFEATURE_HALTI0,
    ljvFEATURE_HALTI1,
    ljvFEATURE_HALTI2,
    ljvFEATURE_SUPPORT_GCREGTX,
    ljvFEATURE_2D_MIRROR_EXTENSION,
    ljvFEATURE_TEXTURE_ASTC,
    ljvFEATURE_TEXTURE_ASTC_DECODE_FIX,
    ljvFEATURE_TEXTURE_ASTC_BASE_LOD_FIX,
    ljvFEATURE_2D_SUPER_TILE_V1,
    ljvFEATURE_2D_SUPER_TILE_V2,
    ljvFEATURE_2D_SUPER_TILE_V3,
    ljvFEATURE_2D_MULTI_SOURCE_BLT_EX2,
    ljvFEATURE_NEW_RA,
    ljvFEATURE_BUG_FIXED_IMPLICIT_PRIMITIVE_RESTART,
    ljvFEATURE_PE_MULTI_RT_BLEND_ENABLE_CONTROL,
    ljvFEATURE_SMALL_MSAA, /* An upgraded version of Fast MSAA */
    ljvFEATURE_VERTEX_INST_ID_AS_ATTRIBUTE,
    ljvFEATURE_DUAL_16,
    ljvFEATURE_BRANCH_ON_IMMEDIATE_REG,
    ljvFEATURE_2D_COMPRESSION,
    ljvFEATURE_TPC_COMPRESSION,
    ljvFEATURE_TPCV11_COMPRESSION,
    ljvFEATURE_DEC_COMPRESSION,
    ljvFEATURE_DEC300_COMPRESSION,
    ljvFEATURE_DEC400_COMPRESSION,
    /*Its a new core for DEC400 compression*/
    ljvFEATURE_DEC400EX_COMPRESSION,
    ljvFEATURE_DEC_TPC_COMPRESSION,
    ljvFEATURE_DEC_COMPRESSION_TILE_NV12_8BIT,
    ljvFEATURE_DEC_COMPRESSION_TILE_NV12_10BIT,
    ljvFEATURE_2D_OPF_YUV_OUTPUT,
    ljvFEATURE_2D_FILTERBLIT_A8_ALPHA,
    ljvFEATURE_2D_MULTI_SRC_BLT_TO_UNIFIED_DST_RECT,
    ljvFEATURE_2D_MULTI_SRC_BLT_BILINEAR_FILTER,
    ljvFEATURE_2D_MULTI_SRC_BLT_1_5_ENHANCEMENT,
    ljvFEATURE_V2_COMPRESSION_Z16_FIX,
    ljvFEATURE_VERTEX_INST_ID_AS_INTEGER,
    ljvFEATURE_2D_YUV_MODE,
    ljvFEATURE_2D_CACHE_128B256BPERLINE,
    ljvFEATURE_2D_SEPARATE_CACHE,
    ljvFEATURE_2D_MAJOR_SUPER_TILE,
    ljvFEATURE_2D_V4COMPRESSION,
    ljvFEATURE_2D_VMSAA,
    ljvFEATURE_2D_10BIT_OUTPUT_LINEAR,
    ljvFEATURE_2D_YUV420_OUTPUT_LINEAR,
    ljvFEATURE_ACE,
    ljvFEATURE_NO_YUV420_SOURCE,/* unsupported source with three planes */
    ljvFEATURE_COLOR_COMPRESSION,
    ljvFEATURE_32BPP_COMPONENT_TEXTURE_CHANNEL_SWIZZLE,
    ljvFEATURE_64BPP_HW_CLEAR_SUPPORT,
    ljvFEATURE_TX_LERP_PRECISION_FIX,
    ljvFEATURE_COMPRESSION_V2,
    ljvFEATURE_MMU,
    ljvFEATURE_COMPRESSION_V3,
    ljvFEATURE_TX_DECOMPRESSOR,
    ljvFEATURE_MRT_TILE_STATUS_BUFFER,
    ljvFEATURE_COMPRESSION_V1,
    ljvFEATURE_V1_COMPRESSION_Z16_DECOMPRESS_FIX,
    ljvFEATURE_RTT,
    ljvFEATURE_GENERIC_ATTRIB,
    ljvFEATURE_2D_ONE_PASS_FILTER,
    ljvFEATURE_2D_ONE_PASS_FILTER_TAP,
    ljvFEATURE_2D_POST_FLIP,
    ljvFEATURE_2D_PIXEL_ALIGNMENT,
    ljvFEATURE_CORRECT_AUTO_DISABLE_COUNT,
    ljvFEATURE_CORRECT_AUTO_DISABLE_COUNT_WIDTH,
    ljvFEATURE_8K_RT,
    ljvFEATURE_HALTI3,
    ljvFEATURE_EEZ,
    ljvFEATURE_INTEGER_SIGNEXT_FIX,
    ljvFEATURE_PSOUTPUT_MAPPING,
    ljvFEATURE_8K_RT_FIX,
    ljvFEATURE_TX_TILE_STATUS_MAPPING,
    ljvFEATURE_SRGB_RT_SUPPORT,
    ljvFEATURE_TEXTURE_16K,
    ljvFEATURE_PA_FARZCLIPPING_FIX,
    ljvFEATURE_PE_DITHER_COLORMASK_FIX,
    ljvFEATURE_ZSCALE_FIX,
    ljvFEATURE_MULTI_PIXELPIPES,
    ljvFEATURE_PIPE_CL,
    ljvFEATURE_BUG_FIXES18,
    ljvFEATURE_UNIFIED_SAMPLERS,
    ljvFEATURE_CL_PS_WALKER,
    ljvFEATURE_NEW_HZ,
    ljvFEATURE_TX_FRAC_PRECISION_6BIT,
    ljvFEATURE_SH_INSTRUCTION_PREFETCH,
    ljvFEATURE_PROBE,
    ljvFEATURE_SINGLE_PIPE_HALTI1,
    ljvFEATURE_BUG_FIXES8, /* This HW feature is wrong, we can't use this to check integer branch!!!*/
    ljvFEATURE_2D_ALL_QUAD,
    ljvFEATURE_SEPARATE_SRC_DST,
    ljvFEATURE_TX_HOR_ALIGN_SEL,
    ljvFEATURE_HALTI4,
    ljvFEATURE_MRT_FC_FIX,
    ljvFEATURE_TESSELLATION,
    ljvFEATURE_DRAW_INDIRECT,
    ljvFEATURE_COMPUTE_INDIRECT,
    ljvFEATURE_MSAA_TEXTURE,
    ljvFEATURE_STENCIL_TEXTURE,
    ljvFEATURE_S8_ONLY_RENDERING,
    ljvFEATURE_D24S8_SAMPLE_STENCIL,
    ljvFEATURE_ADVANCED_BLEND_MODE_PART0,
    ljvFEATURE_RA_DEPTH_WRITE,
    ljvFEATURE_RS_DS_DOWNSAMPLE_NATIVE_SUPPORT,
    ljvFEATURE_S8_MSAA_COMPRESSION,
    ljvFEATURE_MSAA_FRAGMENT_OPERATION,
    ljvFEATURE_FE_START_VERTEX_SUPPORT,
    ljvFEATURE_DIVISOR_STREAM_ADDR_FIX,
    ljvFEATURE_ZERO_ATTRIB_SUPPORT,
    ljvFEATURE_DANGLING_VERTEX_FIX,
    ljvFEATURE_PE_DISABLE_COLOR_PIPE,
    ljvFEATURE_FE_12bit_stride,
    ljvFEATURE_TX_LOD_GUARDBAND,
    ljvFEATURE_HAS_PRODUCTID,
    ljvFEATURE_INTEGER32_FIX,
    ljvFEATURE_TEXTURE_GATHER,
    ljvFEATURE_IMG_INSTRUCTION,
    ljvFEATURE_HELPER_INVOCATION,
    ljvFEATURE_NO_USER_CSC,
    /* ANDROID_ONLY_REMOVED,remove some non-android features from lj520c:
     *     (1)Monochrome expansion.
     *     (2)Remove 3D compression and keep read tile status and tile input.
     *     (3)ROP2, ROP3, ROP4. Android only needs one solid color as source. Transparency by monochrome mask, pattern mask, src/dst color key, chroma key.
     *     (4)2x2 minor tile.
     *     (5)7 & 9 tap OPF.
     *     (6)User-defined CSC.
     *     (7)MultiSrc walker v1.5.
     *     (8)SuperTile V1.
     *     (9)Big endian.
     */
    ljvFEATURE_ANDROID_ONLY_REMOVED,
    ljvFEATURE_V2_MSAA_COHERENCY_FIX,
    ljvFEATURE_BLOCK_SIZE_16x16,
    ljvFEATURE_TX_SUPPORT_DEC,
    ljvFEATURE_RSBLT_MSAA_DECOMPRESSION,
    ljvFEATURE_TILEFILLER_32TILE_ALIGNED,
    ljvFEATURE_GEOMETRY_SHADER,
    ljvFEATURE_HALTI5,
    ljvFEATURE_PIPELINE_32_ATTRIBUTES,
    ljvFEATURE_USC,
    ljvFEATURE_CUBEMAP_ARRAY,
    ljvFEATURE_TX_DESCRIPTOR,
    ljvFEATURE_SEPARATE_RT_CTRL,
    ljvFEATURE_RENDER_ARRAY,
    ljvFEATURE_BLT_ENGINE,
    ljvFEATURE_TEXTURE_BUFFER,
    ljvFEATURE_GS_SUPPORT_EMIT,
    ljvFEATURE_SAMPLER_BASE_OFFSET,
    ljvFEATURE_IMAGE_OUT_BOUNDARY_FIX,
    ljvFEATURE_TX_BORDER_CLAMP,
    ljvFEATURE_MSAA_SHADING,
    ljvFEATURE_ADVANCED_SH_INST,
    ljvFEATURE_LOD_FIX_FOR_BASELEVEL,
    ljvFEATURE_MULTIDRAW_INDIRECT,
    ljvFEATURE_DRAW_ELEMENTS_BASE_VERTEX,
    ljvFEATURE_NEW_STEERING_AND_ICACHE_FLUSH, /* Steering base on register base. Trigger-style Icache flush state. */
    ljvFEATURE_PE_DITHER_FIX2,
    ljvFEATURE_INDEX_FETCH_FIX,
    ljvFEATURE_TEX_BASELOD,
    ljvFEATURE_TEX_SEAMLESS_CUBE,
    ljvFEATURE_TEX_ETC2,
    ljvFEATURE_TEX_CUBE_BORDER_LOD,
    ljvFEATURE_FE_ALLOW_STALL_PREFETCH_ENG,
    ljvFEATURE_TX_8BPP_TS_FIX,
    ljvFEATURE_HW_TFB,
    ljvFEATURE_HW_TFB_PERF_FIX,
    ljvFEATURE_COMPRESSION_V4,
    ljvFEATURE_FENCE_32BIT,
    ljvFEATURE_FENCE_64BIT,
    ljvFEATURE_R8_UNORM,
    ljvFEATURE_TX_DEFAULT_VALUE_FIX,
    ljvFEATURE_TX_8bit_UVFrac,
    ljvFEATURE_TX_MIPFILTER_NONE_FIX,
    ljvFEATURE_MC_STENCIL_CTRL,
    ljvFEATURE_DEPTH_MATH_FIX,
    ljvFEATURE_PE_B2B_PIXEL_FIX,
    ljvFEATURE_TEXTURE_GATHER_OFFSETS,
    ljvFEATURE_TEX_CACHE_FLUSH_FIX,
    ljvFEATURE_WIDELINE_HELPER_FIX,
    ljvFEATURE_LINE_DIAMOND_RULE_FIX,
    ljvFEATURE_MULTIGPU_SYNC_V2,
    ljvFEATURE_DRAW_ID,
    ljvFEATURE_SNAPPAGE_CMD,
    ljvFEATURE_COMMAND_PREFETCH,
    ljvFEATURE_SAMPLEPOS_SWIZZLE_FIX,
    ljvFEATURE_SELECTMAP_SRC0_SWIZZLE_FIX,
    ljvFEATURE_LOADATTR_OOB_FIX,
    ljvFEATURE_RA_DEPTH_WRITE_MSAA1X_FIX,
    ljvFEATURE_MRT_8BIT_DUAL_PIPE_FIX,
    ljvFEATURE_BUG_FIXES1,
    ljvFEATURE_MULTI_SOURCE_BLT,
    ljvFEATURE_ZCOMPRESSION,
    ljvFEATURE_DITHER_AND_FILTER_PLUS_ALPHA_2D,
    ljvFEATURE_ONE_PASS_2D_FILTER,
    ljvFEATURE_TX_FILTER,
    ljvFEATURE_CHIPENABLE_LINK,
    ljvFEATURE_TEXTURE_BIAS_LOD_FIX,
    ljvFEATURE_USE_GL_Z,
    ljvFEATURE_SUPPORT_INTEGER,
    /* PARTLY_SUPPORT_INTEGER_BRANCH:
     *      chips can support all integer types for compare instructions, e.g, CMP, SELECT.
     * FULLLY_SUPPORT_INTEGER_BRANCH:
     *      chips can support all integer types for JMP instruction.
     * If PARTLY_SUPPORT_INTEGER_BRANCH is TRUE but FULLLY_SUPPORT_INTEGER_BRANCH is FALSE,
     * then this chip can only support INT32/UINT32 JMP instruction.
     */
    ljvFEATURE_PARTLY_SUPPORT_INTEGER_BRANCH,
    ljvFEATURE_FULLLY_SUPPORT_INTEGER_BRANCH,
    ljvFEATURE_SUPPORT_INTEGER_ATTRIBUTE,
    ljvFEATURE_SUPPORT_MOVAI,
    ljvFEATURE_NEED_FIX_FOR_CL_X,
    ljvFEATURE_NEED_FIX_FOR_CL_XE,
    ljvFEATURE_HAS_OUTPUT_COUNT_FIX,
    ljvFEATURE_VARYING_PACKING_LIMITATION,
    ljvFEATURE_HIGHP_VARYING_SHIFT,
    ljvFEATURE_BUG_FIXES2,
    ljvFEATURE_64K_L2_CACHE,
    ljvFEATURE_128BTILE,
    ljvFEATURE_ADVANCED_BLEND_OPT,
    ljvFEATURE_SNAPPAGE_CMD_FIX,
    ljvFEATURE_L2_CACHE_FOR_2D_420,
    ljvFEATURE_TILE_STATUS_2BITS,
    ljvFEATURE_EXTRA_SHADER_INSTRUCTIONS0,
    ljvFEATURE_EXTRA_SHADER_INSTRUCTIONS1,
    ljvFEATURE_EXTRA_SHADER_INSTRUCTIONS2,
    ljvFEATURE_MEDIUM_PRECISION,
    ljvFEATURE_FE20_BIT_INDEX,
    ljvFEATURE_BUG_FIXES4,
    ljvFEATURE_BUG_FIXES12,
    ljvFEATURE_VMSAA,
    ljvFEATURE_ROBUST_ATOMIC,
    ljvFEATURE_32F_COLORMASK_FIX,
    ljvFEATURE_NEW_GPIPE,
    ljvFEATURE_RS_NEW_BASEADDR,
    ljvFEATURE_TX_DXT,
    ljvFEATURE_SH_FLAT_INTERPOLATION_DUAL16_FIX,
    ljvFEATURE_EVIS,
    ljvFEATURE_SH_SUPPORT_V4,
    ljvFEATURE_SH_SUPPORT_ALPHA_KILL,
    ljvFEATURE_PE_NO_ALPHA_TEST,
    ljvFEATURE_SH_SNAP2PAGE_MAXPAGES_FIX,
    ljvFEATURE_USC_FULLCACHE_FIX,
    ljvFEATURE_PE_64bit_FENCE_FIX,
    ljvFEATURE_BLT_8bit_256TILE_FC_FIX,
    ljvFEATURE_PE_RGBA16I_FIX,
    ljvFEATURE_BLT_64bpp_MASKED_CLEAR_FIX,
    ljvFEATURE_SH_PSO_MSAA1x_FIX,
    ljvFEATURE_USC_ATOMIC_FIX,
    ljvFEATURE_INDEX_CONST_ON_B0,
    ljvFEATURE_SH_NO_ONECONST_LIMIT,
    ljvFEATURE_EVIS_NO_ABSDIFF,
    ljvFEATURE_EVIS_NO_BITREPLACE,
    ljvFEATURE_EVIS_NO_BOXFILTER,
    ljvFEATURE_EVIS_NO_CORDIAC,
    ljvFEATURE_EVIS_NO_DP32,
    ljvFEATURE_EVIS_NO_FILTER,
    ljvFEATURE_EVIS_NO_IADD,
    ljvFEATURE_EVIS_NO_SELECTADD,
    ljvFEATURE_EVIS_LERP_7OUTPUT,
    ljvFEATURE_EVIS_ACCSQ_8OUTPUT,
    ljvFEATURE_ROBUSTNESS,
    ljvFEATURE_SECURITY,
    ljvFEATURE_TX_YUV_ASSEMBLER_10BIT,
    ljvFEATURE_USC_GOS_ADDR_FIX,
    ljvFEATURE_SUPPORT_MSAA2X,
    ljvFEATURE_TX_DESC_CACHE_CLOCKGATE_FIX,
    ljvFEATURE_TX_INTEGER_COORDINATE,
    ljvFEATURE_PSIO_SAMPLEMASK_IN_R0ZW_FIX,
    ljvFEATURE_MULTI_CORE_BLOCK_SET_CONFIG,
    ljvFEATURE_SH_IMG_LDST_ON_TEMP,
    ljvFEATURE_TX_INTEGER_COORDINATE_V2,
    ljvFEATURE_COMPUTE_ONLY,
    ljvFEATURE_SH_IMG_LDST_CLAMP,
    ljvFEATURE_SH_ICACHE_ALLOC_COUNT_FIX,
    ljvFEATURE_MSAA_OQ_FIX,
    ljvFEATURE_PE_ENHANCEMENTS2,
    ljvFEATURE_PSIO_MSAA_CL_FIX,
    ljvFEATURE_FE_NEED_DUMMYDRAW,
    ljvFEATURE_MULTI_CLUSTER,
    ljvFEATURE_PSIO_INTERLOCK,
    ljvFEATURE_BLIT_COMPRESS_DEST,
    ljvFEATURE_SH_MULTI_WG_PACK,
    ljvFEATURE_FE_ROBUST_FIX,
    ljvFEATURE_TX_ASTC_MULTISLICE_FIX,
    ljvFEATURE_PSIO_DUAL16_32bpc_FIX,
    ljvFEATURE_LS_SUPPORT_PER_COMP_DEPENDENCY,
    ljvFEATURE_COMPRESSION_DEC400,
    ljvFEATURE_SH_TEXLD_U_FIX,
    ljvFEATURE_TX_FLUSH_L1CACHE,
    ljvFEATURE_USC_DEFER_FILL_FIX,
    ljvFEATURE_MC_FCCACHE_BYTEMASK,
    ljvFEATURE_SH_MULTI_WG_PACK_FIX,
    ljvFEATURE_FE_PATCHLIST_FETCH_FIX,
    ljvFEATURE_RA_CG_FIX,
    ljvFEATURE_EVIS_VX2,
    ljvFEATURE_SH_HALF_DEPENDENCY_FIX,
    ljvFEATURE_FE_BASEINSTANCE,
    ljvFEATURE_FE_COMPUREINDIRECT_SKIP_UNIFORM,
    ljvFEATURE_SH_CLOCK_GATE_FIX,
    ljvFEATURE_GPIPE_CLOCK_GATE_FIX,
    ljvFEATURE_TP_ENGINE,
    ljvFEATURE_TX_BORDER_CLAMP_FIX,
    ljvFEATURE_SH_IMAGE_LD_LAST_PIXEL_FIX,
    ljvFEATURE_MULTI_CORE_BLOCK_SET_CONFIG2,
    ljvFEATURE_MULTIGPU_SYNC_V3,
    ljvFEATURE_PE_VMSAA_COVERAGE_CACHE_FIX,
    ljvFEATURE_SECURITY_AHB,
    ljvFEATURE_TX_LERP_LESS_BIT,
    ljvFEATURE_SMALL_BATCH,
    ljvFEATURE_SH_IDIV0_SWZL_EHS,
    ljvFEATURE_SH_CMPLX,
    ljvFEATURE_VIP_V7,
    ljvFEATURE_SH_GM_ENDIAN,
    ljvFEATURE_SH_GM_USC_UNALLOC,
    ljvFEATURE_SH_END_OF_BB,
    ljvFEATURE_ASYNC_BLIT,
    ljvFEATURE_ASYNC_FE_FENCE_FIX,
    ljvFEATURE_PSCS_THROTTLE,
    ljvFEATURE_SEPARATE_LS,
    ljvFEATURE_PA_VARYING_COMPONENT_TOGGLE_FIX,
    ljvFEATURE_TX_MULTISAMPLER_FC_FIX,
    ljvFEATURE_WIDELINE_TRIANGLE_EMU,
    ljvFEATURE_FENCE,
    ljvFEATURE_MCFE,
    ljvFEATURE_NN_INTERLEAVE8,
    ljvFEATURE_TP_REORDER,
    ljvFEATURE_TP_RTNE,
    ljvFEATURE_TP_LRN,
    ljvFEATURE_TP_ROI_POOLING,
    ljvFEATURE_TP_MAX_POOLING_STRIDE1,
    ljvFEATURE_NN_BRICK_MODE,
    ljvFEATURE_NN_BORDER_MODE,
    ljvFEATURE_NN_FP16_ALU,
    ljvFEATURE_NN_BF16_ALU,
    ljvFEATURE_NN_INT16_ALU,
    ljvFEATURE_NN_ZDP3,
    ljvFEATURE_NN_ZDP6,
    ljvFEATURE_PE_DEPTH_ONLY_OQFIX,
    ljvFEATURE_TX_SNORM_SUPPORT,
    ljvFEATURE_HWMANAGED_LS,
    ljvFEATURE_SH_SCATTER_GATHER,
    ljvFEATURE_NN_POWER_ISOLATION,
    ljvFEATURE_SWTILING_PHASE1,
    ljvFEATURE_SWTILING_PHASE2,
    ljvFEATURE_SWTILING_PHASE3,
    ljvFEATURE_TF_QUANTIZATION,
    ljvFEATURE_NN_XYDP9,
    ljvFEATURE_TP_SIMPLE_INT16,
    ljvFEATURE_TP_REAL_INT16,
    ljvFEATURE_NN_FIRST_PIXEL_POOLING,
    ljvFEATURE_NN_STRIDE_SUPPORT,
    ljvFEATURE_NN_XYDP6,
    ljvFEATURE_NN_XYDP0,
    ljvFEATURE_TP_REORDER_FIX,
    ljvFEATURE_NN_CONV1x1_PERF_FIX,
    ljvFEATURE_NN_CACHELINE_MODE_PERF_FIX,
    ljvFEATURE_NN_PER3DTILE_BUBBLE_FIX,
    ljvFEATURE_SH_IO_CG_FIX,
    ljvFEATURE_USC_STAY_LRU,
    ljvFEATURE_NN_NONZERO_MIRROR_BORDER,
    ljvFEATURE_NN_COEF_DECOMPRESS_PERF2X,
    ljvFEATURE_4BIT_INPUT,
    ljvFEATURE_COEF_COMPRESSION_ENHANCEMENT,
    ljvFEATURE_NN_ZDP3_NO_COMPRESS_FIX,
    ljvFEATURE_NN_ASYNC_COPY_PERF_FIX,
    ljvFEATURE_OCB_COUNTER,
    ljvFEATURE_NN_ZXDP3_KERNEL_READ_CONFLICT_FIX,
    ljvFEATURE_NN_FULLCACHE_KERNEL_INTERLEAVE_FIX,
    ljvFEATURE_DR_JD_DIFF_CONDITION_FOR_CACHELINE_MODE_PRE_FIX,
    ljvFEATURE_USC_BOTTLENECK_FIX,
    ljvFEATURE_OCB_REMAP_PHYSICAL_ADDRESS,
    ljvFEATURE_BIT_NN_HW_LIMITATION_NATIVE_KER_1x2_2x1,
    ljvFEATURE_NN_SLICE_PADDING_TO_64BYTE_ALIGN,
    ljvFEATURE_NN_DW_1x1_CONV_MERGE,
    ljvFEATURE_TP_REORDER_LAYER_SUSPEND_FIX,
    ljvFEATURE_KERNEL_VIP_SRAM_READ_BW_LIMITATION_FIX,
    ljvFEATURE_IMG_POP_PIPELINE_PAUSE_FIX,
    ljvFEATURE_NN_SLOW_OUTPUT,
    ljvFEATURE_NO_NARROW_POST_PROCESS_PIPE,
    ljvFEATURE_TP_NN_PROBE,
    ljvFEATURE_TP_23BITS_POST_MULTIPLIER,
    ljvFEATURE_NN_TRANSPOSE,
    ljvFEATURE_OUTIMAGE_X_BITWIDTH_LIMIT_FOR_NN_TRANSPOSE_FIX,
    ljvFEATURE_TP_BFLOAT16,
    ljvFEATURE_EVIS2_FLOP_RESET_FIX,
    ljvFEATURE_USC_ASYNC_CP_RTN_FLOP_RESET_FIX,
    ljvFEATURE_USC_EVICT_CTRL_FIFO_FLOP_RESET_FIX,
    ljvFEATURE_NEGATIVE_POST_SHIFT_FIX,
    ljvFEATURE_NN_COMMAND_KERNEL_REQUEST_CONFICT_FIX,
    ljvFEATURE_NN_LEAKY_RELU,
    ljvFEATURE_NN_PRELU,
    ljvFEATURE_NN_NATIVE_STRIDE_TWO,
    ljvFEATURE_BIT_NN_SUPPORT_CONV1x1_AND_NATIVE_CONV_STRIDE2,
    ljvFEATURE_NN_TENSOR_ADD,

    ljvFEATURE_IMAGE_LS_NO_FULLMASK_FIX,
    ljvFEATURE_BLT_YUV_OUTPUT,
    ljvFEATURE_PE_TILE_CACHE_FLUSH_FIX,
    ljvFEATURE_SH_ROBUSTNESS_FIX,
    ljvFEATURE_USC_ATOMIC_FIX2,
    ljvFEATURE_MULTIVIEW_RENDER,
    ljvFEATURE_FE_DRAW_DIRECT,
    ljvFEATURE_TX_VKBORDER_MODE,
    ljvFEATURE_TX_UNNORMALIZED_COORD,
    ljvFEATURE_VG_IMAGE_16K,
    ljvFEATURE_MULTICORE_CONFIG,
    ljvFEATURE_PA_LINECLIP_FIX,
    ljvFEATURE_NN_ENGINE,
    ljvFEATURE_NN_ASYNC_COPY_MERGE_FIX,
    ljvFEATURE_NN_CONVOUT_FIFO_DEPTH_FIX,
    ljvFEATURE_NN_SMALLBATCH_PHASE1,
    ljvFEATURE_TP_SMALLBATCH_PHASE1,
    ljvFEATURE_VIP_SCALER,
    ljvFEATURE_VIP_SCALER_4K,
    ljvFEATURE_TX_8bit_UVFrac_ROUNDING_FIX,
    ljvFEATURE_NN_REQ_SLOWARBITRATION_FIX,
    ljvFEATUER_IMAGE_PARTIAL_CACHE,
    ljvFEATURE_FULLCACHE_KERNELHEAD_FIX,
    ljvFEATURE_NN_SINGLEPORT_ACCUMBUFFER,
    ljvFEATURE_NN_SMALLBATCH,
    ljvFEATURE_TP_SMALLBATCH,
    ljvFEATURE_NN_ZDP_INIMAGE_SIZE_FIX,
    ljvFEATURE_HI_REORDER_FIX,
    ljvFEATURE_TP_COEF_COMPRESSION_ENHANCEMENT,
    ljvFEATURE_NN_DEPTHWISE_SUPPORT,
    ljvFEATURE_IMAGE_NOT_PACKED_IN_SRAM_FIX,
    ljvFEATURE_IDLE_BEFORE_FLUSH_COMPLETE_FIX,
    ljvFEATURE_NO_FLUSH_USC_FIX,
    ljvFEATURE_COEF_DELTA_CORD_OVERFLOW_ZRL_8BIT_FIX,
    ljvFEATURE_XY_OFFSET_LIMITATION_FIX,
    ljvFEATURE_USC_INVALIDATE_CACHE_LINE_FIX,
    ljvFEATURE_LOW_EFFICIENCY_OF_ID_WRITE_IMGBUF_FIX,
    ljvFEATURE_KERNEL_PER_CORE_LESS_THAN_THIRD_COEF_BUFF_DEPTH_FIX,
    ljvFEATURE_NN_PER_CHANNEL_QUANT,
    ljvFEATURE_NN_NO_Z_LOCATION_OFFSET,
    ljvFEATURE_NN_KERNEL_SIZE_WASTE_IN_PARTIAL_MODE_FIX,
    ljvFEATURE_INCORRECT_WR_REQ_TO_USC_BETWEEN_REORDER_AND_NORMAL_LAYER_FIX,
    ljvFEATURE_VIP_DEC400,
    ljvFEATURE_MAX_POINTSIZE_CLAMP,
    ljvFEATURE_2D_FAST_CLEAR, /* For tilestatus Fast Clear feature*/
    ljvFEATURE_NN_PER_CHANNEL_QUANT_ASYM,
    ljvFEATURE_SMALL_BATCH_FLOPS_RESET_FIX,
    ljvFEATURE_SMALL_BATCH_DISBLE_FIX,
    ljvFEATURE_FORMAT_10BIT_CROSS_4K,
    ljvFEATURE_ENDIAN_CONTROL,
    ljvFEATURE_SH_VX2_FLOATING_MAD_FIX,
    ljvFEATURE_PE_A8B8G8R8, /* For PE support A8B8G8R8 format feature*/
    ljvFEATURE_DEPTHWISE_NEIGHBOR_IMG_DATA_TRANSFER_NOT_EFFICIENT_FIX,

    /* FP16 enhancement-related features. */
    ljvFEATURE_DST_TEX_I2F_F2I_INST_DEPRECATE,
    ljvFEATURE_ALU_FP16_INST_SUPPORT,
    ljvFEATURE_DUAL16_14BIT_PC_SUPPORT,
    ljvFEATURE_LDST_CONV_4ROUNDING_MODES,
    ljvFEATURE_FULL_PACK_MODE_SUPPORT,
    ljvFEATURE_FP32_TO_FP16_CONV_FIX,

    ljvFEATURE_SH_HAS_IMGLD_COMP_COUNT_FIX,
    ljvFEATURE_SH_SUPPORT_FP32_FMA,

    ljvFEATURE_SH_SUPPORT_VEC2_INT_MULMAD,
    ljvFEATURE_SH_SUPPORT_VEC4_INT_MULMAD,

    ljvFEATURE_SH_SUPPORT_HIGHPVEC_FORMAT,
    ljvFEATURE_SH_HAS_32BIT_NEG_OFFSET_FIX_FOR_40BIT_VA,
    ljvFEATURE_SH_SUPPORT_AIGM,
    ljvFEATURE_SH_CS_PAGE_SIZE_ISSUE,
    ljvFEATURE_SH_FRONT_FACE_FIX,
    ljvFEATURE_SH_SUPPORT_MULTIVIEWPORT,

    ljvFEATURE_SH_PER_STAGE_LOCAL_STORAGE,
    ljvFEATURE_SH_SUPPORT_SEPARATED_TEX,
    ljvFEATURE_SH_SUPPORT_CLIP_CULL_DISTANCE,
    ljvFEATURE_SH_D3D11_SUPPORT,

    ljvFEATURE_SH_DYNAMIC_TEXTURE_INDEXING,
    ljvFEATURE_SH_INT64_VA_CALC_ENHANCE,

    /* AIGPU feature. */
    ljvFEATURE_AI_GPU,
    ljvFEATURE_NN_FAST_FIRST_PIXEL_POOLING,
    ljvFEATURE_NN_FLOAT_POST_MULT,
    ljvFEATURE_NN_ASYMMETRIC_INT8,

    ljvFEATURE_FORMAT_YUV_I010, /*support YUVI010 & P010_LSB format*/
    ljvFEATURE_FORMAT_YUV420_101010, /*support YUV420_101010 format*/
    ljvFEATURE_FORMAT_FLOATPOINT, /*support FloatPoint format,also include packed-RGB888*/

    ljvFEATURE_BIT_NN_COMPRESSION_BYPASSS,
    ljvFEATURE_BIT_BFLOAT_COEF_COMPRESSION_ZERO_COEFBIT14_INVERSE,
    ljvFEATURE_BIT_TP_KERNEL_1BYTE_ALGIN,
    ljvFEATURE_PREPROCESS_IMG_BUF_640BYTE_LIMIT,
    ljvFEATURE_BIT_TPLITE_BFLOAT16,
    ljvFEATURE_VIP_HW_FINAL_RELEASE,
    ljvFEATURE_OUTPUT_CONVERT_UINT8_INT8_TO_UINT16_INT16_FIX,
    ljvFEATURE_IMG_ADDR_NOT_WRAP_IF_OVER_OCB_ADDR_FIX, /* 2089 */
    ljvFEATURE_BIT_V8_SINGLE_PORT_ACCUMULATION_BUFFER_RW_CONFICT_ZERO_SKIP_PERF_FIX, /* 2043 */
    ljvFEATURE_BIT_BURST_COLLECT_DUMMY_DATA_WASTE_CYCLES_FIX, /* 2111 */
    ljvFEATURE_BIT_TP_ACCESS_VIPSRAM_OT_IS_ONE_FIX, /* 2050 */

    ljvFEATURE_BIT_USE_SINGLE_PORT_VIPSRAM,
    ljvFEATURE_VALUE_DDR_KERNEL_BURST_SIZE,
    ljvFEATURE_BIT_TILE_ACCESS_CAPABILITY,
    ljvFEATURE_BIT_FAST_DP3_PREPROCESSOR,

    ljvFEATURE_BIT_INIMG_NOT_64BYTE_ALIGN_CACHELINE_MODE_FIX, /* 2112 */
    ljvFEATURE_BIT_DEPTHWISE_16BIT_FORMAT,

    ljvFEATURE_2D_TILESTATUS_ROTATION, /*Fix fastclear feature with rotation*/
    ljvFEATURE_BIT_TP_FC_FLOAT_LAST_PIXEL_NEGATIVE_0_FIX,
    ljvFEATURE_TS_FC_VULKAN_SUPPORT,
    ljvFEATURE_BIT_V8_ACCUMLATION_READ_OUT_HAS_BUBBLES_PERF_FIX, /* 2044 */
    ljvFEATURE_BIT_MAX_TILE_SIZE,
    ljvFEATURE_2D_TARGET_MAJOR_SUPER_TILE, /*target support supertile Y major*/
    ljvFEATURE_BIT_INIMAGE_2DTILE_NOT_LESS_160PIXEL_FIX,
    ljvFEATURE_BIT_NN_IN_TILE_DATA_IS_ALL_PAD_FIX, /* 2131 */
    ljvFEATURE_BIT_US_SRAM_READ_INTF_FIFO_OVERFLOW_FIX, /* 2280 */

    /* TP reorder the int tile x should be less than 512 */
    ljvFEATURE_TP_REORDER_INTILE_X_SIZE_512_FIX,
    ljvFEATURE_NN_WASTE_COEF_READ_WRITE_BANDWIDTH_128BYTE_VIPSRAM_IN_FULL_PATIAL_CACHE_MODE_FIX,
    ljvFEATURE_BIT_BFP_COEF_AUTO_PAD_INCOMPLETE_ZERO_IN_KZ_PLANE,
    ljvFEATURE_NN_FLOAT32_IO,
    ljvFEATURE_TP_FLOAT32_IO,
    /* add for support INT16x(U)INT8 */
    ljvFEATURE_BIT_NN_23BITS_POST_MULTIPLIER_VIP_V7,
    ljvFEATURE_BIT_TP_23BITS_POST_MULTIPLIER_VIP_V7,
    ljvFEATURE_CONV_INT16X8BIT_VIP_V7,

    /* Q channel support. */
    ljvFEATURE_Q_CHANNEL_SUPPORT,

    /* MMU descriptor new refinement. */
    ljvFEATURE_MMU_PAGE_DESCRIPTOR,

    ljvFEATURE_BIT_NN_TILE_NUM_BIGGER_THAN_1024_FIX,

    ljvFEATURE_BIT_HI1_L2_CACHE,

    ljvFEATURE_BIT_NN_SUPPORT_CONV_1D,

    ljvFEATURE_BIT_NN_DEPTHWISE_AFTER_16BIT_LAYER_LIMIT_FIX,

    /* only support ljvSURF_B8G8R8_PLANAR & ljvSURF_AYUV format as target */
    ljvFEATURE_BIT_BGR_PLANAR,

    ljvFEATURE_BIT_USC_INDIVIDUAL_PORT_WRT_EARLY_EVICT_DATA_CORRUPT_FIX,
    ljvFEATURE_BIT_NN_TP_INSTR_COMPLETE_IN_SAME_CYCLE_WITH_WAIT_EVENT_FIX,

    ljvFEATURE_BIT_TP_SOFTMAX,
    ljvFEATURE_TP_TENSOR_ADD_MUL,

    ljvFEATURE_NN_REMOVE_POOLING,
    ljvFEATURE_BIT_NN_DEPTHWISE_INT16XINT8,
    ljvFEATURE_BIT_NN_DEPTHWISE_8BIT_VIP_V7,
    ljvFEATURE_BIT_NN_ZDP_TRANSPOSE_CH9_ONLY,
    ljvFEATURE_BIT_NN_SUPPORT_DUMMY_TILE,
    ljvFEATURE_BIT_USE_VIPSRAM_FOR_KERNEL_STREAMING,
    ljvFEATURE_BIT_NN_SUPPORT_KERNEL_1BYTE_ALIGN,
    ljvFEATURE_BIT_NN_SMALL_BATCH_PHASE2,
    ljvFEATURE_SH_MOVAI_MOVAR_UNUSED_COMPONENTS_WRITE_DIRTY_DATA_FIX,
    ljvFEATURE_BIT_NN_ENHANCED_MAX_POOLING,
    ljvFEATURE_NN_1x1_NON_POOLING_PACKING,
    ljvFEATURE_BIT_NN_SUPPORT_BOTH_CONV_NATIVE_STRIDE2_AND_POOLING,
    ljvFEATURE_BIT_NN_SUPPORT_ALU,
    ljvFEATURE_BIT_NN_TRANSPOSE_PHASE2,
    ljvFEATURE_BIT_NN_FC_ENHANCEMENT,
    ljvFEATURE_BIT_NN_2ND_IMG_BASE_ADDR_FIX,
    ljvFEATURE_BIT_NN_TENSOR_ADD_FIELD_MOVE_TO_EXT_CMD,

    ljvFEATURE_IMGLD_WIDTH_LT16_FIX,
    ljvFEATURE_BIT_GPU_INSPECTOR_COUNTERS,

    ljvFEATURE_VIP_REMOVE_MMU,
    ljvFEATURE_BIT_TPLITE_SUPPORT_TP_DATA_TRANSPOSE,
    ljvFEATURE_BIT_NN_JD_DIRECT_MODE_FIX,
    ljvFEATURE_BIT_NN_CONV_CORE_BYPASS,
    ljvFEATURE_BIT_TP_REMOVE_FC,

    ljvFEATURE_BIT_HI_DEFAULT_ENABLE_REORDER_FIX,
    ljvFEATURE_BIT_NN_TENSOR_ADD_RELU,
    ljvFEATURE_BIT_NN_VIPSRAM_DOUBLE_BUFFER_FIX,

    ljvFEATURE_BIT_NN_POST_OUT_SUPPORT_FP16,
    ljvFEATURE_BIT_NN_POST_OUT_SUPPORT_BF16,
    ljvFEATURE_BIT_NN_POST_OUT_SUPPORT_FP32,
    ljvFEATURE_BIT_NN_POST_OUT_SUPPORT_INT32,
    ljvFEATURE_BIT_DEPTHWISE_FLOAT_FIX,

    /*
     * Using event 28 as frame done interrupt, set by End command with bit 28
     * interrupt enabled by AHB 0x14 register and clear by 0x10 register.
     */
    ljvFEATURE_2D_FRAME_DONE_INTR,
    ljvFEATURE_BIT_NN_BURST_COLLECTER_LAST_FLAG_FIX,
    ljvFEATURE_BIT_NN_POST_MULT_SUPPORT_FP_CONV,

    /*
     * support AXI Front-End hardware moudle for IP (subsystem) directly interfacing
     * to SOC through AXI port.
     */
    ljvFEATURE_BIT_AXI_FE,
    ljvFEATURE_BIT_V83_1ST_CACHE_MODE_VIPSRAM_RD_UPDATE_FIX,
    ljvFEATURE_BIT_NN_KERNEL_MSS_SBP2_DIRECT_STEAM_STEAM_FIX,
    ljvFEATURE_BIT_NN_RD_IMG_NEED_EXTRA_SPACE,
    ljvFEATURE_BIT_V83_NUMOFPENDINGTILES_FOR_2NDIMAGE_FIX,
    ljvFEATURE_BIT_CORE_NUM_OF_KID_FOR_MULTI_LAYER_FIX,
    ljvFEATURE_BIT_USC_RW_SAME_CACHELINE_UPDATE_FIX,
    ljvFEATURE_BIT_V83_1ST_KERNEL_STREAM_BUFFER_UPDATE_FIX,
    ljvFEATURE_BIT_NN_CMD_SUPPORT_SLICE,
    ljvFEATURE_BIT_NN_HW_V83,

    /* ANDROID_ONLY_RESERVED,reserve some non-android features:
     *     (1)Line drawing,
     *     (2)8x8 pattern,
     *     (3)Index8 format,
     *     (4)Demultiply,
     *     (5)Alpha blending:(ONE,ONE_MINUS_SRC_ALPHA),(SRC_ALPHA,ONE_MINUS_SRC_ALPHA),global alpha and pre-multiply,
     *     (6)Rectangle clear and fill,
     *     (7)Rotation.Android uses'90 deg','H flip','V flip'three bits to describe 8 transformations.
     */
    ljvFEATURE_ANDROID_ONLY_RESERVED,
    ljvFEATURE_2D_MULTISOURCE_PIPE, /* move bitblit/stretchblit pipe line to multisource blit */
    ljvFEATURE_2D_MASK_AND_COLORKEY, /* maskblit and src/dst color key */

    ljvFEATURE_BIT_V83_INTILESIZE_1X1_10BITS_FIX,
    ljvFEATURE_BIT_NN_CIRCULAR_BUF_WRAP_ADDRESS_OVERFLOW_FIX,
    ljvFEATURE_BIT_TP_CIRCULAR_BUF_WRAP_ADDRESS_OVERFLOW_FIX,
    ljvFEATURE_BIT_TP_CIRCULAR_BUF_WRAP_ADDRESS_LESS_FIX,
    ljvFEATURE_BIT_USC_PAUSE_TP_WR_REQ_MORE_THAN_256_CYCLES_FIX,

    ljvFEATURE_BIT_TP_SPECIAL_LIST_PARSER_FIX, /* 2365 */

    ljvFEATURE_2D_STRETCH_MULTISOURCE_PIPE, /* move stretchblit pipe line to multisource blit */

    ljvFEATURE_BIT_PA_ZEROAREA_LINE_FIX, /* HW 2380 */
    ljvFEATURE_BIT_RS_TILER_YUV420_FIX, /* HW 2114 */

    ljvFEATURE_BIT_NN_JOB_CANCELATION,

    ljvFEATURE_BIT_V8_DIRECT_MODE_START_ADDR_BIAS_FOR_NEGATIVE_OFFSET_FIX,

    /* only support ljvSURF_B8G8R8_PLANAR & ljvSURF_AYUV format as source */
    ljvFEATURE_BIT_BGR_PLANAR_SOURCE,

    ljvFEATURE_2D_FC_IN_DEC400EX,/* 2D Fast Clear support in DEC400EX */
    ljvFEATURE_BIT_DIRECT_INIMAGE_XSTIDE_LE_13BIT_FIX,
    ljvFEATURE_BIT_PE_64BPP_LINEAR_FORMAT,
    ljvFEATURE_BIT_NN_SUPPORT_MULTI_AXI_ID,
    ljvFEATURE_BIT_NN_STREAM_PROCESSOR,
    ljvFEATURE_BIT_TRSPB2_ENDADDR_EQUAL_SRAMEND_FIX,

    /* Feature about normalization */
    ljvFEATURE_2D_NORMALIZATION,
    ljvFEATURE_2D_NORMALIZATION_QUANTIZATION,

    ljvFEATURE_BIT_NN_SUPPORT_16_8_QUANTIZATION,
    ljvFEATURE_BIT_SPECIAL_8BIT_SIGN_ABS_CONV,
    ljvFEATURE_BIT_VIP_SUPPORT_TENSOR_TRANSFER,
    ljvFEATURE_BIT_NN_SUPPORT_CMD_LOOP,

    ljvFEATURE_BIT_NN_1ST_AND_2ND_INIMAGE_RAISE_VIPSRAM_RD_UPDATE_AT_SAME_TIME_FIX,
    ljvFEATURE_BIT_NN_1ST_AND_2ND_INIMAGE_RAISE_VIPSRAM_RD_UPDATE_AT_SAME_TIME_PHASE1_FIX,
    ljvFEATURE_BIT_NN_1ST_AND_2ND_INIMAGE_RAISE_VIPSRAM_RD_UPDATE_AT_SAME_TIME_PHASE2_FIX,
    ljvFEATURE_BIT_SECONDIMG_TILE_SIDEBANFIFO_FIX,
    ljvFEATURE_BIT_NN_NONZERO_BORDER,
    ljvFEATURE_BIT_NN_SUPPORT_CLAMP_BORDER_MODE,
    ljvFEATURE_BIT_NN_MIRROR_BORDER,
    ljvFEATURE_BIT_NN_NONZERO_MIRROR_BORDER,
    ljvFEATURE_BIT_NN_4BIT_PERF_EVEN_TILEXSIZE_FIX,

    ljvFEATURE_BIT_NN_4BIT_PHASE1,
    ljvFEATURE_BIT_NN_SUPPORT_DECONVNxN_S_LESS_THAN_16,
    ljvFEATURE_BIT_NN_PICOCORE_DEPTHWISE,
    ljvFEATURE_BIT_NN_SINGLE_POSTMULT_FIELDS_IN_BITSTREAM,
    ljvFEATURE_VALUE_NN_SMALL_ACCUM_BITS,
    ljvFEATURE_VALUE_NN_SMALL_ACCUM,
    ljvFEATURE_BIT_VIP_SUPPORT_X_FRAME_COMPRESSION,
    ljvFEATURE_NN_SUPPORT_EFUSE,
    ljvFEATURE_BIT_NN_WRITE_WITHOUT_USC,
    ljvFEATURE_BIT_NN_SUPPORT_CONFIGURABLE_FASTXDP3,
    ljvFEATURE_BIT_SH_SUPPORT_VEC2,
    ljvFEATURE_BIT_KERNEL_WR_RD_LUTLOAD_DIRECTMODE_ADDR_FIX,
    ljvFEATURE_VALUE_NN_COEF_DECOMPRESS_PERF_X,
    ljvFEATURE_BIT_VZ_GROUP_START_Z_OVERFLOW_FIX,
    ljvFEATURE_BIT_NN_SPLIT_X_AMONG_CLUSTE,
    ljvFEATURE_BIT_SRAM_PARITY,
    ljvFEATURE_BIT_TRSP2_CONV_SMALLBATCH_FIX,
    ljvFEATURE_BIT_NN_SUPPORT_GEMM_PHASE1,
    ljvFEATURE_BIT_NN_SUPPORT_GEMM_PHASE2,
    ljvFEATURE_NN_TENSOR_ADD_INT16,
    ljvFEATURE_BIT_DEPTHTOSPACE_SAME_XY_FIX,
    ljvFEATURE_BIT_NN_SUPPORT_ZDP_LOOP6,
    ljvFEATURE_NN_ELEMENTWISE_BROADCAST,
    ljvFEATURE_NN_2ND_IMAGE_DATA_TYPE,
    ljvFEATURE_BIT_FP_INIMAGE_POST_SCALE,
    ljvFEATURE_BIT_FASTXDP3_ONLY_IN_DEPTHWISE_FIX,
    ljvFEATURE_BIT_NN_TILE_YSIZE_127_LIMITATION_FIX,
    ljvFEATURE_BIT_NN_2ND_IMG_SMALL_3D_TILE_FIX,
    ljvFEATURE_BIT_NN_CONV_1D_16BIT_FORMAT_INTILE_SIZE_LIMITATION_FIX,
    ljvFEATURE_BIT_SP_NOIN_IMGRD_DUMMY_FIX,
    ljvFEATURE_BIT_PERF_KERNEL_DESCRIPTOR_SOURCE_FIX,
    ljvFEATURE_BIT_TENSOR_DMA,
    ljvFEATURE_BIT_SBP1_KHEAD_CMDSIZE_FIX,

    /* Insert features above this comment only. */
    ljvFEATURE_COUNT                /* Not a feature. */
} ljeFEATURE;

/* Chip Power Status. */
typedef enum _ljeCHIPPOWERSTATE {
    ljvPOWER_INVALID = -1,

    /* Global/base states. */
    ljvPOWER_ON = 0,
    ljvPOWER_IDLE,
    ljvPOWER_SUSPEND,
    ljvPOWER_OFF,

    /* Power on but not global or broadcast. */
    ljvPOWER_ON_AUTO,

    /* Broadcast states. */
    ljvPOWER_FLAG_BROADCAST    = 0x10,
    ljvPOWER_IDLE_BROADCAST    = ljvPOWER_IDLE    | ljvPOWER_FLAG_BROADCAST,
    ljvPOWER_SUSPEND_BROADCAST = ljvPOWER_SUSPEND | ljvPOWER_FLAG_BROADCAST,
    ljvPOWER_OFF_BROADCAST     = ljvPOWER_OFF     | ljvPOWER_FLAG_BROADCAST,

    /* Timeout states. */
    ljvPOWER_FLAG_TIMEOUT      = 0x20,
    ljvPOWER_IDLE_TIMEOUT      = ljvPOWER_IDLE    | ljvPOWER_FLAG_TIMEOUT,
    ljvPOWER_SUSPEND_TIMEOUT   = ljvPOWER_SUSPEND | ljvPOWER_FLAG_TIMEOUT,
    ljvPOWER_OFF_TIMEOUT       = ljvPOWER_OFF     | ljvPOWER_FLAG_TIMEOUT,

} ljeCHIPPOWERSTATE;

/* CPU cache operations */
typedef enum _ljeCACHEOPERATION {
    ljvCACHE_CLEAN      = 0x01, /* Flush CPU cache to mem */
    ljvCACHE_INVALIDATE = 0x02, /* Invalidte CPU cache */
    ljvCACHE_FLUSH      = ljvCACHE_CLEAN  | ljvCACHE_INVALIDATE, /* Both flush & invalidate */
    ljvCACHE_MEMORY_BARRIER = 0x04
} ljeCACHEOPERATION;

/* Surface types. */
typedef enum _ljeSURF_TYPE {
    ljvSURF_TYPE_UNKNOWN = 0,
    ljvSURF_INDEX,
    ljvSURF_VERTEX,
    ljvSURF_TEXTURE,
    ljvSURF_RENDER_TARGET,
    ljvSURF_DEPTH,
    ljvSURF_BITMAP,
    ljvSURF_TILE_STATUS,
    ljvSURF_IMAGE,
    ljvSURF_MASK,
    ljvSURF_SCISSOR,
    ljvSURF_HIERARCHICAL_DEPTH,
    ljvSURF_ICACHE,
    ljvSURF_TXDESC,
    ljvSURF_FENCE,
    ljvSURF_TFBHEADER,
    ljvSURF_NUM_TYPES, /* Make sure this is the last one! */

    /* Combinations. */
    ljvSURF_NO_TILE_STATUS          = 0x100,
    ljvSURF_NO_VIDMEM               = 0x200, /* Used to allocate surfaces with no underlying vidmem node.
                                                  * In Android, vidmem node is allocated by another process.
                                                  */
    ljvSURF_CACHEABLE               = 0x400, /* Used to allocate a cacheable surface */
    ljvSURF_TILE_RLV_FENCE          = 0x800, /* create texture fence as tile */
    ljvSURF_TILE_STATUS_DIRTY       = 0x1000, /* Init tile status to all dirty */
    ljvSURF_LINEAR                  = 0x2000,
    ljvSURF_CREATE_AS_TEXTURE       = 0x4000, /* create it as a texture */
    ljvSURF_PROTECTED_CONTENT       = 0x8000, /* create it as content protected */
    ljvSURF_CREATE_AS_DISPLAYBUFFER = 0x10000, /*create it as a display buffer surface */
    ljvSURF_CONTIGUOUS              = 0x20000, /*create it as contiguous */
    ljvSURF_NO_COMPRESSION          = 0x40000, /* Create it as no compression, valid on when it has tile status. */
    ljvSURF_DEC                     = 0x80000, /* Surface is DEC compressed */
    ljvSURF_NO_HZ                   = 0x100000,
    ljvSURF_3D                      = 0x200000, /* It's 3d surface */
    ljvSURF_DMABUF_EXPORTABLE       = 0x400000, /* master node can be exported as dma-buf fd */
    ljvSURF_CACHE_MODE_128          = 0x800000,
    ljvSURF_TILED                   = 0x1000000, /* force create tile buffer, as we will convert it to supertile according to related hardware feature by default */
    ljvSURF_FORCE_32BIT_VA          = 0x2000000, /* force allocate 32bit VA */
    ljvSURF_LINEAR_NO_ALIGNMENT     = 0x4000000, /* only for linear render target buffer */

    ljvSURF_TEXTURE_LINEAR               = ljvSURF_TEXTURE
                                         | ljvSURF_LINEAR,

    ljvSURF_RENDER_TARGET_LINEAR         = ljvSURF_RENDER_TARGET
                                         | ljvSURF_LINEAR,

    ljvSURF_RENDER_TARGET_NO_TILE_STATUS = ljvSURF_RENDER_TARGET
                                         | ljvSURF_NO_TILE_STATUS,

    ljvSURF_RENDER_TARGET_NO_COMPRESSION = ljvSURF_RENDER_TARGET
                                         | ljvSURF_NO_COMPRESSION,

    ljvSURF_RENDER_TARGET_TS_DIRTY       = ljvSURF_RENDER_TARGET
                                         | ljvSURF_TILE_STATUS_DIRTY,

    ljvSURF_DEPTH_NO_TILE_STATUS         = ljvSURF_DEPTH
                                         | ljvSURF_NO_TILE_STATUS,

    ljvSURF_DEPTH_TS_DIRTY               = ljvSURF_DEPTH
                                         | ljvSURF_TILE_STATUS_DIRTY,

    /* Supported surface types with no vidmem node. */
    ljvSURF_BITMAP_NO_VIDMEM             = ljvSURF_BITMAP
                                         | ljvSURF_NO_VIDMEM,

    ljvSURF_TEXTURE_NO_VIDMEM            = ljvSURF_TEXTURE
                                         | ljvSURF_NO_VIDMEM,

    /* Cacheable surface types with no vidmem node. */
    ljvSURF_CACHEABLE_BITMAP_NO_VIDMEM   = ljvSURF_BITMAP_NO_VIDMEM
                                         | ljvSURF_CACHEABLE,

    ljvSURF_CACHEABLE_BITMAP             = ljvSURF_BITMAP
                                         | ljvSURF_CACHEABLE,

    ljvSURF_TEXTURE_3D                  = ljvSURF_TEXTURE
                                         | ljvSURF_3D
} ljeSURF_TYPE;

/*
 * Surface formats.
 * Name rules is from MSB->LSB.
 */
typedef enum _ljeSURF_FORMAT {
    /* Unknown format. */
    ljvSURF_UNKNOWN             = 0,

    /* Format test */
    ljvSURF_TEST                = 1,

    /* Palettized formats. */
    ljvSURF_INDEX1              = 100,
    ljvSURF_INDEX4,
    ljvSURF_INDEX8,
#if ljdVG_ONLY
    ljvSURF_INDEX2,
#endif

    /* RGB formats. */
    ljvSURF_A2R2G2B2            = 200,
    ljvSURF_R3G3B2,
    ljvSURF_A8R3G3B2,
    ljvSURF_X4R4G4B4,
    ljvSURF_A4R4G4B4,
    ljvSURF_R4G4B4A4,
    ljvSURF_X1R5G5B5,
    ljvSURF_A1R5G5B5,
    ljvSURF_R5G5B5A1,
    ljvSURF_R5G6B5,
    ljvSURF_R8G8B8,
    ljvSURF_X8R8G8B8,
    ljvSURF_A8R8G8B8,
    ljvSURF_R8G8B8A8,
    ljvSURF_G8R8G8B8,
    ljvSURF_R8G8B8G8,
    ljvSURF_X2R10G10B10,
    ljvSURF_A2R10G10B10,
    ljvSURF_R10G10B10A2,
    ljvSURF_X12R12G12B12,
    ljvSURF_A12R12G12B12,
    ljvSURF_X16R16G16B16,
    ljvSURF_A16R16G16B16,
    ljvSURF_A32R32G32B32,
    ljvSURF_R8G8B8X8,
    ljvSURF_R5G5B5X1,
    ljvSURF_R4G4B4X4,
    ljvSURF_X16R16G16B16_2_A8R8G8B8,
    ljvSURF_A16R16G16B16_2_A8R8G8B8,
    ljvSURF_A32R32G32B32_2_G32R32F,
    ljvSURF_A32R32G32B32_4_A8R8G8B8,
    ljvSURF_R8G8B8_PLANAR,
    ljvSURF_R8G8B8I,
    ljvSURF_R8G8B8I_PLANAR,
    ljvSURF_R16G16B16I,
    ljvSURF_R16G16B16I_PLANAR,

    /* BGR formats. */
    ljvSURF_A4B4G4R4            = 300,
    ljvSURF_A1B5G5R5,
    ljvSURF_B5G6R5,
    ljvSURF_B8G8R8,
    ljvSURF_B16G16R16,
    ljvSURF_X8B8G8R8,
    ljvSURF_A8B8G8R8,
    ljvSURF_A2B10G10R10,
    ljvSURF_X16B16G16R16,
    ljvSURF_A16B16G16R16,
    ljvSURF_B32G32R32,
    ljvSURF_X32B32G32R32,
    ljvSURF_A32B32G32R32,
    ljvSURF_B4G4R4A4,
    ljvSURF_B5G5R5A1,
    ljvSURF_B8G8R8X8,
    ljvSURF_B8G8R8A8,
    ljvSURF_B10G10R10A2,
    ljvSURF_X4B4G4R4,
    ljvSURF_X1B5G5R5,
    ljvSURF_B4G4R4X4,
    ljvSURF_B5G5R5X1,
    ljvSURF_X2B10G10R10,
    ljvSURF_B8G8R8_SNORM,
    ljvSURF_X8B8G8R8_SNORM,
    ljvSURF_A8B8G8R8_SNORM,
    ljvSURF_A8B12G12R12_2_A8R8G8B8,
    ljvSURF_B8G8R8_PLANAR,

    /* Compressed formats. */
    ljvSURF_DXT1                = 400,
    ljvSURF_DXT2,
    ljvSURF_DXT3,
    ljvSURF_DXT4,
    ljvSURF_DXT5,
    ljvSURF_CXV8U8,
    ljvSURF_ETC1,
    ljvSURF_R11_EAC,
    ljvSURF_SIGNED_R11_EAC,
    ljvSURF_RG11_EAC,
    ljvSURF_SIGNED_RG11_EAC,
    ljvSURF_RGB8_ETC2,
    ljvSURF_SRGB8_ETC2,
    ljvSURF_RGB8_PUNCHTHROUGH_ALPHA1_ETC2,
    ljvSURF_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2,
    ljvSURF_RGBA8_ETC2_EAC,
    ljvSURF_SRGB8_ALPHA8_ETC2_EAC,
    ljvSURF_SDXT1,
    ljvSURF_SDXT3,
    ljvSURF_SDXT5,

    /* YUV formats. */
    ljvSURF_YUY2                = 500,
    ljvSURF_UYVY,
    ljvSURF_YV12,
    ljvSURF_I420,
    ljvSURF_NV12,
    ljvSURF_NV21,
    ljvSURF_NV16,
    ljvSURF_NV61,
    ljvSURF_YVYU,
    ljvSURF_VYUY,
    ljvSURF_AYUV,
    ljvSURF_YUV420_10_ST,
    ljvSURF_YUV420_TILE_ST,
    ljvSURF_YUV420_TILE_10_ST,
    ljvSURF_NV12_10BIT,
    ljvSURF_NV21_10BIT,
    ljvSURF_NV16_10BIT,
    ljvSURF_NV61_10BIT,
    ljvSURF_P010,
    ljvSURF_P010_LSB,
    ljvSURF_I010,
    ljvSURF_I010_LSB,
    ljvSURF_YUV420_101010,
    ljvSURF_GRAY8,
#if ljdVG_ONLY
    ljvSURF_AYUY2,
    ljvSURF_ANV12,
    ljvSURF_ANV16,
    ljvSURF_AUYVY,
    ljvSURF_YV16,
#endif

    /* Depth formats. */
    ljvSURF_D16                 = 600,
    ljvSURF_D24S8,
    ljvSURF_D32,
    ljvSURF_D24X8,
    ljvSURF_D32F,
    ljvSURF_S8D32F,
    ljvSURF_S8D32F_1_G32R32F,
    ljvSURF_S8D32F_2_A8R8G8B8,
    ljvSURF_D24S8_1_A8R8G8B8,
    ljvSURF_S8,
    ljvSURF_X24S8,
    ljvSURF_X24S8_1_A8R8G8B8,

    /* Alpha formats. */
    ljvSURF_A4                  = 700,
    ljvSURF_A8,
    ljvSURF_A12,
    ljvSURF_A16,
    ljvSURF_A32,
    ljvSURF_A1,

    /* Luminance formats. */
    ljvSURF_L4                  = 800,
    ljvSURF_L8,
    ljvSURF_L12,
    ljvSURF_L16,
    ljvSURF_L32,
    ljvSURF_L1,
    ljvSURF_L8_RAW,

    /* Alpha/Luminance formats. */
    ljvSURF_A4L4                = 900,
    ljvSURF_A2L6,
    ljvSURF_A8L8,
    ljvSURF_A4L12,
    ljvSURF_A12L12,
    ljvSURF_A16L16,

    ljvSURF_A8L8_1_A8R8G8B8,

    ljvSURF_A8L8_RAW,

    /* Bump formats. */
    ljvSURF_L6V5U5              = 1000,
    ljvSURF_V8U8,
    ljvSURF_X8L8V8U8,
    ljvSURF_Q8W8V8U8,
    ljvSURF_A2W10V10U10,
    ljvSURF_V16U16,
    ljvSURF_Q16W16V16U16,

    /* R/RG/RA formats. */
    ljvSURF_R8                  = 1100,
    ljvSURF_X8R8,
    ljvSURF_G8R8,
    ljvSURF_X8G8R8,
    ljvSURF_A8R8,
    ljvSURF_R16,
    ljvSURF_X16R16,
    ljvSURF_G16R16,
    ljvSURF_X16G16R16,
    ljvSURF_A16R16,
    ljvSURF_R32,
    ljvSURF_X32R32,
    ljvSURF_G32R32,
    ljvSURF_X32G32R32,
    ljvSURF_A32R32,
    ljvSURF_RG16,
    ljvSURF_R8_SNORM,
    ljvSURF_G8R8_SNORM,

    ljvSURF_R8_1_X8R8G8B8,
    ljvSURF_G8R8_1_X8R8G8B8,

    /* Floating point formats. */
    ljvSURF_R16F                = 1200,
    ljvSURF_X16R16F,
    ljvSURF_G16R16F,
    ljvSURF_X16G16R16F,
    ljvSURF_B16G16R16F,
    ljvSURF_X16B16G16R16F,
    ljvSURF_A16B16G16R16F,
    ljvSURF_R32F,
    ljvSURF_X32R32F,
    ljvSURF_G32R32F,
    ljvSURF_X32G32R32F,
    ljvSURF_B32G32R32F,
    ljvSURF_X32B32G32R32F,
    ljvSURF_A32B32G32R32F,
    ljvSURF_A16F,
    ljvSURF_L16F,
    ljvSURF_A16L16F,
    ljvSURF_A16R16F,
    ljvSURF_A32F,
    ljvSURF_L32F,
    ljvSURF_A32L32F,
    ljvSURF_A32R32F,
    ljvSURF_E5B9G9R9,
    ljvSURF_B10G11R11F,
    ljvSURF_B16G16R16F_PLANAR,
    ljvSURF_B32G32R32F_PLANAR,
    ljvSURF_R16G16B16F,
    ljvSURF_R32G32B32F,

    ljvSURF_GRAY16F,
    ljvSURF_GRAY32F,

    ljvSURF_X16B16G16R16F_2_A8R8G8B8,
    ljvSURF_A16B16G16R16F_2_A8R8G8B8,
    ljvSURF_A16B16G16R16F_2_G16R16F,
    ljvSURF_G32R32F_2_A8R8G8B8,
    ljvSURF_X32B32G32R32F_2_G32R32F,
    ljvSURF_A32B32G32R32F_2_G32R32F,
    ljvSURF_X32B32G32R32F_4_A8R8G8B8,
    ljvSURF_A32B32G32R32F_4_A8R8G8B8,

    ljvSURF_R16F_1_A4R4G4B4,
    ljvSURF_G16R16F_1_A8R8G8B8,
    ljvSURF_B16G16R16F_2_A8R8G8B8,

    ljvSURF_R32F_1_A8R8G8B8,
    ljvSURF_B32G32R32F_3_A8R8G8B8,
    ljvSURF_B10G11R11F_1_A8R8G8B8,

    ljvSURF_A32F_1_R32F,
    ljvSURF_L32F_1_R32F,
    ljvSURF_A32L32F_1_G32R32F,

    ljvSURF_R16G16B16F_PLANAR,
    ljvSURF_R32G32B32F_PLANAR,

    /* sRGB format. */
    ljvSURF_SBGR8               = 1400,
    ljvSURF_A8_SBGR8,
    ljvSURF_X8_SBGR8,
    ljvSURF_A8_SRGB8,
    ljvSURF_X8_SRGB8,

    /* Integer formats. */
    ljvSURF_R8I                 = 1500,
    ljvSURF_R8UI,
    ljvSURF_R16I,
    ljvSURF_R16UI,
    ljvSURF_R32I,
    ljvSURF_R32UI,
    ljvSURF_X8R8I,
    ljvSURF_G8R8I,
    ljvSURF_X8R8UI,
    ljvSURF_G8R8UI,
    ljvSURF_X16R16I,
    ljvSURF_G16R16I,
    ljvSURF_X16R16UI,
    ljvSURF_G16R16UI,
    ljvSURF_X32R32I,
    ljvSURF_G32R32I,
    ljvSURF_X32R32UI,
    ljvSURF_G32R32UI,
    ljvSURF_X8G8R8I,
    ljvSURF_B8G8R8I,
    ljvSURF_X8G8R8UI,
    ljvSURF_B8G8R8UI,
    ljvSURF_X16G16R16I,
    ljvSURF_B16G16R16I,
    ljvSURF_X16G16R16UI,
    ljvSURF_B16G16R16UI,
    ljvSURF_X32G32R32I,
    ljvSURF_B32G32R32I,
    ljvSURF_X32G32R32UI,
    ljvSURF_B32G32R32UI,
    ljvSURF_X8B8G8R8I,
    ljvSURF_A8B8G8R8I,
    ljvSURF_X8B8G8R8UI,
    ljvSURF_A8B8G8R8UI,
    ljvSURF_X16B16G16R16I,
    ljvSURF_A16B16G16R16I,
    ljvSURF_X16B16G16R16UI,
    ljvSURF_A16B16G16R16UI,
    ljvSURF_X32B32G32R32I,
    ljvSURF_A32B32G32R32I,
    ljvSURF_X32B32G32R32UI,
    ljvSURF_A32B32G32R32UI,
    ljvSURF_A2B10G10R10UI,
    ljvSURF_G32R32I_2_A8R8G8B8,
    ljvSURF_G32R32I_1_G32R32F,
    ljvSURF_G32R32UI_2_A8R8G8B8,
    ljvSURF_G32R32UI_1_G32R32F,
    ljvSURF_X16B16G16R16I_2_A8R8G8B8,
    ljvSURF_X16B16G16R16I_1_G32R32F,
    ljvSURF_A16B16G16R16I_2_A8R8G8B8,
    ljvSURF_A16B16G16R16I_1_G32R32F,
    ljvSURF_X16B16G16R16UI_2_A8R8G8B8,
    ljvSURF_X16B16G16R16UI_1_G32R32F,
    ljvSURF_A16B16G16R16UI_2_A8R8G8B8,
    ljvSURF_A16B16G16R16UI_1_G32R32F,
    ljvSURF_X32B32G32R32I_2_G32R32I,
    ljvSURF_A32B32G32R32I_2_G32R32I,
    ljvSURF_A32B32G32R32I_2_G32R32F,
    ljvSURF_X32B32G32R32I_3_A8R8G8B8,
    ljvSURF_A32B32G32R32I_4_A8R8G8B8,
    ljvSURF_X32B32G32R32UI_2_G32R32UI,
    ljvSURF_A32B32G32R32UI_2_G32R32UI,
    ljvSURF_A32B32G32R32UI_2_G32R32F,
    ljvSURF_X32B32G32R32UI_3_A8R8G8B8,
    ljvSURF_A32B32G32R32UI_4_A8R8G8B8,
    ljvSURF_A2B10G10R10UI_1_A8R8G8B8,
    ljvSURF_A8B8G8R8I_1_A8R8G8B8,
    ljvSURF_A8B8G8R8UI_1_A8R8G8B8,
    ljvSURF_R8I_1_A4R4G4B4,
    ljvSURF_R8UI_1_A4R4G4B4,
    ljvSURF_R16I_1_A4R4G4B4,
    ljvSURF_R16UI_1_A4R4G4B4,
    ljvSURF_R32I_1_A8R8G8B8,
    ljvSURF_R32UI_1_A8R8G8B8,
    ljvSURF_X8R8I_1_A4R4G4B4,
    ljvSURF_X8R8UI_1_A4R4G4B4,
    ljvSURF_G8R8I_1_A4R4G4B4,
    ljvSURF_G8R8UI_1_A4R4G4B4,
    ljvSURF_X16R16I_1_A4R4G4B4,
    ljvSURF_X16R16UI_1_A4R4G4B4,
    ljvSURF_G16R16I_1_A8R8G8B8,
    ljvSURF_G16R16UI_1_A8R8G8B8,
    ljvSURF_X32R32I_1_A8R8G8B8,
    ljvSURF_X32R32UI_1_A8R8G8B8,
    ljvSURF_X8G8R8I_1_A4R4G4B4,
    ljvSURF_X8G8R8UI_1_A4R4G4B4,
    ljvSURF_B8G8R8I_1_A8R8G8B8,
    ljvSURF_B8G8R8UI_1_A8R8G8B8,
    ljvSURF_B16G16R16I_2_A8R8G8B8,
    ljvSURF_B16G16R16I_1_G32R32F,
    ljvSURF_B16G16R16UI_2_A8R8G8B8,
    ljvSURF_B16G16R16UI_1_G32R32F,
    ljvSURF_B32G32R32I_3_A8R8G8B8,
    ljvSURF_B32G32R32UI_3_A8R8G8B8,
    ljvSURF_A16B16G16R16_2_A8R8G8B8,
    ljvSURF_R8G8B8_1_A8R8G8B8,
    ljvSURF_G16R16_1_A8R8G8B8,
    ljvSURF_A2B10G10R10_1_A8R8G8B8,
    ljvSURF_A2R10G10B10_1_A8R8G8B8,
    ljvSURF_A2W10V10U10_1_A8R8G8B8,

    /* ASTC formats. */
    ljvSURF_ASTC4x4             = 1600,
    ljvSURF_ASTC5x4,
    ljvSURF_ASTC5x5,
    ljvSURF_ASTC6x5,
    ljvSURF_ASTC6x6,
    ljvSURF_ASTC8x5,
    ljvSURF_ASTC8x6,
    ljvSURF_ASTC8x8,
    ljvSURF_ASTC10x5,
    ljvSURF_ASTC10x6,
    ljvSURF_ASTC10x8,
    ljvSURF_ASTC10x10,
    ljvSURF_ASTC12x10,
    ljvSURF_ASTC12x12,
    ljvSURF_ASTC4x4_SRGB,
    ljvSURF_ASTC5x4_SRGB,
    ljvSURF_ASTC5x5_SRGB,
    ljvSURF_ASTC6x5_SRGB,
    ljvSURF_ASTC6x6_SRGB,
    ljvSURF_ASTC8x5_SRGB,
    ljvSURF_ASTC8x6_SRGB,
    ljvSURF_ASTC8x8_SRGB,
    ljvSURF_ASTC10x5_SRGB,
    ljvSURF_ASTC10x6_SRGB,
    ljvSURF_ASTC10x8_SRGB,
    ljvSURF_ASTC10x10_SRGB,
    ljvSURF_ASTC12x10_SRGB,
    ljvSURF_ASTC12x12_SRGB,

    /* Recompile format*/
    ljvSURF_L16_1_A4R4G4B4      = 1700,
    ljvSURF_V16U16_1_A8R8G8B8,
    ljvSURF_Q8W8V8U8_1_A8R8G8B8,
    ljvSURF_X8L8V8U8_1_A8R8G8B8,
    ljvSURF_R3G3B2_1_A8R8G8B8,
    ljvSURF_A8R3G3B2_1_A8R8G8B8,
    ljvSURF_W11V11U10_1_A8R8G8B8,
    ljvSURF_Q16W16V16U16_2_A8R8G8B8,
    ljvSURF_W11V11U10,
    ljvSURF_V8U8_1_A4R4G4B4,
    ljvSURF_A8B8G8R8_1_A8R8G8B8,
    ljvSURF_A32R32G32B32_1_A8R8G8B8,
    ljvSURF_X16B16G16R16F_1_A8R8G8B8,
    ljvSURF_A16B16G16R16F_1_A8R8G8B8,
    ljvSURF_G32R32F_1_A8R8G8B8,
    ljvSURF_X32B32G32R32F_1_A8R8G8B8,
    ljvSURF_A32B32G32R32F_1_A8R8G8B8,
    ljvSURF_G32R32I_1_A8R8G8B8,
    ljvSURF_G32R32UI_1_A8R8G8B8,
    ljvSURF_A32B32G32R32I_1_A8R8G8B8,
    ljvSURF_A32B32G32R32UI_1_A8R8G8B8,
    ljvSURF_Q16W16V16U16_1_A8R8G8B8,
    ljvSURF_A16B16G16R16_1_A8R8G8B8,

    /* Integer formats (2)) */
    ljvSURF_R10G10B10A2UI       = 1800,
    ljvSURF_R5G6B5UI,
    ljvSURF_B5G6R5UI,
    ljvSURF_R3G3B2UI,
    ljvSURF_B2G3R3UI,
    ljvSURF_R4G4B4A4UI,
    ljvSURF_A4B4G4R4UI,
    ljvSURF_R5G5B5A1UI,
    ljvSURF_A1B5G5R5UI,
    ljvSURF_R8G8B8A8UI,

    /* GL4 formats */
    ljvSURF_G8                  = 1900,
    ljvSURF_B8,
    ljvSURF_G32F,
    ljvSURF_B32F,

    /* Intensity formats */
    ljvSURF_I4                  = 2000,
    ljvSURF_I8,
    ljvSURF_I12,
    ljvSURF_I16,

    /* D3D typeless format*/
    ljvSURF_R32G32B32A32_TYPELESS = 2100,
    ljvSURF_R32G32B32_TYPELESS,
    ljvSURF_R16G16B16A16_TYPELESS,
    ljvSURF_R32G32_TYPELESS,
    ljvSURF_R32G8X24_TYPELESS,
    ljvSURF_R32_FLOAT_X8X24_TYPELESS,
    ljvSURF_X32_TYPELESS_G8X24_UINT,
    ljvSURF_R10G10B10A2_TYPELESS,
    ljvSURF_R8G8B8A8_TYPELESS,
    ljvSURF_R16G16_TYPELESS,
    ljvSURF_R32_TYPELESS,
    ljvSURF_R24G8_TYPELESS,
    ljvSURF_R24_UNORM_X8_TYPELESS,
    ljvSURF_X24_TYPELESS_G8_UINT,
    ljvSURF_R8G8_TYPELESS,
    ljvSURF_R16_TYPELESS,
    ljvSURF_R8_TYPELESS,
    ljvSURF_BC1_TYPELESS,
    ljvSURF_BC2_TYPELESS,
    ljvSURF_BC3_TYPELESS,
    ljvSURF_BC4_TYPELESS,
    ljvSURF_BC5_TYPELESS,
    ljvSURF_B8G8R8A8_TYPELESS,
    ljvSURF_B8G8R8X8_TYPELESS,
    ljvSURF_BC6H_TYPELESS,
    ljvSURF_BC7_TYPELESS,
} ljeSURF_FORMAT;

/* Pipes. */
typedef enum _ljePIPE_SELECT {
    ljvPIPE_INVALID = ~0,
    ljvPIPE_3D      =  0,
    ljvPIPE_2D
} ljePIPE_SELECT;

/* Hardware type. */
typedef enum _ljeHARDWARE_TYPE {
    ljvHARDWARE_INVALID,
    ljvHARDWARE_3D2D,
    ljvHARDWARE_3D,
    ljvHARDWARE_2D,
    ljvHARDWARE_VIP,
    ljvHARDWARE_VG,
    ljvHARDWARE_NUM_TYPES,
} ljeHARDWARE_TYPE;

/* User signal command codes. */
typedef enum _ljeUSER_SIGNAL_COMMAND_CODES {
    ljvUSER_SIGNAL_CREATE,
    ljvUSER_SIGNAL_DESTROY,
    ljvUSER_SIGNAL_SIGNAL,
    ljvUSER_SIGNAL_WAIT,
    ljvUSER_SIGNAL_MAP,
    ljvUSER_SIGNAL_UNMAP,
} ljeUSER_SIGNAL_COMMAND_CODES;

/* Shared buffer command codes. */
typedef enum _ljeSHBUF_COMMAND_CODES {
    ljvSHBUF_CREATE,
    ljvSHBUF_DESTROY,
    ljvSHBUF_MAP,
    ljvSHBUF_WRITE,
    ljvSHBUF_READ,
} ljeSHBUF_COMMAND_CODES;

/* Event locations. */
typedef enum _ljeKERNEL_WHERE {
    ljvKERNEL_COMMAND,
    ljvKERNEL_VERTEX,
    ljvKERNEL_TRIANGLE,
    ljvKERNEL_TEXTURE,
    ljvKERNEL_PIXEL,
    ljvKERNEL_BLT,
} ljeKERNEL_WHERE;

typedef enum _ljeBLOCK {
    ljvBLOCK_COMMAND,
    ljvBLOCK_TESSELLATOR,
    ljvBLOCK_TESSELLATOR2,
    ljvBLOCK_TESSELLATOR3,
    ljvBLOCK_RASTER,
    ljvBLOCK_VG,
    ljvBLOCK_VG2,
    ljvBLOCK_VG3,
    ljvBLOCK_PIXEL,

    /* Number of defined blocks. */
    ljvBLOCK_COUNT
} ljeBLOCK;

typedef enum _ljeCORE_3D_MASK {
    ljvCORE_3D_0_MASK   = (1 << 0),
    ljvCORE_3D_1_MASK   = (1 << 1),

    ljvCORE_3D_ALL_MASK = (0xFFFF)
} ljeCORE_3D_MASK;

typedef enum _ljeCORE_3D_ID {
    ljvCORE_3D_0_ID       = 0,
    ljvCORE_3D_1_ID       = 1,

    ljvCORE_3D_ID_INVALID = ~0UL
} ljeCORE_3D_ID;

typedef enum _ljeCORE_2D_MASK {
    ljvCORE_2D_0_MASK   = (1 << 0),
    ljvCORE_2D_1_MASK   = (1 << 1),
    ljvCORE_2D_2_MASK   = (1 << 2),
    ljvCORE_2D_3_MASK   = (1 << 3),

    ljvCORE_2D_ALL_MASK = (0xFFFF)
} ljeCORE_2D_MASK;

typedef enum _ljeCORE_2D_ID {
    ljvCORE_2D_0_ID       = 0,
    ljvCORE_2D_1_ID       = 1,

    ljvCORE_2D_ID_INVALID = ~0UL
} ljeCORE_2D_ID;


typedef enum _ljeCHIP_FLAG {
    ljvCHIP_FLAG_MSAA_COHERENCEY_ECO_FIX = 1 << 0,
    ljvCHIP_FLAG_LJ2000_R2               = 1 << 1,
    ljvCHIP_AXI_BUS128_BITS              = 1 << 2,
} ljeCHIP_FLAG;

/* If different, choose render engine */
#define PRIORITY_ENGINE(a, b) ljmMIN(a, b)

typedef enum {
    ljvENGINE_RENDER            = 0,
    ljvENGINE_BLT               = 1,
    ljvENGINE_GPU_ENGINE_COUNT  = 2,
    ljvENGINE_CPU               = ljvENGINE_GPU_ENGINE_COUNT,
    ljvENGINE_ALL_COUNT         = ljvENGINE_CPU + 1,
    ljvENGINE_INVALID           = ljvENGINE_ALL_COUNT + 0x100
} ljeENGINE;

/* CORE enum. */
typedef enum _ljeCORE {
    ljvCORE_MAJOR,
    ljvCORE_3D1,
    ljvCORE_3D2,
    ljvCORE_3D3,
    ljvCORE_3D4,
    ljvCORE_3D5,
    ljvCORE_3D6,
    ljvCORE_3D7,
    ljvCORE_3D8,
    ljvCORE_3D9,
    ljvCORE_3D10,
    ljvCORE_3D11,
    ljvCORE_3D12,
    ljvCORE_3D13,
    ljvCORE_3D14,
    ljvCORE_3D15,
    ljvCORE_3D_MAX = ljvCORE_3D15,
    ljvCORE_2D,
    ljvCORE_2D1,
    ljvCORE_2D2,
    ljvCORE_2D3,
    ljvCORE_2D_MAX = ljvCORE_2D3,
    ljvCORE_VG,
#if ljdDEC_ENABLE_AHB
    ljvCORE_DEC,
#endif
    ljvCORE_COUNT
} ljeCORE;

#define ljdCORE_3D_COUNT            (ljvCORE_3D_MAX + 1)
#define ljdCORE_2D_COUNT            4

#define ljdMAX_MAJOR_CORE_COUNT     (ljvCORE_2D_MAX + 1)

#ifndef ljdDEVICE_COUNT
#define ljdDEVICE_COUNT             2
#endif

#ifndef ljdPLATFORM_COUNT
#define ljdPLATFORM_COUNT           ljdDEVICE_COUNT
#endif

#ifndef ljvSRAM_EXT_COUNT
#define ljvSRAM_EXT_COUNT           ljdDEVICE_COUNT
#endif

#ifndef ljdSYSTEM_RESERVE_COUNT
#define ljdSYSTEM_RESERVE_COUNT     ljdDEVICE_COUNT
#endif

#ifndef ljdLOCAL_MEMORY_COUNT
#define ljdLOCAL_MEMORY_COUNT       ljdDEVICE_COUNT
#endif

#ifndef ljdGLOBAL_CORE_COUNT
#define ljdGLOBAL_CORE_COUNT        (ljdDEVICE_COUNT * ljdCORE_3D_COUNT)
#endif

#ifndef ljdGLOBAL_2D_COUNT
#define ljdGLOBAL_2D_COUNT          ljdCORE_2D_COUNT
#endif

#define ljdCHIP_COUNT               ljdGLOBAL_CORE_COUNT

typedef enum _ljeSECURE_MODE {
    /* For cores without ljvFEATURE_SECURITY. */
    ljvSECURE_NONE,

    /* Use registers added in ljvFEATURE_SECURITY in normal driver,
     * In this mode, GPU always works under non secure mode and
     * should not touch secure buffer. It is used to test basic function.
     */
    ljvSECURE_IN_NORMAL,

    /* Make use of ljvFEATURE_SECURITY in trust application. */
    ljvSECURE_IN_TA
} ljeSECURE_MODE;

/* kernel driver compression option, as it's a system global option,
 * it means kernel driver allows the options, NOT necessarily means it must be on.
 */
typedef enum _ljeCOMPRESSION_OPTION {
    ljvCOMPRESSION_OPTION_NONE       = 0x0, /* No any compression */
    ljvCOMPRESSION_OPTION_COLOR      = 0x1, /* Compression for non-msaa color format */
    ljvCOMPRESSION_OPTION_DEPTH      = 0x2, /* Compression for non-msaa depth format */
    ljvCOMPRESSION_OPTION_MSAA_COLOR = 0x4, /* Compression for msaa color */
    ljvCOMPRESSION_OPTION_MSAA_DEPTH = 0x8, /* Compression for msaa depth */

    /* default compressio option */
    ljvCOMPRESSION_OPTION_DEFAULT    = ljvCOMPRESSION_OPTION_DEPTH      |
                                       ljvCOMPRESSION_OPTION_COLOR      |
                                       ljvCOMPRESSION_OPTION_MSAA_COLOR |
                                       ljvCOMPRESSION_OPTION_MSAA_DEPTH,
} ljeCOMPRESSION_OPTION;

typedef enum _ljeSRAM_INTERNAL {
    ljvSRAM_INTERNAL0 = 0,
    ljvSRAM_INTERNAL1,

    ljvSRAM_INTER_COUNT
} ljeSRAM_INTERNAL;

typedef enum _ljeFLATMAP_FLAG {
    ljvFLATMAP_DIRECT,
    ljvFLATMAP_SHIFT,
} ljeFLATMAP_FLAG;

/* Video memory alloation type. */
typedef enum _ljeVIDMEM_TYPE {
    ljvVIDMEM_TYPE_GENERIC          = ljvSURF_TYPE_UNKNOWN,
    ljvVIDMEM_TYPE_INDEX_BUFFER     = ljvSURF_INDEX,
    ljvVIDMEM_TYPE_VERTEX_BUFFER    = ljvSURF_VERTEX,
    ljvVIDMEM_TYPE_TEXTURE          = ljvSURF_TEXTURE,
    ljvVIDMEM_TYPE_COLOR_BUFFER     = ljvSURF_RENDER_TARGET,
    ljvVIDMEM_TYPE_DEPTH_BUFFER     = ljvSURF_DEPTH,
    ljvVIDMEM_TYPE_BITMAP           = ljvSURF_BITMAP,
    ljvVIDMEM_TYPE_TILE_STATUS      = ljvSURF_TILE_STATUS,
    ljvVIDMEM_TYPE_IMAGE            = ljvSURF_IMAGE,
    ljvVIDMEM_TYPE_MASK             = ljvSURF_MASK,
    ljvVIDMEM_TYPE_SCISSOR          = ljvSURF_SCISSOR,
    ljvVIDMEM_TYPE_HZ_BUFFER        = ljvSURF_HIERARCHICAL_DEPTH,
    ljvVIDMEM_TYPE_ICACHE           = ljvSURF_ICACHE,
    ljvVIDMEM_TYPE_TXDESC           = ljvSURF_TXDESC,
    ljvVIDMEM_TYPE_FENCE            = ljvSURF_FENCE,
    ljvVIDMEM_TYPE_TFBHEADER        = ljvSURF_TFBHEADER,
    ljvVIDMEM_TYPE_COMMAND,
    ljvVIDMEM_TYPE_COUNT
} ljeVIDMEM_TYPE;

typedef enum _ljeTASK {
    ljvTASK_LINK,
    ljvTASK_CLUSTER,
    ljvTASK_INCREMENT,
    ljvTASK_DECREMENT,
    ljvTASK_SIGNAL,
    ljvTASK_LOCKDOWN,
    ljvTASK_UNLOCK_VIDEO_MEMORY,
    ljvTASK_FREE_VIDEO_MEMORY,
    ljvTASK_FREE_CONTIGUOUS_MEMORY,
} ljeTASK;

/******************************************************************************
 ******************************** Status Codes ********************************
 ******************************************************************************/

typedef enum _ljeSTATUS {
    ljvSTATUS_OK                    =   0,
    ljvSTATUS_FALSE                 =   0,
    ljvSTATUS_TRUE                  =   1,
    ljvSTATUS_NO_MORE_DATA          =   2,
    ljvSTATUS_CACHED                =   3,
    ljvSTATUS_MIPMAP_TOO_LARGE      =   4,
    ljvSTATUS_NAME_NOT_FOUND        =   5,
    ljvSTATUS_NOT_OUR_INTERRUPT     =   6,
    ljvSTATUS_MISMATCH              =   7,
    ljvSTATUS_MIPMAP_TOO_SMALL      =   8,
    ljvSTATUS_LARGER                =   9,
    ljvSTATUS_SMALLER               =   10,
    ljvSTATUS_CHIP_NOT_READY        =   11,
    ljvSTATUS_NEED_CONVERSION       =   12,
    ljvSTATUS_SKIP                  =   13,
    ljvSTATUS_DATA_TOO_LARGE        =   14,
    ljvSTATUS_INVALID_CONFIG        =   15,
    ljvSTATUS_CHANGED               =   16,
    ljvSTATUS_NOT_SUPPORT_DITHER    =   17,
    ljvSTATUS_EXECUTED              =   18,
    ljvSTATUS_TERMINATE             =   19,

    ljvSTATUS_INVALID_ARGUMENT      =   -1,
    ljvSTATUS_INVALID_OBJECT        =   -2,
    ljvSTATUS_OUT_OF_MEMORY         =   -3,
    ljvSTATUS_MEMORY_LOCKED         =   -4,
    ljvSTATUS_MEMORY_UNLOCKED       =   -5,
    ljvSTATUS_HEAP_CORRUPTED        =   -6,
    ljvSTATUS_GENERIC_IO            =   -7,
    ljvSTATUS_INVALID_ADDRESS       =   -8,
    ljvSTATUS_CONTEXT_LOSSED        =   -9,
    ljvSTATUS_TOO_COMPLEX           =   -10,
    ljvSTATUS_BUFFER_TOO_SMALL      =   -11,
    ljvSTATUS_INTERFACE_ERROR       =   -12,
    ljvSTATUS_NOT_SUPPORTED         =   -13,
    ljvSTATUS_MORE_DATA             =   -14,
    ljvSTATUS_TIMEOUT               =   -15,
    ljvSTATUS_OUT_OF_RESOURCES      =   -16,
    ljvSTATUS_INVALID_DATA          =   -17,
    ljvSTATUS_INVALID_MIPMAP        =   -18,
    ljvSTATUS_NOT_FOUND             =   -19,
    ljvSTATUS_NOT_ALIGNED           =   -20,
    ljvSTATUS_INVALID_REQUEST       =   -21,
    ljvSTATUS_GPU_NOT_RESPONDING    =   -22,
    ljvSTATUS_TIMER_OVERFLOW        =   -23,
    ljvSTATUS_VERSION_MISMATCH      =   -24,
    ljvSTATUS_LOCKED                =   -25,
    ljvSTATUS_INTERRUPTED           =   -26,
    ljvSTATUS_DEVICE                =   -27,
    ljvSTATUS_NOT_MULTI_PIPE_ALIGNED =   -28,
    ljvSTATUS_OUT_OF_SAMPLER         =   -29,
    ljvSTATUS_PROBE_LATER           =   -30,
    ljvSTATUS_RESLUT_OVERFLOW       =   -31,
    ljvSTATUS_RECOVERY              =   -32,
    ljvSTATUS_CANCEL_JOB            =   -33,

    /* register allocation errors. */
    ljvSTATUS_OUT_OF_REG_FAIL                   =   -100,

    /* Linker errors. */
    ljvSTATUS_GLOBAL_TYPE_MISMATCH              =   -1000,
    ljvSTATUS_TOO_MANY_ATTRIBUTES               =   -1001,
    ljvSTATUS_TOO_MANY_UNIFORMS                 =   -1002,
    ljvSTATUS_TOO_MANY_VARYINGS                 =   -1003,
    ljvSTATUS_UNDECLARED_VARYING                =   -1004,
    ljvSTATUS_VARYING_TYPE_MISMATCH             =   -1005,
    ljvSTATUS_MISSING_MAIN                      =   -1006,
    ljvSTATUS_NAME_MISMATCH                     =   -1007,
    ljvSTATUS_INVALID_INDEX                     =   -1008,
    ljvSTATUS_UNIFORM_MISMATCH                  =   -1009,
    ljvSTATUS_UNSAT_LIB_SYMBOL                  =   -1010,
    ljvSTATUS_TOO_MANY_SHADERS                  =   -1011,
    ljvSTATUS_LINK_INVALID_SHADERS              =   -1012,
    ljvSTATUS_CS_NO_WORKGROUP_SIZE              =   -1013,
    ljvSTATUS_LINK_LIB_ERROR                    =   -1014,

    ljvSTATUS_SHADER_VERSION_MISMATCH           =   -1015,
    ljvSTATUS_TOO_MANY_INSTRUCTION              =   -1016,
    ljvSTATUS_SSBO_MISMATCH                     =   -1017,
    ljvSTATUS_TOO_MANY_OUTPUT                   =   -1018,
    ljvSTATUS_TOO_MANY_INPUT                    =   -1019,
    ljvSTATUS_NOT_SUPPORT_CL                    =   -1020,
    ljvSTATUS_NOT_SUPPORT_INTEGER               =   -1021,
    ljvSTATUS_UNIFORM_TYPE_MISMATCH             =   -1022,

    ljvSTATUS_MISSING_PRIMITIVE_TYPE            =   -1023,
    ljvSTATUS_MISSING_OUTPUT_VERTEX_COUNT       =   -1024,
    ljvSTATUS_NON_INVOCATION_ID_AS_INDEX        =   -1025,
    ljvSTATUS_INPUT_ARRAY_SIZE_MISMATCH         =   -1026,
    ljvSTATUS_OUTPUT_ARRAY_SIZE_MISMATCH        =   -1027,
    ljvSTATUS_LOCATION_ALIASED                  =   -1028,
    ljvSTATUS_LOCATION_OVERLAP                  =   -1029,
    ljvSTATUS_LOCATION_NOTCONSISTENT            =   -1030,
    ljvSTATUS_INDEX_OVERLAP                     =   -1031,

    /* Compiler errors. */
    ljvSTATUS_COMPILER_FE_PREPROCESSOR_ERROR    =   -2000,
    ljvSTATUS_COMPILER_FE_PARSER_ERROR          =   -2001,

    /* Recompilation Errors */
    ljvSTATUS_RECOMPILER_CONVERT_UNIMPLEMENTED  =   -3000,
} ljeSTATUS;

/* The patch types. */
enum _ljeHAL_PATCH_TYPE {
    ljvHAL_PATCH_VIDMEM_ADDRESS = 1,
    ljvHAL_PATCH_MCFE_SEMAPHORE,
    ljvHAL_PATCH_VIDMEM_TIMESTAMP,

    /* Must be the last one for counting. */
    ljvHAL_PATCH_TYPE_COUNT,
};

/******************************************************************************
 ******************************** Command Codes *******************************
 ******************************************************************************/

typedef enum _ljeHAL_COMMAND_CODES {
    /*************** Common ***************/

    /* Chip info: count, type and so on. */
    ljvHAL_CHIP_INFO,

    /* HAL driver version. */
    ljvHAL_VERSION,

    /* Query chip id and options. */
    ljvHAL_QUERY_CHIP_IDENTITY,
    ljvHAL_QUERY_CHIP_OPTION,

    /* Query chip frequency, used by CL. */
    ljvHAL_QUERY_CHIP_FREQUENCY,

    /* Query system pool video memory, used by CL. */
    ljvHAL_QUERY_VIDEO_MEMORY,

    /* Memory management. */
    ljvHAL_ALLOCATE_LINEAR_VIDEO_MEMORY,
    ljvHAL_WRAP_USER_MEMORY,
    ljvHAL_RELEASE_VIDEO_MEMORY,
    ljvHAL_LOCK_VIDEO_MEMORY,
    ljvHAL_UNLOCK_VIDEO_MEMORY,
    ljvHAL_BOTTOM_HALF_UNLOCK_VIDEO_MEMORY,
    ljvHAL_MAP_MEMORY,
    ljvHAL_UNMAP_MEMORY,

    /* Cache operations. */
    ljvHAL_CACHE,

    /* HAL user attach and detach. */
    ljvHAL_ATTACH,
    ljvHAL_DETACH,

    /* Event commit. */
    ljvHAL_EVENT_COMMIT,

    /* User command commit. */
    ljvHAL_COMMIT,

    /* Set hardware timeout, used by CL. */
    ljvHAL_SET_TIMEOUT,

    /* User signal operations. */
    ljvHAL_USER_SIGNAL,

    /* Event signal, commit stall. */
    ljvHAL_SIGNAL,

    /* Profile related. */
    ljvHAL_SET_PROFILE_SETTING,
    ljvHAL_READ_PROFILER_REGISTER_SETTING,
    ljvHAL_READ_ALL_PROFILE_REGISTERS_PART1,
    ljvHAL_READ_ALL_PROFILE_REGISTERS_PART2,

    /* Query process database info when debug trace and proflie. */
    ljvHAL_DATABASE,

    /* Power management enable/disable. */
    ljvHAL_CONFIG_POWER_MANAGEMENT,

    /* Debug/dump feature. */
    ljvHAL_DEBUG_DUMP,

    /*************** Common end ***************/

    /*************** GPU only ***************/
    /* Register operations, 2D only. */
    ljvHAL_READ_REGISTER,
    ljvHAL_WRITE_REGISTER,
    ljvHAL_PROFILE_REGISTERS_2D,

    /* Get base address for old mmu. */
    ljvHAL_GET_BASE_ADDRESS,

    /* Read frame database, 3D only. */
    ljvHAL_GET_FRAME_INFO,

    /* Set video memory meta data. */
    ljvHAL_SET_VIDEO_MEMORY_METADATA,

    /* Query command buffer, VG only. */
    ljvHAL_QUERY_COMMAND_BUFFER,

    /* Reset time stamp. */
    ljvHAL_QUERY_RESET_TIME_STAMP,

    /* Create native fence. */
    ljvHAL_CREATE_NATIVE_FENCE,

    /* Wait native fence. */
    ljvHAL_WAIT_NATIVE_FENCE,

    /* Wait until GPU finishes access to a resource. */
    ljvHAL_WAIT_FENCE,

    /* Video memory node operations. */
    ljvHAL_EXPORT_VIDEO_MEMORY,
    ljvHAL_NAME_VIDEO_MEMORY,
    ljvHAL_IMPORT_VIDEO_MEMORY,

    /* Mutex Operation. */
    ljvHAL_DEVICE_MUTEX,
    /*************** GPU only end ***************/

    /*************** DEC only ***************/
    /* DEC200 test. */
    ljvHAL_DEC200_TEST,

    /* DEC300 related operations. */
    ljvHAL_DEC300_READ,
    ljvHAL_DEC300_WRITE,
    ljvHAL_DEC300_FLUSH,
    ljvHAL_DEC300_FLUSH_WAIT,
    /*************** DEC only end ***************/

    /*************** OS specific ***************/

    /* Android gralloc: shared buffer operations. */
    ljvHAL_SHBUF,

    /* Android gralloc: get graphic buffer fd. */
    ljvHAL_GET_GRAPHIC_BUFFER_FD,

    /* Vsimulator only. */
    ljvHAL_UPDATE_DEBUG_CALLBACK,
    ljvHAL_CONFIG_CTX_FRAMEWORK,

    /* Non paged memory management backup compatibility, windows, qnx. */
    ljvHAL_ALLOCATE_NON_PAGED_MEMORY,
    ljvHAL_FREE_NON_PAGED_MEMORY,

    /* Write user data, windows only. */
    ljvHAL_WRITE_DATA,

    /*************** OS specific end ***************/

    /*************** Reserved ***************/
    /* Access APB register. */
    ljvHAL_APB_AXIFE_ACCESS,

    /* Trigger a software reset. */
    ljvHAL_RESET,

    /* Command commit done, preemption only. */
    ljvHAL_COMMIT_DONE,

    /* Get video memory file description. */
    ljvHAL_GET_VIDEO_MEMORY_FD,

    /* Get profile setting. */
    ljvHAL_GET_PROFILE_SETTING,

    /* Read/Write register ex. */
    ljvHAL_READ_REGISTER_EX,
    ljvHAL_WRITE_REGISTER_EX,

    /* Power management state. */
    ljvHAL_SET_POWER_MANAGEMENT_STATE,
    ljvHAL_QUERY_POWER_MANAGEMENT_STATE,

    /* Query CPU frequency. */
    ljvHAL_QUERY_CPU_FREQUENCY,

    /* Dump HW register state. */
    ljvHAL_DUMP_GPU_STATE,

    /* Sync video memory for special memory pool */
    ljvHAL_SYNC_VIDEO_MEMORY,

    /* Cancel Job. */
    ljvHAL_CANCEL_JOB,

    /* Timer. */
    ljvHAL_TIMESTAMP,

    /* FSCALE_VAL. */
    ljvHAL_SET_FSCALE_VALUE,
    ljvHAL_GET_FSCALE_VALUE,

    /* Destory MMU. */
    ljvHAL_DESTROY_MMU,

    /* Operate fence from user*/
    ljvHAL_FENCE_OP,

    /*************** Reserved end ***************/
    /* Dma operation of CPU Mem <=> GPU Mem */
    ljvHAL_DMA_OPERATION,

    /* get memory pool */
    ljvHAL_GET_VIDEO_MEMORY_POOL,

    /* process count for 3D */
    ljvHAL_INC_PT_CNT_3D,
    ljvHAL_DEC_PT_CNT_3D,
    ljvHAL_GET_PT_CNT_3D,

    /* physical address convert */
    ljvHAL_PHYS_CPU_TO_GPU,

    ljvHAL_NUM_COMMAND_CODES,
} ljeHAL_COMMAND_CODES;

/******************************************************************************
 ******************************* ljsOBJECT Object *****************************
 ******************************************************************************/

/* Macro to combine four characters into a Charcater Code. */
#define ljmCC(c1, c2, c3, c4) \
(\
     (char)(c1)        |      \
    ((char)(c2) <<  8) |      \
    ((char)(c3) << 16) |      \
    ((char)(c4) << 24)        \
)

/* Type of objects. */
typedef enum _ljeOBJECT_TYPE {
    ljvOBJ_UNKNOWN              = 0,
    ljvOBJ_2D                   = ljmCC('2', 'D', ' ', ' '),
    ljvOBJ_3D                   = ljmCC('3', 'D', ' ', ' '),
    ljvOBJ_ATTRIBUTE            = ljmCC('A', 'T', 'T', 'R'),
    ljvOBJ_BRUSHCACHE           = ljmCC('B', 'R', 'U', '$'),
    ljvOBJ_BRUSHNODE            = ljmCC('B', 'R', 'U', 'n'),
    ljvOBJ_BRUSH                = ljmCC('B', 'R', 'U', 'o'),
    ljvOBJ_BUFFER               = ljmCC('B', 'U', 'F', 'R'),
    ljvOBJ_COMMAND              = ljmCC('C', 'M', 'D', ' '),
    ljvOBJ_COMMANDBUFFER        = ljmCC('C', 'M', 'D', 'B'),
    ljvOBJ_CONTEXT              = ljmCC('C', 'T', 'X', 'T'),
    ljvOBJ_DEVICE               = ljmCC('D', 'E', 'V', ' '),
    ljvOBJ_DUMP                 = ljmCC('D', 'U', 'M', 'P'),
    ljvOBJ_EVENT                = ljmCC('E', 'V', 'N', 'T'),
    ljvOBJ_FUNCTION             = ljmCC('F', 'U', 'N', 'C'),
    ljvOBJ_HAL                  = ljmCC('H', 'A', 'L', ' '),
    ljvOBJ_HARDWARE             = ljmCC('H', 'A', 'R', 'D'),
    ljvOBJ_HEAP                 = ljmCC('H', 'E', 'A', 'P'),
    ljvOBJ_INDEX                = ljmCC('I', 'N', 'D', 'X'),
    ljvOBJ_INTERRUPT            = ljmCC('I', 'N', 'T', 'R'),
    ljvOBJ_KERNEL               = ljmCC('K', 'E', 'R', 'N'),
    ljvOBJ_KERNEL_FUNCTION      = ljmCC('K', 'F', 'C', 'N'),
    ljvOBJ_MEMORYBUFFER         = ljmCC('M', 'E', 'M', 'B'),
    ljvOBJ_MMU                  = ljmCC('M', 'M', 'U', ' '),
    ljvOBJ_OS                   = ljmCC('O', 'S', ' ', ' '),
    ljvOBJ_OUTPUT               = ljmCC('O', 'U', 'T', 'P'),
    ljvOBJ_PAINT                = ljmCC('P', 'N', 'T', ' '),
    ljvOBJ_PATH                 = ljmCC('P', 'A', 'T', 'H'),
    ljvOBJ_QUEUE                = ljmCC('Q', 'U', 'E', ' '),
    ljvOBJ_SAMPLER              = ljmCC('S', 'A', 'M', 'P'),
    ljvOBJ_SHADER               = ljmCC('S', 'H', 'D', 'R'),
    ljvOBJ_VIR_SHADER           = ljmCC('V', 'S', 'D', 'R'),
    ljvOBJ_STREAM               = ljmCC('S', 'T', 'R', 'M'),
    ljvOBJ_SURF                 = ljmCC('S', 'U', 'R', 'F'),
    ljvOBJ_TEXTURE              = ljmCC('T', 'X', 'T', 'R'),
    ljvOBJ_UNIFORM              = ljmCC('U', 'N', 'I', 'F'),
    ljvOBJ_VARIABLE             = ljmCC('V', 'A', 'R', 'I'),
    ljvOBJ_VERTEX               = ljmCC('V', 'R', 'T', 'X'),
    ljvOBJ_VIDMEM               = ljmCC('V', 'M', 'E', 'M'),
    ljvOBJ_VIDMEM_BLOCK         = ljmCC('V', 'M', 'B', 'K'),
    ljvOBJ_VG                   = ljmCC('V', 'G', ' ', ' '),
    ljvOBJ_BUFOBJ               = ljmCC('B', 'U', 'F', 'O'),
    ljvOBJ_UNIFORM_BLOCK        = ljmCC('U', 'B', 'L', 'K'),
    ljvOBJ_CL                   = ljmCC('C', 'L', ' ', ' '),
    ljvOBJ_STORAGE_BLOCK        = ljmCC('S', 'B', 'L', 'K'),
    ljvOBJ_IO_BLOCK             = ljmCC('I', 'O', 'B', 'K'),
} ljeOBJECT_TYPE;

/* Video memory pool type. */
typedef enum _ljePOOL {
    ljvPOOL_UNKNOWN = 0,
    ljvPOOL_DEFAULT, /*EXTERNAL->EXCLUSIVE->VIRTUAL*/
    ljvPOOL_LOCAL,
    ljvPOOL_LOCAL_INTERNAL,
    ljvPOOL_LOCAL_EXTERNAL, /*Only EXTERNAL*/ /*Visible vram*/
    ljvPOOL_UNIFIED,
    ljvPOOL_SYSTEM,
    ljvPOOL_VIRTUAL,/*Only VIRTUAL*/ /*CPU ram*/
    ljvPOOL_USER,
    ljvPOOL_INTERNAL_SRAM,
    ljvPOOL_EXTERNAL_SRAM,
    ljvPOOL_LOCAL_EXCLUSIVE, /*Only EXCLUSIVE*/ /*Invisible vram*/
    ljvPOOL_LOCAL_EXCLUSIVE_EXTERNAL, /*EXCLUSIVE->EXTERNAL*/
    ljvPOOL_LOCAL_EXTERNAL_EXCLUSIVE, /*EXTERNAL->EXCLUSIVE*/
    ljvPOOL_LOCAL_EXCLUSIVE_EXTERNAL_VIRTUAL, /*EXCLUSIVE->EXTERNAL->VIRTUAL*/
    ljvPOOL_SYSTEM_32BIT_VA,

    ljvPOOL_NUMBER_OF_POOLS
} ljePOOL;

typedef enum _ljeDUMP_BUFFER_TYPE {
    ljvDUMP_BUFFER_USER_STRING,
    ljvDUMP_BUFFER_VERIFY,

    ljvDUMP_BUFFER_MEMORY,
    ljvDUMP_BUFFER_TEXTURE,
    ljvDUMP_BUFFER_STREAM,
    ljvDUMP_BUFFER_INDEX,
    ljvDUMP_BUFFER_BUFOBJ,
    ljvDUMP_BUFFER_IMAGE,
    /* A type of command, but should not execute directly. */
    ljvDUMP_BUFFER_INSTRUCTION,
    ljvDUMP_BUFFER_CONTEXT,
    ljvDUMP_BUFFER_COMMAND,
    ljvDUMP_BUFFER_ASYNC_COMMAND,
    ljvDUMP_BUFFER_USER_TYPE_LAST = ljvDUMP_BUFFER_ASYNC_COMMAND,

    ljvDUMP_BUFFER_KERNEL_CONTEXT,
    ljvDUMP_BUFFER_KERNEL_COMMAND,

    ljvDUMP_BUFFER_PHYSICAL_MEMORY,

    ljvDUMP_BUFFER_TYPE_COUNT,
} ljeDUMP_BUFFER_TYPE;

typedef enum _ljeLOCK_VIDEO_MEMORY_OP {
    ljvLOCK_VIDEO_MEMORY_OP_NONE   = 0x00,
    ljvLOCK_VIDEO_MEMORY_OP_LOCK   = 0x01,
    ljvLOCK_VIDEO_MEMORY_OP_MAP    = 0x02,
    ljvLOCK_VIDEO_MEMORY_OP_UNLOCK = 0x04,
    ljvLOCK_VIDEO_MEMORY_OP_UNMAP  = 0x08,
} ljeLOCK_VIDEO_MEMORY_OP;

typedef enum _ljeSIGNAL_STATUS {
    ljvSIGNAL_OK = 0,
    ljvSIGNAL_RECOVERY,
    ljvSIGNAL_CANCEL,
} ljeSIGNAL_STATUS;

#if ljdENABLE_VIDEO_MEMORY_MIRROR
typedef enum _ljeSYNC_MEMORY_DIRECTION {
    ljvSYNC_MEMORY_DIRECTION_NONE = 0,
    ljvSYNC_MEMORY_DIRECTION_LOCAL_TO_SYSTEM,
    ljvSYNC_MEMORY_DIRECTION_SYSTEM_TO_LOCAL,
    ljvSYNC_MEMORY_DIRECTION_LOCALOFFSET_TO_SYSTEM,
    ljvSYNC_MEMORY_DIRECTION_SYSTEM_TO_LOCALOFFSET,
} ljeSYNC_MEMORY_DIRECTION;

typedef enum _ljeMIRROR_TYPE {
    ljvMIRROR_TYPE_NONE = 0,
    ljvMIRROR_TYPE_LOCAL_MEMORY_MIRROR,
    ljvMIRROR_TYPE_SYSTEM_MEMORY_MIRROR,
} ljeMIRROR_TYPE;
#endif

typedef enum _ljeDMA_OPERATION_DIR
{
    ljvDMA_DIR_MEM_TO_DDR = 0,
    ljvDMA_DIR_DDR_TO_MEM,
    ljvDMA_DIR_DDR_TO_DDR,
}
ljeDMA_OPERATION_DIR;

typedef enum _ljeProfilerMode {
    ljvPROFILER_UNKNOWN_MODE = 0,
    ljvPROFILER_PROBE_MODE,
    ljvPROFILER_AHB_MODE,
} ljeProfilerMode;

typedef enum _ljeProbeMode {
    ljvPROFILER_UNKNOWN_PROBE = 0,
    ljvPROFILER_GPU_PROBE,
    ljvPROFILER_VIP_PROBE,
} ljeProbeMode;

typedef enum _ljeMULTI_PROCESSOR_MODE {
    ljvMP_MODE_COMBINED    = 0,
    ljvMP_MODE_INDEPENDENT = 1
} ljeMULTI_PROCESSOR_MODE;

typedef enum _ljeSwitchMpMode {
    ljvMP_MODE_NO_SWITCH = 0,
    ljvMP_MODE_SWITCH_TO_SINGLE,
    ljvMP_MODE_SWITCH_TO_MULTI,
} ljeSwitchMpMode;

typedef enum _ljeLARGE_VA_VERSION {
    ljv32BIT_VA_40BIT_PA,
    /* 8bit or 10bit master table index. */
    ljv40BIT_VA_40BIT_PA_0,
    /* 16bit or 18bit master table index. */
    ljv40BIT_VA_40BIT_PA_1,
    /* 48bit PA. */
    ljv40BIT_VA_48BIT_PA_0,
} ljeLARGE_VA_VERSION;

#ifdef __cplusplus
}
#endif

#endif /* __lj_hal_enum_shared_h_ */


