/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

#ifndef __lj_hal_kernel_allocator_array_h_
#define __lj_hal_kernel_allocator_array_h_

extern ljeSTATUS
_GFPAlloctorInit(ljkOS Os, ljsDEBUGFS_DIR *Parent, ljkALLOCATOR *Allocator);

extern ljeSTATUS
_UserMemoryAlloctorInit(ljkOS Os, ljsDEBUGFS_DIR *Parent, ljkALLOCATOR *Allocator);

extern ljeSTATUS
_ReservedMemoryAllocatorInit(ljkOS Os, ljsDEBUGFS_DIR *Parent, ljkALLOCATOR *Allocator);

#ifdef CONFIG_DMA_SHARED_BUFFER
extern ljeSTATUS
_DmabufAlloctorInit(ljkOS Os, ljsDEBUGFS_DIR *Parent, ljkALLOCATOR *Allocator);
#endif

#ifndef NO_DMA_COHERENT
extern ljeSTATUS
_DmaAlloctorInit(ljkOS Os, ljsDEBUGFS_DIR *Parent, ljkALLOCATOR *Allocator);
#endif

/* Default allocator entry. */
ljsALLOCATOR_DESC allocatorArray[] = {
/*BUS32: dma first;  BUS40: gfp first;  you need adjust it manually*/
/*#ifndef NO_DMA_COHERENT
        ljmkDEFINE_ALLOCATOR_DESC("dma", _DmaAlloctorInit),
#endif
*/
    /* GFP allocator. */
    ljmkDEFINE_ALLOCATOR_DESC("gfp", _GFPAlloctorInit),

    /* User memory importer. */
    ljmkDEFINE_ALLOCATOR_DESC("user", _UserMemoryAlloctorInit),

#ifdef CONFIG_DMA_SHARED_BUFFER
    /* Dmabuf allocator. */
    ljmkDEFINE_ALLOCATOR_DESC("dmabuf", _DmabufAlloctorInit),
#endif

#ifndef NO_DMA_COHERENT
    ljmkDEFINE_ALLOCATOR_DESC("dma", _DmaAlloctorInit),
#endif

    ljmkDEFINE_ALLOCATOR_DESC("reserved-mem", _ReservedMemoryAllocatorInit),
};

#endif
