/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

#if LINUX_VERSION_CODE >= KERNEL_VERSION(5, 16, 0)
# include <linux/stdarg.h>
#else
# include <stdarg.h>
#endif

#ifndef __lj_hal_kernel_debugfs_h_
# define __lj_hal_kernel_debugfs_h_

# define MAX_LINE_SIZE   768 /* Max bytes for a line of debug info */

typedef struct _ljsDEBUGFS_DIR *ljkDEBUGFS_DIR;
typedef struct _ljsDEBUGFS_DIR {
    struct dentry       *root;
    struct list_head     nodeList;
} ljsDEBUGFS_DIR;

typedef struct _ljsINFO {
    const char          *name;
    int                 (*show)(struct seq_file *m, void *data);
    int                 (*write)(const char __user *buf, size_t count, void *data);
} ljsINFO;

typedef struct _ljsINFO_NODE {
    ljsINFO             *info;
    ljtPOINTER           device;
    struct dentry       *entry;
    struct list_head     head;
} ljsINFO_NODE;

ljeSTATUS
ljkDEBUGFS_DIR_Init(ljkDEBUGFS_DIR  Dir, struct dentry *root, ljtCONST_STRING Name);

ljeSTATUS
ljkDEBUGFS_DIR_CreateFiles(ljkDEBUGFS_DIR Dir, ljsINFO *List,
                           int count, ljtPOINTER Data);

ljeSTATUS
ljkDEBUGFS_DIR_RemoveFiles(ljkDEBUGFS_DIR Dir, ljsINFO *List, int count);

void
ljkDEBUGFS_DIR_Deinit(ljkDEBUGFS_DIR Dir);

#endif /* __lj_hal_kernel_debugfs_h_ */
