/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

#ifndef _lj_hal_kernel_mutex_h_
#define _lj_hal_kernel_mutex_h_

#include "lj_hal.h"
#include <linux/mutex.h>

#if IS_ENABLED(CONFIG_PROVE_LOCKING) && (LINUX_VERSION_CODE >= KERNEL_VERSION(5, 1, 0))

struct key_mutex {
    struct mutex mut;
    struct lock_class_key key;
};


#define ljkOS_CreateMutex(Os, Mutex)                                               \
({                                                                                 \
    /* Allocate the mutex structure. */                                            \
    struct key_mutex *key_mut;                                                     \
    ljeSTATUS _status = ljkOS_Allocate(Os, ljmSIZEOF(struct key_mutex), (ljtPOINTER *) &key_mut); \
                                                                                   \
    if (ljmIS_SUCCESS(_status)) {                                                  \
        /* Initialize the mutex. */                                                \
        lockdep_register_key(&key_mut->key);                                       \
        __mutex_init((&key_mut->mut), #Mutex, (&key_mut->key));                    \
    }                                                                              \
    *(Mutex) = (ljtPOINTER)key_mut;                                                \
    _status;                                                                       \
})
#else

/* Create a new mutex. */
#define ljkOS_CreateMutex(Os, Mutex)                                        \
({                                                                          \
    /* Allocate the mutex structure. */                                     \
    ljeSTATUS _status = ljkOS_Allocate(Os, ljmSIZEOF(struct mutex), Mutex); \
                                                                            \
    if (ljmIS_SUCCESS(_status)) {                                           \
        /* Initialize the mutex. */                                         \
        mutex_init(*(struct mutex **)Mutex);                                \
    }                                                                       \
                                                                            \
    _status;                                                                \
})
#endif

#endif
