/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

#ifndef __lj_hal_kernel_os_h_
#define __lj_hal_kernel_os_h_

typedef struct _LINUX_MDL     LINUX_MDL,     *PLINUX_MDL;
typedef struct _LINUX_MDL_MAP LINUX_MDL_MAP, *PLINUX_MDL_MAP;

struct _LINUX_MDL_MAP {
    ljtINT                  pid;

    /* map references. */
    ljtUINT32               count;

    struct vm_area_struct  *vma;
    ljtPOINTER              vmaAddr;
    ljtBOOL                 cacheable;
    ljtBOOL                 fromDRM;

    struct list_head        link;
};

struct _LINUX_MDL {
    ljkOS                   os;

    atomic_t                refs;

    /* Kernel address. */
    char                   *addr;

    /* Size and covered page count. */
    size_t                  bytes;
    size_t                  numPages;

    ljtBOOL                 contiguous;
    dma_addr_t              dmaHandle;
    ljtBOOL                 cacheable;

    struct page             **pages;
    ljtBOOL                 wrapped;

    /* maps mutex */
    struct mutex            mapsMutex;
    struct list_head        mapsHead;

    /* Pointer to allocator which allocates memory for this mdl. */
    void                   *allocator;

    /* Private data used by allocator. */
    void                   *priv;

    uint                    gid;

    struct list_head        link;

    ljtBOOL                 pageUnit1M;

    /* list header for sub mdl for dynamic mapping */
    struct list_head        rmaHead;

    /* sub mdl list */
    struct list_head        rmaLink;

    /* If it is wrapped node from logical. */
    ljtBOOL                 wrapFromLogical;
    /* If it is wrapped node from physical. */
    ljtBOOL                 wrapFromPhysical;

    /* Platform device structure */
    ljtPOINTER              device;

    /* If the mdl is allocated for user space. */
    ljtBOOL                 fromUser;

    ljeVIDMEM_TYPE          type;
};

extern PLINUX_MDL_MAP
FindMdlMap(PLINUX_MDL Mdl, ljtINT PID);

typedef struct _DRIVER_ARGS {
    ljtUINT64               InputBuffer;
    ljtUINT64               InputBufferSize;
    ljtUINT64               OutputBuffer;
    ljtUINT64               OutputBufferSize;
} DRIVER_ARGS;

#endif /* __lj_hal_kernel_os_h_ */
