/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

#ifndef _lj_hal_kernel_platform_aimotive_edma_dev_h_
#define _lj_hal_kernel_platform_aimotive_edma_dev_h_

#include <linux/types.h>
#include <linux/mutex.h>
#include <linux/completion.h>
#include "lj_hal.h"
#include "lj_hal_base.h"
#include "lj_hal_types.h"
#include "lj_hal_profiler.h"
#include "lj_hal_driver.h"
#include "lj_hal_kernel_platform.h"
#include "lj_hal_kernel_dma_engine.h"
#include "lj_hal_kernel_platform_edma.h"

#define DMA_POLL_TIMEOUT    (5000)

/*define amba dma regs*/
#define MISC_REG_BASE                   0x308400
#define MISC_DMA_AADDR_HIGH_OFFSET      0x18
#define MISC_DMA_CONFIG_OFFSET          0x10
#define DEBUG_STATUS_REGISTER           0x330d00
#define DEBUG_COMMAND_REGISTER          0x330d04
#define DEBUG_INSTRUCTION_0_REGISTER    0x330d08
#define DEBUG_INSTRUCTION_1_REGISTER    0x330d0c
#define INTERRUPT_ENABLE_REGISTER       0x330020
#define INTERRUPT_STATUS_REGISTER       0x330028
#define INTERRUPT_CLEAR_REGISTER        0x33002c

#define AMBA_TR_LEN_LIMIT_1             0x1010000
#define AMBA_TR_LEN_LIMIT_2             0x1000000
#define AMBA_TR_LEN_LIMIT_3             0x10000

typedef enum
{
    ljvDMA_UNUSE = 0,
    ljvDMA_USED,
}ljvEDMA_STATE;

typedef enum
{
    ljvEDMA_MEM_TO_DEV = 1,
    ljvEDMA_DEV_TO_MEM,
}ljvEDMA_DIRECTION;

typedef struct
{
    ljsDMA_CHANNEL *dmaChan;
    ljvEDMA_STATE state;
    ljtUINT64 src;
    ljtUINT64 dst;
    ljtSIZE_T len;
    ljeDMA_TX_DIRECTION dir;
    ljtBOOL sync_wait;
    ljdDMA_TX_IDENTIFIER identifier;
    struct completion comp;
    ljtUINT index;
    struct sg_table *sgt;
}ljsEDMA_CHAN;

typedef struct
{
    edma_device *edma_dev;
    ljsEDMA_CHAN *rdChan;
    ljsEDMA_CHAN *wrChan;
    struct mutex dmaMutex;
    unsigned long flag;
//    ljtBOOL dmaBusy;  fq
}ljsEDMA;

ljeSTATUS ljkEDMA_DeviceInit(edma_device *edma);
void ljkEDMA_DeviceExit(void);
#if 0
ljeSTATUS ljkEDMA_SyncMemory(
        IN ljtPOINTER Object,
        IN ljtPOINTER DstNode,
        IN ljtPOINTER SrcNode,
        IN ljtUINT32  Reason,
        IN ljtUINT64  SyncLen,
        IN ljtUINT64  Offset
        );
#else
ljeSTATUS
ljkEDMA_dmaCopy(ljtPOINTER Object, ljsDMA_TRANS_INFO *Info);
#endif

ljeSTATUS ljkDMA_Operaton(
        IN ljtPOINTER Object,
        IN ljtPOINTER Node_Src,
        IN ljtPOINTER Node_Dst,
        IN ljtUINT32  Dir,
        IN ljtUINT64  TransLen
        );

ljeSTATUS ljkEDMA_Exit(void);

#endif
