/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

#ifndef __lj_hal_kernel_platform_gp_h_
#define __lj_hal_kernel_platform_gp_h_

#include <linux/io.h>
#include "lj_hal_kernel_platform_edma.h"
#include "lj_hal_kernel_platform_edma_dev.h"

#if USE_LINUX_PCIE

#define PCI_BAR_0       0x0
#define PCI_BAR_2       0x2
#define PCI_BAR_4       0x4
#define PCI_BAR_5       0x5

/*
 * register regions
 */
#define REG_GP101_GART_OFFSET   0x1400      /* GART offset */
#if 0
#define REG_GP101_HDMI0_OFFSET  0xF000
#define REG_GP101_HDMI1_OFFSET  0xF400
#define REG_GP101_DDR_OFFSET    0x1800
#endif

#if 1 /*GP203*/
#define REG_3D_OFFSET           0x40000     /* Offset of major/first 3D registers. */
#define REG_3D_SIZE             (256 << 10) /* Size of 3D registers. */

#define REG_3D1_OFFSET          0x80000     /* Offset of major/first 3D registers. */
#define REG_3D1_SIZE            (256 << 10) /* Size of 3D registers. */
#define REG_2D_OFFSET           0xc0000     /* Offset of 2D register */
#define REG_2D_SIZE             (256 << 10) /* Size of 2D register. */
#else /*GP301*/
#define REG_3D_OFFSET           0x640000     /* Offset of major/first 3D registers. */
#define REG_3D_SIZE             (256 << 10) /* Size of 3D registers. */

#define REG_3D1_OFFSET          0x680000     /* Offset of major/first 3D registers. */
#define REG_3D1_SIZE            (256 << 10) /* Size of 3D registers. */
#define REG_2D_OFFSET           0x6c0000     /* Offset of 2D register */
#define REG_2D_SIZE             (256 << 10) /* Size of 2D register. */
#endif

/* core registers */
#define REG_CHIP_ID_ADR         (0x8 << 2)

#endif  /* ~USE_LINUX_PCIE */

#endif
