/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

/******************************************************************************
*
*  版权所有(c)，2020-2099，中船第709研究所
*
*******************************************************************************
*
*  文件名称: lj_hal_kernel_platform_hdma.h
*  版 本 号: V1.0
*  作    者: cbb
*  生成日期: 2023年5月15日
*
*  功能描述: HDMA
*
*  修改历史:
*         1. 日    期: 2023年5月15日
*            作    者: cbb
*            修改内容: 创建文件
*
******************************************************************************/

#include "lj_hal_kernel_platform_edma.h"


/*==========================================================*/
/*   PCIe HDMA define   */
/*==========================================================*/
#define HDMA_BASE_ADDR                                       0x780000//hdma bar2 offset

#define HDMA_EN_OFF_WRCH(i)                                  (HDMA_BASE_ADDR+i*0x200+0x00L)
#define HDMA_DOORBELL_OFF_WRCH(i)                            (HDMA_BASE_ADDR+i*0x200+0x04L)
#define HDMA_ELEM_PF_OFF_WRCH(i)                             (HDMA_BASE_ADDR+i*0x200+0x08L)
#define HDMA_HANDSHAKE_OFF_WRCH(i)                           (HDMA_BASE_ADDR+i*0x200+0x0cL)
#define HDMA_LLP_LOW_OFF_WRCH(i)                             (HDMA_BASE_ADDR+i*0x200+0x10L)
#define HDMA_LLP_HIGH_OFF_WRCH(i)                            (HDMA_BASE_ADDR+i*0x200+0x14L)
#define HDMA_CYCLE_OFF_WRCH(i)                               (HDMA_BASE_ADDR+i*0x200+0x18L)
#define HDMA_XFERSIZE_OFF_WRCH(i)                            (HDMA_BASE_ADDR+i*0x200+0x1cL)
#define HDMA_SAR_LOW_OFF_WRCH(i)                             (HDMA_BASE_ADDR+i*0x200+0x20L)
#define HDMA_SAR_HIGH_OFF_WRCH(i)                            (HDMA_BASE_ADDR+i*0x200+0x24L)
#define HDMA_DAR_LOW_OFF_WRCH(i)                             (HDMA_BASE_ADDR+i*0x200+0x28L)
#define HDMA_DAR_HIGH_OFF_WRCH(i)                            (HDMA_BASE_ADDR+i*0x200+0x2cL)
#define HDMA_WATERMARK_EN_OFF_WRCH(i)                        (HDMA_BASE_ADDR+i*0x200+0x30L)
#define HDMA_CONTROL1_OFF_WRCH(i)                            (HDMA_BASE_ADDR+i*0x200+0x34L)
#define HDMA_FUNC_NUM_OFF_WRCH(i)                            (HDMA_BASE_ADDR+i*0x200+0x38L)
#define HDMA_QOS_OFF_WRCH(i)                                 (HDMA_BASE_ADDR+i*0x200+0x3cL)
#define HDMA_STATUS_OFF_WRCH(i)                              (HDMA_BASE_ADDR+i*0x200+0x80L)
#define HDMA_INT_STATUS_OFF_WRCH(i)                          (HDMA_BASE_ADDR+i*0x200+0x84L)
#define HDMA_INT_SETUP_OFF_WRCH(i)                           (HDMA_BASE_ADDR+i*0x200+0x88L)
#define HDMA_INT_CLEAR_OFF_WRCH(i)                           (HDMA_BASE_ADDR+i*0x200+0x8cL)
#define HDMA_MSI_STOP_LOW_OFF_WRCH(i)                        (HDMA_BASE_ADDR+i*0x200+0x90L)
#define HDMA_MSI_STOP_HIGH_OFF_WRCH(i)                       (HDMA_BASE_ADDR+i*0x200+0x94L)
#define HDMA_MSI_WATERMARK_LOW_OFF_WRCH(i)                   (HDMA_BASE_ADDR+i*0x200+0x98L)
#define HDMA_MSI_WATERMARK_HIGH_OFF_WRCH(i)                  (HDMA_BASE_ADDR+i*0x200+0x9cL)
#define HDMA_MSI_ABORT_LOW_OFF_WRCH(i)                       (HDMA_BASE_ADDR+i*0x200+0xa0L)
#define HDMA_MSI_ABORT_HIGH_OFF_WRCH(i)                      (HDMA_BASE_ADDR+i*0x200+0xa4L)
#define HDMA_MSI_MSGD_OFF_WRCH(i)                            (HDMA_BASE_ADDR+i*0x200+0xa8L)

#define HDMA_EN_OFF_RDCH(i)                                  (HDMA_BASE_ADDR+i*0x200+0x100+0x00L)
#define HDMA_DOORBELL_OFF_RDCH(i)                            (HDMA_BASE_ADDR+i*0x200+0x100+0x04L)
#define HDMA_ELEM_PF_OFF_RDCH(i)                             (HDMA_BASE_ADDR+i*0x200+0x100+0x08L)
#define HDMA_HANDSHAKE_OFF_RDCH(i)                           (HDMA_BASE_ADDR+i*0x200+0x100+0x0cL)
#define HDMA_LLP_LOW_OFF_RDCH(i)                             (HDMA_BASE_ADDR+i*0x200+0x100+0x10L)
#define HDMA_LLP_HIGH_OFF_RDCH(i)                            (HDMA_BASE_ADDR+i*0x200+0x100+0x14L)
#define HDMA_CYCLE_OFF_RDCH(i)                               (HDMA_BASE_ADDR+i*0x200+0x100+0x18L)
#define HDMA_XFERSIZE_OFF_RDCH(i)                            (HDMA_BASE_ADDR+i*0x200+0x100+0x1cL)
#define HDMA_SAR_LOW_OFF_RDCH(i)                             (HDMA_BASE_ADDR+i*0x200+0x100+0x20L)
#define HDMA_SAR_HIGH_OFF_RDCH(i)                            (HDMA_BASE_ADDR+i*0x200+0x100+0x24L)
#define HDMA_DAR_LOW_OFF_RDCH(i)                             (HDMA_BASE_ADDR+i*0x200+0x100+0x28L)
#define HDMA_DAR_HIGH_OFF_RDCH(i)                            (HDMA_BASE_ADDR+i*0x200+0x100+0x2cL)
#define HDMA_WATERMARK_EN_OFF_RDCH(i)                        (HDMA_BASE_ADDR+i*0x200+0x100+0x30L)
#define HDMA_CONTROL1_OFF_RDCH(i)                            (HDMA_BASE_ADDR+i*0x200+0x100+0x34L)
#define HDMA_FUNC_NUM_OFF_RDCH(i)                            (HDMA_BASE_ADDR+i*0x200+0x100+0x38L)
#define HDMA_QOS_OFF_RDCH(i)                                 (HDMA_BASE_ADDR+i*0x200+0x100+0x3cL)
#define HDMA_STATUS_OFF_RDCH(i)                              (HDMA_BASE_ADDR+i*0x200+0x100+0x80L)
#define HDMA_INT_STATUS_OFF_RDCH(i)                          (HDMA_BASE_ADDR+i*0x200+0x100+0x84L)
#define HDMA_INT_SETUP_OFF_RDCH(i)                           (HDMA_BASE_ADDR+i*0x200+0x100+0x88L)
#define HDMA_INT_CLEAR_OFF_RDCH(i)                           (HDMA_BASE_ADDR+i*0x200+0x100+0x8cL)
#define HDMA_MSI_STOP_LOW_OFF_RDCH(i)                        (HDMA_BASE_ADDR+i*0x200+0x100+0x90L)
#define HDMA_MSI_STOP_HIGH_OFF_RDCH(i)                       (HDMA_BASE_ADDR+i*0x200+0x100+0x94L)
#define HDMA_MSI_WATERMARK_LOW_OFF_RDCH(i)                   (HDMA_BASE_ADDR+i*0x200+0x100+0x98L)
#define HDMA_MSI_WATERMARK_HIGH_OFF_RDCH(i)                  (HDMA_BASE_ADDR+i*0x200+0x100+0x9cL)
#define HDMA_MSI_ABORT_LOW_OFF_RDCH(i)                       (HDMA_BASE_ADDR+i*0x200+0x100+0xa0L)
#define HDMA_MSI_ABORT_HIGH_OFF_RDCH(i)                      (HDMA_BASE_ADDR+i*0x200+0x100+0xa4L)
#define HDMA_MSI_MSGD_OFF_RDCH(i)                            (HDMA_BASE_ADDR+i*0x200+0x100+0xa8L)

//channel status CS;HDMA_STATUS_OFF_WRCH,HDMA_STATUS_OFF_RDCH
#define HDMA_CS_RUNNING                  (0x1L)
#define HDMA_CS_ABORTED                  (0x2L)
#define HDMA_CS_STOPPED                  (0x3L)

//HDMA_DOORBELL_OFF_WRCH,HDMA_DOORBELL_OFF_RDCH
#define HDMA_TRANSFER_START              (0x1L << 0)
#define HDMA_TRANSFER_STOP               (0x1L << 1)

//HDMA_INT_STATUS_OFF_WRCH,HDMA_INT_STATUS_OFF_RDCH
#define HDMA_STOP_INT                    (0x1L << 0)
#define HDMA_WATERMARK_INT               (0x1L << 1)
#define HDMA_ABORT_INT                   (0x1L << 2)
#define HDMA_ERROR_INT                   (0xfL << 3)

#define HDMA_V0_MAX_NR_CH                   8
#define HDMA_V0_LOCAL_ABORT_INT_EN			BIT(6)
#define HDMA_V0_REMOTE_ABORT_INT_EN			BIT(5)
#define HDMA_V0_LOCAL_STOP_INT_EN			BIT(4)
#define HDMA_V0_REMOTEL_STOP_INT_EN			BIT(3)
#define HDMA_V0_ABORT_INT_MASK				BIT(2)
#define HDMA_V0_STOP_INT_MASK				BIT(0)
#define HDMA_V0_LINKLIST_EN					BIT(0)

void hdma_dev_init(iomem_t reg_base);
int threadHdma(void *ctxt);
irqreturn_t hdma_dev_interrupt_handler(int irq, void *dev_id);
void hdma_dev_handle_done(edma_channel *edma_chan);
ljeSTATUS hdma_dev_alloc_chan_resources(ljsDMA_CHANNEL *chan);
void hdma_dev_free_chan_resources(ljsDMA_CHANNEL *chan);
ljsDMA_TX_DESCRIPTOR* hdma_dev_prep_slave_sg(
    ljsDMA_CHANNEL *chan,
    struct scatterlist *sgl,
    size_t sg_len,
    ljeDMA_TX_DIRECTION direction,
    unsigned int flags,
    void *context
    );
ljsDMA_TX_DESCRIPTOR* hdma_dev_prep_dma_memcpy(
    ljsDMA_CHANNEL *Chan,
    dma_addr_t Src,
    dma_addr_t Dst,
    ljtSIZE_T Len,
    ljtUINT32 Flag
    );
ljeSTATUS hdma_terminate_all(ljsDMA_CHANNEL *chan);
ljeDMA_STATUS hdma_tx_status(
    ljsDMA_CHANNEL *chan,
    ljdDMA_TX_IDENTIFIER identifier,
    ljsDMA_TX_STATE *state
    );
void hdma_issue_pending(ljsDMA_CHANNEL *chan);
void hdma_complete_all(edma_channel *edma_chan);
ljeSTATUS hdma_dev_channels_init(edma_device *edma_dev);

