/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

#ifndef __lj_hal_options_h_
#define __lj_hal_options_h_

#ifndef ljdMAINMEM_CMD_BUFFER
#   define ljdMAINMEM_CMD_BUFFER                0
#endif

#ifndef ljdCMD_VMEM_WRITE_CHECK
#   define ljdCMD_VMEM_WRITE_CHECK              1
#endif

/*
 * ljdVMEM_ALIGN_WITH_PAD
 *
 *      insert padding bytes for alignment to avoid node split
 */
#ifndef ljdVMEM_ALIGN_WITH_PAD
#   define ljdVMEM_ALIGN_WITH_PAD               1
#endif
#if ljdVMEM_ALIGN_WITH_PAD
#   define ljdVMEM_ALIGN_MAX_PAD                256
#endif

/*
 *   ljdSECURITY
 */
#ifndef ljdSECURITY
#define ljdSECURITY                     0
#endif

/*
 *   ljdPRINT_VERSION
 *
 *       Print HAL version.
 */
#ifndef ljdPRINT_VERSION
#define ljdPRINT_VERSION                0
#endif

/*
 *   USE_KERNEL_VIRTUAL_BUFFERS
 *
 *       This define enables the use of VM for ljkCommand and fence buffers.
 */
#ifndef USE_KERNEL_VIRTUAL_BUFFERS
#if defined(UNDER_CE)
#  define USE_KERNEL_VIRTUAL_BUFFERS  1
# else
#  define USE_KERNEL_VIRTUAL_BUFFERS  1
# endif
#endif

/*
 *   USE_NEW_LINUX_SIGNAL
 *
 *       This define enables the Linux kernel signaling between kernel and user.
 */
#ifndef USE_NEW_LINUX_SIGNAL
#define USE_NEW_LINUX_SIGNAL            0
#endif

/*
 *   USE_LINUX_PCIE
 *
 *       This define enables ljmcore as a Linux PCIE driver.
 */
#ifndef USE_LINUX_PCIE
#define USE_LINUX_PCIE                  1
#endif

/*
 *   LJMICRO_PROFILER
 *
 *       This define enables the profiler for hardware counters.
 */
#ifndef LJMICRO_PROFILER
#define LJMICRO_PROFILER                1
#endif

/*
 *   ljdUSE_VG
 *
 *       Enable VG HAL layer (only for LJ350).
 */
#ifndef ljdUSE_VG
#define ljdUSE_VG                       0
#endif

/*
 *   ljdUSE_VX
 *
 *       Enable VX HAL layer.
 */
#ifndef ljdUSE_VX
#define ljdUSE_VX                       1
#endif

/*
 *   PROFILE_HAL_COUNTERS
 *
 *       This define enables HAL counter profiling support.  HW and SHADER
 *       counter profiling depends on this.
 */
#ifndef PROFILE_HAL_COUNTERS
#define PROFILE_HAL_COUNTERS            1
#endif

/*
 *   PROFILE_HW_COUNTERS
 *
 *       This define enables HW counter profiling support.
 */
#ifndef PROFILE_HW_COUNTERS
#define PROFILE_HW_COUNTERS             1
#endif

/*
 *   PROFILE_SHADER_COUNTERS
 *
 *       This define enables SHADER counter profiling support.
 */
#ifndef PROFILE_SHADER_COUNTERS
#define PROFILE_SHADER_COUNTERS         1
#endif

/*
 *   COMMAND_PROCESSOR_VERSION
 *
 *       The version of the command buffer and task manager.
 */
#define COMMAND_PROCESSOR_VERSION           1

/*
 *   ljdDUMP
 *
 *       Dump for hw capture.
 *       When set to 1, a dump of all states and memory uploads, as well as other
 *       hardware related execution will be printed to the debug console.  This
 *       data can be used for playing back applications.
 *
 *       When set to 2, for vxc, all output memory will be dump.
 *
 *       Please get tweak settings in lj_hal_dump.h.
 */
#ifndef ljdDUMP
#define ljdDUMP                         0
#endif

/*
 *   ljdDUMP_IN_KERNEL
 *
 *       Enhanced feature for hw capture.
 *       Required for MCFE.
 *       When set to 1, all dumps will happen in the kernel.  This is handy if
 *       you want the kernel to dump its command buffers as well and the data
 *       needs to be in sync.
 *
 *       Dump in kernel implies kernel command dump.
 *       See debugfs:/lj/dump/ for runtime configuration.
 */
#ifndef ljdDUMP_IN_KERNEL
#define ljdDUMP_IN_KERNEL               0
#endif

/*
 *   ljdDUMP_HW_SUBCOMMAND
 *
 *       Dump for hw command buffer
 *       When set to 1, will dump hw command buffer when GPU/VIP hang.
 */
#ifndef ljdDUMP_HW_SUBCOMMAND
#define ljdDUMP_HW_SUBCOMMAND           0
#endif

/*
 *   ljdDUMP_2D
 *
 *       Dump for 2D capture.
 *       When set to non-zero, it will dump the 2D command and surface.
 *
 *       Please get tweak settings in lj_hal_dump.h.
 */
#ifndef ljdDUMP_2D
#define ljdDUMP_2D                      0
#endif

/*
 *   ljdDUMP_API
 *
 *       Dump driver level API.
 *       When set to 1, a high level dump of the EGL and GL/VG APs's are
 *       captured.
 *
 *       Please get tweak settings in lj_hal_dump.h.
 */
#ifndef ljdDUMP_API
#define ljdDUMP_API                     0
#endif

/*
 *   ljdDUMP_PER_OPERATION
 *
 *       Operation based dump.
 *
 *       Dump the block as below.
 *       1. Multiple operations belong to the same SW tiling block.
 *       2. Single operation which is NOT in any SW tiling block.
 */
#ifndef ljdDUMP_PER_OPERATION
#define ljdDUMP_PER_OPERATION           0
#endif

/*
 *   ljdDEBUG_OPTION
 *       When set to 1, the debug options are enabled. We must set other MACRO to enable
 *       sub case.
 */
#ifndef ljdDEBUG_OPTION
#define ljdDEBUG_OPTION                 0

#if ljdDEBUG_OPTION
/*
 *   ljdDEBUG_OPTION_KEY
 *       The process name of debug application.
 */
#ifndef ljdDEBUG_OPTION_KEY
#   define ljdDEBUG_OPTION_KEY                 "process"
#  endif
/*
 *   ljdDEBUG_OPTION_NO_GL_DRAWS
 *       When set to 1, all glDrawArrays and glDrawElements will be skip.
 */
#ifndef ljdDEBUG_OPTION_NO_GL_DRAWS
#   define ljdDEBUG_OPTION_NO_GL_DRAWS         0
#  endif
/*
 *   ljdDEBUG_OPTION_NO_DRAW_PRIMITIVES
 *       When set to 1, all DrawPrimitives will be skip.
 */
#ifndef ljdDEBUG_OPTION_NO_DRAW_PRIMITIVES
#   define ljdDEBUG_OPTION_NO_DRAW_PRIMITIVES  0
#  endif
/*
 *   ljdDEBUG_OPTION_SKIP_SWAP
 *       When set to 1, just one out of ljdDEBUG_OPTION_SKIP_FRAMES(such as 1/10)
 *       eglSwapBuffers will be resolve, others skip.
 */
#ifndef ljdDEBUG_OPTION_SKIP_SWAP
#   define ljdDEBUG_OPTION_SKIP_SWAP                   0
#   define ljdDEBUG_OPTION_SKIP_FRAMES                 10
#  endif
/*
 *   ljdDEBUG_OPTION_FORCE_16BIT_RENDER_TARGET
 *       When set to 1, the format of render target will force to RGB565.
 */
#ifndef ljdDEBUG_OPTION_FORCE_16BIT_RENDER_TARGET
#   define ljdDEBUG_OPTION_FORCE_16BIT_RENDER_TARGET   0
#  endif
/*
 *   ljdDEBUG_OPTION_NONE_TEXTURE
 *       When set to 1, the type of texture will be set to
 *       0x0.
 */
#ifndef ljdDEBUG_OPTION_NONE_TEXTURE
#   define ljdDEBUG_OPTION_NONE_TEXTURE    0
#  endif
/*
 *   ljdDEBUG_OPTION_NONE_DEPTH
 *       When set to 1, the depth format of surface will be set to ljvSURF_UNKNOWN.
 */
#ifndef ljdDEBUG_OPTION_NONE_DEPTH
#   define ljdDEBUG_OPTION_NONE_DEPTH      0
#  endif

/*
 *   ljdDEBUG_FORCE_CONTEXT_UPDATE
 *       When set to 1, context will be updated before every commit.
 */
#ifndef ljdDEBUG_FORCE_CONTEXT_UPDATE
#   define ljdDEBUG_FORCE_CONTEXT_UPDATE   0
#  endif

/*
 *   ljdDEBUG_OPTION_SPECIFY_POOL
 *       When set to 1, pool of each type surface can be specified by
 *       changing poolPerType[] in ljsSURF_NODE_Construct.
 */
#ifndef ljdDEBUG_OPTION_SPECIFY_POOL
#   define ljdDEBUG_OPTION_SPECIFY_POOL    0
#  endif

# endif
#endif

/*
 *   ljdENABLE_FSCALE_VAL_ADJUST
 *       When non-zero, FSCALE_VAL when ljvPOWER_ON can be adjusted externally.
 */
#ifndef ljdENABLE_FSCALE_VAL_ADJUST
#define ljdENABLE_FSCALE_VAL_ADJUST             1
#endif

#ifndef ljdCAPTURE_ONLY_MODE
#define ljdCAPTURE_ONLY_MODE                    0
#endif

/*
 *   ljdNULL_DRIVER
 *
 *   Set to 1 for infinite speed hardware.
 *   Set to 2 for bypassing the HAL.
 */
#ifndef ljdNULL_DRIVER
#define ljdNULL_DRIVER                          0
#endif

/*
 *   ljdENABLE_TIMEOUT_DETECTION
 *
 *       Enable timeout detection.
 */
#ifndef ljdENABLE_TIMEOUT_DETECTION
#define ljdENABLE_TIMEOUT_DETECTION             0
#endif

/*
 *   ljdCMD_BUFFER_SIZE
 *
 *       Number of bytes in a command buffer.
 */
#ifndef ljdCMD_BUFFER_SIZE
#if ljdCAPTURE_ONLY_MODE
#  define ljdCMD_BUFFER_SIZE                  (4 << 10)
# else
#  define ljdCMD_BUFFER_SIZE                  (256 << 10)	/*(128 << 10)*/
# endif
#endif

/*
 *   ljdCMD_BLT_BUFFER_SIZE
 *
 *       Number of bytes in a command buffer.
 */
#ifndef ljdCMD_BLT_BUFFER_SIZE
#define ljdCMD_BLT_BUFFER_SIZE                  (1 << 10)
#endif

/*
 *   ljdCMD_BUFFERS
 *
 *       Number of command buffers to use per client.
 */
#ifndef ljdCMD_BUFFERS
#if ljdCAPTURE_ONLY_MODE
#  define ljdCMD_BUFFERS                      1
# else
#  define ljdCMD_BUFFERS                      2
# endif
#endif

/*
 *   ljdMAX_CMD_BUFFERS
 *
 *       Maximum number of command buffers to use per client.
 */
#ifndef ljdMAX_CMD_BUFFERS
#define ljdMAX_CMD_BUFFERS                      8
#endif

/*
 *   ljdCOMMAND_QUEUES
 *
 *       Number of command queues in the kernel.
 */
#ifndef ljdCOMMAND_QUEUES
#define ljdCOMMAND_QUEUES                       2
#endif

/*
 *   ljdPOWER_CONTROL_DELAY
 *
 *       The delay in milliseconds required to wait until the GPU has woke up
 *       from a suspend or power-down state.  This is system dependent because
 *       the bus clock also needs to stabalize.
 */
#ifndef ljdPOWER_CONTROL_DELAY
#define ljdPOWER_CONTROL_DELAY                  0
#endif

/*
 *   ljdMMU_SIZE
 *
 *       Size of the MMU page table in bytes.  Each 4 bytes can hold 4kB worth of
 *       virtual data.
 */
#ifndef ljdMMU_SIZE
#define ljdMMU_SIZE                             (256 << 10)
#endif

#ifndef ljdLJ355_VGMMU_MEMORY_SIZE_KB
#define ljdLJ355_VGMMU_MEMORY_SIZE_KB           32
#endif

/*
 *   ljdREGISTER_READ_FROM_USER
 *   ljdREGISTER_WRITE_FROM_USER
 *
 *       Set to 1 to allow IOCTL calls to get through from user land.  This
 *       should only be in debug or development drops.
 */
#ifndef ljdREGISTER_READ_FROM_USER
#define ljdREGISTER_READ_FROM_USER              1
#endif

#ifndef ljdREGISTER_WRITE_FROM_USER
#define ljdREGISTER_WRITE_FROM_USER             0
#endif

/*
 *   ljdHEAP_SIZE
 *
 *       Set the allocation size for the internal heaps.  Each time a heap is
 *       full, a new heap will be allocated with this minmimum amount of bytes.
 *       The bigger this size, the fewer heaps there are to allocate, the better
 *       the performance.  However, heaps won't be freed until they are
 *       completely free, so there might be some more memory waste if the size is
 *       too big.
 */
#ifndef ljdHEAP_SIZE
#define ljdHEAP_SIZE (64 << 10)
#endif

/*
 *   ljdPOWER_SUSPEND_WHEN_IDLE
 *
 *       Set to 1 to make GPU enter ljvPOWER_SUSPEND when idle detected,
 *       otherwise GPU will enter ljvPOWER_IDLE.
 */
#ifndef ljdPOWER_SUSPEND_WHEN_IDLE
#define ljdPOWER_SUSPEND_WHEN_IDLE              1
#endif

#ifndef ljdFPGA_BUILD
#define ljdFPGA_BUILD                           0
#endif

/*
 *   ljdGPU_TIMEOUT
 *
 *       This define specified the number of milliseconds the system will wait
 *       before it broadcasts the GPU is stuck.  In other words, it will define
 *       the timeout of any operation that needs to wait for the GPU.
 *
 *       If the value is 0, no timeout will be checked for.
 */
#ifndef ljdGPU_TIMEOUT
#if ljdFPGA_BUILD
#  define ljdGPU_TIMEOUT                      2000000
# else
#  define ljdGPU_TIMEOUT                      20000
# endif
#endif

/*
    ljdGPU_2D_TIMEOUT

        This define specified the number of milliseconds the system will wait
        before it broadcasts the 2D GPU is stuck.  In other words, it will define
        the timeout of any operation that needs to wait for the GPU.

        If the value is 0, no timeout will be checked for.
*/
#ifndef ljdGPU_2D_TIMEOUT
#if ljdFPGA_BUILD
#define ljdGPU_2D_TIMEOUT                       400000
#else
#define ljdGPU_2D_TIMEOUT                       20000
#endif
#endif


/*
 *   ljdGPU_ADVANCETIMER
 *
 *       it is advance timer.
 */
#ifndef ljdGPU_ADVANCETIMER
#define ljdGPU_ADVANCETIMER                     250
#endif

/*
 *   ljdSTATIC_LINK
 *
 *       This define disalbes static linking;
 */
#ifndef ljdSTATIC_LINK
#define ljdSTATIC_LINK                          0
#endif

/*
 *   ljdUSE_NEW_HEAP
 *
 *       Setting this define to 1 enables new heap.
 */
#ifndef ljdUSE_NEW_HEAP
#define ljdUSE_NEW_HEAP                         0
#endif

/*
 *   ljdCMD_NO_2D_CONTEXT
 *
 *       This define enables no-context 2D command buffer.
 */
#ifndef ljdCMD_NO_2D_CONTEXT
#define ljdCMD_NO_2D_CONTEXT                    1
#endif

/*
 *   ljdENABLE_BUFFER_ALIGNMENT
 *
 *   When enabled, video memory is allocated with at least 16KB alignment
 *   between multiple sub-buffers.
 */
#ifndef ljdENABLE_BUFFER_ALIGNMENT
#if ljdCAPTURE_ONLY_MODE
#  define ljdENABLE_BUFFER_ALIGNMENT          0
# else
#  define ljdENABLE_BUFFER_ALIGNMENT          1
# endif
#endif

/*
 *   ljdENABLE_BANK_ALIGNMENT
 *
 *   When enabled, video memory is allocated bank aligned. The vendor can modify
 *   _GetSurfaceBankAlignment() and _GetBankOffsetBytes() to define how
 *   different types of allocations are bank and channel aligned.
 *   When disabled (default), no bank alignment is done.
 *   For CAPTURE ONLY MODE, should make sure that ljdENABLE_BANK_ALIGNMENT is disabled.
 */
#ifndef ljdENABLE_BANK_ALIGNMENT
#if ljdCAPTURE_ONLY_MODE
#  define ljdENABLE_BANK_ALIGNMENT            0
# else
#  define ljdENABLE_BANK_ALIGNMENT            0
# endif
#endif

/*
 *   ljdBANK_BIT_START
 *
 *   Specifies the start bit of the bank (inclusive).
 */
#ifndef ljdBANK_BIT_START
#define ljdBANK_BIT_START                       12
#endif

/*
 *   ljdBANK_BIT_END
 *
 *   Specifies the end bit of the bank (inclusive).
 */
#ifndef ljdBANK_BIT_END
#define ljdBANK_BIT_END                         14
#endif

/*
 *   ljdBANK_CHANNEL_BIT
 *
 *   When set, video memory when allocated bank aligned is allocated such that
 *   render and depth buffer addresses alternate on the channel bit specified.
 *   This option has an effect only when ljdENABLE_BANK_ALIGNMENT is enabled.
 *   When disabled (default), no alteration is done.
 */
#ifndef ljdBANK_CHANNEL_BIT
#define ljdBANK_CHANNEL_BIT                     7
#endif

/*
 *   ljdDYNAMIC_SPEED
 *
 *       When non-zero, it informs the kernel driver to use the speed throttling
 *       broadcasting functions to inform the system the GPU should be spet up or
 *       slowed down. It will send a broadcast for slowdown each "interval"
 *       specified by this define in milliseconds
 *       (ljkOS_BroadcastCalibrateSpeed).
 */
#ifndef ljdDYNAMIC_SPEED
#define ljdDYNAMIC_SPEED                        2000
#endif

/*
 *   ljdDYNAMIC_EVENT_THRESHOLD
 *
 *       When non-zero, it specifies the maximum number of available events at
 *       which the kernel driver will issue a broadcast to speed up the GPU
 *       (ljkOS_BroadcastHurry).
 */
#ifndef ljdDYNAMIC_EVENT_THRESHOLD
#define ljdDYNAMIC_EVENT_THRESHOLD              5
#endif

/*
 *   ljdENABLE_PROFILING
 *
 *       Enable profiling macros.
 */
#ifndef ljdENABLE_PROFILING
#define ljdENABLE_PROFILING                     0
#endif

/*
 *   ljdENABLE_128B_MERGE
 *
 *       Enable 128B merge for the BUS control.
 */
#ifndef ljdENABLE_128B_MERGE
#define ljdENABLE_128B_MERGE                    0
#endif

/*
 *   ljdFRAME_DB
 *
 *       When non-zero, it specified the number of frames inside the frame
 *       database. The frame DB will collect per-frame timestamps and hardware
 *       counters.
 */
#ifndef ljdFRAME_DB
#define ljdFRAME_DB                             0
#define ljdFRAME_DB_RESET                       0
#define ljdFRAME_DB_NAME                        "/var/log/frameDB.log"
#endif

/*
 *  ljdENABLE_CACHEABLE_COMMAND_BUFFER
 *
 *       When non-zero, command buffer will be cacheable.
 */
#ifndef ljdENABLE_CACHEABLE_COMMAND_BUFFER
#define ljdENABLE_CACHEABLE_COMMAND_BUFFER      0
#endif

/*
 *  ljdENABLE_BUFFERABLE_VIDEO_MEMORY
 *
 *       When non-zero, all video memory will be bufferable by default.
 */
#ifndef ljdENABLE_BUFFERABLE_VIDEO_MEMORY
#define ljdENABLE_BUFFERABLE_VIDEO_MEMORY       1
#endif

/*
 *   ljdENABLE_INFINITE_SPEED_HW
 *           enable the Infinte HW, this is for 2D openVG
 */
#ifndef ljdENABLE_INFINITE_SPEED_HW
#define ljdENABLE_INFINITE_SPEED_HW             0
#endif

/*
 *   ljdPOWEROFF_TIMEOUT
 *
 *       When non-zero, GPU will power off automatically from
 *       idle state, and ljdPOWEROFF_TIMEOUT is also the default
 *       timeout in milliseconds.
 */
#ifndef ljdPOWEROFF_TIMEOUT
#define ljdPOWEROFF_TIMEOUT                     300
#endif

/*
 *   QNX_SINGLE_THREADED_DEBUGGING
 */
#ifndef QNX_SINGLE_THREADED_DEBUGGING
#define QNX_SINGLE_THREADED_DEBUGGING           0
#endif

/*
 *   ljdSHARED_RESOLVE_BUFFER_ENABLED
 *
 *       Use shared resolve buffer for all app buffers.
 */
#ifndef ljdSHARED_RESOLVE_BUFFER_ENABLED
#define ljdSHARED_RESOLVE_BUFFER_ENABLED        0
#endif

/*
 *    ljdUSE_TRIANGLE_STRIP_PATCH
 */
#ifndef ljdUSE_TRIANGLE_STRIP_PATCH
#define ljdUSE_TRIANGLE_STRIP_PATCH             1
#endif

#ifndef ljdUSE_PVR
#define ljdUSE_PVR                              1
#endif

/*
 *   ljdSMALL_BLOCK_SIZE
 *
 *       When non-zero, a part of VIDMEM will be reserved for requests
 *       whose requesting size is less than ljdSMALL_BLOCK_SIZE.
 *
 *       For Linux, it's the size of a page. If this requeset fallbacks
 *       to ljvPOOL_VIRTUAL, memory will be wasted
 *       because they allocate a page at least.
 */
#ifndef ljdSMALL_BLOCK_SIZE
#define ljdSMALL_BLOCK_SIZE                     4096
#define ljdRATIO_FOR_SMALL_MEMORY               32
#endif

/*
 *   ljdENABLE_VIRTUAL_ADDR_UNMAP
 *       enable virtual address unmap for the weight_bias and the virtual image
 */
#ifndef ljdENABLE_VIRTUAL_ADDRESS_UNMAP
#define ljdENABLE_VIRTUAL_ADDRESS_UNMAP         0
#endif

/*
 *   ljdENABLE_GPU_1M_PAGE
 *       When non-zero, GPU page size will be 1M until the pool is out of memory
 *       and low-level to 4K pages. When zero, it uses 4k GPU pages.
 */
#ifndef ljdENABLE_GPU_1M_PAGE
#if !ljdSECURITY && defined(LINUX)
#ifdef EMULATOR
#   define ljdENABLE_GPU_1M_PAGE           0
#  else
#   define ljdENABLE_GPU_1M_PAGE           1
#  endif
# else
#  define ljdENABLE_GPU_1M_PAGE               0
# endif
#endif

/*
 *   ljdCONTIGUOUS_SIZE_LIMIT
 *       When non-zero, size of video node from ljvPOOL_VIRTUAL contiguous is
 *       limited by ljdCONTIGUOUS_SIZE_LIMIT.
 */
#ifndef ljdCONTIGUOUS_SIZE_LIMIT
#define ljdCONTIGUOUS_SIZE_LIMIT                0
#endif

/*
 *   ljdLINK_QUEUE_SIZE
 *
 *       When non-zero, driver maintains a queue to record information of
 *       latest lined context buffer and command buffer. Data in this queue
 *       is be used to debug.
 */
#ifndef ljdLINK_QUEUE_SIZE
#define ljdLINK_QUEUE_SIZE                      64
#endif

/*  ljdALPHA_KILL_IN_SHADER
 *
 *       Enable alpha kill inside the shader. This will be set automatically by the
 *       HAL if certain states match a criteria.
 */
#ifndef ljdALPHA_KILL_IN_SHADER
#define ljdALPHA_KILL_IN_SHADER                 1
#endif

#ifndef ljdPRINT_SWAP_TIME
#define ljdPRINT_SWAP_TIME                      0
#endif

/*
 *   ljdDVFS
 *
 *       When non-zero, software will make use of dynamic voltage and
 *       frequency feature.
 */
#ifndef ljdDVFS
#define ljdDVFS                                 0
#define ljdDVFS_ANAYLSE_WINDOW                  4
#define ljdDVFS_POLLING_TIME                    (ljdDVFS_ANAYLSE_WINDOW * 4)
#endif

#ifndef ljdSYNC
#define ljdSYNC                                 1
#endif

#ifndef ljdSHADER_SRC_BY_MACHINECODE
#define ljdSHADER_SRC_BY_MACHINECODE            1
#endif

#ifndef ljdGLB27_SHADER_REPLACE_OPTIMIZATION
#define ljdGLB27_SHADER_REPLACE_OPTIMIZATION    1
#endif

/*
 *   ljdSUPPORT_SWAP_RECTANGLE
 *
 *       Support swap with a specific rectangle.
 *
 *       Set the rectangle with eglSetSwapRectangleVIV api.
 *       Android only.
 */
#ifndef ljdSUPPORT_SWAP_RECTANGLE
#define ljdSUPPORT_SWAP_RECTANGLE               0
#endif

/*
 *   ljdGPU_LINEAR_BUFFER_ENABLED
 *
 *       Use linear buffer for GPU apps so HWC can do 2D composition.
 *       Android only.
 */
#ifndef ljdGPU_LINEAR_BUFFER_ENABLED
#define ljdGPU_LINEAR_BUFFER_ENABLED            1
#endif

/*
 *   ljdENABLE_RENDER_INTO_WINDOW
 *
 *       Enable Render-Into-Window (ie, No-Resolve) feature on android.
 *       NOTE that even if enabled, it still depends on hardware feature and
 *       android application behavior. When hardware feature or application
 *       behavior can not support render into window mode, it will fail back
 *       to normal mode.
 *       When Render-Into-Window is finally used, window back buffer of android
 *       applications will be allocated matching render target tiling format.
 *       Otherwise buffer tiling is decided by the above option
 *       'ljdGPU_LINEAR_BUFFER_ENABLED'.
 *       Android only for now.
 */
#ifndef ljdENABLE_RENDER_INTO_WINDOW
#define ljdENABLE_RENDER_INTO_WINDOW            1
#endif

/*
 *   ljdENABLE_RENDER_INTO_WINDOW_WITH_FC
 *
 *       Enable Direct-rendering (ie, No-Resolve) with tile status.
 *       This is expremental and in development stage.
 *       This will dynamically check if color compression is available.
 */
#ifndef ljdENABLE_RENDER_INTO_WINDOW_WITH_FC
#define ljdENABLE_RENDER_INTO_WINDOW_WITH_FC    1
#endif

/*
 *   ljdENABLE_BLIT_BUFFER_PRESERVE
 *
 *       Render-Into-Window (ie, No-Resolve) does not include preserved swap
 *       behavior.  This feature can enable buffer preserve in No-Resolve mode.
 *       When enabled, previous buffer (may be part of ) will be resolve-blitted
 *       to current buffer.
 */
#ifndef ljdENABLE_BLIT_BUFFER_PRESERVE
#define ljdENABLE_BLIT_BUFFER_PRESERVE          1
#endif

/*
 *   ljdANDROID_NATIVE_FENCE_SYNC
 *
 *       Enable android native fence sync. It is introduced since jellybean-4.2.
 *       Depends on linux kernel option: CONFIG_SYNC.
 *
 *       0: Disabled
 *       1: Build framework for native fence sync feature, and EGL extension
 *       2: Enable async swap buffers for client
 *          * Native fence sync for client 'queueBuffer' in EGL, which is
 *            'acquireFenceFd' for layer in compositor side.
 *       3. Enable async hwcomposer composition.
 *          * 'releaseFenceFd' for layer in compositor side, which is native
 *            fence sync when client 'dequeueBuffer'
 *          * Native fence sync for compositor 'queueBuffer' in EGL, which is
 *            'acquireFenceFd' for framebuffer target for DC
 */
#ifndef ljdANDROID_NATIVE_FENCE_SYNC
#define ljdANDROID_NATIVE_FENCE_SYNC            0
#endif

#ifndef ljdLINUX_SYNC_FILE
#define ljdLINUX_SYNC_FILE                      0
#endif

/*
 *   ljdANDROID_IMPLICIT_NATIVE_BUFFER_SYNC
 *
 *       Enable implicit android native buffer sync.
 *
 *       For non-HW_RENDER buffer, CPU (or other hardware) and GPU can access
 *       the buffer at the same time. This is to add implicit synchronization
 *       between CPU (or the hardware) and GPU.
 *
 *       Eventually, please do not use implicit native buffer sync, but use
 *       "fence sync" or "android native fence sync" instead in libgui, which
 *       can be enabled in frameworks/native/libs/gui/Android.mk. This kind
 *       of synchronization should be done by app but not driver itself.
 *
 *       Please disable this option when either "fence sync" or
 *       "android native fence sync" is enabled.
 */
#ifndef ljdANDROID_IMPLICIT_NATIVE_BUFFER_SYNC
#define ljdANDROID_IMPLICIT_NATIVE_BUFFER_SYNC  1
#endif

/*
 * Implicit native buffer sync is not needed when ANDROID_native_fence_sync
 * is available.
 */
#if ljdANDROID_NATIVE_FENCE_SYNC
#undef ljdANDROID_IMPLICIT_NATIVE_BUFFER_SYNC
#define ljdANDROID_IMPLICIT_NATIVE_BUFFER_SYNC  0
#endif

/*
 *   ljdUSE_WCLIP_PATCH
 *
 *       Enable wclipping patch.
 */
#ifndef ljdUSE_WCLIP_PATCH
#define ljdUSE_WCLIP_PATCH              1
#endif

#ifndef ljdUSE_NPOT_PATCH
#define ljdUSE_NPOT_PATCH               1
#endif

/*
 *   ljdINTERNAL_COMMENT
 *
 *       Wrap internal comment, content wrapped by it and the macor itself
 *       will be removed in release driver.
 */
#ifndef ljdINTERNAL_COMMENT
#define ljdINTERNAL_COMMENT             1
#endif

/*
 *   ljdRTT_DISABLE_FC
 *
 *       Disable RTT FC support. For test only.
 */
#ifndef ljdRTT_DISABLE_FC
#define ljdRTT_DISABLE_FC               0
#endif

/*
 *   ljdFORCE_MIPMAP
 *
 *       Force generate mipmap for texture.
 */
#ifndef ljdFORCE_MIPMAP
#define ljdFORCE_MIPMAP                 0
#endif

/*
 *   ljdFORCE_BILINEAR
 *
 *       Force bilinear for mipfilter.
 */
#ifndef ljdFORCE_BILINEAR
#define ljdFORCE_BILINEAR               1
#endif

/*
 *   ljdBINARY_TRACE
 *
 *       When non-zero, binary trace will be generated.
 *
 *       When ljdBINARY_TRACE_FILE_SIZE is non-zero, binary trace buffer will
 *       be written to a file which size is limited to
 *       ljdBINARY_TRACE_FILE_SIZE.
 */
#ifndef ljdBINARY_TRACE
#define ljdBINARY_TRACE                 0
#define ljdBINARY_TRACE_FILE_SIZE       0
#endif

#ifndef ljdMOVG
# define ljdMOVG                         0
# define ljdENABLE_TS_DOUBLE_BUFFER      1
#else
#if ljdMOVG
#  define ljdENABLE_TS_DOUBLE_BUFFER  0
# else
#  define ljdENABLE_TS_DOUBLE_BUFFER  1
# endif
#endif

/*  ljdINTERRUPT_STATISTIC
 *
 *  Monitor the event send to GPU and interrupt issued by GPU.
 */

#ifndef ljdINTERRUPT_STATISTIC
#if defined(LINUX) || defined(__QNXNTO__) || defined(UNDER_CE) || defined(__VXWORKS__)
#  define ljdINTERRUPT_STATISTIC  1
# else
#  define ljdINTERRUPT_STATISTIC  0
# endif
#endif

/*
 *   ljdFENCE_WAIT_LOOP_COUNT
 *       Wait fence, loop count.
 */
#ifndef ljdFENCE_WAIT_LOOP_COUNT
#define ljdFENCE_WAIT_LOOP_COUNT    10000
#endif

/*
 *   ljdPARTIAL_FAST_CLEAR
 *       When it's not zero, partial fast clear is enabled.
 *       Depends on ljdHAL_3D_DRAWBLIT, if ljdHAL_3D_DRAWBLIT is not enabled,
 *       only available when scissor box is completely aligned.
 *       Expremental, under test only. Not ready for production.
 */
#ifndef ljdPARTIAL_FAST_CLEAR
#define ljdPARTIAL_FAST_CLEAR       0
#endif

/*
 *   ljdREMOVE_SURF_ORIENTATION
 *       When it's not zero, we will remove surface orientation function.
 *       It wil become to a parameter of resolve function.
 */
#ifndef ljdREMOVE_SURF_ORIENTATION
#define ljdREMOVE_SURF_ORIENTATION  1
#endif

/*
 *   ljdTEST_DEC200
 *       Test part for DEC200. Remove when release.
 */
#ifndef ljdTEST_DEC200
#define ljdTEST_DEC200              0
#endif

/*
 *   ljdPATTERN_FAST_PATH
 *        For pattern match
 */
#ifndef ljdPATTERN_FAST_PATH
#define ljdPATTERN_FAST_PATH        1
#endif

/*
 *   ljdUSE_INPUT_DEVICE
 *        disable input devices usage under fb mode to support fb+vdk multi-process
 */
#ifndef ljdUSE_INPUT_DEVICE
#define ljdUSE_INPUT_DEVICE         1
#endif

/*
 *   ljdPERFORMANCE_ANALYSIS
 *
 *       When set to 1, driver will pass information through loadstate
 *       to HW. This loadstate does not impact HW execution.
 */
#ifndef ljdPERFORMANCE_ANALYSIS
#define ljdPERFORMANCE_ANALYSIS     0
#endif

/*
 *   ljdFRAMEINFO_STATISTIC
 *       When enable, collect frame information.
 */
#ifndef ljdFRAMEINFO_STATISTIC

#if (defined(DBG) && DBG) || defined(DEBUG)               || \
     defined(_DEBUG) || ljdDUMP || ljdPERFORMANCE_ANALYSIS || \
     (defined(WIN32) && !defined(UNDER_CE))                || \
     ljdFPGA_BUILD
#  define ljdFRAMEINFO_STATISTIC  1
# else
#  define ljdFRAMEINFO_STATISTIC  0
# endif

#endif

/*
 *   ljdDEC_ENABLE_AHB
 *       Enable DEC300 compression AHB mode or not.
 */
#ifndef ljdDEC_ENABLE_AHB
#define ljdDEC_ENABLE_AHB           0
#endif

/*
 *   ljdENABLE_UNIFIED_CONSTANT
 *       Enable unified constant or not.
 */
#ifndef ljdENABLE_UNIFIED_CONSTANT
#define ljdENABLE_UNIFIED_CONSTANT  1
#endif

/*
 *   Core configurations. By default enable all cores.
 */
#ifndef ljdENABLE_3D
#define ljdENABLE_3D                1
#endif

#ifndef ljdENABLE_2D
#define ljdENABLE_2D                1
#endif

#ifndef ljdVG_NONE
#define ljdVG_NONE                   0
#endif

#ifndef ljdENABLE_VG
#define ljdENABLE_VG                (0 && !ljdVG_NONE)
#endif

#ifndef ljdVG_ONLY
#define ljdVG_ONLY (!ljdENABLE_3D && !ljdENABLE_2D && ljdENABLE_VG)
#endif

#if defined(WIN32) && !defined(UNDER_CE) && (ljdENABLE_VG == 1)

#ifdef ljdUSE_VX
#  undef ljdUSE_VX
# endif

#ifdef COMMAND_PROCESSOR_VERSION
#  undef COMMAND_PROCESSOR_VERSION
# endif

#ifdef ljdENABLE_TRUST_APPLICATION
#  undef ljdENABLE_TRUST_APPLICATION
# endif

#ifdef ljdENABLE_3D
#  undef ljdENABLE_3D
# endif

#ifdef ljdENABLE_2D
#  undef ljdENABLE_2D
# endif

# define ljdENABLE_3D                0
# define ljdENABLE_2D                0
# define ljdUSE_VX                   0
# define COMMAND_PROCESSOR_VERSION   2
# define ljdENABLE_TRUST_APPLICATION 0

#endif /* Only for LJ355 Cmodel build. */

#ifndef ljdLJ355_PROFILER
#define ljdLJ355_PROFILER                       0
#endif

/*
 *   This definition must be paired with LJMICRO_PROFILER_SYSTEM_MEMORY
 */
#ifndef ljdLJ355_MEM_PRINT
# define ljdLJ355_MEM_PRINT                      0
#else
#if (!((ljdENABLE_3D == 0) && (ljdENABLE_2D == 0) && (ljdENABLE_VG == 1)))
#  undef ljdLJ355_MEM_PRINT
#  define ljdLJ355_MEM_PRINT                  0
# endif
#endif

/*
 *   ljdRECORD_COMMAND
 */
#ifndef ljdRECORD_COMMAND
#define ljdRECORD_COMMAND                       0
#endif

/*
 *   ljdALLOC_CMD_FROM_RESERVE
 *
 *   Provide a way by which location of command buffer can be
 *   specified. This is a DEBUG option to limit command buffer
 *   to some memory range.
 */
#ifndef ljdALLOC_CMD_FROM_RESERVE
#define ljdALLOC_CMD_FROM_RESERVE               0
#endif

/*
 *   ljdBOUNDARY_CHECK
 *
 *   When enabled, add bounary before and after a range of
 *   GPU address. So overflow can be trapped by MMU exception.
 *   This is a debug option for new MMU and ljdUSE_MMU_EXCEPTION
 *   is enabled.
 */
#ifndef ljdBOUNDARY_CHECK
#define ljdBOUNDARY_CHECK                       0
#endif

/*
 *   ljdRENDER_QUALITY_CHECK
 *
 *   When enabled, we disable performance opt patch
 *   to get know rendering quality comparing with other vendor.
 */
#ifndef ljdRENDER_QUALITY_CHECK
#define ljdRENDER_QUALITY_CHECK                 0
#endif

/*
 *   ljdSYSTRACE
 *
 *   When enabled, we embed systrace in function header/footer
 *   to gather time information on linux platforms include android.
 *   '1' to trace API (EGL, ES11, ES2x, ES3x, etc)
 *   '2' to trace HAL (except compiler)
 *   '4' to trace HAL compiler
 *   See lj_hal_user_debug.c for more detailed trace zones.
 */
#ifndef ljdSYSTRACE
#define ljdSYSTRACE                             0
#endif

#ifndef ljdENABLE_APPCTXT_BLITDRAW
#define ljdENABLE_APPCTXT_BLITDRAW              0
#endif

/*
 *   When enabled, use 1K mode for MMU version 2.0. otherwise use 4K mode.
 */
#ifndef ljdENABLE_MMU_1KMODE
#define ljdENABLE_MMU_1KMODE                    1
#endif

/*
 *   ljdENABLE_TRUST_APPLICATION
 *
 *   When enabled, trust application is used to handle 'security' registers.
 *
 *   1) If HW doesn't have robust and security feature, this option is meaningless.
 *   2) If HW have robust and security and this option is not enable,
 *      security registers are handled by non secure driver. It is for
 *      platform doesn't want/need to use trust zone.
 */
#ifndef ljdENABLE_TRUST_APPLICATION
#  define ljdENABLE_TRUST_APPLICATION           0
#endif

/* Disable ljdENABLE_TRUST_APPLICATION when oboslete ljdSECURITY enabled. */
#if ljdSECURITY
# undef ljdENABLE_TRUST_APPLICATION
# define ljdENABLE_TRUST_APPLICATION            0
#endif

#ifndef ljdMMU_SECURE_AREA_SIZE
#if defined(ljdENABLE_MMU_1KMODE)
#  define ljdMMU_SECURE_AREA_SIZE             32
# else
#  define ljdMMU_SECURE_AREA_SIZE             128
# endif
#endif

#ifndef ljdUSE_MMU_EXCEPTION
#define ljdUSE_MMU_EXCEPTION                    1
#endif

#ifndef ljdVX_OPTIMIZER
#define ljdVX_OPTIMIZER                         0
#endif

#ifndef ljdALLOC_ON_FAULT
#define ljdALLOC_ON_FAULT                       0
#endif

/*
 *   ljdDISABLE_GPU_VIRTUAL_ADDRESS
 *
 *       When enabled, disable MMU and all virtual allocated from MMU.
 */
#ifndef ljdDISABLE_GPU_VIRTUAL_ADDRESS
#define ljdDISABLE_GPU_VIRTUAL_ADDRESS          0
#endif

/*
 *   ljd2D_COMPRESSION_DEC400_ALIGN_MODE
 *
 *       Only for DEC400 compression.
 *       Set 0 as 16bytes aligned. 1 as 32bytes aligned. 2 as 64bytes aligned.
 *       Default is 0 which means 32bytes aligned.
 */
#ifndef ljd2D_COMPRESSION_DEC400_ALIGN_MODE
#define ljd2D_COMPRESSION_DEC400_ALIGN_MODE     1
#endif

/*
 *   ljdENABLE_KERNEL_FENCE
 *       When enabled, use kernel fence to do resource tracking.
 */
#ifndef ljdENABLE_KENREL_FENCE
#define ljdENABLE_KERNEL_FENCE                  0
#endif

/*
 *   ljdUSE_VXC_BINARY
 *       When enabled, will use prebuilt shader binary in VX driver.
 */
#ifndef ljdUSE_VXC_BINARY
#define ljdUSE_VXC_BINARY                       0
#endif

/*
 *   ljdFEATURE_SANITYCHECK
 *       When enabled, will do hardware feature sanity check, each
 *       used hardware feature should be printed out.
 */
#ifndef ljdFEATURE_SANITYCHECK
#define ljdFEATURE_SANITYCHECK                  0
#endif

/*
 *   LJMICRO_PROFILER_SYSTEM_MEMORY
 *
 *       This define enables the profiling data for system memory allocated by driver
 */
#ifndef LJMICRO_PROFILER_SYSTEM_MEMORY
#define LJMICRO_PROFILER_SYSTEM_MEMORY          1
#define VP_MALLOC_OFFSET                        (16)

#endif

#define ljdHAL_TEST                                 1

/*
 *   ljdUSE_ZWP_SYNCHRONIZATION
 *
 *       When enabled, will use the zwp_linux_surface_synchronization path,
 *       otherwise switch to old wayland path.
 */
#define ljdUSE_ZWP_SYNCHRONIZATION                  1

/*
 *   ljdUSE_SINGLE_CONTEXT
 *       When enabled, will enable single context.
 */
#ifndef ljdUSE_SINGLE_CONTEXT
#define ljdUSE_SINGLE_CONTEXT                   0
#endif

/*
 *   ljdKERNEL_QUERY_PERFORMANCE_COUNTER_V8
 *       When enabled, will enable query new performance counter of V8.0 in kernel
 *       space.
 */
#ifndef ljdKERNEL_QUERY_PERFORMANCE_COUNTER_V8
#define ljdKERNEL_QUERY_PERFORMANCE_COUNTER_V8  0
#endif

/*
 *   ljdIGNORE_DRIVER_VERSIONS_MISMATCH
 *       When enabled, driver will ignore user and kernel driver version mismatch.
 */
#ifndef ljdIGNORE_DRIVER_VERSIONS_MISMATCH
#define ljdIGNORE_DRIVER_VERSIONS_MISMATCH      0
#endif

/*
 *   ljdEXTERNAL_SRAM_USAGE
 *       '0': User driver queries the whole external SRAM and manages the memory.
 *            Or user driver dynamically allocate the external SRAM with pool type
 *            ljvPOOL_EXTERNAL_SRAM.
 *
 *       '1': External SRAM only can be used for the initial command,
 *            but the external SRAM base and size must be set by customer.
 *            And it only can be used if pool type is ljvPOOL_EXTERNAL_SRAM when
 *            allocating video memory.
 *
 *       '2': To be extended.
 */
#ifndef ljdEXTERNAL_SRAM_USAGE
#define ljdEXTERNAL_SRAM_USAGE                  0
#endif

/*
 *   ljdENABLE_SW_PREEMPTION
 *       Enable software preemption if set to 1, disable by default.
 *       Only support Linux OS currently.
 */
#ifndef ljdENABLE_SW_PREEMPTION
#define ljdENABLE_SW_PREEMPTION                 0
#endif

/*
 *   ljdSUPPORT_DEVICE_TREE_SOURCE
 *       To suppor device tree feature if set to 1, disable by default.
 *       Only works on linux OS.
 */
#ifndef ljdSUPPORT_DEVICE_TREE_SOURCE
#define ljdSUPPORT_DEVICE_TREE_SOURCE           0
#endif

/*
 *   ljdENABLE_PER_DEVICE_PM
 *       Enable per device power management if set to 2, all the hardware
 *       cores will be one device. Enable per user device power management
 *       if set to 1, the brother cores of a device depends on user driver.
 *       Disable per device power management if set to 0.
 *       Only support Linux OS currently.
 */
#ifndef ljdENABLE_PER_DEVICE_PM
#define ljdENABLE_PER_DEVICE_PM                 0
#endif

/*
 *   ljdUSE_CAPBUF
 */
#ifndef ljdUSE_CAPBUF
#define ljdUSE_CAPBUF                           1
#endif

/*
 *   ljdENABLE_MP_SWITCH
 *       Enable multi-processor mode dynamic switch, the processor count is
 *       determined by specific conditions.
 *       Only support Linux OS currently.
 */
#ifndef ljdENABLE_MP_SWITCH
#define ljdENABLE_MP_SWITCH                     0
#endif

/*
 *   ljdANON_FILE_FOR_ALLOCATOR
 *       Enable this macro can replace the /dev/zero by anon_inode:
 *       [ljmcore] in /proc/<pid>/maps.
 *       Without the macro, run 'cat /proc/<pid>/maps' will print "/dev/zero".
 */
#ifndef ljdANON_FILE_FOR_ALLOCATOR
#define ljdANON_FILE_FOR_ALLOCATOR              0
#endif

/*
 *   ljdWAIT_LINK_FE_MODE
 *       0 means always end at the end of commit user command buffer
 *         and reset FE for each commit.
 *       1 means default wait-link mode.
 */
#ifndef ljdWAIT_LINK_FE_MODE
#define ljdWAIT_LINK_FE_MODE                    1
#endif

/*
 *   ljdENABLE_RECOVERY_ALL_CORES
 *       When enabled, will recovery all cores when the gpu hang.
 */
#ifndef ljdENABLE_RECOVERY_ALL_CORES
#define ljdENABLE_RECOVERY_ALL_CORES            1
#endif

/*
 *   ljdENABLE_VIDEO_MEMORY_MIRROR
 *       Enable pcie local memory mirror and dma sync.
 *       Only support Linux OS currently.
 */
#ifndef ljdENABLE_VIDEO_MEMORY_MIRROR
#define ljdENABLE_VIDEO_MEMORY_MIRROR           1
#endif
/*
 *   ljdINIT_VIDEO_MEMORY_MIRROR
 *       Init mirror and pcie local memory to characteristic value for debugging.
 *       Depends on ljdENABLE_VIDEO_MEMORY_MIRROR.
 *       Only support Linux OS currently.
 */
#ifndef ljdINIT_VIDEO_MEMORY_MIRROR
#define ljdINIT_VIDEO_MEMORY_MIRROR             0
#endif

/*
 *   ljdSTATIC_VIDEO_MEMORY_MIRROR
 *       Dynamic allocate/free the mirror buffer if set to 0.
 *       Depends on ljdENABLE_VIDEO_MEMORY_MIRROR.
 *       Only support Linux OS currently.
 */
#ifndef ljdSTATIC_VIDEO_MEMORY_MIRROR
#define ljdSTATIC_VIDEO_MEMORY_MIRROR           1
#endif

#ifndef ljdWRAP_USER_MEMORY_MIRROR
#define ljdWRAP_USER_MEMORY_MIRROR              1
#endif

/*
 *   ljdENABLE_VIDEO_MEMORY_TRACE
 *       Dynamic trace video memory, if set to 1.
 *       Depends on kernel support.
 *       Only support Linux OS currently.
 */
#ifndef ljdENABLE_VIDEO_MEMORY_TRACE
#define ljdENABLE_VIDEO_MEMORY_TRACE            0
#endif

/*
 *   ljdUSER_COMMAND_IN_EXCLUSIVE
 *       User command buffer can be able in exclusive local memory.
 */
#ifndef ljdUSER_COMMAND_IN_EXCLUSIVE
#define ljdUSER_COMMAND_IN_EXCLUSIVE            0
#endif

/*
 *   ljdVALID_COMMAND_BUFFER
 *       If enabled, will check the validity of the command buffer before commit.
 */
#ifndef ljdVALID_COMMAND_BUFFER
#define ljdVALID_COMMAND_BUFFER                 0
#endif

/*
 *   ljdENABLE_MULTI_DEVICE_MANAGEMENT
 *
 *       Manage cores on multiple hardware devices.
 *
 *       Hardware device is composed by a set of cores which are the
 *       same type, such as 3D, 3D2D, VIP etc. and these cores have
 *       direct connection to work in combined mode.
 */
#ifndef ljdENABLE_MULTI_DEVICE_MANAGEMENT
#define ljdENABLE_MULTI_DEVICE_MANAGEMENT       0
#endif

/*
 *   ljdENABLE_DEVFREQ
 *
 *       Enable linux generic dynamic voltage and frequency scaling.
 *       Now only support frequency scaling.
 */
#ifndef ljdENABLE_DEVFREQ
#define ljdENABLE_DEVFREQ                       0
#endif

/*
 *   ljdSHARED_COMMAND_BUFFER
 *
 *   Share one user command buffer and kernel command buffer for multi-core.
 */
#ifndef ljdSHARED_COMMAND_BUFFER
#define ljdSHARED_COMMAND_BUFFER                 0
#endif

/*
 *   ljd_2D_PRINT_TIME_STAMP
 *
 *   Print time stamp by 2D driver
 */
#ifndef ljd_2D_PRINT_TIME_STAMP
#define ljd_2D_PRINT_TIME_STAMP                  0
#endif

/*
 *   ljdENABLE_AHBXTTD
 *
 *   Enable AHBXTTD register feature. Now only support Xiaomi.
 */
#ifndef ljdENABLE_AHBXTTD
#define ljdENABLE_AHBXTTD                        0
#endif

/*
    ljdENABLE_MEMORY_OPTIMIZATION
        If enabled, will move some object in system memory.
*/
#ifndef ljdENABLE_MEMORY_OPTIMIZATION
#define ljdENABLE_MEMORY_OPTIMIZATION            0
#endif

/*
 *   ljdENABLE_NONCACHE_COMMANDBUF
 *
 *     If enable, map the command buffer without writebuffer and cache
 */
#ifndef ljdENABLE_NONCACHE_COMMANDBUF
#define ljdENABLE_NONCACHE_COMMANDBUF            0
#endif

/*
 *  ljdENABLE_CLEAR_FENCE
 *
 *      If enabled, will record fence value in kernel and
 *      recovery all fence when the kernel do recovery operation.
 */
#ifndef ljdENABLE_CLEAR_FENCE
#if defined(LINUX) && !defined(EMULATOR)
#  define ljdENABLE_CLEAR_FENCE                  1
# else
#  define ljdENABLE_CLEAR_FENCE                  0
# endif
#endif

/*
 *   ljdENABLE_DRM_DEBUG
 *
 *     If enable, driver will dump drm debug zone.
 */

#ifndef ljdENABLE_DRM_DEBUG
#define ljdENABLE_DRM_DEBUG                      1
#endif

#ifndef ljdENABLE_EVICTION
#define ljdENABLE_EVICTION                       0
#endif

#ifndef ljdENABLE_PERF_DISPATCH
#define ljdENABLE_PERF_DISPATCH                  0
#endif

/*SY: if enable, ljmLayer in OpenGL will be build*/
#ifndef ljdENABLE_LJMLAYER_GL
#define ljdENABLE_LJMLAYER_GL                    1
#endif

#endif /* __lj_hal_options_h_ */


