/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

/**************************************************************************
* 版权所有 (C)2024, 武汉凌久微电子有限公司。
*
* 文件名称： ljmicro_adma.h
* 文件标识：
* 内容摘要： 本文件定义amba dma控制器相关寄存器及相关宏
* 其它说明：
* 当前版本： v1.0
* 作    者： zhoupw, 武汉凌久微电子有限公司
* 完成日期： 2024年8月27日
***************************************************************************/

#ifndef _LJMICRO_ADMA_H_
#define _LJMICRO_ADMA_H_

#define REG_DMAC_OFFSET                       0x190000
#define DMAC_CHAN_MAX                         8
#define DMAC_CHAN_EN_SHIFT                    0
#define DMAC_CHAN_EN_WE_SHIFT                 8

#define VRAM_START_AMBA                       0x8000000000
#define MEM_IO_START_AMBA                     0x1000000
#define I2S0_REG_AMBA_BASE                    0x188800
#define REG_I2S_OFFSET                        0x188800
#define I2S_AUDIO_DATA_OFFSET                 0x1c8
#define REG_I2S_SIZE                          0x400

#define DMAC_CFGREG                           0x10
#define DMAC_CHENREG                          0x18
#define DMAC_CHENREG_L                        0x18
#define DMAC_CHENREG_H                        0x1C
#define DMAC_INTSTATUSREG                     0x30
#define DMAC_COMMONREG_INTSTATUS_ENABLEREG    0x40
#define DMAC_COMMONREG_INTSIGNAL_ENABLEREG    0x48

#define CHx_SAR_L                             0x100
#define CHx_SAR_H                             0x104
#define CHx_DAR_L                             0x108
#define CHx_DAR_H                             0x10c
#define CHx_BLOCK_TS                          0x110
#define CHx_CTL_L                             0x118
#define CHx_CTL_H                             0x11c
#define CHx_CFG_L                             0x120
#define CHx_CFG_H                             0x124
#define CHx_LLP_L                             0x128
#define CHx_LLP_H                             0x12c
#define CHx_STATUSREG                         0x130
#define CHx_DMA_LEFT_FIFO                     0x134
#define CHx_AXI_IDREG                         0x150
#define CHx_SSTATAR_L                         0x170
#define CHx_SSTATAR_H                         0x174
#define CHx_DSTATAR_L                         0x178
#define CHx_DSTATAR_H                         0x17c
#define CHx_INTSTATUS_ENABLEREG               0x180
#define CHx_INTSTATUS_L                       0x188
#define CHx_INTSTATUS_H                       0x18c
#define CHx_INTSIGNAL_ENABLEREG               0x190
#define CHx_INTCLEARREG                       0x198

#endif
