/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

#include "ljmicro_base.h"
#include "ljmicro_device.h"

#if 0
#define _LJ_OBJ_ZONE    ljvZONE_KMS
#define LJMGPU_MAX_BL_LEVEL 0x64

//backlight
static int ljm_backlight_get_brightness(struct backlight_device *bd)
{
    return bd->props.brightness;
}

static int ljm_backlight_update_status(struct backlight_device *bd)
{
    /*
     * 时钟：clk_ref(27M Hz)
     * 频率F = 27 / (一级分频 * 二级分频)
     * 占空比D = 占空比寄存器 / 二级分频
     * 占空比D范围：0% ~ 100%
     *
     * ===> 一级分频写入1，二级分频写入100，即频率F = 27M Hz / 100 = 270K Hz
     * 根据传参空比D，即可确定占空比寄存器值
     *
     ***/

    struct ljm_device *ljm_dev = (struct ljm_device *)dev_get_drvdata(&bd->dev);

    //set first reg
    //led1,led2
    CR_WR(ljm_dev->cur_card, 0xd0, 0x11);
    CR_WR(ljm_dev->cur_card, 0xd1, 0x11);

    //set second reg
    //led1
    CR_WR(ljm_dev->cur_card, 0xc0, 0x64);
    CR_WR(ljm_dev->cur_card, 0xc1, 0x00);
    //led2
    CR_WR(ljm_dev->cur_card, 0xc4, 0x64);
    CR_WR(ljm_dev->cur_card, 0xc5, 0x00);
    //led3
    CR_WR(ljm_dev->cur_card, 0xc8, 0x64);
    CR_WR(ljm_dev->cur_card, 0xc9, 0x00);
    //led4
    CR_WR(ljm_dev->cur_card, 0xcc, 0x64);
    CR_WR(ljm_dev->cur_card, 0xcd, 0x00);

    //set D reg
    //led1
    CR_WR(ljm_dev->cur_card, 0xc2, bd->props.brightness);
    CR_WR(ljm_dev->cur_card, 0xc3, 0x00);
    //led2
    CR_WR(ljm_dev->cur_card, 0xc6, bd->props.brightness);
    CR_WR(ljm_dev->cur_card, 0xc7, 0x00);
    //led3
    CR_WR(ljm_dev->cur_card, 0xca, bd->props.brightness);
    CR_WR(ljm_dev->cur_card, 0xcb, 0x00);
    //led4
    CR_WR(ljm_dev->cur_card, 0xce, bd->props.brightness);
    CR_WR(ljm_dev->cur_card, 0xcf, 0x00);

    //set enable reg
    CR_WR(ljm_dev->cur_card, 0xd2, 0x0f);

    printk("INFO: [%s %d] set brightness value = %d.\n",__FUNCTION__,__LINE__,bd->props.brightness);

    return 0;
}

static struct backlight_ops ljm_backlight_ops = {
    .options = BL_CORE_SUSPENDRESUME,
    .get_brightness = ljm_backlight_get_brightness,
    .update_status = ljm_backlight_update_status,
};

void ljm_register_backlight_device(struct ljm_device *ljm_dev, int index)
{
    char bl_name[15+1] = {0};
    struct backlight_properties props = {0};

    props.max_brightness = LJMGPU_MAX_BL_LEVEL;
    props.brightness = LJMGPU_MAX_BL_LEVEL;
    props.type = BACKLIGHT_RAW;

    snprintf(bl_name, sizeof(bl_name), "ljmicro_bl%d", ljm_dev->ddev->primary->index);

    ljm_dev->backlight_dev[index] = backlight_device_register(bl_name, ljm_dev->ddev->dev, ljm_dev, &ljm_backlight_ops, &props);
    if (IS_ERR(ljm_dev->backlight_dev[index]))
    {
        printk("ERROR:[%s %d] register backlight device failed, name: %s.\n",__FUNCTION__,__LINE__,bl_name);
    }
}
#endif
