/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

#ifndef __LJMICRO_CLK_H__
#define __LJMICRO_CLK_H__

#define GP201_CRU_CONTROL_REGISTER 0x0308000
#define GP201_CRU_PLLEN               0x00 /*PLL enable Control Register*/
#define GP201_CRU_DEVPLL              0x04 /*DEV_PLL Control Register*/
#define GP201_CRU_DEV2PLL             0x08 /*DEV2_PLL Control Register*/
#define GP201_CRU_GPUPLL              0x0c /*GPU_PLL Control Register*/
#define GP201_CRU_GPU2PLL             0x10 /*GPU2_PLL Control Register*/
#define GP201_CRU_DDRPLL              0x14 /*DDR PLL Control Register*/
#define GP201_CRU_PXLPLL0             0x18 /*PXL_PLL0 Control Register*/
#define GP201_CRU_PXLPLL1             0x1c /*PXL_PLL1 Control Register*/
#define GP201_CRU_PXLPLL2             0x20 /*PXL_PLL2 Control Register*/
#define GP201_CRU_PXLPLL3             0x24 /*PXL_PLL3 Control Register*/
#define GP201_CRU_CKMUX               0x30 /*CLK mux select register*/
#define GP201_CRU_CKDIV               0x34 /*Clk divider select register*/
#define GP201_CRU_CKEN0               0x38 /*Device Clk enable Control Register0*/
#define GP201_CRU_CKEN1               0x3c /*Device Clk enable Control Register1*/
#define GP201_CRU_CNTCLK              0x40 /*Counter Clk parameter Register*/
#define GP201_CRU_STATUS              0x50 /*Status Register*/
#define GP201_CRU_SOFTRST0            0x60 /*Device Reset(w1w0) Control Register0*/
#define GP201_CRU_SOFTRST1            0x64 /*Device Reset(w1w0) Control Register1*/
#define GP201_CRU_HWRST               0x68 /*Device Reset(w1) Control Register*/
#define GP201_CRU_DEBUG               0x70 /*CRU Debug Register*/


int  ljm_clk_init(struct ljm_device *ljm_dev);
int ljm_clk_remove(struct ljm_device *ljm_dev);


#endif
