/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

/**************************************************************************
* 版权所有 (C)2022, 武汉凌久微电子有限公司。
*
* 文件名称： ljmicro_connector_codec.h
* 文件标识：
* 内容摘要： 本文件定义接口codec相关的数据结构及函数声明
* 其它说明：
* 当前版本： v1.0
* 作    者： zhoupw, 武汉凌久微电子有限公司
* 完成日期： 2022年4月27日
***************************************************************************/

#ifndef LJMICRO_CONNECTOR_CODEC_H
#define LJMICRO_CONNECTOR_CODEC_H

#include "ljmicro_device.h"

#include "ljmicro_hdmi_codec.h"
#include "ljmicro_dp_codec.h"

struct ljm_connector_codec_data {
    struct hdmi_dev **hdmi_devs;
    int num_hdmis;
    struct ljm_hdmi_codec_data *hdmi_audio_data;
    struct hdmi_codec_ops *ljm_hdmi_codec_ops;
    struct dp_dev **dp_devs;
    int num_dps;
    struct ljm_dp_codec_data *dp_audio_data;
    struct hdmi_codec_ops *ljm_dp_codec_ops;
};

#ifndef ENABLE_DP_AUDIO
#define ENABLE_DP_AUDIO 1
#endif

#ifndef ENABLE_HDMI_AUDIO
#define ENABLE_HDMI_AUDIO 1
#endif

#if ENABLE_HDMI_AUDIO
    int ljm_hdmi_codec_init(struct ljm_connector_codec_data *audio_data, struct ljm_device *ljm_dev);
#endif

#if ENABLE_DP_AUDIO
    int ljm_dp_codec_init(struct ljm_connector_codec_data *audio_data, struct ljm_device *ljm_dev);
#endif

int ljm_codec_register(struct ljm_device * ljm_dev);

#endif

