/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

#ifndef __LJMICRO_DDRCTL_H__
#define __LJMICRO_DDRCTL_H__

#include "ljmicro_ddrcom.h"

#define DDR_CTL_MSTR 0x0
/*
  bit[31:30] device_config  0x1 x8device  0x2 x16 device
  bit[x:24]  active_ranks
  bit[22]    frequency_ratio  0x0 1:2mode  0x1 1:1 mode
  bit[19:16] burst_rdwr       0x4 burst length 8
  bit[4]     ddr4             0x1 ddr4 device in use
*/

#define DDR_CTL_STAT 0x4
/*
  bit[x:0] operating_mode :
  000 - Init
  001 - Normal
  010 - Power-down
  011 - Self-refresh
  1XX - Deep power-down/Maximum Power Saving Mode
*/
#define m_DDR_CTL_STAT_NORMAL 0x1
#define DDR_CTL_STAT_INIT     0x0



#define DDR_CTL_MRCTRL0       0x10
#define DDR_CTL_MRCTRL1       0x14
#define DDR_CTL_MRCTRL2       0x1c
//#define DDR_CTL_DERATEEN      0x20
#define DDR_CTL_DERATEINT     0x24
#define DDR_CTL_MSTR2         0x28
#define DDR_CTL_DERATECTL     0x2c
#define DDR_CTL_PWRTMG        0x34
#define DDR_CTL_HWLPCTL       0x38
#define DDR_CTL_HWFFCCTL      0x3c
#define DDR_CTL_HWFFCEX_RANK1 0x44


#define DDR_CTL_DERATEEN 0x20  //for lpddr only
//bit[12]   derate_mr4_tuf_dis : no for ddr4
//bit[10:8] rc_derate_value    : for lpddr4
//bit[2:1]  derate_value       : for lpddr
//bit[0]    derate_enable      : This field must be set to '0' for non-LPDDR2/LPDDR3/LPDDR4 mode

#define DDR_CTL_SBRCTL 0xf24
//bit[6:4]  refresh_mode
//0x0 (Fix1x): Fixed 1x (Normal mode)
//0x1 (Fix2x): Fixed 2x
//0x2 (Fix4x): Fixed 4x
//0x5 (OTFx2): Enable on the fly 2x (not supported)
//0x6 (OTFx4): Enable on the fly 4x (not supported


#define DDR_CTL_RFSHCTL3 0x60
uint32_t ddr_ctl_refresh_mode[7] = {0, 0, 0, 0x20, 0x20, 0, 0};


#define DDR_CTL_PWRCTL 0x30
#define m_LPDDR4_SR_ALLOWED       (0x1 << 8)//for lpddr4?
#define m_DIS_CAM_DRAIN_SELFREF   (0x1 << 7)
#define m_STAY_IN_SELFREF         (0x1 << 6)
#define m_SELFREF_SW              (0x1 << 5)
#define m_MPSM_EN                 (0x1 << 4)
#define m_EN_DFI_DRAM_CLK_DISABLE (0x1 << 3)
#define m_DEEPPOWERDOWN_EN        (0x1 << 2)
#define m_POWERDOWN_EN            (0x1 << 1)
#define m_SELFREF_EN              (0x1 << 0)

#define DDR_CTL_RFSHCTL0  0x50
#define DDR_CTL_RFSHCTL1  0x54
#define DDR_CTL_RFSHCTL2  0x58
#define DDR_CTL_RFSHCTL4  0x5c
#define DDR_CTL_RFSHTMG   0x64
#define DDR_CTL_RFSHTMG1  0x68

#define DDR_RFSH_NUM 5
uint32_t ddr_ctl_rfsh[7][DDR_RFSH_NUM] = {
     //800M
    {0x00210000, 0x00010008, 0x00000000, 0x00300034, 0x00600000},
     //1066M
    {0x00210000, 0x00010008, 0x00000000, 0x00400046, 0x00600000},
     //1600M
    {0x00210000, 0x00010008, 0x00000001, 0x00610068, 0x00600000},
     //2400M
    {0x00210000, 0x00010008, 0x00000021, 0x00920042, 0x00600000},
     //2666M
    {0x00210000, 0x00010008, 0x00000021, 0x00a2004a, 0x00600000},
     //2933M
    {0x00210000, 0x00010008, 0x00000021, 0x00B20051, 0x00600000},
     //3200M
    {0x00210000, 0x00010008, 0x00000001, 0x00C300D0, 0x00600000},
};





#define DDR_CTL_ECCCFG0   0x70
#define DDR_CTL_ECCCFG1   0x74
#define DDR_CTL_ECCCCTL   0x7c
#define DDR_CTL_ECCPOISONADDR0 0xb8
#define DDR_CTL_ECCPOISONADDR1 0xbc
#define DDR_CTL_CRCPARCTL0     0xc0
#define DDR_CTL_CRCPARCTL1     0xc4


#define DDR_CTL_INT0      0xd0
#define DDR_CTL_INT1      0xd4
#define DDR_CTL_INT2      0xd8
#define DDR_CTL_INT3      0xdc
#define DDR_CTL_INT4      0xe0
#define DDR_CTL_INT5      0xe4
#define DDR_CTL_INT6      0xe8
#define DDR_CTL_INT7      0xec


uint32_t ddr_ctl_intreg[7][8] = {
     //800M
    {0xc00200c5, 0x00500000, 0x00000000, 0x00340305, 0x00000000, 0x00110000, 0x02000600, 0x00000010},
     //1066M
    {0xc00200c5, 0x00500000, 0x00000000, 0x00040305, 0x00000000, 0x00110000, 0x02000600, 0x00000010},
     //1600M
    {0xc00200c5, 0x00500000, 0x00000000, 0x02340305, 0x00000000, 0x00110000, 0x02000600, 0x00000410},
     //2400M
    {0xC0030126, 0x00770000, 0x00000000, 0x08340305, 0x00180280, 0x00110000, 0x02000600, 0x00000810},
     //2666M
    {0xc0030147, 0x00840000, 0x00000000, 0x0a400305, 0x00200280, 0x00110000, 0x02000600, 0x00000c10},
     //2933M
    {0xC0030167, 0x00910000, 0x00000000, 0x0E440305, 0x00280480, 0x00110000, 0x02000600, 0x00001010},
     //3200M
    {0xC0030188, 0x009E0000, 0x00000000, 0x0C500305, 0x00280400, 0x00110000, 0x02000600, 0x00001015},
};


//DIMM Control Register
#define DDR_CTL_DIMMCTL   0xf0
//Rank Control Register
#define DDR_CTL_RANKCTL   0xf4
#define DDR_CTL_RANKCTL1  0xf8


#define DDR_CTL_DRAMTMG0  0x100
#define DDR_CTL_DRAMTMG1  0x104
#define DDR_CTL_DRAMTMG2  0x108
#define DDR_CTL_DRAMTMG3  0x10c
#define DDR_CTL_DRAMTMG4  0x110
#define DDR_CTL_DRAMTMG5  0x114
#define DDR_CTL_DRAMTMG6  0x118
#define DDR_CTL_DRAMTMG7  0x11c
#define DDR_CTL_DRAMTMG8  0x120
#define DDR_CTL_DRAMTMG9  0x124
#define DDR_CTL_DRAMTMG10 0x128
#define DDR_CTL_DRAMTMG11 0x12c
#define DDR_CTL_DRAMTMG12 0x130
#define DDR_CTL_DRAMTMG13 0x134
#define DDR_CTL_DRAMTMG14 0x138
#define DDR_CTL_DRAMTMG15 0x13c
#define DDR_CTL_DRAMTMG16 0x140
#define DDR_CTL_DRAMTMG17 0x144

uint32_t ddr_ctl_dramtmg[7][17] = {
     //800M
    {0x0A060D07, 0x0002020A, 0x05080609, 0x0000400c, 0x03020204, 0x03030202, 0x00000003, 0x00000303, \
     0x02020B03, 0x00020208, 0x000f0c06, 0x0D04010E, 0x00000008, 0x00000000, 0x00000000, 0x00000000, 0x003c003c},
     //1066M
    {0x0B081209, 0x0002020D, 0x05050309, 0x0000400c, 0x04030205, 0x03030202, 0x00000003, 0x00000303, \
     0x02020B04, 0x00020208, 0x000f0c06, 0x0D05010E, 0x00000008, 0x00000000, 0x00000000, 0x00000000, 0x003c003c},
     //1600M
    {0x0d0c1b0d, 0x00030313, 0x0508060a, 0x0000400c, 0x06030306, 0x04040302, 0x00000003, 0x00000404, \
     0x03030b05, 0x00020308, 0x000f0c06, 0x1106010e, 0x00000008, 0x00000000, 0x00000000, 0x00000000, 0x003c003c},
     //2400M
    {0x11122914, 0x0004051C, 0x0608050D, 0x0000400C, 0x08030409, 0x06060403, 0x00000003, 0x00000606, \
     0x04040D07, 0x0002040A, 0x000f0c06, 0x1309010E, 0x00000008, 0x00000000, 0x00000000, 0x00000000, 0x003c003c},
     //2666M
    {0x13142d16, 0x00040520, 0x0709050e, 0x0000400c, 0x0a04050b, 0x07070404, 0x00000003, 0x00000707, \
     0x04040f07, 0x0002040b, 0x000f0c06, 0x1409010e, 0x00000008, 0x00000000, 0x00000000, 0x00000000, 0x003c003c},
     //2933M
    {0x15163218, 0x00050623, 0x080A0510, 0x0000400C, 0x0B04050C, 0x08080504, 0x00000003, 0x00000808, \
     0x04041008, 0x0002040C, 0x000f0c06, 0x160A010E, 0x00000008, 0x00000000, 0x00000000, 0x00000000, 0x003c003c},
     //3200
    {0x1618361A, 0x00050626, 0x080B0711, 0x0000400C, 0x0C04060D, 0x08080504, 0x00000003, 0x00000808, \
     0x04041108, 0x0002050C, 0x000f0c06, 0x180B010E, 0x00000008, 0x00000000, 0x00000000, 0x00000000, 0x003c003c},
};



#define DDR_CTL_ZQCTL0 0x180
#define DDR_CTL_ZQCTL1 0x184
#define DDR_CTL_ZQCTL2 0x188
uint32_t ddr_ctl_zqctl1[] ={0x0000186A, 0x000030d4, 0x000030d4, 0x0000493E, 0x0000515d, 0x0000597B, 0x000061A8};


#define DDR_CTL_DFITMG0    0x190
#define DDR_CTL_DFITMG1    0x194
#define DDR_CTLDFILPCFG0   0x198
#define DDR_CTLDFILPCFG1   0x19c
#define DDR_CTL_DFIUPD0    0x1a0
#define DDR_CTL_DFIUPD1    0x1a4
#define DDR_CTL_DFIUPD2    0x1a8
#define DDR_CTL_DFIMISC    0x1b0
#define m_DISDYNADRTRI         (0x1 << 6)
#define m_DFI_INITSTART        (0x1 << 5)
#define m_DFI_INIT_COMPLETE_EN (0x1 << 0)


#define DDR_CTL_DFISTAT    0x1bc
#define m_DFI_INIT_COMPELETE   (0x1 << 0)

#define DDR_CTL_DFIMISC1   0x1b4
#define DDR_CTL_DFIMISC2   0x1b8
#define DDR_CTL_DBICTL     0x1c0
#define DDR_CTL_DFIPHYMSTR 0x1c4

uint32_t ddr_ctl_dfitmg[7][2] ={
    {0x038B8204, 0x02020303}, //800M
    {0x03858204, 0x02020303}, //1066M
    {0x038b8204, 0x02020303}, //1600M
    {0x038B8207, 0x02020303}, //2400M
    {0x038d8209, 0x02020303}, //1666M
    {0x038F820B, 0x02020303}, //2933M
    {0x0391820B, 0x02020303}, //3200M

};

uint32_t ddr_ctl_dfimisc[7][3] ={
    {0x00000001, 0x00000B04, 0x00000004}, //800M
    {0x00000001, 0x00000504, 0x00000004}, //1066M
    {0x00000001, 0x00000B04, 0x00000004}, //1600M
    {0x00000001, 0x00000B07, 0x00000004}, //2400M
    {0x00000001, 0x00000d09, 0x00000004}, //2666M
    {0x00000001, 0x00000F0B, 0x00000004}, //2933M
    {0x00000001, 0x0000110B, 0x00000004}, //3200M
};



#define DDR_CTL_ADDRMAP0  0x200
#define DDR_CTL_ADDRMAP1  0x204
#define DDR_CTL_ADDRMAP2  0x208
#define DDR_CTL_ADDRMAP3  0x20c
#define DDR_CTL_ADDRMAP4  0x210
#define DDR_CTL_ADDRMAP5  0x214
#define DDR_CTL_ADDRMAP6  0x218
#define DDR_CTL_ADDRMAP7  0x21c
#define DDR_CTL_ADDRMAP8  0x220
#define DDR_CTL_ADDRMAP9  0x224
#define DDR_CTL_ADDRMAP10 0x228
#define DDR_CTL_ADDRMAP11 0x22c

uint32_t ddr_ctl_addrmap[7][12] ={
    //800M
    {0x0000001f, 0x003f0909, 0x00000700, 0x00000000, 0x00001f1f, 0x07070707, 0x0f070707, 0x00000f0f, 0x00003f01, 0x00000000, 0x00000000, 0x00000000},
    //1066M
    {0x0000001f, 0x003f0909, 0x00000700, 0x00000000, 0x00001f1f, 0x07070707, 0x0f070707, 0x00000f0f, 0x00003f01, 0x00000000, 0x00000000, 0x00000000},
    //1600M
    {0x0000001f, 0x003f0909, 0x00000000, 0x00000000, 0x00001f1f, 0x07070707, 0x0f070707, 0x00000f0f, 0x00003f08, 0x00000000, 0x00000000, 0x00000000},
    //2400M
    {0x0000001f, 0x003f0909, 0x00000700, 0x00000000, 0x00001f1f, 0x07070707, 0x0f070707, 0x00000f0f, 0x00003f01, 0x00000000, 0x00000000, 0x00000000},
    //2666M
    {0x0000001f, 0x003f0909, 0x00000700, 0x00000000, 0x00001f1f, 0x07070707, 0x0f070707, 0x00000f0f, 0x00003f01, 0x00000000, 0x00000000, 0x00000000},
    //2933M
    {0x0000001f, 0x003f0909, 0x00000700, 0x00000000, 0x00001f1f, 0x07070707, 0x0f070707, 0x00000f0f, 0x00003f01, 0x00000000, 0x00000000, 0x00000000},
    //3200M
    {0x0000001f, 0x003f0909, 0x00000700, 0x00000000, 0x00001f1f, 0x07070707, 0x0f070707, 0x00000f0f, 0x00003f01, 0x00000000, 0x00000000, 0x00000000},
};


#define DDR_CTL_ODTCFG 0x240
uint32_t ddr_ctl_odtcfg[7] = {0x0600061C, 0x06000604, 0x0600061c, 0x06000610, 0x06000610, 0x06000610, 0x06000618};


#define DDR_CTL_DBG1 0x304
#define m_DIS_HIF (0x1 << 1)
#define m_DIS_DQ  (0x1 << 0)


#define DDR_CTL_SWCTL 0x320
//bit[0] 0x0 (SwDone0): Program this register to 0 to enable quasi-dynamic programming
//       0x1 (SwDone1): Set back register to 1 once programming is done
#define m_SW_DONE (0x1 << 0)


#define DDR_CTL_SWSTAT 0x324 //read only
//bit[0] Wait for sw_done value 1 to propagate to sw_done_ack at the
//end of the programming sequence to ensure that the correct
//registers values are propagated to the destination clock domains


#define GP201_DDR_CTL_PORT_USED 3
#define GP202_DDR_CTL_PORT_USED 2

#define DDR_CTL_PORT_STEP (0xb0)


#define DDR_CTL_PCCFG 0x400

#define DDR_CTL_PCFGR_N 0x404
//Port n Configuration Read Register    0x404 + 0xb0*n

#define DDR_CTL_PCFGW_N 0x408
//Port n Configuration Write Register   0x408 + 0xb0*n

#define DDR_CTL_PCFGW_C 0x40c
//Port n Common Configuration Register  0x40c + 0xb0*n


#define DDR_CTRL_PCTRL_N 0x490
//Port n Control Register
/* port control register 0 <= n <=15    step=0xb0 */
#define m_PORT_EN  (0x1 << 0) //bit0 : 0x1 (PortEn): Enabled

/* Port n Read QoS Configuration Register 0 */
#define DDR_CTL_PCFGQOS0_N 0x494
/*
bit[x:0] rqos_map_level1 :Separation level1 indicating the end of region0 mapping; start
                          of region0 is 0. Possible values for level1 are 0 to 13 (for dual
                          RAQ) or 0 to 14 (for single RAQ) which corresponds to arqos.
                          Note that for PA, arqos values are used directly as port
                          priorities, where the higher the value corresponds to higher port priority
*/


//Port n Read QoS Configuration Register 0  0x494 + 0xb0*n

#define DDR_CTL_PCFGQOS1_N  0x498
//Port n Read QoS Configuration Register 1  0x498 + 0xb0*n

#define DDR_CTL_PCFGWQOS0_N 0x49c
//Port n Write QoS Configuration Register 0 0x49c + 0xb0*n


#define DDR_CTL_PCFGWQOS1_N 0x4a0
//Port n Write QoS Configuration Register 1 0x4a0 + 0xb0*n

#define DDR_CTL_SBRCTL      0xf24


uint32_t ddr_ctl_pccfg[7][29] ={
    //800M    port0 1 2 3
    {0x00000110, 0x000160cc, 0x00004358, 0x00000001, 0x0010000b, 0x06430279, 0x01110c0b, 0x01ee06f7, \
                 0x000171da, 0x00003284, 0x00000001, 0x00210000, 0x045a04a8, 0x01110a07, 0x066e0599, \
                 0x0001522e, 0x00002323, 0x00000001, 0x00210007, 0x01010734, 0x01000801, 0x022f0406, \
                 0x00010049, 0x000071d7, 0x00000001, 0x00210004, 0x009c05b3, 0x00100e0d, 0x064a0572},
    //1066M
    {0x00000110, 0x000160cc, 0x00004358, 0x00000001, 0x0010000b, 0x06430279, 0x01110c0b, 0x01ee06f7, \
                 0x000171da, 0x00003284, 0x00000001, 0x00210000, 0x045a04a8, 0x01110a07, 0x066e0599, \
                 0x0001522e, 0x00002323, 0x00000001, 0x00210007, 0x01010734, 0x01000801, 0x022f0406, \
                 0x00010049, 0x000071d7, 0x00000001, 0x00210004, 0x009c05b3, 0x00100e0d, 0x064a0572},
    //1600M
    {0x00000110, 0x000160cc, 0x00004358, 0x00000001, 0x0010000b, 0x06430279, 0x01110c0b, 0x01ee06f7, \
                 0x000171da, 0x00003284, 0x00000001, 0x00210000, 0x045a04a8, 0x01110a07, 0x066e0599, \
                 0x0001522e, 0x00002323, 0x00000001, 0x00210007, 0x01010734, 0x01000801, 0x022f0406, \
                 0x00010049, 0x000071d7, 0x00000001, 0x00210004, 0x009c05b3, 0x00100e0d, 0x064a0572},
    //2400M
    {0x00000100, 0x000172ff, 0x000072ff, 0x00000001, 0x02100e07, 0x06000096, 0x01100e07, 0x06000096, \
                 0x000172ff, 0x000072ff, 0x00000001, 0x02100e07, 0x06000096, 0x01100e07, 0x06000096, \
                 0x000172ff, 0x000072ff, 0x00000001, 0x02100e07, 0x06000096, 0x01100e07, 0x06000096, \
                 0x000172ff, 0x000072ff, 0x00000001, 0x02100e07, 0x06000096, 0x01100e07, 0x06000096},
    //2666M
    {0x00000100, 0x000172ff, 0x000072ff, 0x00000001, 0x02100e07, 0x06000096, 0x01100e07, 0x06000096, \
                 0x000172ff, 0x000072ff, 0x00000001, 0x02100e07, 0x06000096, 0x01100e07, 0x06000096, \
                 0x000172ff, 0x000072ff, 0x00000001, 0x02100e07, 0x06000096, 0x01100e07, 0x06000096, \
                 0x000172ff, 0x000072ff, 0x00000001, 0x02100e07, 0x06000096, 0x01100e07, 0x06000096},
    //2933M
    {0x00000100, 0x000172ff, 0x000072ff, 0x00000001, 0x02100e07, 0x00620096, 0x01100e07, 0x00c8012c, \
                 0x000172ff, 0x00003284, 0x00000001, 0x00210000, 0x045a04a8, 0x01110a07, 0x066e0599, \
                 0x000172ff, 0x00002323, 0x00000001, 0x00210007, 0x01010734, 0x01000801, 0x022f0406, \
                 0x000172ff, 0x000071d7, 0x00000001, 0x00210004, 0x009c05b3, 0x00100e0d, 0x064a0572},
    //3200M
    {0x00000110, 0x000172ff, 0x00004358, 0x00000001, 0x0010000b, 0x06430279, 0x01110c0b, 0x01ee06f7, \
                 0x000172ff, 0x00003284, 0x00000001, 0x00210000, 0x045a04a8, 0x01110a07, 0x066e0599, \
                 0x000172ff, 0x00002323, 0x00000001, 0x00210007, 0x01010734, 0x01000801, 0x022f0406, \
                 0x000172ff, 0x000071d7, 0x00000001, 0x00210004, 0x009c05b3, 0x00100e0d, 0x064a0572},
};





ddr_reg_val_v2 ddr_ctl_sbr[] = {
    {0x00000f24, 0x00021e12},//SBRCTL
    {0x00000f2c, 0xf457acc3},//SBRWDATA0
    {0x00000f30, 0x97f15d8d},//SBRWDATA1
    {0x00000f38, 0x005cc81d},//SBRSTART0
    {0x00000f3c, 0x00000000},//SBRSTART1
    {0x00000f40, 0x005cd02e},//SBRRANGE0
    {0x00000f44, 0x00000000},
};

ddr_reg_val_v2 ddr_ctl_freq0[] = {
    {0x00000244, 0x00001323},//ODTMAP
    {0x00000250, 0x00001a05},//SCHED
    {0x00000254, 0x0000001f},
    {0x0000025c, 0x10000010},//PERFHPR1
    {0x00000264, 0x100000ff},//PERFLPR1
    {0x0000026c, 0x100002ff},//PERFWR1
    {0x00000280, 0x00000000},//DQMAP0
    {0x00000284, 0x00000000},
    {0x00000288, 0x00000000},
    {0x0000028c, 0x00000000},
    {0x00000290, 0x00000000},
    {0x00000294, 0x00000001},//DQMAP5
    {0x00000300, 0x00000006},//DBG0
    {0x00000304, 0x00000000},
    {0x0000030c, 0x00000000},//DBGCMD
    {0x00000320, 0x00000001},//SWCTL
    {0x00000328, 0x00000000},//SWCTLSTATIC
    {0x0000036c, 0x00000000},//POISONCFG
    {0x00000374, 0x000000dc},//ADVECCINDEX
    {0x0000037c, 0x00000000},//ECCPOISONPAT0
    {0x00000380, 0x00000000},//ECCPOISONPAT1
    {0x00000384, 0x00000000},
    {0x000003d0, 0x01000900},//RCDINIT1
    {0x000003d4, 0x00350700},
    {0x000003d8, 0x00350055},
    {0x000003dc, 0x07000900},
};


ddr_reg_val_v2 ddr_ctl_freq1[] = {
    {0x00002020, 0x00001606},
    {0x00002024, 0x103ed8bb},
    {0x00002034, 0x000efe03},
    {0x00002044, 0x5e030302},
    {0x00002050, 0xa001f040},
    {0x00002064, 0x00300040},
    {0x00002068, 0x00600000},
    {0x000020dc, 0x02050001},
    {0x000020e0, 0x00000040},
    {0x000020e8, 0x004007c0},
    {0x000020ec, 0x00000446},
    {0x000020f4, 0x0000022b},
    {0x00002100, 0x0d0e1a0e},
    {0x00002104, 0x00030313},
    {0x00002108, 0x0505040c},
    {0x0000210c, 0x0000e00e},
    {0x00002110, 0x05030306},
    {0x00002114, 0x080c0302},
    {0x00002118, 0x0d04000d},
    {0x0000211c, 0x00000c08},
    {0x00002120, 0x03032a08},
    {0x00002124, 0x0002030a},
    {0x00002128, 0x000f0c06},
    {0x0000212c, 0x0e06011f},
    {0x00002130, 0x0c000008},
    {0x00002134, 0x00000000},
    {0x00002138, 0x00000000},
    {0x0000213c, 0x01000000},
    {0x00002144, 0x003c003c},
    {0x00002180, 0x01000040},
    {0x00002190, 0x06888207},
    {0x00002194, 0x32080505},
    {0x000021b4, 0x00000807},
    {0x000021b8, 0x0000000b},
    {0x00002240, 0x03110258},
    {0x000023d0, 0x0a8e05f3},
    {0x000023d4, 0x1ca015ce},
    {0x000023d8, 0x05280542},
    {0x000023dc, 0x0fd91b16},
};

ddr_reg_val_v2 ddr_ctl_freq2[] = {
    {0x00003020, 0x00001606},
    {0x00003024, 0x103ed8bb},
    {0x00003034, 0x000efe03},
    {0x00003044, 0x06030207},
    {0x00003050, 0xe801f040},
    {0x00003064, 0x00308040},
    {0x00003068, 0x00600000},
    {0x000030dc, 0x02050001},
    {0x000030e0, 0x00000040},
    {0x000030e8, 0x004007c0},
    {0x000030ec, 0x00000446},
    {0x000030f4, 0x0000622b},
    {0x00003100, 0x0d0e1a0e},
    {0x00003104, 0x00030313},
    {0x00003108, 0x0505040c},
    {0x0000310c, 0x0000e00e},
    {0x00003110, 0x05030306},
    {0x00003114, 0x080c0302},
    {0x00003118, 0x0d04000d},
    {0x0000311c, 0x00000c08},
    {0x00003120, 0x03032a08},
    {0x00003124, 0x0002030a},
    {0x00003128, 0x000f0c06},
    {0x0000312c, 0x0e06011f},
    {0x00003130, 0x0c000008},
    {0x00003134, 0x00000000},
    {0x00003138, 0x00000000},
    {0x0000313c, 0x01000000},
    {0x00003144, 0x003c003c},
    {0x00003180, 0x01000040},
    {0x00003190, 0x06888207},
    {0x00003194, 0x32080505},
    {0x000031b4, 0x00000807},
    {0x000031b8, 0x0000000b},
    {0x00003240, 0x03110258},
    {0x000033d0, 0x17fa1277},
    {0x000033d4, 0x04a31afc},
    {0x000033d8, 0x06721202},
    {0x000033dc, 0x1e000e8b},
};


ddr_reg_val_v2 ddr_ctl_freq3[] = {
    {0x00004020, 0x00001606},
    {0x00004024, 0x103ed8bb},
    {0x00004034, 0x000efe03},
    {0x00004044, 0x46040401},
    {0x00004050, 0x8801f040},
    {0x00004064, 0x00308040},
    {0x00004068, 0x00600000},
    {0x000040dc, 0x02050001},
    {0x000040e0, 0x00000040},
    {0x000040e8, 0x004007c0},
    {0x000040ec, 0x00000446},
    {0x000040f4, 0x0000222b},
    {0x00004100, 0x0d0e1a0e},
    {0x00004104, 0x00030313},
    {0x00004108, 0x0505040c},
    {0x0000410c, 0x0000e00e},
    {0x00004110, 0x05030306},
    {0x00004114, 0x080c0302},
    {0x00004118, 0x0d04000d},
    {0x0000411c, 0x00000c08},
    {0x00004120, 0x03032a08},
    {0x00004124, 0x0002030a},
    {0x00004128, 0x000f0c06},
    {0x0000412c, 0x0e06011f},
    {0x00004130, 0x0c000008},
    {0x00004134, 0x00000000},
    {0x00004138, 0x00000000},
    {0x0000413c, 0x01000000},
    {0x00004144, 0x003c003c},
    {0x00004180, 0x01000040},
    {0x00004190, 0x06888207},
    {0x00004194, 0x32080505},
    {0x000041b4, 0x00000807},
    {0x000041b8, 0x0000000b},
    {0x00004240, 0x03110258},
    {0x000043d0, 0x0edf0710},
    {0x000043d4, 0x14881f56},
    {0x000043d8, 0x047a195a},
    {0x000043dc, 0x08da0eb9},
};

#endif

