/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

/**************************************************************************
* 版权所有 (C)2022, 武汉凌久微电子有限公司。
*
* 文件名称： ljmicro_dp_codec.h
* 文件标识：
* 内容摘要： 本文件定义DP接口音频驱动相关的数据结构
* 其它说明：
* 当前版本： v1.0
* 作    者： yuqj, 武汉凌久微电子有限公司
* 完成日期： 2022年4月27日
***************************************************************************/

#ifndef LJMICRO_DP_CODEC_H
#define LJMICRO_DP_CODEC_H

struct dp_dev;

enum audio_format {
    DP_I2S,
    DP_RIGHT_J,
    DP_LEFT_J,
    DP_DSP_A,
    DP_DSP_B,
    DP_AC97,
    DP_SPDIF,
    DP_DS_FIFO,
    DP_DMA,
};

struct params_info {
    unsigned char status[24];
    enum audio_format format;
    int sample_rate;
    int channels;
    int sample_width;
};

struct ljm_dp_codec_data {
    struct dp_dev *dp;
    u8 *eld;
    struct params_info info;

    void (*write)(struct ljm_dp_codec_data *audio, u32 val, int offset);
    u32 (*read)(struct ljm_dp_codec_data *audio, int offset);
};

#endif


