/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

/******************************************************************************
 *
 *  版权所有(c)，2020-2099，武汉凌久微电子有限公司
 *
 ******************************************************************************
 *
 *  文件名称：ljmicro_dpcd.h
 *  版 本 号：V1.0
 *  作    者：胡艳明
 *  生成日期：2022年7月5日
 *
 *  功能描述：DPCD寄存器定义
 *
 *  修改历史：
 *         1. 日    期：2022年7月5日
 *            作    者：胡艳明
 *            修改内容：创建文件
 *
 *****************************************************************************/

#ifndef __LJMICRO_DPCD__
#define __LJMICRO_DPCD__

/******************************************************************************
 *                                     宏定义                                 *
 ******************************************************************************/

//------------------------------------------------------------------------------
//  AUX CH DPCD Info
//------------------------------------------------------------------------------
#define TR_DPCD_REVISION                        0x00000ul   // DPCD Revision Number
#define TR_DPCD_MAX_LINK_RATE                   0x00001ul   // Max Link Rate
#define TR_DPCD_MAX_LANE_COUNT                  0x00002ul   // Max Lane Count
#define TR_DPCD_MAX_DOWNSPREAD                  0x00003ul   // Max down-spread
#define TR_DPCD_NUM_RX_PORTS                    0x00004ul   // Number of Receive Ports
#define TR_DPCD_DOWNSTREAM_PORTS_PRESENT        0x00005ul   // Downstream port present
#define TR_DPCD_MAIN_LINK_CODING                0x00006ul   // Main link channel coding
#define TR_DPCD_NUM_DOWNSTREAM_PORTS            0x00007ul   // Downstream port count
#define TR_DPCD_RX_PORT0_CAPS_0                 0x00008ul   // Receive Port 0 Capabilities 0
#define TR_DPCD_RX_PORT0_CAPS_1                 0x00009ul   // Receive Port 0 Capabilities 1
#define TR_DPCD_RX_PORT1_CAPS_0                 0x0000aul   // Receive Port 1 Capabilities 0
#define TR_DPCD_RX_PORT1_CAPS_1                 0x0000bul   // Receive Port 1 Capabilities 1
#define TR_DPCD_I2C_SPD_CTRL_CAP                0x0000cul   // I2C Speed Control Capabilities Bit Map
#define TR_DPCD_eDP_CONFIG_CAP                  0x0000dul   // eDP Configuration Capabilities
#define TR_DPCD_TRAIN_AUX_RD_INTRVL             0x0000eul   // Training Aux Rd Interval
#define TR_DPCD_ADAPTER_CAPS                    0x0000ful   // Adapter Capabilities

#define TR_DPCD_SUPPORTED_LINK_RATES            0x00010ul   // Supported LInk Rates

#define TR_DPCD_MSTM_CAPS                       0x00021ul   // MST Messaging capabilities
#define TR_DPCD_NUM_AUDIO_ENDS                  0x00022ul   // Number of Audio End-points
#define TR_DPCD_AV_SYNC_BLCK_AV_GRAN            0x00023ul   // AV Sync Data Block AV Granularity
#define TR_DPCD_AV_SYNC_BLCK                    0x00024ul   // AV Sync Data Block
#define TR_DPCD_AUD_DEC_LAT_15_8                0x00025ul   // Aud Dec Lat 15:8
#define TR_DPCD_AUD_PP_LAT_7_0                  0x00026ul   // Aud PP Lat 7:0
#define TR_DPCD_AUD_PP_LAT_15_8                 0x00027ul   // Aud PP Lat 15:8
#define TR_DPCD_Vid_Inter_Lat_7_0               0x00028ul   // Video Interlaced Latency 7:0
#define TR_DPCD_VID_PROG_LAT_7_0                0x00029ul   // Video Progressive Latency 7:0
#define TR_DPCD_REP_LAT_7_0                     0x0002aul   // Repeater Latency 7:0
#define TR_DPCD_AUD_DEL_INS_7_0                 0x0002bul   // Aud Del Ins 7:0
#define TR_DPCD_AUD_DEL_INS_15_8                0x0002cul   // Aud Del Ins 15:8
#define TR_DPCD_AUD_DEL_INS_23_16               0x0002dul   // Aud Del Ins 23:16
#define TR_DPCD_RECEIV_ADVAN_LINK_PWR_CAPS      0x0002eul   // Receiver Advanced Link Power Management Capabilities
#define TR_DPCD_AUX_FRAME_SYNC                  0x0002ful

#define TR_DPCD_GUID                            0x00030ul   // GUID
#define TR_DPCD_RX_GTC_VALUE_7_0                0x00054ul   // Rx GTC Value 7:0
#define TR_DPCD_RX_GTC_VALUE_15_8               0x00055ul   // Rx GTC Value 15:8
#define TR_DPCD_RX_GTC_VALUE_23_16              0x00056ul   // Rx GTC Value 23:16
#define TR_DPCD_RX_GTC_VALUE_31_24              0x00057ul   // Rx GTC Value 31:24
#define TR_DPCD_RX_GTC_MSTR_REQ                 0x00058ul   // Rx GTC Master Request
#define TR_DPCD_RX_GTC_FREQ_LOCK_DONE           0x00059ul   // Rx GTC Frequency Lock Done
#define TR_DPCD_RX_GTC_PHASE_SKEW_OFFSET_7_0    0x0005aul   // Rx GTC Phase Skew Offset 7:0
#define TR_DPCD_RX_GTC_PHASE_SKEW_OFFSET_15_8   0x0005bul   // Rx GTC Phase Skew Offset 15:8

#define TR_DPCD_DSC_SUPPORT                     0x00060ul   // DSC Support
#define TR_DPCD_DSC_ALGO_REVISION               0x00061ul   // DSC Algorithm Revision
#define TR_DPCD_DSC_RC_BUFFER_BLOCK_SIZE        0x00062ul   // DSC RC Buffer Block Size
#define TR_DPCD_DSC_RC_BUFFER_SIZE              0x00063ul   // DSC RC Buffer Size
#define TR_DPCD_DSC_SLICE_CAP_1                 0x00064ul   // DSC Slice Capabilities 1
#define TR_DPCD_DSC_LINE_BUFF_BIT_DEPTH         0x00065ul   // DSC Line Buffer Bit Depth
#define TR_DPCD_DSC_BLOCK_PREDIC_SUPP           0x00066ul   // DSC Block Prediction Support
#define TR_DPCD_MAX_BPP7_0_SUPP                 0x00067ul   // Maximum bits_per_pixel 7:0 Supported by the Decompressor
#define TR_DPCD_MAX_BPP9_8_SUPP                 0x00068ul   // Maximum bits_per_pixel 9:8 Supported by the Decompressor
#define TR_DPCD_DSC_DECOD_CLR_FRMT_CAPS         0x00069ul   // DSC Decoder Color Format Capabilities
#define TR_DPCD_DSC_DECOD_CLR_DPTH_CAPS         0x0006aul   // DSC Decoder Color Depth Capabilities
#define TR_DPCD_PEAK_DSC_PUT                    0x0006bul   // Peak DSC Throughput (DSC Sink)
#define TR_DPCD_DSC_MAX_SLICE_WIDTH             0x0006cul   // DSC Maximum Slice Width
#define TR_DPCD_DSC_SLICE_CAPS_2                0x0006dul   // DSC Slice Capabilities 2
#define TR_DPCD_BITS_PP_INCREMENT               0x0006ful   // Bits Per Pixel Increment

#define TR_DPCD_DOWNSTREAM_PORT_CAPS            0x00080ul   // Downstream Port 0 - 15 Capabilities

#define TR_DPCD_FEC_CAPS                        0x00090ul   // FEC Capabilities

#define TR_DPCD_LINK_BANDWIDTH_SET              0x00100ul   // Link Bandwidth Set
#define TR_DPCD_LANE_COUNT_SET                  0x00101ul   // Lane Count Set
#define TR_DPCD_TRAINING_PATTERN_SET            0x00102ul   // Training Pattern Set
#define TR_DPCD_TRAINING_LANE0_SET              0x00103ul   // Training Adjustment Lane 0 Set
#define TR_DPCD_TRAINING_LANE1_SET              0x00104ul   // Training Adjustment Lane 1 Set
#define TR_DPCD_TRAINING_LANE2_SET              0x00105ul   // Training Adjustment Lane 2 Set
#define TR_DPCD_TRAINING_LANE3_SET              0x00106ul   // Training Adjustment Lane 3 Set
#define TR_DPCD_DOWNSPREAD_CONTROL              0x00107ul   // Downspread Control
#define TR_DPCD_MAIN_LINK_CODING_SET            0x00108ul   // Main Link Channel Coding Set
#define TR_DPCD_I2C_SPD_BIT_MAP                 0x00109ul   // I2C Speed Control/Status Bit Map
#define TR_DPCD_EDP_CONFIG_SET                  0x0010aul   // eDP Configuration Set
#define TR_DPCD_LINK_QUAL_LANE0_SET             0x0010bul   // Link Qual Lane0 Set
#define TR_DPCD_LINK_QUAL_LANE1_SET             0x0010cul   // Link Qual Lane1 Set
#define TR_DPCD_LINK_QUAL_LANE2_SET             0x0010dul   // Link Qual Lane2 Set
#define TR_DPCD_LINK_QUAL_LANE3_SET             0x0010eul   // Link Qual Lane3 Set

#define TR_DPCD_MSTM_CTRL                       0x00111ul   // MST Messaging Control
#define TR_DPCD_AUDIO_DELAY_7_0                 0x00112ul   // Audio Delay 7:0
#define TR_DPCD_AUDIO_DELAY_15_8                0x00113ul   // Audio Delay 15:8
#define TR_DPCD_AUDIO_DELAY_23_16               0x00114ul   // Audio Delay 23:16
#define TR_DPCD_LINK_RATE_SET                   0x00115ul   // Link Rate Set
#define TR_DPCD_RECEIV_ADVAN_LINK_PWR_CONFIG    0x00116ul   // Receiver Advanced Link Power Management Configuration
#define TR_DPCD_SINK_AUX_FRAME_SYNC_CONFIG      0x00117ul   // Sink Device Aux Frame Sync Configuration
#define TR_DPCD_UPSTREAM_PWR_NEED               0x00118ul   // Upstream Device DP Power Need
#define TR_DPCD_XTNDED_DPRX_SLEEP_WAKE_GRANT    0x00119ul   // Extended DPRX Sleep Wake Timeout Granted

#define TR_DPCD_FEC_CONFIGURATION               0x00120ul   // FEC Configuration

#define TR_DPCD_TX_GTC_VALUE_7_0                0x00154ul   // TX GTC Value 7:0
#define TR_DPCD_TX_GTC_VALUE_15_8               0x00155ul   // TX GTC Value 15:8
#define TR_DPCD_TX_GTC_VALUE_23_16              0x00156ul   // TX GTC Value 23:16
#define TR_DPCD_TX_GTC_VALUE_31_24              0x00157ul   // TX GTC Value 31:24
#define TR_DPCD_RX_GTC_VAL_PHS_SKEW_EN          0x00158ul   // RX GTC Value Phase Skew En
#define TR_DPCD_TX_GTC_FREQ_LOCK_DONE           0x00159ul   // TX GTC Frequency Lock Done
#define TR_DPCD_TX_GTC_PHS_SKEW_OFFSET_7_0      0x0015aul   // TX GTC Phase Skew Offset 7:0
#define TR_DPCD_TX_GTC_PHS_SKEW_OFFSET_15_8     0x0015bul   // TX GTC Phase Skew Offset 15:8
#define TR_DPCD_AUX_FRAME_SYNC_VALUE_7_1        0x0015cul   // Aux Frame Sync Value 7:1
#define TR_DPCD_AUX_FRAME_SYNC_VALUE_15_8       0x0015dul   // Aux Frame Sync Value 15:8
#define TR_DPCD_AUX_FRAME_SYNC_VALUE_23_16      0x0015eul   // Aux Frame Sync Value 23:16
#define TR_DPCD_AUX_FRAME_SYNC_VALUE_31_24      0x0015ful   // Aux Frame Sync Value 31:24

#define TR_DPCD_DSC_ENABLE                      0x00160ul   // DSC Enable

#define TR_DPCD_PSR_ENABLE                      0x00170ul   // Panel Self Refresh Enable

#define TR_DPCD_ADAPTER_CTRL                    0x001a0ul   // Adapter Control
#define TR_DPCD_BRANCH_DEVICE_CTRL              0x001a1ul   // Branch Device Control

#define TR_DPCD_PAYLOAD_ALLO_SET                0x001c0ul   // Payload Allocate Set
#define TR_DPCD_PAYLOAD_ALLO_STRT_TIME_SLOT     0x001c1ul   // Payload Allocate Start Time Slot
#define TR_DPCD_PAYLOAD_ALLO_TIME_SLOT_COUNT    0x001c2ul   // Payload Allocate Time Slot Count

#define TR_DPCD_SINK_COUNT                      0x00200ul   // Sink Count
#define TR_DPCD_DEVICE_SERVICE_IRQ              0x00201ul   // Device Service IRQ Vector
#define TR_DPCD_STATUS_LANE_0_1                 0x00202ul   // Lane 0 & 1 Status
#define TR_DPCD_STATUS_LANE_2_3                 0x00203ul   // Lane 2 & 3 Status
#define TR_DPCD_LANE_ALIGNMENT_STATUS_UPDATED   0x00204ul   // Lane Alignment Status Updated
#define TR_DPCD_SINK_STATUS                     0x00205ul   // Sink Status
#define TR_DPCD_ADJUST_REQ_LANE_0_1             0x00206ul   // Adjust Request Lane 0 & 1
#define TR_DPCD_ADJUST_REQ_LANE_2_3             0x00207ul   // Adjust Request Lane 2 & 3
#define TR_DPCD_TRAINING_SCORE_LANE_0           0x00208ul   // Training Score Lane 0
#define TR_DPCD_TRAINING_SCORE_LANE_1           0x00209ul   // Training Score Lane 1
#define TR_DPCD_TRAINING_SCORE_LANE_2           0x0020aul   // Training Score Lane 2
#define TR_DPCD_TRAINING_SCORE_LANE_3           0x0020bul   // Training Score Lane 3

#define TR_DPCD_DSC_STATUS                      0x0020ful   // DSC Status

#define TR_DPCD_SYMBOL_ERROR_COUNT_LANE0_7_0    0x00210ul   // Symbol Error Count Lane0 7:0
#define TR_DPCD_SYMBOL_ERROR_COUNT_LANE0_14_8   0x00211ul   // Symbol Error Count Lane0 14:8
#define TR_DPCD_SYMBOL_ERROR_COUNT_LANE1_7_0    0x00212ul   // Symbol Error Count Lane1 7:0
#define TR_DPCD_SYMBOL_ERROR_COUNT_LANE1_14_8   0x00213ul   // Symbol Error Count Lane1 14:8
#define TR_DPCD_SYMBOL_ERROR_COUNT_LANE2_7_0    0x00214ul   // Symbol Error Count Lane2 7:0
#define TR_DPCD_SYMBOL_ERROR_COUNT_LANE2_14_8   0x00215ul   // Symbol Error Count Lane2 14:8
#define TR_DPCD_SYMBOL_ERROR_COUNT_LANE3_7_0    0x00216ul   // Symbol Error Count Lane3 7:0
#define TR_DPCD_SYMBOL_ERROR_COUNT_LANE3_14_8   0x00217ul   // Symbol Error Count Lane3 14:8
#define TR_DPCD_TEST_REQUEST                    0x00218ul   // Test Request
#define TR_DPCD_TEST_LINK_RATE                  0x00219ul   // Test Link Rate

#define TR_DPCD_TEST_LANE_COUNT                 0x00220ul   // Test Lane Count
#define TR_DPCD_TEST_PATTERN                    0x00221ul   // Test Pattern
#define TR_DPCD_TEST_H_TOTAL_15_8               0x00222ul   // Test H Total 15:8
#define TR_DPCD_TEST_H_TOTAL_7_0                0x00223ul   // Test H Total 7:0
#define TR_DPCD_TEST_V_TOTAL_15_8               0x00224ul   // Test V Total 15:8
#define TR_DPCD_TEST_V_TOTAL_7_0                0x00225ul   // Test V Total 7:0
#define TR_DPCD_TEST_H_START_15_8               0x00226ul   // Test H Start 15:8
#define TR_DPCD_TEST_H_START_7_0                0x00227ul   // Test H Start 7:0
#define TR_DPCD_TEST_V_START_15_8               0x00228ul   // Test V Start 15:8
#define TR_DPCD_TEST_V_START_7_0                0x00229ul   // Test V Start 7:0
#define TR_DPCD_TEST_HSYNC_14_8                 0x0022aul   // Test HSync 14:8
#define TR_DPCD_TEST_HSYNC_7_0                  0x0022bul   // Test HSync 7:0
#define TR_DPCD_TEST_VSYNC_14_8                 0x0022cul   // Test VSync 14:8
#define TR_DPCD_TEST_VSYNC_7_0                  0x0022dul   // Test VSync 7:0
#define TR_DPCD_TEST_H_WIDTH_15_8               0x0022eul   // Test H Width 15:8
#define TR_DPCD_TEST_H_WIDTH_7_0                0x0022ful   // Test H Width 7:0
#define TR_DPCD_TEST_V_HEIGHT_15_8              0x00230ul   // Test V Height 15:8
#define TR_DPCD_TEST_V_HEIGHT_7_0               0x00231ul   // Test V Height 7:0
#define TR_DPCD_TEST_MISC_BYTE0                 0x00232ul   // Test Misc Byte0
#define TR_DPCD_TEST_MISC_BYTE1                 0x00233ul   // Test Misc Byte1
#define TR_DPCD_TEST_REFRESH_RATE_NUM           0x00234ul   // Test Refresh Rate Numberator

#define TR_DPCD_TEST_CRC_R_CR_7_0               0x00240ul   // Test CRC R Cr, CRC Value 7:0
#define TR_DPCD_TEST_CRC_R_CR_15_8              0x00241ul   // Test CRC R Cr, CRC Value 15:8
#define TR_DPCD_TEST_CRC_G_Y_7_0                0x00242ul   // Test CRC G Y, CRC Value 7:0
#define TR_DPCD_TEST_CRC_G_Y_15_8               0x00243ul   // Test CRC G Y, CRC Value 15:8
#define TR_DPCD_TEST_CRC_B_CB_7_0               0x00244ul   // Test CRC B Cb, CRC Value 7:0
#define TR_DPCD_TEST_CRC_B_CB_15_8              0x00245ul   // Test CRC B Cb, CRC Value 15:8
#define TR_DPCD_TEST_SINK_MISC                  0x00246ul   // Test Sink Misc
#define TR_DPCD_PHY_TEST_PATTERN                0x00248ul   // Phy Test Pattern

#define TR_DPCD_TEST_80BIT_PATTERN_7_0          0x00250ul   // Test 80bit Custom Pattern Value 7:0
#define TR_DPCD_TEST_80BIT_PATTERN_15_8         0x00251ul   // Test 80Bit Custom Pattern Value 15:8
#define TR_DPCD_TEST_80BIT_PATTERN_23_16        0x00252ul   // Test 80Bit Custom Pattern Value 23:16
#define TR_DPCD_TEST_80BIT_PATTERN_31_24        0x00253ul   // Test 80Bit Custom Pattern Value 31:24
#define TR_DPCD_TEST_80BIT_PATTERN_39_32        0x00254ul   // Test 80Bit Custom Pattern Value 39:32
#define TR_DPCD_TEST_80BIT_PATTERN_47_40        0x00255ul   // Test 80Bit Custom Pattern Value 47:40
#define TR_DPCD_TEST_80BIT_PATTERN_55_48        0x00256ul   // Test 80Bit Custom Pattern Value 55:48
#define TR_DPCD_TEST_80BIT_PATTERN_63_56        0x00257ul   // Test 80Bit Custom Pattern Value 63:56
#define TR_DPCD_TEST_80BIT_PATTERN_71_64        0x00258ul   // Test 80Bit Custom Pattern Value 71:64
#define TR_DPCD_TEST_80BIT_PATTERN_79_72        0x00259ul   // Test 80Bit Custom Pattern Value 79:72
#define TR_DPCD_CONT_80BIT_PATTERN_CAPS         0x0025aul   // Continuous 80Bit Pattern From DPRX Aux CH Capability
#define TR_DPCD_CONT_80BIT_PATTERN_CTRL         0x0025bul   // Continuous 80Bit Pattern From DPRX Aux CH Control

#define TR_DPCD_TEST_RESPONSE                   0x00260ul   // Test Response
#define TR_DPCD_TEST_EDID_CHECKSUM              0x00261ul   // Test EDID Checksum
#define TR_DPCD_DSC_CRC_0_7_0                   0x00262ul   // DSC0 CRC 7:0
#define TR_DPCD_DSC_CRC_0_15_8                  0x00263ul   // DSC0 CRC 15:8
#define TR_DPCD_DSC_CRC_1_7_0                   0x00264ul   // DSC1 CRC 7:0
#define TR_DPCD_DSC_CRC_1_15_8                  0x00265ul   // DSC1 CRC 15:8
#define TR_DPCD_DSC_CRC_2_7_0                   0x00266ul   // DSC2 CRC 7:0
#define TR_DPCD_DSC_CRC_2_15_8                  0x00267ul   // DSC2 CRC 15:8

#define TR_DPCD_TEST_SINK                       0x00270ul   // Test Sink
#define TR_DPCD_TEST_AUDIO_MODE                 0x00271ul   // Test Audio Mode
#define TR_DPCD_TEST_AUDIO_PATTERN_TYPE         0x00272ul   // Test Audio Pattern Type
#define TR_DPCD_TEST_AUDIO_PERIOD_CH_1          0x00273ul   // Test Audio Period Ch 1
#define TR_DPCD_TEST_AUDIO_PERIOD_CH_2          0x00274ul   // Test Audio Period Ch 2
#define TR_DPCD_TEST_AUDIO_PERIOD_CH_3          0x00275ul   // Test Audio Period Ch 3
#define TR_DPCD_TEST_AUDIO_PERIOD_CH_4          0x00276ul   // Test Audio Period Ch 4
#define TR_DPCD_TEST_AUDIO_PERIOD_CH_5          0x00277ul   // Test Audio Period Ch 5
#define TR_DPCD_TEST_AUDIO_PERIOD_CH_6          0x00278ul   // Test Audio Period Ch 6
#define TR_DPCD_TEST_AUDIO_PERIOD_CH_7          0x00279ul   // Test Audio Period Ch 7
#define TR_DPCD_TEST_AUDIO_PERIOD_CH_8          0x0027aul   // Test Audio Period Ch 8

#define TR_DPCD_FEC_STATUS                      0x00280ul   // FEC Status
#define TR_DPCD_FEC_ERROR_COUNT_7_0             0x00281ul   // FEC Error Count 7:0
#define TR_DPCD_FEC_ERROR_COUNT_14_8            0x00282ul   // FEC Error Count 14:8

#define TR_DPCD_PAYLOAD_TABLE_UPDATE_STATUS     0x002c0ul   // Payload Table Update Status
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_1            0x002c1ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_2            0x002c2ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_3            0x002c3ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_4            0x002c4ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_5            0x002c5ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_6            0x002c6ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_7            0x002c7ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_8            0x002c8ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_9            0x002c9ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_10           0x002caul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_11           0x002cbul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_12           0x002ccul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_13           0x002cdul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_14           0x002ceul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_15           0x002cful
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_16           0x002d0ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_17           0x002d1ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_18           0x002d2ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_19           0x002d3ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_20           0x002d4ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_21           0x002d5ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_22           0x002d6ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_23           0x002d7ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_24           0x002d8ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_25           0x002d9ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_26           0x002daul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_27           0x002dbul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_28           0x002dcul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_29           0x002ddul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_30           0x002deul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_31           0x002dful
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_32           0x002e0ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_33           0x002e1ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_34           0x002e2ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_35           0x002e3ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_36           0x002e4ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_37           0x002e5ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_38           0x002e6ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_39           0x002e7ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_40           0x002e8ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_41           0x002e9ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_42           0x002eaul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_43           0x002ebul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_44           0x002ecul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_45           0x002edul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_46           0x002eeul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_47           0x002eful
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_48           0x002f0ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_49           0x002f1ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_50           0x002f2ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_51           0x002f3ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_52           0x002f4ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_53           0x002f5ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_54           0x002f6ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_55           0x002f7ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_56           0x002f8ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_57           0x002f9ul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_58           0x002faul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_59           0x002fbul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_60           0x002fcul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_61           0x002fdul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_62           0x002feul
#define TR_DPCD_VC_PAYLOAD_ID_SLOT_63           0x002fful

//------------------------------------------------------------------------------
// Source Device-Specific Field
//------------------------------------------------------------------------------
#define TR_DPCD_SOURCE_IEEE_OUI_0               0x00300ul   // Source IEEE OUI 7:0
#define TR_DPCD_SOURCE_IEEE_OUI_1               0x00301ul   // Source IEEE OUI 15:8
#define TR_DPCD_SOURCE_IEEE_OUI_2               0x00302ul   // Source IEEE OUI 23:16
#define TR_DPCD_SOURCE_DEVICE_IDENT_STRING_1    0x00303ul   // Device Identification String 1
#define TR_DPCD_SOURCE_DEVICE_IDENT_STRING_2    0x00304ul   // Device Identification String 2
#define TR_DPCD_SOURCE_DEVICE_IDENT_STRING_3    0x00305ul   // Device Identification String 3
#define TR_DPCD_SOURCE_DEVICE_IDENT_STRING_4    0x00306ul   // Device Identification String 4
#define TR_DPCD_SOURCE_DEVICE_IDENT_STRING_5    0x00307ul   // Device Identification String 5
#define TR_DPCD_SOURCE_DEVICE_IDENT_STRING_6    0x00308ul   // Device Identification String 6
#define TR_DPCD_SOURCE_HARDWARE_REVISION        0x00309ul   // Hardware Revision
#define TR_DPCD_SOURCE_F_S_WARE_MAJOR_REVISION  0x0030aul   // Firmware/Software Major Revision Source
#define TR_DPCD_SOURCE_F_S_WARE_MINOR_REVISION  0x0030bul   // Firmware/Software Minor Revision Source

//------------------------------------------------------------------------------
// Sink Device-Specific Field    0x0403 - 0x004FF : Reserved for vendor-specific usage
//------------------------------------------------------------------------------
#define TR_DPCD_SINK_IEEE_OUT_0                 0x00400ul   // Sink IEEE OUI 7:0
#define TR_DPCD_SINK_IEEE_OUT_1                 0x00401ul   // Sink IEEE OUI 15:8
#define TR_DPCD_SINK_IEEE_OUT_2                 0x00402ul   // Sink IEEE OUI 23:16
#define TR_DPCD_SINK_DEVICE_IDENT_STRING_1      0x00403ul   // Device Identification String 1
#define TR_DPCD_SINK_DEVICE_IDENT_STRING_2      0x00404ul   // Device Identification String 2
#define TR_DPCD_SINK_DEVICE_IDENT_STRING_3      0x00405ul   // Device Identification String 3
#define TR_DPCD_SINK_DEVICE_IDENT_STRING_4      0x00406ul   // Device Identification String 4
#define TR_DPCD_SINK_DEVICE_IDENT_STRING_5      0x00407ul   // Device Identification String 5
#define TR_DPCD_SINK_DEVICE_IDENT_STRING_6      0x00408ul   // Device Identification String 6
#define TR_DPCD_SINK_HARDWARE_REVISION          0x00409ul   // Hardware Revision
#define TR_DPCD_SINK_F_S_WARE_MAJOR_REVISION    0x0040aul   // Firmware/Software Major Revision Sink
#define TR_DPCD_SINK_F_S_WARE_MINOR_REVISION    0x0040bul   // Firmware/Software Minor Revision Sink

//------------------------------------------------------------------------------
// Branch Device-Specific Field  0x0503 - 0x005FF : Reserved for vendor-specific usage
//------------------------------------------------------------------------------
#define TR_DPCD_BRANCH_DEVICE_IEEE_OUI_0        0x00500ul   // Branch Device IEEE OUI 7:0
#define TR_DPCD_BRANCH_DEVICE_IEEE_OUI_1        0x00501ul   // Branch Device IEEE OUI 15:8
#define TR_DPCD_BRANCH_DEVICE_IEEE_OUI_2        0x00502ul   // Branch Device IEEE OUI 23:16
#define TR_DPCD_BRANCH_DEVICE_IDENT_STRING_1    0x00503ul   // Branch Device Indentification String 1
#define TR_DPCD_BRANCH_DEVICE_IDENT_STRING_2    0x00504ul   // Branch Device Indentification String 2
#define TR_DPCD_BRANCH_DEVICE_IDENT_STRING_3    0x00505ul   // Branch Device Indentification String 3
#define TR_DPCD_BRANCH_DEVICE_IDENT_STRING_4    0x00506ul   // Branch Device Indentification String 4
#define TR_DPCD_BRANCH_DEVICE_IDENT_STRING_5    0x00507ul   // Branch Device Indentification String 5
#define TR_DPCD_BRANCH_DEVICE_IDENT_STRING_6    0x00508ul   // Branch Device Indentification String 6
#define TR_DPCD_BRANCH_HARDWARE_REVISION        0x00509ul   // Branch Hardware Revision
#define TR_DPCD_BRANCH_F_S_WARE_MAJOR_REVISION  0x0050aul   // Branch Firmware/Software Major Revision
#define TR_DPCD_BRANCH_F_S_WARE_MINOR_REVISION  0x0050bul   // Branch Firmware/Software Minor Revision

#define TR_DPCD_SET_POWER                       0x00600ul   // Set Power

#define TR_DPCD_EDP_DPCD_REV                    0x00700ul   // EPD PDCD REV
#define TR_DPCD_EDP_GENERAL_CAP_1               0x00701ul   // EDP General Capability 1
#define TR_DPCD_EDP_BACKLIGHT_ADJUSTMENT_CAPS   0x00702ul   // EDP Backlight Adjustment Capabilities
#define TR_DPCD_EDP_GENERAL_CAP_2               0x00703ul   // EDP General Capability 2
#define TR_DPCD_EDP_GENERAL_CAP_3               0x00704ul   // EDP General Capability 3

#define TR_DPCD_EDP_DISPLAY_CONTROL             0x00720ul   // EDP Display Control
#define TR_DPCD_EDP_BACKLIGHT_MODE_SET          0x00721ul   // EDP Backlight Mode Set
#define TR_DPCD_EDP_BACKLIGHT_BRIGHT_MSB        0x00722ul   // EDP Backlight Brightness MSB
#define TR_DPCD_EDP_BACKLIGHT_BRIGHT_LSB        0x00723ul   // EDP Backlight Brightness LSB
#define TR_DPCD_EDP_PWMGEN_BIT_COUNT            0x00724ul   // EDP PWMGEN Bit Count
#define TR_DPCD_EDP_PWMGEN_BIT_COUNT_CAP_MIN    0x00725ul   // EDP PWMGEN Bit Count Cap Min
#define TR_DPCD_EDP_PWMGEN_BIT_COUNT_CAP_MAX    0x00726ul   // EDP PWMGEN Bit Count Cap Max
#define TR_DPCD_EDP_BACKLIGHT_CONTROL_STATUS    0x00727ul   // EDP Backlight Control Status
#define TR_DPCD_EDP_BACKLIGHT_FREQ_SET          0x00728ul   // EDP Backlight Freq Set
#define TR_DPCD_EDP_BACKLIGHT_FREQ_CAP_MIN_MSB  0x0072aul   // EDP Backlight Freq Cap min MSB
#define TR_DPCD_EDP_BACKLIGHT_FREQ_CAP_MIN_MID  0x0072bul   // EDP Backlight Freq Cap min MID
#define TR_DPCD_EDP_BACKLIGHT_FREQ_CAP_MIN_LSB  0x0072cul   // EDP Backlight Freq Cap min LSB
#define TR_DPCD_EDP_BACKLIGHT_FREQ_CAP_MAX_MSB  0x0072dul   // EDP Backlight Freq Cap Max MSB
#define TR_DPCD_EDP_BACKLIGHT_FREQ_CAP_MAX_MID  0x0072eul   // EDP Backlight Freq Cap Max MID
#define TR_DPCD_EDP_BACKLIGHT_FREQ_CAP_MAX_LSB  0x0072ful   // EDP Backlight Freq Cap Max LSB

#define TR_DPCD_EDP_DBC_MIN_BRIGHTNESS_SET      0x00732ul   // EDP DBC Minimum Brightness Set
#define TR_DPCD_EDP_DBC_MAX_BRIGHTNESS_SET      0x00733ul   // EDP DBC Maximum Brightness Set

#define TR_DPCD_REGIONAL_BACKLIGHT_BASE         0x00740ul   // Regional Backlight Base
#define TR_DPCD_REGIONAL_BACKLIGHT_BRIGHT_0     0x00741ul   // Regional Backlight Brightness 0
#define TR_DPCD_REGIONAL_BACKLIGHT_BRIGHT_1     0x00742ul   // Regional Backlight Brightness 1
#define TR_DPCD_REGIONAL_BACKLIGHT_BRIGHT_2     0x00743ul   // Regional Backlight Brightness 2
#define TR_DPCD_REGIONAL_BACKLIGHT_BRIGHT_3     0x00744ul   // Regional Backlight Brightness 3
#define TR_DPCD_REGIONAL_BACKLIGHT_BRIGHT_4     0x00745ul   // Regional Backlight Brightness 4
#define TR_DPCD_REGIONAL_BACKLIGHT_BRIGHT_5     0x00746ul   // Regional Backlight Brightness 5
#define TR_DPCD_REGIONAL_BACKLIGHT_BRIGHT_6     0x00747ul   // Regional Backlight Brightness 6
#define TR_DPCD_REGIONAL_BACKLIGHT_BRIGHT_7     0x00748ul   // Regional Backlight Brightness 7
#define TR_DPCD_REGIONAL_BACKLIGHT_BRIGHT_8     0x00749ul   // Regional Backlight Brightness 8
#define TR_DPCD_REGIONAL_BACKLIGHT_BRIGHT_9     0x0074aul   // Regional Backlight Brightness 9
#define TR_DPCD_REGIONAL_BACKLIGHT_BRIGHT_10    0x0074bul   // Regional Backlight Brightness 10
#define TR_DPCD_REGIONAL_BACKLIGHT_BRIGHT_11    0x0074cul   // Regional Backlight Brightness 11
#define TR_DPCD_REGIONAL_BACKLIGHT_BRIGHT_12    0x0074dul   // Regional Backlight Brightness 12
#define TR_DPCD_REGIONAL_BACKLIGHT_BRIGHT_13    0x0074eul   // Regional Backlight Brightness 13
#define TR_DPCD_REGIONAL_BACKLIGHT_BRIGHT_14    0x0074ful   // Regional Backlight Brightness 14

#define TR_DPCD_MSO_LINK_CAPS                   0x007a4ul   // MSO Link Capabilities
#define TR_DPCD_TEST_CRC_R_CR_MSO_2_7_0         0x007a5ul   // Test CRC R Cr MSO 2 7:0
#define TR_DPCD_TEST_CRC_R_CR_MSO_2_15_8        0x007a6ul   // Test CRC R Cr MSO 2 15:8
#define TR_DPCD_TEST_CRC_G_Y_MSO_2_7_0          0x007a7ul   // Test CRC G Y MSO 2 7:0
#define TR_DPCD_TEST_CRC_G_Y_MSO_2_15_8         0x007a8ul   // Test CRC G Y MSO 2 15:8
#define TR_DPCD_TEST_CRC_B_CB_MSO_2_7_0         0x007a9ul   // Test CRC B Cb MSO 2 7:0
#define TR_DPCD_TEST_CRC_B_CB_MSO_2_15_8        0x007aaul   // Test CRC B Cb MSO 2 15:8
#define TR_DPCD_TEST_SINK_MISC_MSO_2            0x007abul   // Test Sink Misc MSO 2
#define TR_DPCD_TEST_CRC_R_CR_MSO_3_7_0         0x007acul   // Test CRC R Cr MSO 3 7:0
#define TR_DPCD_TEST_CRC_R_CR_MSO_3_15_8        0x007adul   // Test CRC R Cr MSO 3 15:8
#define TR_DPCD_TEST_CRC_G_Y_MSO_3_7_0          0x007aeul   // Test CRC G Y MSO 3 7:0
#define TR_DPCD_TEST_CRC_G_Y_MSO_3_15_8         0x007aful   // Test CRC G Y MSO 3 15:8

#define TR_DPCD_TEST_CRC_B_CB_MSO_3_7_0         0x007b0ul   // Test CRC B Cb MSO 3 7:0
#define TR_DPCD_TEST_CRC_B_CB_MSO_3_15_8        0x007b1ul   // Test CRC B Cb MSO 3 15:8
#define TR_DPCD_TEST_SINK_MISC_MSO_3            0x007b2ul   // Test Sink Misc MSO 3
#define TR_DPCD_TEST_CRC_R_CR_MSO_4_7_0         0x007b3ul   // Test CRC R Cr MSO 4 7:0
#define TR_DPCD_TEST_CRC_R_CR_MSO_4_15_8        0x007b4ul   // Test CRC R Cr MSO 4 15:8
#define TR_DPCD_TEST_CRC_G_Y_MSO_4_7_0          0x007b5ul   // Test CRC G Y MSO 4 7:0
#define TR_DPCD_TEST_CRC_G_Y_MSO_4_15_8         0x007b6ul   // Test CRC G Y MSO 4 15:8
#define TR_DPCD_TEST_CRC_B_CB_MSO_4_7_0         0x007b7ul   // Test CRC B Cb MSO 4 7:0
#define TR_DPCD_TEST_CRC_B_CB_MSO_4_15_8        0x007b8ul   // Test CRC B Cb MSO 4 15:8
#define TR_DPCD_TEST_SINK_MISC_MSO_4            0x007b9ul   // Test Sink Misc MSO 4

//------------------------------------------------------------------------------
// MST Sideband message buffer addresses
//------------------------------------------------------------------------------
#define TR_DPCD_MST_SIDEBAND_MSG_BFR_DN_REQ     0x01000ul   // Down Request Sideband Message Buffer
#define TR_DPCD_MST_SIDEBAND_MSG_BFR_UP_REP     0x01200ul   // Up Reply Sideband Message Buffer
#define TR_DPCD_MST_SIDEBAND_MSG_BFR_DN_REP     0x01400ul   // Down Reply Sideband Message Buffer
#define TR_DPCD_MST_SIDEBAND_MSG_BFR_UP_REQ     0x01600ul   // Up Request Sideband Message Buffer
#define TR_DPCD_SINK_COUNT_ESI                  0x02002ul   // Sink Count ESI
#define TR_DPCD_DEVICE_SERV_IRQ_VEC_ESI0        0x02003ul   // Device Service IRQ Vector ESI0
#define TR_DPCD_DEVICE SERV_IRQ_VEC_ESI1        0x02004ul   // Device Service IRQ Vector ESI1
#define TR_DPCD_LINK_SERV_IRQ_VEC_ESI0          0x02005ul   // Link Service IRQ Vector ESI0
#define TR_DPCD_RECEIV_ADVAN_LINK_PWR_STATUS    0x0200bul   // Receiver Advanced Link Power Management Status
#define TR_DPCD_LANE0_1_STATUS_ESI              0x0200cul   // Lane0 1 Status ESI
#define TR_DPCD_LANE2_3_STATUS_ESI              0x0200dul   // Lane2 3 Status ESI
#define TR_DPCD_LANE_ALIGN_STATUS_UPDATED_ESI   0x0200eul   // Lane Align Status Updated ESI
#define TR_DPCD_SINK_STATUS_ESI                 0x0200ful   // Sink Status ESI

#define TR_DPCD_SINK_AUX_FRAME_SYNC_STATUS      0x02010ul   // Sink Device Aux Frame Sync Status
#define TR_DPCD_SINK_USER_IRQ_VECTOR            0x02012ul   // Sink User IRQ Vector

#define TR_DPCD_REVISION_ERC                    0x02200ul   // DPCD Revision Extended Receiver Capability
#define TR_DPCD_MAX_LINK_RATE_ERC               0x02201ul   // Max Link Rate
#define TR_DPCD_MAX_LANE_COUNT_ERC              0x02202ul   // Max Lane Count
#define TR_DPCD_MAX_DOWNSPREAD_ERC              0x02203ul   // Max Downspread
#define TR_DPCD_PWR_VOLTAGE_CAP_ERC             0x02204ul   // DP Power Voltage Capbility
#define TR_DPCD_DOWN_STREAM_PORT_PRESENT_ERC    0x02205ul   // Down Stream Port Present
#define TR_DPCD_MAIN_LINK_CHAN_CODING_ERC       0x02206ul   // Main Link Channel Coding
#define TR_DPCD_DOWN_STREAM_PORT_COUNT_ERC      0x02207ul   // Down Stream Port Count
#define TR_DPCD_RECEIVE_PORT0_CAP_0             0x02208ul   // Receive Port0 Cap 0
#define TR_DPCD_RECEIVE_PORT0_CAP_1             0x02209ul   // Receive Port0 Cap 1
#define TR_DPCD_RECEIVE_PORT1_CAP_0             0x0220aul   // Receive Port1 Cap 0
#define TR_DPCD_RECEIVE_PORT1_CAP_1             0x0220bul   // Receive Port1 Cap 1
#define TR_DPCD_I2C_SPD_CTR_CAP_ERC             0x0220cul   // I2C Speed Control Capabilities Bit Map
#define TR_DPCD_eDP_CONFIG_CAP_ERC              0x0220dul   // eDP Configuration Capabilites
#define TR_DPCD_TRAIN_AUX_RD_INTRVL_ERC         0x0220eul   // Training Aux RD Interval
#define TR_DPCD_ADAPTER_CAP_ERC                 0x0220ful   // Adapter Capabilities

#define TR_DPCD_DPRX_FEAT_ENUM_LIST_ERC         0x02210ul   // DPRX Feature Enumeration List
#define TR_DPCD_XTNDED_DPRX_SLEEP_WAKE_REQUEST  0x02211ul   // Extended DPRX Sleep Wake Timeout Request
#define TR_DPCD_VSC_EXT_VESA_SDP_MAX_CHAINING   0x02212ul   // VSC Ext VESA SDP Max Chaining
#define TR_DPCD_VSC_EXT_CTA_SDP_MAX_CHAINING    0x02213ul   // VSC Ext CTA SDP Max Chaining
#define TR_DPCD_ADAPTIVE_SYNC_CAPABILITY        0x02214ul   // Adaptive Sync Capability

#define TR_DPCD_CEC_TUNNELING_CAP               0x03000ul   // CEC Tunneling Capability
#define TR_DPCD_CEC_TUNNELING_CTRL              0x03001ul   // CEC Tunneling Control
#define TR_DPCD_CEC_RX_MESSAGE_INFO             0x03002ul   // CEC Rx Message Info
#define TR_DPCD_CEC_TX_MESSAGE_INFO             0x03003ul   // CEC Tx Message Info
#define TR_DPCD_CEC_TUNNELING_IRQ_FLAGS         0x03004ul   // CEC Tunneling IRQ Flags
#define TR_DPCD_CEC_LOGICAL_ADDRESS_MASK        0x0300eul   // CEC Logical Address Mask
#define TR_DPCD_CEC_RX_MESSAGE_BUFFER           0x03010ul   // CEC Rx Message Buffer
#define TR_DPCD_CEC_TX_MESSAGE_BUFFER           0x03020ul   // CEC Tx Message Buffer
#define TR_DPCD_DOWNSTREAM_LINK_ERR_REPORT_SUPP 0x03030ul   // Downstream Link Error Reporting Supported
#define TR_DPCD_DOWNSTREAM_HDMI_ERR_STATUS_CH0  0x03031ul   // Downstream HDMI Error Status Ch0
#define TR_DPCD_DOWNSTREAM_HDMI_ERR_STATUS_CH1  0x03032ul   // Downstream HDMI Error Status Ch1
#define TR_DPCD_DOWNSTREAM_HDMI_ERR_STATUS_CH2  0x03033ul   // Downstream HDMI Error Status Ch2
#define TR_DPCD_HDMI_SINK_BIT_DEPTH_SUPP        0x03034ul   // HDMI Sink YCBCR420 Component Bit Depth Support

#define TR_DPCD_PROTOCOL_CONV_CTRL_0            0x03050ul   // Protocol Converter Control 0
#define TR_DPCD_PROTOCOL_CONV_CTRL_1            0x03051ul   // Protocol Converter Control 1
#define TR_DPCD_PROTOCOL_CONV_CTRL_2            0x03052ul   // Protocol Converter Control 2
#define TR_DPCD_OUTPUT_HTOTAL_7_0               0x03054ul   // Output HTotal 7:0
#define TR_DPCD_OUTPUT_HTOTAL_15_8              0x03055ul   // Output HTotal 15:8
#define TR_DPCD_OUTPUT_HSTART_7_0               0x03056ul   // Output HStart 7:0
#define TR_DPCD_OUTPUT_HSTART_15_8              0x03057ul   // Output HStart 15:8
#define TR_DPCD_OUTPUT_HSP_HSW_7_0              0x03058ul   // Output HSP HSW 7:0
#define TR_DPCD_OUTPUT_HSP_HSW_14_8             0x03059ul   // Output HSP HSW 14:8

#define TR_DPCD_VENDOR_ID                       0x60000ul   // Vendor ID
#define TR_DPCD_PRODUCT_ID                      0x60002ul   // Product ID
#define TR_DPCD_VERSION_NUMBER                  0x60004ul   // Version Number
#define TR_DPCD_TOUCH_CAPABILITY                0x60006ul   // Touch Capability
#define TR_DPCD_TOUCH_STATUS                    0x60007ul   // Touch Status
#define TR_DPCD_TOUCH_PARAM_0                   0x60008ul   // Touch Parameters Byte 0
#define TR_DPCD_TOUCH_PARAM_1                   0x60009ul   // Touch Parameters Byte 1
#define TR_DPCD_TOUCH_PARAM_2                   0x6000aul   // Touch Parameters Byte 2
#define TR_DPCD_TOUCH_PARAM_3                   0x6000bul   // Touch Parameters Byte 3
#define TR_DPCD_CONFIGURE_TOUCH                 0x6000cul   // Configure Touch
#define TR_DPCD_CONFIGURE_EKBM                  0x6000dul   // Configure eKBM

#define TR_DPCD_IDLE_RATES_0                    0x6000eul   // Idle Rates 0
#define TR_DPCD_IDLE_RATES_1                    0x6000ful   // Idle Rates 1
#define TR_DPCD_IDLE_RATES_2                    0x60010ul   // Idle Rates 2
#define TR_DPCD_IDLE_RATES_3                    0x60011ul   // Idle Rates 3
#define TR_DPCD_IDLE_RATES_4                    0x60012ul   // Idle Rates 4
#define TR_DPCD_IDLE_RATES_5                    0x60013ul   // Idle Rates 5
#define TR_DPCD_IDLE_RATES_6                    0x60014ul   // Idle Rates 6
#define TR_DPCD_IDLE_RATES_7                    0x60015ul   // Idle Rates 7
#define TR_DPCD_IDLE_RATES_8                    0x60016ul   // Idle Rates 8
#define TR_DPCD_IDLE_RATES_9                    0x60017ul   // Idle Rates 9
#define TR_DPCD_IDLE_RATES_10                   0x60018ul   // Idle Rates 10
#define TR_DPCD_IDLE_RATES_11                   0x60019ul   // Idle Rates 11
#define TR_DPCD_IDLE_RATES_12                   0x6001aul   // Idle Rates 12
#define TR_DPCD_IDLE_RATES_13                   0x6001bul   // Idle Rates 13
#define TR_DPCD_IDLE_RATES_14                   0x6001cul   // Idle Rates 14

#define TR_DPCD_FEATURE_REPORT_SIZE_MAX_0       0x6001dul   // Feature Report Size Max 0
#define TR_DPCD_FEATURE_REPORT_SIZE_MAX_1       0x6001eul   // Feature Report Size Max 1

#endif  /* ~__LJMICRO_DPCD__ */