/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

/******************************************************************************
 *
 *  版权所有(c)，2020-2099，武汉凌久微电子有限公司
 *
 ******************************************************************************
 *
 *  文件名称: ljmicro_edid.h
 *  版 本 号: V1.0
 *  作    者: zhaiyf
 *  生成日期: 2022年4月26日
 *
 *  功能描述: 驱动中与edid相关的接口封装
 *
 *  修改历史:
 *         1. 日    期: 2022年4月26日
 *            作    者: zhaiyf
 *            修改内容: 创建文件
 *
 *****************************************************************************/

#ifndef __LJMICRO_EDID_H__
#define __LJMICRO_EDID_H__

/******************************************************************************
 *                                   标准库头文件                                   *
 ******************************************************************************/
#if LINUX_VERSION_CODE < KERNEL_VERSION(6, 2, 0)
#include <stdbool.h>
#endif

/******************************************************************************
 *                                     宏定义                                     *
 ******************************************************************************/

#define LJM_EDID_LENGTH     0X80
#define LJM_EDID_SERIALNUM_BASE 0x0C
#define LJM_EDID_EXTENSIONS     0X7E

#define LJM_EDID_CEA_EXT        0x02

#define	LJM_EDID_VENDOR_BLOCK   0x03

#define LJM_HDMI_IEEE_OUI 0x000c03

#define ljm_edid_for_each_cea_db(cea, i, start, end) \
    for ((i) = (start); (i) < (end) && (i) + ljm_edid_cea_db_payload_len(&(cea)[(i)]) < (end); \
         (i) += ljm_edid_cea_db_payload_len(&(cea)[(i)]) + 1)



/******************************************************************************
 *                                    函数声明                                    *
 ******************************************************************************/
bool ljm_edid_is_hdmi(u8 *edid);
int ljm_mode_vrefresh(const struct drm_display_mode *mode);
#endif/* __LJMICRO_EDID_H__ */

