/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

/* this file defines the CHIP_  and family flags used in the pciids,
 * its is common between kms and non-kms because duplicating it and
 * changing one place is fail.
 */
#ifndef __LJMICRO_FAMILY_H__
#define __LJMICRO_FAMILY_H__

#define LJM_MAX_CARDS_NUM   4
#define LJM_MAX_PORTS       16
#define LJM_MAX_CRTCS       4
#define LJM_MAX_LAYERS      4
#define LJM_MAX_ZVIDEOS     4
#define LJM_MAX_HPD_PINS    16
#define LJM_MAX_CONNECTORS  16
#define LJM_MAX_HDMIS       4
#define LJM_MAX_DPS         4
#define LJM_MAX_I2CS        6
#define LJM_MAX_BLACKLIGHTS 4
#define LJM_MAX_I2SS        2
#define LJM_MAX_DDRS        4

/**
 * Misc
 */
#define MISC_CHIP_R00      0x0 /* GP201: 0x5a5a5a5a */
#define MISC_CHIP_R01      0x4 /* GP201: 0x02010000 */
#define MISC_CHIP_R02      0x8
#define MISC_CHIP_R03      0xC /* for ASIC */
#define MISC_FPGA_DDRDONE  0xC /* for FPGA */
#define m_DDRDONE_CALIB_FIN_MASK 0x1 /* FPGA DDRx init_calib_complete mask. RO. 0: not finish, 1: finished */

/* interrupt status register */
#define MISC_INTR_SRC          0x40 /* interupt mask */
#define m_INTR_SRC_EDMAW_C0 (1U << 0)
#define m_INTR_SRC_EDMAW_C1 (1U << 1)
#define m_INTR_SRC_EDMAW_C2 (1U << 2)
#define m_INTR_SRC_EDMAW_C3 (1U << 3)
#define m_INTR_SRC_EDMAW_C4 (1U << 4)
#define m_INTR_SRC_EDMAW_C5 (1U << 5)
#define m_INTR_SRC_EDMAW_C6 (1U << 6)
#define m_INTR_SRC_EDMAW_C7 (1U << 7)
#define m_INTR_SRC_EDMAR_C0 (1U << 8)
#define m_INTR_SRC_EDMAR_C1 (1U << 9)
#define m_INTR_SRC_EDMAR_C2 (1U << 10)
#define m_INTR_SRC_EDMAR_C3 (1U << 11)
#define m_INTR_SRC_EDMAR_C4 (1U << 12)
#define m_INTR_SRC_EDMAR_C5 (1U << 13)
#define m_INTR_SRC_EDMAR_C6 (1U << 14)
#define m_INTR_SRC_EDMAR_C7 (1U << 15)
#define m_INTR_SRC_EDMAR_C7 (1U << 15)
#define m_INTR_SRC_EDMA     0xffffU
#define m_INTR_SRC_G3D0     (1U << 16)
#define m_INTR_SRC_G3D1     (1U << 17)
#define m_INTR_SRC_G2D      (1U << 18)
#define m_INTR_SRC_VPU0     (1U << 19)
#define m_INTR_SRC_VPU1     (1U << 20)
#define m_INTR_SRC_VGA      (1U << 21)
#define m_INTR_SRC_DDRC     (1U << 22)
#define m_INTR_SRC_PVT      (1U << 23)
#define m_INTR_SRC_ADMA     (1U << 24)
#define m_INTR_SRC_I2C      (1U << 25) /* GP202 */
#define m_INTR_SRC_SW       (1U << 27) /* GP202 */
#define m_INTR_SRC_EIRQ0    (1U << 28)
#define m_INTR_SRC_EIRQ1    (1U << 29)
#define m_INTR_SRC_EIRQ2    (1U << 30)
#define m_INTR_SRC_EIRQ3    (1U << 31)

/* PCIE interrupt mask register */
#define MISC_INTR_EN          0x44
#define m_INTR_EN_EDMAW_C0 (1U << 0)
#define m_INTR_EN_EDMAW_C1 (1U << 1)
#define m_INTR_EN_EDMAW_C2 (1U << 2)
#define m_INTR_EN_EDMAW_C3 (1U << 3)
#define m_INTR_EN_EDMAW_C4 (1U << 4)
#define m_INTR_EN_EDMAW_C5 (1U << 5)
#define m_INTR_EN_EDMAW_C6 (1U << 6)
#define m_INTR_EN_EDMAW_C7 (1U << 7)
#define m_INTR_EN_EDMAR_C0 (1U << 8)
#define m_INTR_EN_EDMAR_C1 (1U << 9)
#define m_INTR_EN_EDMAR_C2 (1U << 10)
#define m_INTR_EN_EDMAR_C3 (1U << 11)
#define m_INTR_EN_EDMAR_C4 (1U << 12)
#define m_INTR_EN_EDMAR_C5 (1U << 13)
#define m_INTR_EN_EDMAR_C6 (1U << 14)
#define m_INTR_EN_EDMAR_C7 (1U << 15)
#define m_INTR_EN_EDMAR_C7 (1U << 15)
#define m_INTR_EN_EDMA     0xffffU
#define m_INTR_EN_G3D0     (1U << 16)
#define m_INTR_EN_G3D1     (1U << 17)
#define m_INTR_EN_G2D      (1U << 18)
#define m_INTR_EN_VPU0     (1U << 19)
#define m_INTR_EN_VPU1     (1U << 20)
#define m_INTR_EN_VGA      (1U << 21)
#define m_INTR_EN_DDRC     (1U << 22)
#define m_INTR_EN_PVT      (1U << 23)
#define m_INTR_EN_ADMA     (1U << 24)
#define m_INTR_EN_I2C      (1U << 25) /* GP202 */
#define m_INTR_EN_SW       (1U << 27) /* GP202 */
#define m_INTR_EN_EIRQ0    (1U << 28)
#define m_INTR_EN_EIRQ1    (1U << 29)
#define m_INTR_EN_EIRQ2    (1U << 30)
#define m_INTR_EN_EIRQ3    (1U << 31)

/* INTR VGA pending register */
#define MISC_INTR_VGAPD           0x50
#define m_INTR_VGAPD_DAC0      (1U << 0)
#define m_INTR_VGAPD_L4_BW     (1U << 1)
#define m_INTR_VGAPD_L3_BW     (1U << 2)
#define m_INTR_VGAPD_L2_BW     (1U << 3)
#define m_INTR_VGAPD_L1_BW     (1U << 4)
#define m_INTR_VGAPD_ZV3       (1U << 5)
#define m_INTR_VGAPD_ZV2       (1U << 6)
#define m_INTR_VGAPD_ZV1       (1U << 7)
#define m_INTR_VGAPD_ZV0       (1U << 8)
#define m_INTR_VGAPD_CRTC3_HPD (1U << 9)
#define m_INTR_VGAPD_CRTC3_BW  (1U << 10)
#define m_INTR_VGAPD_CRTC3_VS  (1U << 11)
#define m_INTR_VGAPD_CRTC2_HPD (1U << 12)
#define m_INTR_VGAPD_CRTC2_BW  (1U << 13)
#define m_INTR_VGAPD_CRTC2_VS  (1U << 14)
#define m_INTR_VGAPD_CRTC1_HPD (1U << 15)
#define m_INTR_VGAPD_CRTC1_BW  (1U << 16)
#define m_INTR_VGAPD_CRTC1_VS  (1U << 17)
#define m_INTR_VGAPD_CRTC0_HPD (1U << 18)
#define m_INTR_VGAPD_CRTC0_BW  (1U << 19)
#define m_INTR_VGAPD_CRTC0_VS  (1U << 20)
#define m_INTR_VGAPD_DP0_PHY   (1U << 21)   /* GP202 */
#define m_INTR_VGAPD_DP0_CTRL  (1U << 22)   /* GP202 */
#define m_INTR_VGAPD_I2S0      (1U << 26)   /* GP202 */
#define m_INTR_VGAPD_I2S1      (1U << 27)   /* GP202 */
#define m_INTR_VGAPD_HDMI0     (1U << 28)
#define m_INTR_VGAPD_HDMI1     (1U << 29)
#define m_INTR_VGAPD_HDMI2     (1U << 30)
#define m_INTR_VGAPD_HDMI3     (1U << 31)

/* INTR MSI register GP202 only*/
#define MISC_INTR_EDMA_WR0_MSI_MSG_DATA_OFFSET           0x70
#define MISC_INTR_EDMA_WR1_MSI_MSG_DATA_OFFSET           0x74
#define MISC_INTR_EDMA_WR2_MSI_MSG_DATA_OFFSET           0x78
#define MISC_INTR_EDMA_WR3_MSI_MSG_DATA_OFFSET           0x7C
#define MISC_INTR_EDMA_WR4_MSI_MSG_DATA_OFFSET           0x80
#define MISC_INTR_EDMA_WR5_MSI_MSG_DATA_OFFSET           0x84
#define MISC_INTR_EDMA_WR6_MSI_MSG_DATA_OFFSET           0x88
#define MISC_INTR_EDMA_WR7_MSI_MSG_DATA_OFFSET           0x8C
#define MISC_INTR_EDMA_RD0_MSI_MSG_DATA_OFFSET           0x90
#define MISC_INTR_EDMA_RD1_MSI_MSG_DATA_OFFSET           0x94
#define MISC_INTR_EDMA_RD2_MSI_MSG_DATA_OFFSET           0x98
#define MISC_INTR_EDMA_RD3_MSI_MSG_DATA_OFFSET           0x9C
#define MISC_INTR_EDMA_RD4_MSI_MSG_DATA_OFFSET           0xA0
#define MISC_INTR_EDMA_RD5_MSI_MSG_DATA_OFFSET           0xA4
#define MISC_INTR_EDMA_RD6_MSI_MSG_DATA_OFFSET           0xA8
#define MISC_INTR_EDMA_RD7_MSI_MSG_DATA_OFFSET           0xAC
#define MISC_INTR_3D_MSI_MSG_DATA_OFFSET                 0xB0
#define MISC_INTR_2D_MSI_MSG_DATA_OFFSET                 0xB4
#define MISC_INTR_VPU_MSI_MSG_DATA_OFFSET                0xB8
#define MISC_INTR_VGA_MSI_MSG_DATA_OFFSET                0xBC
#define MISC_INTR_DDR_MSI_MSG_DATA_OFFSET                0xC0
#define MISC_INTR_PVT_MSI_MSG_DATA_OFFSET                0xC4
#define MISC_INTR_AXIDMA_MSI_MSG_DATA_OFFSET             0xC8
#define MISC_INTR_I2C_MSI_MSG_DATA_OFFSET                0xCC
#define MISC_INTR_SW_MSI_MSG_DATA_OFFSET                 0xD0
#define MISC_INTR_EXT0_MSI_MSG_DATA_OFFSET               0xD4
#define MISC_INTR_EXT1_MSI_MSG_DATA_OFFSET               0xD8
#define MISC_INTR_EXT2_MSI_MSG_DATA_OFFSET               0xDC
#define MISC_INTR_EXT3_MSI_MSG_DATA_OFFSET               0xE0

#define MISC_MSI_MSG_CNT_LO_OFFSET                       0xF0
#define MISC_MSI_MSG_CNT_HI_OFFSET                       0xF4
#define MISC_MSI_MSG_THROTTLE_US_OFFSET                  0xF8
/* INTR MSI register GP202 only over*/

#define MISC_DDR_PHY_ADDR0          0x110
#define MISC_QSPI_XIP_EN_IO_MMIO    0x164
#define MISC_QSPI_MCU_DONE          0x168   /**< QSPI config */
#define MISC_QSPI_INIT_INTR_STATUS  0x16C
#define m_QSPI_MCU_DONE         (1U << 0)   /**< QSPI attached. 0: attached with apb*_rom/flash_auto_cfg, 1: attached with apb*_io/mmio */
#define m_QSPI_ASK_EXIT         (1U << 1)   /**< issue check for QSPI exit from XiP */
#define m_EXITXIP_FIN_IO_MMIO   (1U << 7)
#define m_SPI_MODE             (1U << 12)

#ifdef UEFI_GOP
#define PCI_ANY_ID (~0)
#else /* !UEFI_GOP */
#include <linux/types.h>
#include <asm/io.h>

extern void *g_mmio_base;
extern int   g_card_cnt;
extern void *g_mmio_bases[LJM_MAX_CARDS_NUM];

/**
 * hardware special data
 */
struct ljm_gpu_hardware_t {
    /** DDR */
    int max_ddr_channels;
    u32 reg_ddr_ctr_offset[LJM_MAX_DDRS];
    u32 reg_ddr_phy_offset[LJM_MAX_DDRS];

    /** misc */
    u32 reg_misc_offset;

    /** SPI flash */
    u32 reg_spi_offset;

    /** CRU */
    u32 reg_cru_offset;

    /** NOC */
    u32 reg_noc_offset;

    /** IO MUX */
    u32 reg_iomux_offset;
};

extern struct ljm_gpu_hardware_t ljm_gpu_hardware;

#define LJM_MISC_R32(CARD, ADDR)      readl(g_mmio_bases[CARD] + ljm_gpu_hardware.reg_misc_offset + (ADDR))
#define LJM_MISC_W32(CARD, ADDR, VAL) writel((u32)(VAL), g_mmio_bases[CARD] + ljm_gpu_hardware.reg_misc_offset + (ADDR))

#define LJM_MISC_R32_BASE(BASE, ADDR)      readl((void __iomem *)(BASE) + ljm_gpu_hardware.reg_misc_offset + (ADDR))
#define LJM_MISC_W32_BASE(BASE, ADDR, VAL) writel((u32)(VAL), (void __iomem *)(BASE) + ljm_gpu_hardware.reg_misc_offset + (ADDR))

#define LJM_DISABLE_ALL_IRQ(CARD) \
    if (ljm_gpu_hardware.reg_misc_offset) { \
        writel(0, g_mmio_bases[CARD] + ljm_gpu_hardware.reg_misc_offset + MISC_INTR_EN); \
    }

/* CRU */
#define LJM_CRU_R32(CARD, ADDR)           readl(g_mmio_bases[CARD] + ljm_gpu_hardware.reg_cru_offset + (ADDR))
#define LJM_CRU_W32(CARD, ADDR, VAL)      writel((u32)(VAL), g_mmio_bases[CARD] + ljm_gpu_hardware.reg_cru_offset + (ADDR))
#define LJM_CRU_R32_BASE(BASE, ADDR)      readl((void __iomem *)(BASE) + ljm_gpu_hardware.reg_cru_offset + (ADDR))
#define LJM_CRU_W32_BASE(BASE, ADDR, VAL) writel((u32)(VAL), (void __iomem *)(BASE) + ljm_gpu_hardware.reg_cru_offset + (ADDR))

#endif /* ~UEFI_GOP */

#define LJM_VENDOR_ID   0x0709

/*
 * ljmicro chip families
 */
enum ljm_family
{
    CHIP_GP100 = 0x100, /* GP100 family */
    CHIP_GP200 = 0x200, /* GP200 family */
    CHIP_GP300 = 0x300, /* GP300 family */

    CHIP_GP101 = 0x101, /* GP101/GP102 device ID */
    CHIP_GP201 = 0x201, /* GP201 device ID */
    CHIP_GP202 = 0x202, /* GP202 device ID */
    CHIP_GP301 = 0x301, /* GP301 device ID */
};

/*
 * Chip flags
 */
enum ljm_chip_flags
{
    LJMICRO_FAMILY_MASK = 0x0000ff00UL,
    LJMICRO_CHIP_MASK   = 0x0000ffffUL,
    LJMICRO_FLAGS_MASK  = 0xffff0000UL,
    LJMICRO_IS_MSI      = 0x00010000UL, /* support MSI */
    LJMICRO_IS_FPGA     = 0x00020000UL, /* FPGA platform */
    LJMICRO_IS_BUS32    = 0x00040000UL, /* 32-bit gpu bus, need fixed gart */
    LJMICRO_IS_S2C      = 0x00080000UL, /* old S2C platform, low 4MB invisible vram is wrong */
    LJMICRO_HAS_3D      = 0x00100000UL, /* 3D: offset 0x40000 */
    LJMICRO_HAS_3D1     = 0x00200000UL, /* 3D1: offset 0x80000 */
    LJMICRO_HAS_2D      = 0x00400000UL, /* 2D: offset 0xc0000 */
    LJMICRO_HAS_VPU     = 0x00800000UL, /* VPU */
    LJMICRO_RSV_FB      = 0x01000000UL, /* reserved framebuffer */
    LJMICRO_VRAM_2G     = 0x02000000UL, /* VRAM size is 2G */
    LJMICRO_HAS_VPU_ENC = 0x04000000UL, /* VPU_ENC */
    LJMICRO_HAS_HDMA    = 0x08000000UL, /* EDMA -> HDMA */
};

#define GP_PCI_IDS \
    /* old S2C board, only 32 bit bus */ \
    /*{0x0709, 0x0001, PCI_ANY_ID, PCI_ANY_ID, 0, 0, CHIP_GP201 | LJMICRO_IS_FPGA | LJMICRO_IS_MSI | LJMICRO_IS_BUS32 \
     * | LJMICRO_IS_S2C | LJMICRO_HAS_3D},*/ \
\
    /* GP200 2D fpga board, NE-EVAL-DUAL, Rev1.0 (0737004) */ \
    {0x0709, 0x0201, 0x0709, 0xf001, 0, 0, CHIP_GP201 | LJMICRO_IS_FPGA | LJMICRO_IS_MSI | LJMICRO_HAS_2D}, \
\
    /* GP200 2D fpga board, NE-EVAL-DUAL, Rev1.0 (0737004) */ \
    {0x0709, 0x0201, 0x0709, 0xf006, 0, 0, CHIP_GP201 | LJMICRO_IS_FPGA | LJMICRO_IS_MSI | LJMICRO_HAS_2D}, \
\
    /* GP200 2D fpga board, NE-EVAL-DUAL, Rev1.0 (0737013) */ \
    {0x0709, 0x0201, 0x0709, 0xf005, 0, 0, CHIP_GP201 | LJMICRO_IS_FPGA | LJMICRO_IS_MSI | LJMICRO_HAS_2D}, \
\
    /* GP200 2D fpga board, TBS-VU440-LSI (0710005)  ||   haps only 3D fpga board. you need adjust manually*/ \
    {0x0709, 0x0201, 0x0709, 0x0001, 0, 0, CHIP_GP201 | LJMICRO_IS_FPGA | LJMICRO_IS_MSI | LJMICRO_HAS_2D}, \
\
  /*{0x0709, 0x0201, 0x0709, 0x0001, 0, 0, CHIP_GP201 | LJMICRO_IS_FPGA | LJMICRO_IS_MSI | LJMICRO_IS_BUS32 | LJMICRO_HAS_3D | LJMICRO_VRAM_2G},*/ \
\
    /* GP200 2D&VPU fpga board, TBS-VU440-LSI (0710006) */ \
    {0x0709, 0x0201, 0x0709, 0xf007, 0, 0, CHIP_GP201 | LJMICRO_IS_FPGA | LJMICRO_IS_MSI | LJMICRO_HAS_2D \
        | LJMICRO_HAS_VPU | LJMICRO_VRAM_2G}, \
\
    /* GP200 VPU fpga board, NE-VU440-LSI (0732043) */ \
    {0x0709, 0x0201, 0x0709, 0xf003, 0, 0, CHIP_GP201 | LJMICRO_IS_FPGA | LJMICRO_IS_MSI | LJMICRO_HAS_VPU | LJMICRO_VRAM_2G}, \
\
    /* GP201 chip */ \
    {0x0709, 0x0201, PCI_ANY_ID, PCI_ANY_ID, 0, 0, CHIP_GP201 | LJMICRO_IS_MSI | LJMICRO_HAS_3D | LJMICRO_HAS_3D1 \
        | LJMICRO_HAS_2D | LJMICRO_HAS_VPU}, \
\
    /* GP200 2D&3D fpga board, TBS-VU440-LSI (0710006) */ \
    {0x0709, 0x0202, 0x0709, 0xf025, 0, 0, CHIP_GP202 | LJMICRO_IS_FPGA | LJMICRO_IS_MSI | LJMICRO_HAS_2D \
        | LJMICRO_HAS_3D | LJMICRO_VRAM_2G}, \
\
    /* GP202 2D fpga board, PHINE */ \
    {0x0709, 0x0202, 0x0709, 0xf029, 0, 0, CHIP_GP202 | LJMICRO_IS_FPGA | LJMICRO_IS_MSI | LJMICRO_HAS_2D \
        | LJMICRO_VRAM_2G | LJMICRO_HAS_HDMA}, \
\
    /* GP202 2D fpga board, TBS440 */ \
    {0x0709, 0x0202, 0x0709, 0xf030, 0, 0, CHIP_GP202 | LJMICRO_IS_FPGA | LJMICRO_IS_MSI | LJMICRO_HAS_2D \
        | LJMICRO_VRAM_2G | LJMICRO_HAS_HDMA}, \
\
    /* GP202 2D fpga board with VPU */ \
    {0x0709, 0x0202, 0x0709, 0xf021, 0, 0, CHIP_GP202 | LJMICRO_IS_FPGA | LJMICRO_IS_MSI | LJMICRO_HAS_2D \
        | LJMICRO_HAS_VPU | LJMICRO_VRAM_2G | LJMICRO_HAS_HDMA}, \
\
    /* GP200 Z1 host */ \
    /* {0x0709, 0x0202, 0x0709, 0x0202, 0, 0, CHIP_GP202 | LJMICRO_IS_MSI | LJMICRO_HAS_3D */ \
    /*    | LJMICRO_HAS_2D | LJMICRO_HAS_VPU | LJMICRO_VRAM_2G | LJMICRO_HAS_HDMA}, */ \
\
    /* GP202 chip */ \
    {0x0709, 0x0202, PCI_ANY_ID, PCI_ANY_ID, 0, 0, CHIP_GP202 | LJMICRO_IS_MSI | LJMICRO_HAS_3D \
        | LJMICRO_HAS_2D | LJMICRO_HAS_VPU | LJMICRO_HAS_HDMA}, \
\
    /* GP200 2D&VPU fpga board, PHINE */ \
    {0x0709, 0x0203, 0x0709, 0xf019, 0, 0, CHIP_GP201 | LJMICRO_IS_FPGA | LJMICRO_IS_MSI | LJMICRO_HAS_2D \
      | LJMICRO_HAS_VPU | LJMICRO_HAS_VPU_ENC | LJMICRO_VRAM_2G}, \
\
    /* GP300 chip */ \
    {0x0709, 0x0301, PCI_ANY_ID, PCI_ANY_ID, 0, 0, CHIP_GP301 | LJMICRO_IS_MSI | LJMICRO_HAS_3D | LJMICRO_HAS_3D1 \
        | LJMICRO_HAS_2D | LJMICRO_HAS_VPU}, \
    {0, 0, 0}

/*
 * VRAM regions
 */

/* in some platforms, such as Z1, reserved 64MB for framebuffer */
#define VRAM_RESERVED_FB_OFFSET 0
#define VRAM_RESERVED_FB_SIZE   (64 << 20) /* VRAM reserved for framebuffer */

/* video memory for GART page table */
#define VRAM_FIX_GART_PAGE_SIZE 0x200000 /* 2MB gart for 2GB mapping */

/* video memory for FIX region */
#define VRAM_FIX_PCI_DMA_SIZE 0x400000 /* 4MB fix function region, for (8+8)*256k channels LINK DMA */

/* video memory for FIX_inst region */
#define VRAM_FIX_INST_SIZE 0x100000 /* 1MB fix_inst function region, for AMBA DMA */

#define VRAM_FIX_VPU_SIZE   0x800000    /* 8MB fix vram for VPU */

/* total fix video memory size */
#define VRAM_TOTAL_FIX_SIZE 0x1000000   /* 16MB total fix external vram */

#define GPU_PAGE_SIZE       4096

/*
 * total fix vram in external region as following table
 * |--------------------------------------------------|
 * | possible GART (2MB) if GP100 or LJMICRO_IS_BUS32 |
 * |--------------------------------------------------|
 * | EDMA FIX (4MB)                                   |
 * |--------------------------------------------------|
 * | AMBA DMA FIX (1MB)                               |
 * |--------------------------------------------------|
 * | Reserved (1MB if GART exists, or 3MB)            |
 * |--------------------------------------------------|
 * | VPU FIX (8MB)                                    |
 * |--------------------------------------------------|
 */

/* for S2C board, 4MB invisible vram are bad */
#define VRAM_INVISIBLE_BAD_OFFSET 0
#define VRAM_INVISIBLE_BAD_SIZE   (4 << 20)
#define VRAM_INVISIBLE_FLAG       (1ULL << 63)

#define VRAM_GP100_GPU_START       0x40000000ULL /* GP100 GPU VRAM start address */
#define VRAM_GP200_BUS32_GPU_START 0x80000000ULL /* GP200 GPU VRAM start address with bus32 */
#define VRAM_GP200_BUS40_GPU_START 0x8000000000ULL /* GP200 GPU VRAM start address with bus40 */

#define GP100_DMA_ADDR_TOP   0x80000000ULL /* GP100 max dma address */
#define GP100_HOST_MEM_START 0x80000000ULL /* GP100 host memory start address */
#define GP100_HOST_MEM_SIZE  0x80000000ULL /* GP100 host memory size: 2GB */
#if 0 /*S2C condition*/
#define GP200_BUS32_DMA_ADDR_TOP   0x40000000ULL
#define GP200_BUS32_HOST_MEM_START 0x40000000ULL
#define GP200_BUS32_HOST_MEM_SIZE  0x40000000ULL
#else /*haps condition*/
#define GP200_BUS32_DMA_ADDR_TOP   0x80000000ULL
#define GP200_BUS32_HOST_MEM_START 0x0ULL
#define GP200_BUS32_HOST_MEM_SIZE  0x80000000ULL
#endif

/* LEGACY_INT means 2d 3d0 3d1 and edma int handle are detached */
#define LEGACY_INT      0
/* if MSI_MULTI_VECTOR_TEST =1;you must set LEGACY_INT =1; todo: we need to add intr auto adjust for 1/32 vectors and remove this define */
#define MSI_MULTI_VECTOR_TEST   0
/* if GP202_REGS_TEST =1;  todo: we need to add regs auto adjust for GP201/GP202 and remove this define */
#define GP202_REGS_TEST   0

#endif
