/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

#ifndef __LJMICRO_FAN_H__
#define __LJMICRO_FAN_H__

#include <linux/thermal.h>
#include <linux/kernel.h>

#define LJM_THERMAL_POLL_DELAY      5000    /* ms */
#define LJM_THERMAL_SLOW_POLL_INT   20000   /* ms */
#define LJM_THERMAL_TEMP_NORM       50000
#define LJM_THERMAL_TEMP_HIGH       85000
#define LJM_THERMAL_TEMP_HOT        110000
#define LJM_THERMAL_HYST_TEMP       5000
#define LJM_THERMAL_MAX_STATE       10
#define LJM_THERMAL_MAX_DUTY        1000    /* 0x3E8,通过这个直接写寄存器进而直接调节风扇转速 */

struct ljm_cooling_states
{
    int min_state;
    int max_state;
};

struct ljm_device;

struct ljm_fan {
    int card;
    struct pci_dev *pdev;
    struct thermal_cooling_device *cdev;
    struct thermal_zone_device *tzdev;
    struct thermal_trip trips[3];
    struct ljm_cooling_states cooling_states[3];
    int polling_delay;
    int current_state;
    uint32_t current_temp;
    //int emul_temp;
    int max_state;
    bool manual;
};

/* 在 pre_init 函数中先调用，根据百分比percent 设置风扇初转速 */
void ljm_fan_pre_init(int card, int percent);

/* thermal 热管理策略注册函数，将 fan 与 gpu temp 绑定，fan 转速会随着 gpu temp 而动态改变 */
int ljm_pwm_fan_init(struct ljm_device *ljm_dev);
void ljm_pwm_fan_exit(struct ljm_device *ljm_dev);
long ljmicro_ioctl_thermal(unsigned int cmd, unsigned long data);

#endif /* __LIMICRO_FAN_H__ */
