/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/

/**
 * @file ljmicro_glx.h
 * @author penghr (penghr@ljmicro.net)
 * @brief 用于 x driver 与 glx 模块握手
 * @version 0.1
 * @date 2024-06-25
 *
 * @copyright Copyright (c) 2021-2024 武汉凌久微电子有限公司版权所有
 * Copyright (c) 2021-2024 LJMICRO Inc. All Rights Reserved.
 * The material in this file is confidential and contains trade secrets
 * of LJMICRO Inc. This is proprietary information owned by LJMICRO Inc.
 * No part of this work may be disclosed, reproduced, copied, transmitted,
 * or used in any way for any purpose, without the express written
 * permission of LJMICRO Inc.
 *
 * @par 修改日志:
 * <table>
 * <tr><th>Date       <th>Version <th>Author  <th>Description
 * <tr><td>2024-06-25 <td>v0.1    <td>penghr  <td>新增文件
 * </table>
 */

#ifndef LJMICRO_GLX_H
#define LJMICRO_GLX_H

#include <xorg/screenint.h>
#include "ljmicro_version.h"

typedef Bool (*__ScreenIsLjmFuncPtr)(ScreenPtr pScreen);

typedef struct __glXLjmHelloRec
{
    const char          *version_string;
    int major;
    int minor;
    __ScreenIsLjmFuncPtr ScreenIsLjm;
} glXLjmHello;

typedef struct __glXLjmAnswerRec
{
    const char *version_string;
    int major;
    int minor;
} glXLjmAnswer;

_X_EXPORT Bool
glXLjmHandShake(glXLjmHello *hello, glXLjmAnswer *answer);

#endif /* LJMICRO_GLX */