/****************************************************************************
*
*    Copyright (c) 2016 - 2099 by LJW.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of LJW. This is proprietary information owned by LJW. No
*    part of this work may be disclosed, reproduced, copied, transmitted,
*    or used in any way for any purpose, without the express written
*    permission of LJW.
*
*****************************************************************************/


#include "subsys.h"

/******************************************************************************/
/* subsystem configuration                                                    */
/******************************************************************************/
#define IRQ_NUM		313
#define DUAL_SUBSYSTEM  1

/* List of subsystems */
struct SubsysDesc subsys_array_201[] = {
  /* {slice_index, index, base} */
#if 1/*DIE 0*/
  {0, 0, 0x310000},
#if DUAL_SUBSYSTEM
  {0, 1, 0x320000}
#endif
#else/*DIE 1*/
  {0, 0, 0x910000},
#if DUAL_SUBSYSTEM
  {0, 1, 0x920000}
#endif
#endif
};
struct SubsysDesc subsys_array_202[] = {
  /* {slice_index, index, base} */
  {0, 0, 0x290000},
};

/* List of all HW cores. */
struct CoreDesc core_array_201[] = {
  /* {slice, subsys, core_type, offset, iosize, irq, has_apbfilter} */
#if 0
  {0, 0, HW_VC8000DJ, 0x600000, 0, 0},
  {0, 0, HW_VC8000D, 0x602000, 0, 0},
  {0, 0, HW_L2CACHE, 0x604000, 0, 0},
  {0, 0, HW_DEC400, 0x606000, 0, 0},
  {0, 0, HW_BIGOCEAN, 0x608000, 0, 0},
  {0, 0, HW_NOC,0x60a000, 0, 0},
  {0, 0, HW_AXIFE, 0x60c000, 0, 0}
#endif
  {0, 0, HW_VCMD, 0x0, 27*4, -1, 0},
  {0, 0, HW_VC8000D, 0x1000, 512*4, -1, 1},
  {0, 0, HW_L2CACHE, 0x2000, 231*4, -1, 0},
  //{0, 0, HW_MMU, 0x3000, 228*4, -1, 0},
  //{0, 0, HW_MMU_WR, 0x4000, 228*4, -1, 0},
  //{0, 0, HW_AXIFE, 0x5000, 64*4, -1, 1},
  //{0, 0, HW_DEC400, 0x6000, 1568*4, -1, 0},
#if DUAL_SUBSYSTEM
  {0, 1, HW_VCMD, 0x0, 27*4, -1, 0},
  {0, 1, HW_VC8000D, 0x1000, 512*4, -1, 1},
  {0, 1, HW_L2CACHE, 0x2000, 231*4, -1, 0},
#endif
  //{0, 1, HW_MMU, 0x3000, 228*4, -1, 0},
  //{0, 1, HW_MMU_WR, 0x4000, 228*4, -1, 0},
  //{0, 1, HW_AXIFE, 0x5000, 64*4, -1, 1},
  //{0, 1, HW_DEC400, 0x6000, 1568*4, -1, 0},
};
struct CoreDesc core_array_202[] = {
  /* {slice, subsys, core_type, offset, iosize, irq, has_apbfilter} */
#if 0
  {0, 0, HW_VC8000DJ, 0x600000, 0, 0},
  {0, 0, HW_VC8000D, 0x602000, 0, 0},
  {0, 0, HW_L2CACHE, 0x604000, 0, 0},
  {0, 0, HW_DEC400, 0x606000, 0, 0},
  {0, 0, HW_BIGOCEAN, 0x608000, 0, 0},
  {0, 0, HW_NOC,0x60a000, 0, 0},
  {0, 0, HW_AXIFE, 0x60c000, 0, 0}
#endif
  {0, 0, HW_VCMD, 0x0, 27*4, -1, 0},
  {0, 0, HW_VC8000D, 0x1000, 512*4, -1, 1},
  {0, 0, HW_L2CACHE, 0x2000, 231*4, -1, 0},
  //{0, 0, HW_MMU, 0x3000, 228*4, -1, 0},
  //{0, 0, HW_MMU_WR, 0x4000, 228*4, -1, 0},
  //{0, 0, HW_AXIFE, 0x5000, 64*4, -1, 1},
  //{0, 0, HW_DEC400, 0x6000, 1568*4, -1, 0},

  //{0, 1, HW_MMU, 0x3000, 228*4, -1, 0},
  //{0, 1, HW_MMU_WR, 0x4000, 228*4, -1, 0},
  //{0, 1, HW_AXIFE, 0x5000, 64*4, -1, 1},
  //{0, 1, HW_DEC400, 0x6000, 1568*4, -1, 0},
};

extern struct vcmd_config vcmd_core_array[MAX_SUBSYS_NUM];
extern int total_vcmd_core_num;
extern unsigned long multicorebase[];
extern int irq[];
extern unsigned int iosize[];
extern int reg_count[];

/*
   If VCMD is used, convert core_array to vcmd_core_array, which are used in
   hantor_vcmd.c.
   Otherwise, covnert core_array to multicore_base/irq/iosize, which are used in
   hantro_dec.c

   VCMD:
        - struct vcmd_config vcmd_core_array[MAX_SUBSYS_NUM]
        - total_vcmd_core_num

   NON-VCMD:
        - multicorebase[HXDEC_MAX_CORES]
        - irq[HXDEC_MAX_CORES]
        - iosize[HXDEC_MAX_CORES]
*/
void CheckSubsysCoreArray_201(struct subsys_config *subsys, int *vcmd) {
  int num = sizeof(subsys_array_201)/sizeof(subsys_array_201[0]);
  int i, j;

  memset(subsys, 0, sizeof(subsys[0])*MAX_SUBSYS_NUM);

  for (i = 0; i < num; i++) {
    subsys[i].base_addr = subsys_array_201[i].base;
    subsys[i].irq = -1;
    for (j = 0; j < HW_CORE_MAX; j++) {
      subsys[i].submodule_offset[j] = 0xffff;
      subsys[i].submodule_iosize[j] = 0;
      subsys[i].submodule_hwregs[j] = NULL;
    }
  }
  subsys[0].irq = IRQ_NUM;
  subsys[1].irq = IRQ_NUM;

  total_vcmd_core_num = 0;

  for (i = 0; i < sizeof(core_array_201)/sizeof((core_array_201)[0]); i++) {
    if (!subsys[(core_array_201)[i].subsys].base_addr) {
      /* undefined subsystem */
      continue;
    }
    subsys[(core_array_201)[i].subsys].submodule_offset[(core_array_201)[i].core_type]
                                  = (core_array_201)[i].offset;
    subsys[(core_array_201)[i].subsys].submodule_iosize[(core_array_201)[i].core_type]
                                  = (core_array_201)[i].iosize;
    if (subsys[(core_array_201)[i].subsys].irq != -1 && (core_array_201)[i].irq != -1) {
      if (subsys[(core_array_201)[i].subsys].irq != (core_array_201)[i].irq) {
       VPUPRINT("hw core type %d irq %d != subsystem irq %d\n",
                          (core_array_201)[i].core_type,
                          (core_array_201)[i].irq,
                          subsys[(core_array_201)[i].subsys].irq);
       VPUPRINT("hw cores of a subsystem should have same irq\n");
      } else {
        subsys[(core_array_201)[i].subsys].irq = (core_array_201)[i].irq;
      }
    }
    subsys[(core_array_201)[i].subsys].has_apbfilter[(core_array_201)[i].core_type] = (core_array_201)[i].has_apb;
    /* vcmd found */
    if ((core_array_201)[i].core_type == HW_VCMD) {
      *vcmd = 1;
      total_vcmd_core_num++;
    }
  }

    VPUPRINT("vcmd = %d\n", *vcmd);

  /* To plug into hantro_vcmd.c */
  if (*vcmd) {
    for (i = 0; i < total_vcmd_core_num; i++) {
      vcmd_core_array[i].vcmd_base_addr = subsys[i].base_addr;
      vcmd_core_array[i].vcmd_iosize = subsys[i].submodule_iosize[HW_VCMD];
      vcmd_core_array[i].vcmd_irq = subsys[i].irq;
      vcmd_core_array[i].sub_module_type = 2; /* TODO(min): to be fixed */
      vcmd_core_array[i].submodule_main_addr = subsys[i].submodule_offset[HW_VC8000D];
      vcmd_core_array[i].submodule_dec400_addr = subsys[i].submodule_offset[HW_DEC400];
      vcmd_core_array[i].submodule_L2Cache_addr = subsys[i].submodule_offset[HW_L2CACHE];
      vcmd_core_array[i].submodule_MMU_addr = subsys[i].submodule_offset[HW_MMU];
      vcmd_core_array[i].submodule_MMUWrite_addr = subsys[i].submodule_offset[HW_MMU_WR];
      vcmd_core_array[i].submodule_axife_addr = subsys[i].submodule_offset[HW_AXIFE];
    }
  }
  memset(multicorebase, 0, sizeof(multicorebase[0]) * HXDEC_MAX_CORES);
  for (i = 0; i < num; i++) {
    multicorebase[i] = subsys[i].base_addr + subsys[i].submodule_offset[HW_VC8000D];
    irq[i] = subsys[i].irq;
    iosize[i] = subsys[i].submodule_iosize[HW_VC8000D];
    VPUPRINT("[%d] multicorebase 0x%08lx, iosize %d\n", i, multicorebase[i], iosize[i]);
  }
}

/*
   If VCMD is used, convert core_array to vcmd_core_array, which are used in
   hantor_vcmd.c.
   Otherwise, covnert core_array to multicore_base/irq/iosize, which are used in
   hantro_dec.c

   VCMD:
        - struct vcmd_config vcmd_core_array[MAX_SUBSYS_NUM]
        - total_vcmd_core_num

   NON-VCMD:
        - multicorebase[HXDEC_MAX_CORES]
        - irq[HXDEC_MAX_CORES]
        - iosize[HXDEC_MAX_CORES]
*/
void CheckSubsysCoreArray_202(struct subsys_config *subsys, int *vcmd) {

  int num = sizeof(subsys_array_202)/sizeof(subsys_array_202[0]);
  int i, j;

  memset(subsys, 0, sizeof(subsys[0])*MAX_SUBSYS_NUM);

  for (i = 0; i < num; i++) {
    subsys[i].base_addr = subsys_array_202[i].base;
    subsys[i].irq = -1;
    for (j = 0; j < HW_CORE_MAX; j++) {
      subsys[i].submodule_offset[j] = 0xffff;
      subsys[i].submodule_iosize[j] = 0;
      subsys[i].submodule_hwregs[j] = NULL;
    }
  }
  subsys[0].irq = IRQ_NUM;
  subsys[1].irq = IRQ_NUM;

  total_vcmd_core_num = 0;

  for (i = 0; i < sizeof(core_array_202)/sizeof((core_array_202)[0]); i++) {
    if (!subsys[(core_array_202)[i].subsys].base_addr) {
      /* undefined subsystem */
      continue;
    }
    subsys[(core_array_202)[i].subsys].submodule_offset[(core_array_202)[i].core_type]
                                  = (core_array_202)[i].offset;
    subsys[(core_array_202)[i].subsys].submodule_iosize[(core_array_202)[i].core_type]
                                  = (core_array_202)[i].iosize;
    if (subsys[(core_array_202)[i].subsys].irq != -1 && (core_array_202)[i].irq != -1) {
      if (subsys[(core_array_202)[i].subsys].irq != (core_array_202)[i].irq) {
       VPUPRINT("hw core type %d irq %d != subsystem irq %d\n",
                          (core_array_202)[i].core_type,
                          (core_array_202)[i].irq,
                          subsys[(core_array_202)[i].subsys].irq);
       VPUPRINT("hw cores of a subsystem should have same irq\n");
      } else {
        subsys[(core_array_202)[i].subsys].irq = (core_array_202)[i].irq;
      }
    }
    subsys[(core_array_202)[i].subsys].has_apbfilter[(core_array_202)[i].core_type] = (core_array_202)[i].has_apb;
    /* vcmd found */
    if ((core_array_202)[i].core_type == HW_VCMD) {
      *vcmd = 1;
      total_vcmd_core_num++;
    }
  }

    VPUPRINT("vcmd = %d\n", *vcmd);

  /* To plug into hantro_vcmd.c */
  if (*vcmd) {
    for (i = 0; i < total_vcmd_core_num; i++) {
      vcmd_core_array[i].vcmd_base_addr = subsys[i].base_addr;
      vcmd_core_array[i].vcmd_iosize = subsys[i].submodule_iosize[HW_VCMD];
      vcmd_core_array[i].vcmd_irq = subsys[i].irq;
      vcmd_core_array[i].sub_module_type = 2; /* TODO(min): to be fixed */
      vcmd_core_array[i].submodule_main_addr = subsys[i].submodule_offset[HW_VC8000D];
      vcmd_core_array[i].submodule_dec400_addr = subsys[i].submodule_offset[HW_DEC400];
      vcmd_core_array[i].submodule_L2Cache_addr = subsys[i].submodule_offset[HW_L2CACHE];
      vcmd_core_array[i].submodule_MMU_addr = subsys[i].submodule_offset[HW_MMU];
      vcmd_core_array[i].submodule_MMUWrite_addr = subsys[i].submodule_offset[HW_MMU_WR];
      vcmd_core_array[i].submodule_axife_addr = subsys[i].submodule_offset[HW_AXIFE];
    }
  }
  memset(multicorebase, 0, sizeof(multicorebase[0]) * HXDEC_MAX_CORES);
  for (i = 0; i < num; i++) {
    multicorebase[i] = subsys[i].base_addr + subsys[i].submodule_offset[HW_VC8000D];
    irq[i] = subsys[i].irq;
    iosize[i] = subsys[i].submodule_iosize[HW_VC8000D];
    VPUPRINT("[%d] multicorebase 0x%08lx, iosize %d\n", i, multicorebase[i], iosize[i]);
  }
}

